using System;

namespace DynoLib
{
	/// <summary>
	/// Contains the data for ONE point in the graph
	/// </summary>
	public class GraphItem: IComparable
	{
		private float[] data;
		public GraphItem(float[] thedata)
		{
			Data = thedata;
		}

		/// <summary>
		/// Copies the data into the data store.
		/// </summary>
		public float[] Data
		{
			get{return data;}
			set
			{
				data = new float[value.Length];
				for(int i = 0; i<data.Length; i++)
					data[i] = value[i];
			}
		}

		public int DataLength
		{
			get{return data.Length;}
		}
		#region IComparable Members

		public int CompareTo(object obj)
		{
			GraphItem rhs = (GraphItem)obj;
			if(DataLength>1 && rhs.DataLength>1)
			{
				if(Data[0]>rhs.Data[0])
					return 1;
				else if(Data[0]<rhs.Data[0])
					return -1;
			}
			return 0;
		}

		#endregion
	}
}
