using System;

namespace DynoLib
{
	/// <summary>
	/// Summary description for MixtureGraphConstraints.
	/// </summary>
	public class MixtureGraphConstraints
	{
		private float min,max;
		private float mixGraphPad = 25F,mixGraphH = 150f,oldH = 150f;

		private int numScales = 4;

		private string units;

		private bool show;

		#region Properties
		public string Units
		{
			get{ return units; }
			set{ units = value; }
		}
		public float MixtureMin
		{
			get{ return min; }
			set{ min = value; }
		}
		public float MixtureMax
		{
			get{ return max; }
			set{ max = value; }
		}
		public float GraphPadding
		{
			get{ return mixGraphPad; }
			set{ mixGraphPad = value; }
		}
		public float GraphHeightViewable
		{
			get{ return mixGraphH; }
			set{ mixGraphH = value;}
		}
		public float GraphHeightOld
		{
			get{ return oldH; }
			set{ oldH = value; }
		}
		public float GraphHeight
		{
			get{ return mixGraphH; }
			set
			{ 
				mixGraphH = value;
				oldH = value;
			}
		}
		public bool Visible
		{
			get{ return show; }
			set{ show = value; }
		}

		public float YScale
		{
			get{ return (max-min) / (float)numScales; }
		}

		public int NumScaleLines
		{
			get{ return numScales; }
			set{ numScales = value; } 
		}

		#endregion

		public MixtureGraphConstraints()
		{
			min = float.MaxValue;
			units = "AFR";
		}
	}
}
