using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ScriptTesting
{

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.TextBox path;
		private System.Windows.Forms.TextBox methodname;
		private System.Windows.Forms.Button open;
		private System.Windows.Forms.Button execute;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			scripting = new CSScriptLibrary.CSScript();
			manager = new CSScriptLibrary.ScriptManager();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public void CreateCheckBox(string caption, int x, int y, string method)
		{
			// 
			// checkBox1
			// 
			NewCheckBox cb = new NewCheckBox();
			Random r = new Random();

			cb.Method = method;
			cb.Location = new System.Drawing.Point(x, y);
			cb.Size = new System.Drawing.Size(128, 16);
			cb.Text = caption;
			cb.Name = caption.Replace(" ","") + r.Next(100).ToString();
			cb.CheckedChanged += new System.EventHandler(this.checkBoxes_CheckedChanged);

			this.Controls.Add(cb);
			scripting.getScript(method).addControl(cb);
			
		}

		public void AddObject(Control[] con)
		{
			foreach(Control c in con)
			{
				NewCheckBox cb = (NewCheckBox)c;
				this.Controls.Add(cb);
				scripting.getScript(cb.Method).addControl(cb);
			}
		}

		public Control CreateCheckBox(int x, int y, string method)
		{
			NewCheckBox cb = new NewCheckBox();
			Random r = new Random();

			cb.Method = method;
			cb.Location = new System.Drawing.Point(x, y);
			cb.Size = new System.Drawing.Size(128, 16);
			cb.Text = "test";
			cb.Name = "test" + r.Next(100).ToString();
			cb.CheckedChanged += new System.EventHandler(this.checkBoxes_CheckedChanged);

			return cb;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.path = new System.Windows.Forms.TextBox();
			this.methodname = new System.Windows.Forms.TextBox();
			this.open = new System.Windows.Forms.Button();
			this.execute = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// path
			// 
			this.path.Location = new System.Drawing.Point(16, 24);
			this.path.Name = "path";
			this.path.Size = new System.Drawing.Size(232, 20);
			this.path.TabIndex = 0;
			this.path.Text = "Script path";
			// 
			// methodname
			// 
			this.methodname.Location = new System.Drawing.Point(16, 72);
			this.methodname.Name = "methodname";
			this.methodname.Size = new System.Drawing.Size(232, 20);
			this.methodname.TabIndex = 1;
			this.methodname.Text = "ScriptMain";
			// 
			// open
			// 
			this.open.Location = new System.Drawing.Point(256, 24);
			this.open.Name = "open";
			this.open.Size = new System.Drawing.Size(40, 24);
			this.open.TabIndex = 2;
			this.open.Text = "...";
			this.open.Click += new System.EventHandler(this.open_Click);
			// 
			// execute
			// 
			this.execute.Location = new System.Drawing.Point(256, 72);
			this.execute.Name = "execute";
			this.execute.Size = new System.Drawing.Size(72, 24);
			this.execute.TabIndex = 3;
			this.execute.Text = "execute";
			this.execute.Click += new System.EventHandler(this.execute_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(56, 104);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(96, 24);
			this.button1.TabIndex = 4;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 134);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.execute);
			this.Controls.Add(this.open);
			this.Controls.Add(this.methodname);
			this.Controls.Add(this.path);
			this.Name = "Form1";
			this.Text = "Execute";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void open_Click(object sender, System.EventArgs e)
		{
			if(this.openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				this.path.Text = this.openFileDialog1.FileName;
			}
		}

		CSScriptLibrary.CSScript scripting;
		CSScriptLibrary.ScriptManager manager;
		private void execute_Click(object sender, System.EventArgs e)
		{

			Form f = new Form();

			object[] args = new object[2];
			args[0] = "hello";
			args[1] = this;

			CSScriptLibrary.Script s = scripting.CompileAndLoad(this.path.Text);//, this);
			
			if( s == null)
				return;

			s.CreateInstance(this,args);

			//	CSScriptLibrary.CSScript.ExecuteNonStatic(myobject,this.methodname.Text,);
			
		}

		private void checkBoxes_CheckedChanged(object sender, System.EventArgs e)
		{
			NewCheckBox ncb = ((NewCheckBox)sender);

			object[] args = new object[2];

			args[0] = this;
			args[1] = ncb;

			CSScriptLibrary.Script s = scripting.getScript(ncb.Method);
			s.ExecuteMethod(this,CSScriptLibrary.CSScript.getMethod(ncb.Method),args);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			manager.AddChild(this,"pr3");
			manager.Visible = true;
		}


	}//end class


	public class NewCheckBox: System.Windows.Forms.CheckBox
	{
		string method;

		public NewCheckBox()
		{
		}

		public string Method
		{
			get
			{
				return method;
			}
			set
			{
				method = value;
			}
		}
	}
}
