/*
 * SimpleGridDemo - A demonstration of SimpleGrid
 * 
 * (C) UK 2004 Tim Heron
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing;

namespace SimpleGridDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
	//	private SimpleGrid.Grid grid1;
		private SimpleGrid.Grid grid2;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Timer timer1;
		int r = 0;
		int c = 0;
		int interpc = 10;

		SimpleGrid.Crosshairs xhairs;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
    
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			timer1 = new Timer();
			timer1.Tick +=new EventHandler(timer1_Tick);

			this.grid2.GridSize = new Size(15,17);
			grid2.setAllColumnWidths(45);
			grid2.TabStop = false;

		//	grid2.SelectedColumn = 0;
		//	grid2.SelectedRow = 0;

			grid2.HeaderMode = 1;
			grid2.BackColor = Color.Blue;

			xhairs = grid2.Crosshairs;
			//xhairs.Enabled = true;
			//xhairs.PaintAsCrosshairs = true;
			xhairs.CrossHairColor = Color.FromArgb(180,255,0,0);
      
			int i;

			for(i = 0; i<grid2.GridSize.Width; i++)
			{
				grid2.setHeader(i,"# " + i);
				grid2.setHeaderEditable(i,true);
			}

			grid2.RowHeaderWidth = 50;
			grid2.Mode = SimpleGrid.Grid.MODE_DOUBLE;
			//grid2.PaintMode = SimpleGrid.Grid.M_PAINT_NO_COLORS;

			for(i = 0; i<grid2.GridSize.Height; i++)
			{
				grid2.setRowHeader(i,""+((i+1)*100));
			}
      
			float f = 1.1F;
			for (int x = 0; x < grid2.GridSize.Width; x++)
			  for (int y = 0; y < grid2.GridSize.Height; y++)
			  {
//				  grid2.getValue(x,y);
//				  grid2.getIntValue(x,y);
				  
				  grid2.setValue(x,y,f++);
				  grid2.setCellColor(x,y,System.Drawing.Color.FromArgb(20,(int)((double)(y+x)*0.25*1000.0)%256,240));
			  }
			grid2.CellChanged += new SimpleGrid.GridChangedHandler(this.grid2_CellChanged);
			grid2.ColumnHeaderChanged += new SimpleGrid.GridChangedHandler(grid2_ColumnHeaderChanged);

		//	grid2.ReadOnly = true;
		}
    
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
    
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grid2 = new SimpleGrid.Grid();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// grid2
			// 
			this.grid2.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grid2.AutoScroll = true;
			this.grid2.AutoScrollMinSize = new System.Drawing.Size(30, 20);
			this.grid2.BackColor = System.Drawing.Color.White;
			this.grid2.GridSize = new System.Drawing.Size(0, 0);
			this.grid2.HeaderMode = 0;
			this.grid2.LastSelectedColumn = -1;
			this.grid2.LastSelectedRow = -1;
			this.grid2.Location = new System.Drawing.Point(8, 0);
			this.grid2.Mode = 0;
			this.grid2.Name = "grid2";
			this.grid2.PaintMode = 0;
			this.grid2.ReadOnly = false;
			this.grid2.RowHeaderWidth = 30;
			this.grid2.RowHeight = 20;
			this.grid2.SelectedColumn = -1;
			this.grid2.SelectedForeColor = System.Drawing.Color.White;
			this.grid2.SelectedRow = -1;
			this.grid2.SelectedRowColor = System.Drawing.Color.Blue;
			this.grid2.Size = new System.Drawing.Size(560, 400);
			this.grid2.TabIndex = 0;
			this.grid2.TabStop = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(584, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(24, 56);
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 406);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.grid2);
			this.Name = "Form1";
			this.Text = "SimpleGrid Demo";
			this.ResumeLayout(false);

		}
		#endregion
    
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void grid1_CellChanged(object sender, System.EventArgs e)
		{
			MessageBox.Show("it worked! (" + ((SimpleGrid.CellEvent)e).Column + ", " + ((SimpleGrid.CellEvent)e).Row + ")");
		}
		private void button1_Click(object sender, System.EventArgs e)
		{
			if(button1.Text != "poo")
			{
				timer1.Interval = 100;
				timer1.Start();
				button1.Text = "poo";
			}
			else
			{
				timer1.Stop();
				button1.Text = "click";
			}
		}

		private void grid2_CellChanged(object sender, SimpleGrid.CellEvent e)
		{
			MessageBox.Show("");
		}

		private void grid2_ColumnHeaderChanged(object sender, SimpleGrid.CellEvent e)
		{
			MessageBox.Show(e.Column.ToString());
		}

		private void timer1_Tick(object sender, EventArgs e)
		{
			if(interpc == 1)
			{
				r++;
				c++;
				interpc = 10;
			}
			else
			{
				interpc--;
			}
			
			grid2.SelectedRow = r;
			grid2.SelectedColumn = c;
			grid2.LastSelectedRow = r+1;
			grid2.LastSelectedColumn = c+1;

			//Console.WriteLine("("+xhairs.Location.X+","+xhairs.Location.Y+")");
			//xhairs.Location = new Point(c,r);
			xhairs.Interpolation = new PointF((float)(interpc)/10.0f,(float)(interpc)/10.0f);

			if(c==15 || r==15)
			{
				c = 0;
				r = 0;
			}
			grid2.Refresh();
		}
	}
}