//#pragma unmanaged
//
//#if !defined BENS_BYTECHANGE_H
//#define BENS_BYTECHANGE_H

#pragma once
using namespace System;
using namespace System::Collections;

namespace RomRep
{
	///Represents a byte change
	[Serializable] public __gc class ByteChange
	{
	protected:
		unsigned char byte;
		int location;

	public:
		ByteChange(int loc, unsigned char byte)
		{
			this->byte = byte;
			this->location = loc;
		};

		unsigned char getByte()
		{
			return byte;
		}

		int getLocation()
		{
			return location;
		}
	};

	///Inhereted by classes used in the roms which need to be notified of 
	///a byte change event without having to subscribe the the event in every
	///class.
	[Serializable] public __gc class ByteChangeNotify
	{
	public:
		ByteChangeNotify(){};

		///The child classes override this if functionality is required.
		virtual void byteChangeNotify(ByteChange* bc){};
	};

	///The structure the HondaEcu class uses to notfy the proper 
	///objects.
	[Serializable] public __gc class ByteChangeNotifyList
	{
	private:
		ArrayList* notifyList;
	public:
		ByteChangeNotifyList();

		///notifies all of the objects in the array.
		void notify(ByteChange* bc);
		void add(ByteChangeNotify* bcn);
		void remove(ByteChangeNotify* bc);
		void remove(int index);
	};
}

//#endif