#pragma once

using namespace System;
using namespace System::Text::RegularExpressions;

#include "appsettings.h"

namespace bre20
{

	public __gc class Common
	{
	public: 
		static bool checkCom(String * com);

		static void handleDoubleKeyPress(TextBox* box, System::Windows::Forms::KeyPressEventArgs * e, bool isSigned);
		static void handleIntKeyPress(TextBox* box, System::Windows::Forms::KeyPressEventArgs * e, bool isSigned);

		/*static AppSettings * getNewAppSettings(){
			return new AppSettings();
		}*/

		static float extractDouble(String* str);
		static int extractInt(String* str);

		///\param value the o2 sensor value from the ecu 
		///\param o2type the DatalogOptions o2type
		///\returns the afr given the o2 type
		static float getAfr(unsigned char value, int o2type);

		static float calcLambda(float afr)
		{return afr/14.7F;};
		static float calcAfr(float lambda)
		{return lambda*14.7F;};

		/*!
		This tries to match the matcher string inside the matchee string.
		Multiple strings can be in the matcher string but they must be
		separated by the vertical bar symbol (|). Case 

		\param matcher the string to match
		\param matchee the place to find matcher
		\param caseSensitive true if the search must be case sensitive

		\returns true if matcher is in matchee
		*/
		static bool isMatch(String* matcher, String* matchee, bool caseSensitive);

		/*!
		This opens a FileDialog of your choice and returns the file name(s) chosen by the user

		\param open if true the dialog will be an open dialog, if false a save dialog
		\param multifile if true the dialog will support multiple selections. Only works with open = true
		\param file the name of the starting file in the dialog
		\param filter the filter for the dialog
		\returns an array of the selected file names. A NULL array is returned if the user clicks 
		cancel.
		*/
		static String* openFileDialog(bool open,bool multifile,String* file,String* filter)[];
		static String* csvFilter(){return S"CSV files (*.csv)|*.csv|All files (*.*)|*.*";};

		/*!
		
		*/
		static String* getNumberDivider()
		{
			return System::Globalization::NumberFormatInfo::CurrentInfo->NumberDecimalSeparator;
		}

		static float convertToLocale(String* val);
	};
}