#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "common.h"
#include "global.h"

namespace bre20
{
	/// <summary> 
	/// Summary for DatalogOptions
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class DatalogOptions : public System::Windows::Forms::Form
	{
		
	public: 
		static const int STOCKO2 = 0;
		static const int TENARROW = 1;
		static const int TEWIDEABND = 2;
		static const int INNOVATELM1 = 3;
		static const int ZEITRONIX = 4;
		static const int PLX = 5;
		static const int WBMAX = 5;

		static const int METRIC = 1;
		static const int SAE = 0;

		static const int MIXAFR = 0;
		static const int MIXLAMBDA = 1;

		static const int NOTRACE = 0;
		static const int AFRTRACE = 1;
		static const int KNOCKTRACE = 2;

		DatalogOptions(String* extrao2defs[]);

		bool addTabPage(TabPage* newpage);
		
		void setInterval(int inter);
		int getInterval();

		void setO2Type(int type);
		int getO2Type();
        
		void setUnitsType(int type);
		int getUnitsType();

		bool isMapTraceEnabled();
		bool isRomTraceEnabled(){return chkMapTInRom->Checked;};
		bool isIntepTraceEnabled(){return chkInterpTrace->Checked;};

		void setTraceType(int type);
		int getTraceType();

		int getMixtureUnits();
		float getMultiplyAdjust();
		float getAddAdjust();

	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private:
		private: System::Windows::Forms::Label *  label1;
		private: System::Windows::Forms::Label *  speedstoplab;
		private: System::Windows::Forms::Label *  label3;
		private: System::Windows::Forms::Label *  label4;
		private: System::Windows::Forms::Label *  speedlab;
		private: System::Windows::Forms::Label *  label6;
		private: System::Windows::Forms::TabPage *  autoStartPage;
		private: System::Windows::Forms::GroupBox *  startGrp;
		private: System::Windows::Forms::TextBox *  tpsBox;
		private: System::Windows::Forms::TextBox *  speedbox;
		private: System::Windows::Forms::TextBox *  rpmbox;
		private: System::Windows::Forms::GroupBox *  stopnGrp;
		private: System::Windows::Forms::TextBox *  rpmstopbox;
		private: System::Windows::Forms::TextBox *  tespeedstopbox;
		private: System::Windows::Forms::TextBox *  tpsstopbox;
		private: System::Windows::Forms::GroupBox *  genGrp;
		private: System::Windows::Forms::CheckBox *  asEnabled;
		private: System::Windows::Forms::CheckBox *  newFile;
		private: System::Windows::Forms::Button *  okbutton;
		private: System::Windows::Forms::GroupBox *  tracegroup;
		private: System::Windows::Forms::RadioButton *  mtknock;
		private: System::Windows::Forms::RadioButton *  mtafr;
		private: System::Windows::Forms::RadioButton *  mtnothing;
		private: System::Windows::Forms::GroupBox *  unitsgroup;
		private: System::Windows::Forms::TabControl *  tabControl1;
		private: System::Windows::Forms::TabPage *  genOptions;
		private: System::Windows::Forms::GroupBox *  groupBox1;
		private: System::Windows::Forms::GroupBox *  groupBox2;
		private: System::Windows::Forms::TextBox *  sampleinterval;
		private: System::Windows::Forms::Label *  samplelabel;
		private: System::Windows::Forms::ComboBox *  o2box;
		private: System::Windows::Forms::RadioButton *  sae1;
		private: System::Windows::Forms::RadioButton *  metric;
		private: System::Windows::Forms::CheckBox *  traceEnabled;
		private: System::Windows::Forms::Label *  addlab;
		private: System::Windows::Forms::TextBox *  compAdd;
		private: System::Windows::Forms::GroupBox *  o2Comp;
		private: System::Windows::Forms::Label *  multlab;
		private: System::Windows::Forms::TextBox *  compMult;
		private: System::Windows::Forms::Button *  comphelp;
		private: System::Windows::Forms::GroupBox *  mixtUnitGrp;
		private: System::Windows::Forms::RadioButton *  afrUnit;
		private: System::Windows::Forms::RadioButton *  lambdaUnit;
		private: System::Windows::Forms::CheckBox *  chkMapTInRom;
		private: System::Windows::Forms::CheckBox *  chkInterpTrace;
		private: System::Windows::Forms::GroupBox *  grpOther;
		private: System::Windows::Forms::TextBox *  txtNumTimeoutErrors;
		private: System::Windows::Forms::Label *  labNumTries;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->okbutton = new System::Windows::Forms::Button();
			this->tracegroup = new System::Windows::Forms::GroupBox();
			this->chkInterpTrace = new System::Windows::Forms::CheckBox();
			this->chkMapTInRom = new System::Windows::Forms::CheckBox();
			this->traceEnabled = new System::Windows::Forms::CheckBox();
			this->mtknock = new System::Windows::Forms::RadioButton();
			this->mtafr = new System::Windows::Forms::RadioButton();
			this->mtnothing = new System::Windows::Forms::RadioButton();
			this->unitsgroup = new System::Windows::Forms::GroupBox();
			this->sae1 = new System::Windows::Forms::RadioButton();
			this->metric = new System::Windows::Forms::RadioButton();
			this->tabControl1 = new System::Windows::Forms::TabControl();
			this->genOptions = new System::Windows::Forms::TabPage();
			this->grpOther = new System::Windows::Forms::GroupBox();
			this->labNumTries = new System::Windows::Forms::Label();
			this->txtNumTimeoutErrors = new System::Windows::Forms::TextBox();
			this->mixtUnitGrp = new System::Windows::Forms::GroupBox();
			this->lambdaUnit = new System::Windows::Forms::RadioButton();
			this->afrUnit = new System::Windows::Forms::RadioButton();
			this->groupBox2 = new System::Windows::Forms::GroupBox();
			this->o2Comp = new System::Windows::Forms::GroupBox();
			this->comphelp = new System::Windows::Forms::Button();
			this->compMult = new System::Windows::Forms::TextBox();
			this->multlab = new System::Windows::Forms::Label();
			this->addlab = new System::Windows::Forms::Label();
			this->compAdd = new System::Windows::Forms::TextBox();
			this->o2box = new System::Windows::Forms::ComboBox();
			this->groupBox1 = new System::Windows::Forms::GroupBox();
			this->sampleinterval = new System::Windows::Forms::TextBox();
			this->samplelabel = new System::Windows::Forms::Label();
			this->autoStartPage = new System::Windows::Forms::TabPage();
			this->genGrp = new System::Windows::Forms::GroupBox();
			this->newFile = new System::Windows::Forms::CheckBox();
			this->asEnabled = new System::Windows::Forms::CheckBox();
			this->startGrp = new System::Windows::Forms::GroupBox();
			this->rpmbox = new System::Windows::Forms::TextBox();
			this->speedbox = new System::Windows::Forms::TextBox();
			this->tpsBox = new System::Windows::Forms::TextBox();
			this->label6 = new System::Windows::Forms::Label();
			this->speedlab = new System::Windows::Forms::Label();
			this->label4 = new System::Windows::Forms::Label();
			this->stopnGrp = new System::Windows::Forms::GroupBox();
			this->label3 = new System::Windows::Forms::Label();
			this->speedstoplab = new System::Windows::Forms::Label();
			this->rpmstopbox = new System::Windows::Forms::TextBox();
			this->tespeedstopbox = new System::Windows::Forms::TextBox();
			this->tpsstopbox = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->tracegroup->SuspendLayout();
			this->unitsgroup->SuspendLayout();
			this->tabControl1->SuspendLayout();
			this->genOptions->SuspendLayout();
			this->grpOther->SuspendLayout();
			this->mixtUnitGrp->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->o2Comp->SuspendLayout();
			this->groupBox1->SuspendLayout();
			this->autoStartPage->SuspendLayout();
			this->genGrp->SuspendLayout();
			this->startGrp->SuspendLayout();
			this->stopnGrp->SuspendLayout();
			this->SuspendLayout();
			// 
			// okbutton
			// 
			this->okbutton->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right);
			this->okbutton->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->okbutton->Location = System::Drawing::Point(278, 358);
			this->okbutton->Name = S"okbutton";
			this->okbutton->Size = System::Drawing::Size(120, 32);
			this->okbutton->TabIndex = 2;
			this->okbutton->Text = S"OK";
			this->okbutton->Click += new System::EventHandler(this, okbutton_Click);
			// 
			// tracegroup
			// 
			this->tracegroup->Controls->Add(this->chkInterpTrace);
			this->tracegroup->Controls->Add(this->chkMapTInRom);
			this->tracegroup->Controls->Add(this->traceEnabled);
			this->tracegroup->Controls->Add(this->mtknock);
			this->tracegroup->Controls->Add(this->mtafr);
			this->tracegroup->Controls->Add(this->mtnothing);
			this->tracegroup->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->tracegroup->Location = System::Drawing::Point(8, 88);
			this->tracegroup->Name = S"tracegroup";
			this->tracegroup->Size = System::Drawing::Size(160, 120);
			this->tracegroup->TabIndex = 4;
			this->tracegroup->TabStop = false;
			this->tracegroup->Text = S"Map Trace";
			// 
			// chkInterpTrace
			// 
			this->chkInterpTrace->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->chkInterpTrace->Location = System::Drawing::Point(16, 96);
			this->chkInterpTrace->Name = S"chkInterpTrace";
			this->chkInterpTrace->Size = System::Drawing::Size(128, 16);
			this->chkInterpTrace->TabIndex = 5;
			this->chkInterpTrace->Text = S"Interpolation Trace";
			// 
			// chkMapTInRom
			// 
			this->chkMapTInRom->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->chkMapTInRom->Location = System::Drawing::Point(16, 72);
			this->chkMapTInRom->Name = S"chkMapTInRom";
			this->chkMapTInRom->Size = System::Drawing::Size(64, 16);
			this->chkMapTInRom->TabIndex = 4;
			this->chkMapTInRom->Text = S"In Rom";
			this->chkMapTInRom->CheckedChanged += new System::EventHandler(this, chkMapTInRom_CheckedChanged);
			// 
			// traceEnabled
			// 
			this->traceEnabled->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->traceEnabled->Location = System::Drawing::Point(16, 32);
			this->traceEnabled->Name = S"traceEnabled";
			this->traceEnabled->Size = System::Drawing::Size(72, 16);
			this->traceEnabled->TabIndex = 0;
			this->traceEnabled->Text = S"In Logger";
			this->traceEnabled->CheckedChanged += new System::EventHandler(this, traceEnabled_CheckedChanged);
			// 
			// mtknock
			// 
			this->mtknock->Enabled = false;
			this->mtknock->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->mtknock->Location = System::Drawing::Point(88, 48);
			this->mtknock->Name = S"mtknock";
			this->mtknock->Size = System::Drawing::Size(64, 16);
			this->mtknock->TabIndex = 3;
			this->mtknock->Text = S"Knock";
			// 
			// mtafr
			// 
			this->mtafr->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->mtafr->Location = System::Drawing::Point(88, 32);
			this->mtafr->Name = S"mtafr";
			this->mtafr->Size = System::Drawing::Size(64, 16);
			this->mtafr->TabIndex = 2;
			this->mtafr->Text = S"Mixture";
			// 
			// mtnothing
			// 
			this->mtnothing->Checked = true;
			this->mtnothing->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->mtnothing->Location = System::Drawing::Point(88, 16);
			this->mtnothing->Name = S"mtnothing";
			this->mtnothing->Size = System::Drawing::Size(64, 16);
			this->mtnothing->TabIndex = 1;
			this->mtnothing->TabStop = true;
			this->mtnothing->Text = S"Nothing";
			// 
			// unitsgroup
			// 
			this->unitsgroup->Controls->Add(this->sae1);
			this->unitsgroup->Controls->Add(this->metric);
			this->unitsgroup->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->unitsgroup->Location = System::Drawing::Point(8, 216);
			this->unitsgroup->Name = S"unitsgroup";
			this->unitsgroup->Size = System::Drawing::Size(160, 40);
			this->unitsgroup->TabIndex = 3;
			this->unitsgroup->TabStop = false;
			this->unitsgroup->Text = S"Units";
			// 
			// sae1
			// 
			this->sae1->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->sae1->Location = System::Drawing::Point(24, 16);
			this->sae1->Name = S"sae1";
			this->sae1->Size = System::Drawing::Size(48, 16);
			this->sae1->TabIndex = 0;
			this->sae1->Text = S"SAE";
			this->sae1->CheckedChanged += new System::EventHandler(this, sae1_CheckedChanged);
			// 
			// metric
			// 
			this->metric->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->metric->Location = System::Drawing::Point(80, 16);
			this->metric->Name = S"metric";
			this->metric->Size = System::Drawing::Size(56, 16);
			this->metric->TabIndex = 1;
			this->metric->Text = S"Metric";
			// 
			// tabControl1
			// 
			this->tabControl1->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->tabControl1->Controls->Add(this->genOptions);
			this->tabControl1->Controls->Add(this->autoStartPage);
			this->tabControl1->Location = System::Drawing::Point(0, 0);
			this->tabControl1->Name = S"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(406, 350);
			this->tabControl1->TabIndex = 3;
			// 
			// genOptions
			// 
			this->genOptions->Controls->Add(this->grpOther);
			this->genOptions->Controls->Add(this->mixtUnitGrp);
			this->genOptions->Controls->Add(this->groupBox2);
			this->genOptions->Controls->Add(this->groupBox1);
			this->genOptions->Controls->Add(this->unitsgroup);
			this->genOptions->Controls->Add(this->tracegroup);
			this->genOptions->Location = System::Drawing::Point(4, 22);
			this->genOptions->Name = S"genOptions";
			this->genOptions->Size = System::Drawing::Size(398, 324);
			this->genOptions->TabIndex = 0;
			this->genOptions->Text = S"General";
			// 
			// grpOther
			// 
			this->grpOther->Controls->Add(this->labNumTries);
			this->grpOther->Controls->Add(this->txtNumTimeoutErrors);
			this->grpOther->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->grpOther->Location = System::Drawing::Point(8, 264);
			this->grpOther->Name = S"grpOther";
			this->grpOther->Size = System::Drawing::Size(384, 56);
			this->grpOther->TabIndex = 8;
			this->grpOther->TabStop = false;
			this->grpOther->Text = S"Other";
			// 
			// labNumTries
			// 
			this->labNumTries->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->labNumTries->Location = System::Drawing::Point(136, 24);
			this->labNumTries->Name = S"labNumTries";
			this->labNumTries->Size = System::Drawing::Size(160, 16);
			this->labNumTries->TabIndex = 1;
			this->labNumTries->Text = S"errors before logger times out";
			this->labNumTries->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
			// 
			// txtNumTimeoutErrors
			// 
			this->txtNumTimeoutErrors->Location = System::Drawing::Point(88, 24);
			this->txtNumTimeoutErrors->Name = S"txtNumTimeoutErrors";
			this->txtNumTimeoutErrors->Size = System::Drawing::Size(40, 20);
			this->txtNumTimeoutErrors->TabIndex = 0;
			this->txtNumTimeoutErrors->Text = S"";
			this->txtNumTimeoutErrors->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
			// 
			// mixtUnitGrp
			// 
			this->mixtUnitGrp->Controls->Add(this->lambdaUnit);
			this->mixtUnitGrp->Controls->Add(this->afrUnit);
			this->mixtUnitGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->mixtUnitGrp->Location = System::Drawing::Point(176, 216);
			this->mixtUnitGrp->Name = S"mixtUnitGrp";
			this->mixtUnitGrp->Size = System::Drawing::Size(216, 40);
			this->mixtUnitGrp->TabIndex = 7;
			this->mixtUnitGrp->TabStop = false;
			this->mixtUnitGrp->Text = S"Mixture Unit";
			// 
			// lambdaUnit
			// 
			this->lambdaUnit->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->lambdaUnit->Location = System::Drawing::Point(120, 16);
			this->lambdaUnit->Name = S"lambdaUnit";
			this->lambdaUnit->Size = System::Drawing::Size(64, 16);
			this->lambdaUnit->TabIndex = 1;
			this->lambdaUnit->Text = S"Lambda";
			// 
			// afrUnit
			// 
			this->afrUnit->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->afrUnit->Location = System::Drawing::Point(40, 16);
			this->afrUnit->Name = S"afrUnit";
			this->afrUnit->Size = System::Drawing::Size(48, 16);
			this->afrUnit->TabIndex = 0;
			this->afrUnit->Text = S"AFR";
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->o2Comp);
			this->groupBox2->Controls->Add(this->o2box);
			this->groupBox2->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->groupBox2->Location = System::Drawing::Point(176, 16);
			this->groupBox2->Name = S"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(216, 192);
			this->groupBox2->TabIndex = 6;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = S"Oxygen Sensor";
			// 
			// o2Comp
			// 
			this->o2Comp->Controls->Add(this->comphelp);
			this->o2Comp->Controls->Add(this->compMult);
			this->o2Comp->Controls->Add(this->multlab);
			this->o2Comp->Controls->Add(this->addlab);
			this->o2Comp->Controls->Add(this->compAdd);
			this->o2Comp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->o2Comp->Location = System::Drawing::Point(16, 72);
			this->o2Comp->Name = S"o2Comp";
			this->o2Comp->Size = System::Drawing::Size(184, 104);
			this->o2Comp->TabIndex = 3;
			this->o2Comp->TabStop = false;
			// 
			// comphelp
			// 
			this->comphelp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->comphelp->Location = System::Drawing::Point(112, 72);
			this->comphelp->Name = S"comphelp";
			this->comphelp->Size = System::Drawing::Size(56, 24);
			this->comphelp->TabIndex = 2;
			this->comphelp->Text = S"Help";
			this->comphelp->Click += new System::EventHandler(this, comphelp_Click);
			// 
			// compMult
			// 
			this->compMult->Location = System::Drawing::Point(24, 40);
			this->compMult->Name = S"compMult";
			this->compMult->Size = System::Drawing::Size(56, 20);
			this->compMult->TabIndex = 0;
			this->compMult->Text = S"1";
			this->compMult->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, compMult_KeyPress);
			// 
			// multlab
			// 
			this->multlab->Location = System::Drawing::Point(16, 24);
			this->multlab->Name = S"multlab";
			this->multlab->Size = System::Drawing::Size(56, 16);
			this->multlab->TabIndex = 3;
			this->multlab->Text = S"Multiply";
			// 
			// addlab
			// 
			this->addlab->Location = System::Drawing::Point(104, 24);
			this->addlab->Name = S"addlab";
			this->addlab->Size = System::Drawing::Size(56, 16);
			this->addlab->TabIndex = 4;
			this->addlab->Text = S"Add";
			// 
			// compAdd
			// 
			this->compAdd->Location = System::Drawing::Point(112, 40);
			this->compAdd->Name = S"compAdd";
			this->compAdd->Size = System::Drawing::Size(56, 20);
			this->compAdd->TabIndex = 1;
			this->compAdd->Text = S"0";
			this->compAdd->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, compAdd_KeyPress);
			// 
			// o2box
			// 
			System::Object* __mcTemp__1[] = new System::Object*[6];
			__mcTemp__1[0] = S"Stock O2";
			__mcTemp__1[1] = S"TechEdge Narrow";
			__mcTemp__1[2] = S"TechEdge 2A0";
			__mcTemp__1[3] = S"Innovate LM-1";
			__mcTemp__1[4] = S"Zeitronix";
			__mcTemp__1[5] = S"PLX";
			this->o2box->Items->AddRange(__mcTemp__1);
			this->o2box->Location = System::Drawing::Point(16, 24);
			this->o2box->Name = S"o2box";
			this->o2box->Size = System::Drawing::Size(184, 21);
			this->o2box->TabIndex = 0;
			this->o2box->SelectedIndexChanged += new System::EventHandler(this, o2box_SelectedIndexChanged);
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->sampleinterval);
			this->groupBox1->Controls->Add(this->samplelabel);
			this->groupBox1->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->groupBox1->Location = System::Drawing::Point(8, 16);
			this->groupBox1->Name = S"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(160, 64);
			this->groupBox1->TabIndex = 5;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = S"Interval (ms)";
			// 
			// sampleinterval
			// 
			this->sampleinterval->Location = System::Drawing::Point(40, 32);
			this->sampleinterval->Name = S"sampleinterval";
			this->sampleinterval->Size = System::Drawing::Size(80, 20);
			this->sampleinterval->TabIndex = 0;
			this->sampleinterval->Text = S"";
			this->sampleinterval->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, sampleinterval_KeyPress);
			// 
			// samplelabel
			// 
			this->samplelabel->Location = System::Drawing::Point(32, 16);
			this->samplelabel->Name = S"samplelabel";
			this->samplelabel->Size = System::Drawing::Size(80, 16);
			this->samplelabel->TabIndex = 1;
			this->samplelabel->Text = S"Interval (ms)";
			this->samplelabel->Visible = false;
			// 
			// autoStartPage
			// 
			this->autoStartPage->Controls->Add(this->genGrp);
			this->autoStartPage->Controls->Add(this->startGrp);
			this->autoStartPage->Controls->Add(this->stopnGrp);
			this->autoStartPage->Location = System::Drawing::Point(4, 22);
			this->autoStartPage->Name = S"autoStartPage";
			this->autoStartPage->Size = System::Drawing::Size(398, 324);
			this->autoStartPage->TabIndex = 1;
			this->autoStartPage->Text = S"Auto-Start";
			// 
			// genGrp
			// 
			this->genGrp->Controls->Add(this->newFile);
			this->genGrp->Controls->Add(this->asEnabled);
			this->genGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->genGrp->Location = System::Drawing::Point(16, 152);
			this->genGrp->Name = S"genGrp";
			this->genGrp->Size = System::Drawing::Size(176, 160);
			this->genGrp->TabIndex = 7;
			this->genGrp->TabStop = false;
			this->genGrp->Text = S"General";
			// 
			// newFile
			// 
			this->newFile->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->newFile->Location = System::Drawing::Point(16, 56);
			this->newFile->Name = S"newFile";
			this->newFile->Size = System::Drawing::Size(144, 16);
			this->newFile->TabIndex = 1;
			this->newFile->Text = S"Create new file on start";
			// 
			// asEnabled
			// 
			this->asEnabled->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->asEnabled->Location = System::Drawing::Point(16, 32);
			this->asEnabled->Name = S"asEnabled";
			this->asEnabled->Size = System::Drawing::Size(128, 16);
			this->asEnabled->TabIndex = 0;
			this->asEnabled->Text = S"Auto-Start Enabled";
			this->asEnabled->CheckedChanged += new System::EventHandler(this, asEnabled_CheckedChanged);
			// 
			// startGrp
			// 
			this->startGrp->Controls->Add(this->rpmbox);
			this->startGrp->Controls->Add(this->speedbox);
			this->startGrp->Controls->Add(this->tpsBox);
			this->startGrp->Controls->Add(this->label6);
			this->startGrp->Controls->Add(this->speedlab);
			this->startGrp->Controls->Add(this->label4);
			this->startGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->startGrp->Location = System::Drawing::Point(16, 16);
			this->startGrp->Name = S"startGrp";
			this->startGrp->Size = System::Drawing::Size(176, 120);
			this->startGrp->TabIndex = 0;
			this->startGrp->TabStop = false;
			this->startGrp->Text = S"Start Conditions";
			// 
			// rpmbox
			// 
			this->rpmbox->Location = System::Drawing::Point(104, 88);
			this->rpmbox->Name = S"rpmbox";
			this->rpmbox->Size = System::Drawing::Size(48, 20);
			this->rpmbox->TabIndex = 5;
			this->rpmbox->Text = S"";
			this->rpmbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
			// 
			// speedbox
			// 
			this->speedbox->Location = System::Drawing::Point(104, 56);
			this->speedbox->Name = S"speedbox";
			this->speedbox->Size = System::Drawing::Size(48, 20);
			this->speedbox->TabIndex = 2;
			this->speedbox->Text = S"";
			this->speedbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
			// 
			// tpsBox
			// 
			this->tpsBox->Location = System::Drawing::Point(104, 24);
			this->tpsBox->Name = S"tpsBox";
			this->tpsBox->Size = System::Drawing::Size(48, 20);
			this->tpsBox->TabIndex = 0;
			this->tpsBox->Text = S"";
			this->tpsBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
			// 
			// label6
			// 
			this->label6->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->label6->Location = System::Drawing::Point(16, 24);
			this->label6->Name = S"label6";
			this->label6->Size = System::Drawing::Size(56, 16);
			this->label6->TabIndex = 11;
			this->label6->Text = S"TPS(%)";
			// 
			// speedlab
			// 
			this->speedlab->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->speedlab->Location = System::Drawing::Point(16, 56);
			this->speedlab->Name = S"speedlab";
			this->speedlab->Size = System::Drawing::Size(88, 16);
			this->speedlab->TabIndex = 12;
			this->speedlab->Text = S"Speed";
			// 
			// label4
			// 
			this->label4->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->label4->Location = System::Drawing::Point(16, 88);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(56, 16);
			this->label4->TabIndex = 13;
			this->label4->Text = S"RPM";
			// 
			// stopnGrp
			// 
			this->stopnGrp->Controls->Add(this->label3);
			this->stopnGrp->Controls->Add(this->speedstoplab);
			this->stopnGrp->Controls->Add(this->rpmstopbox);
			this->stopnGrp->Controls->Add(this->tespeedstopbox);
			this->stopnGrp->Controls->Add(this->tpsstopbox);
			this->stopnGrp->Controls->Add(this->label1);
			this->stopnGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->stopnGrp->Location = System::Drawing::Point(208, 16);
			this->stopnGrp->Name = S"stopnGrp";
			this->stopnGrp->Size = System::Drawing::Size(176, 120);
			this->stopnGrp->TabIndex = 6;
			this->stopnGrp->TabStop = false;
			this->stopnGrp->Text = S"Stop Conditions";
			// 
			// label3
			// 
			this->label3->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->label3->Location = System::Drawing::Point(16, 88);
			this->label3->Name = S"label3";
			this->label3->Size = System::Drawing::Size(56, 16);
			this->label3->TabIndex = 10;
			this->label3->Text = S"RPM";
			// 
			// speedstoplab
			// 
			this->speedstoplab->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->speedstoplab->Location = System::Drawing::Point(16, 56);
			this->speedstoplab->Name = S"speedstoplab";
			this->speedstoplab->Size = System::Drawing::Size(88, 16);
			this->speedstoplab->TabIndex = 9;
			this->speedstoplab->Text = S"Speed";
			// 
			// rpmstopbox
			// 
			this->rpmstopbox->Location = System::Drawing::Point(104, 88);
			this->rpmstopbox->Name = S"rpmstopbox";
			this->rpmstopbox->Size = System::Drawing::Size(48, 20);
			this->rpmstopbox->TabIndex = 5;
			this->rpmstopbox->Text = S"";
			this->rpmstopbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
			// 
			// tespeedstopbox
			// 
			this->tespeedstopbox->Location = System::Drawing::Point(104, 56);
			this->tespeedstopbox->Name = S"tespeedstopbox";
			this->tespeedstopbox->Size = System::Drawing::Size(48, 20);
			this->tespeedstopbox->TabIndex = 2;
			this->tespeedstopbox->Text = S"";
			this->tespeedstopbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
			// 
			// tpsstopbox
			// 
			this->tpsstopbox->Location = System::Drawing::Point(104, 24);
			this->tpsstopbox->Name = S"tpsstopbox";
			this->tpsstopbox->Size = System::Drawing::Size(48, 20);
			this->tpsstopbox->TabIndex = 0;
			this->tpsstopbox->Text = S"";
			this->tpsstopbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
			// 
			// label1
			// 
			this->label1->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->label1->Location = System::Drawing::Point(16, 24);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(56, 16);
			this->label1->TabIndex = 8;
			this->label1->Text = S"TPS(%)";
			// 
			// DatalogOptions
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(408, 397);
			this->ControlBox = false;
			this->Controls->Add(this->tabControl1);
			this->Controls->Add(this->okbutton);
			this->Name = S"DatalogOptions";
			this->ShowInTaskbar = false;
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"Datalogger Options";
			this->Load += new System::EventHandler(this, DatalogOptions_Load);
			this->tracegroup->ResumeLayout(false);
			this->unitsgroup->ResumeLayout(false);
			this->tabControl1->ResumeLayout(false);
			this->genOptions->ResumeLayout(false);
			this->grpOther->ResumeLayout(false);
			this->mixtUnitGrp->ResumeLayout(false);
			this->groupBox2->ResumeLayout(false);
			this->o2Comp->ResumeLayout(false);
			this->groupBox1->ResumeLayout(false);
			this->autoStartPage->ResumeLayout(false);
			this->genGrp->ResumeLayout(false);
			this->startGrp->ResumeLayout(false);
			this->stopnGrp->ResumeLayout(false);
			this->ResumeLayout(false);

		}		


		///
		///
		///
		void loadProperties();
		void changeUnits(bool std);
		void setSpeedLabels(bool std);

		void okbutton_Click(System::Object *  sender, System::EventArgs *  e);
		void o2box_SelectedIndexChanged(System::Object *  sender, System::EventArgs *  e);
		void sampleinterval_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e);
		void DatalogOptions_Load(System::Object *  sender, System::EventArgs *  e);
		void traceEnabled_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		void chkMapTInRom_CheckedChanged(System::Object *  sender, System::EventArgs *  e){};
		void prop_Changed(Object * sender, bre20::PropertyEventArgs* e);

		void comphelp_Click(System::Object *  sender, System::EventArgs *  e){
			MessageBox::Show("The O2 compensation boxes enable you to make the values output by the wideband match the wideband manufacturer's software. The boxes are used in the following format: \n\n\t output_value = Multiply_box*wb_corrected_value + Add_box");
		}

		void compMult_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e){
			Common::handleDoubleKeyPress(compMult,e,true);
		}
		void compAdd_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e){
			Common::handleDoubleKeyPress(compAdd,e,true);
		}
		void box_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e){
			Common::handleIntKeyPress(static_cast<TextBox*>(sender),e,false);
		}
		void decbox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e){
			Common::handleDoubleKeyPress(static_cast<TextBox*>(sender),e,false);
		}

		void sae1_CheckedChanged(System::Object *  sender, System::EventArgs *  e){
			setSpeedLabels(this->sae1->Checked);
		}

		void asEnabled_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		{
			bool b = asEnabled->Checked;

			this->startGrp->Enabled = b;
			this->stopnGrp->Enabled = b;
			this->newFile->Enabled = b;

//			this->dynGenGrp->Enabled = b;
//			this->carParamGrp->Enabled = b;
		}
};
}