
using System;
using System.Windows.Forms;

using bre20;
//css_reference ..\bre.exe;

namespace BensScripts
{
	public class ExtraTablesScript
	{
		child romWind;
		public static object AppliesTo(){return "pr3:pw0";}
		public static object ScriptTitle(){return "Extra Tables Edit by Ben Ogle";}
		public object ScriptMain(params object[] args)
		{
			romWind = (child)args[1];
			//subscribe to the event
			romWind.OnExtraTablesCreated += new EventHandler(this.ec_Created);
			return null;
		}
		private void ec_Created(object sender, EventArgs args)
		{	
			int ect1 = -1,ect2 = 0,ect3=0,idle=0,ects1=0,ects2=0,
				iat=0,otheridle=0,tiw=0,revs=0,rest=0, itb = -1;

			string type = romWind.getRom().getType();
			if(Common.isMatch("jdm pw0",type,false))
			{
				ect1 = 0x36e7;
				ect2 = 0x36f7;
				ect3 = 0x3707;
				idle = 0x39c9;
				otheridle = 0x39db;
				tiw=3;
				ects1 = 0x3951;
				ects2 = 0x3966;
				iat = 0x372b;
				revs = 0x3918;
				rest = 0x3920;
			}
			else if(Common.isMatch("pr3",type,false))
			{
				ect1 = 0x2f46;
				ect2 = 0x2f56;
				ect3 = 0x2f66;
				idle = 0x32cd;
				otheridle = 0x32f1;
				tiw=2;
				ects1 = 0x322b;
				ects2 = 0x3240;
				iat = 0x2f7a;
				revs = 0x31dc;
				rest = 0x41db;
				if(Common.isMatch("pr3 itb",type,false))
					itb = 0x6432;
			}
			else if(Common.isMatch("euro pw0",type,false))
			{
				ect1 = 0x36fd;
				ect2 = 0x370d;
				ect3 = 0x371d;
				idle = 0x39df;
				otheridle = 0x39f1;
				tiw=3;
				ects1 = 0x03967;
				ects2 = 0x397c;
				iat = 0x3741;
				revs = 0x03926;
				rest = 0x0392e;
			}
			if(ect1 > -1)
			{
				string[] idlehead = new string[tiw];
				idlehead[tiw-2] = "Normal";
				idlehead[tiw-1] = "AC ON";
				if(tiw-2 != 0)
					idlehead[0] = "IAT < 88F";

				string[] limits = new string[4];
				limits[0] = "Speedlimit";
				limits[1] = "Hi-Cam";
				limits[2] = "Lo-Cam Hot";
				limits[3] = "Lo-Cam Cold";

				ExtraTables ec = (ExtraTables)sender;

				ec.createNewTable(6, "Target Idle (cold)", idle, ExtraTables.MODE_WORD,ExtraTables.MODE_TEMP,ExtraTables.MODE_RPM,true,true);
				ec.createNewTable(tiw, "Target Idle", otheridle, ExtraTables.MODE_WORD,-1,ExtraTables.MODE_RPM,true,false,90,idlehead);
				ec.createNewTable(4, "Revlimits", revs, ExtraTables.MODE_WORD,-1,ExtraTables.MODE_RPM,true,false,90,limits);
				ec.createNewTable(4, "Restarts", rest, ExtraTables.MODE_WORD,-1,ExtraTables.MODE_RPM,true,false,90,limits);
				ec.createNewTable(8, "ECT Enrich 1", ect1, ExtraTables.MODE_BYTE,ExtraTables.MODE_TEMP,ExtraTables.MODE_RAW,true,true);
				ec.createNewTable(8, "ECT Enrich 2", ect2, ExtraTables.MODE_BYTE,ExtraTables.MODE_TEMP,ExtraTables.MODE_RAW,true,true);
				ec.createNewTable(8, "ECT Enrich 3", ect3, ExtraTables.MODE_BYTE,ExtraTables.MODE_TEMP,ExtraTables.MODE_RAW,true,true);
				ec.createNewTable(7, "ECT Startup 1", ects1, ExtraTables.MODE_WORD,ExtraTables.MODE_TEMP,ExtraTables.MODE_RAW,true,true);
				ec.createNewTable(7, "ECT Startup 2", ects2, ExtraTables.MODE_WORD,ExtraTables.MODE_TEMP,ExtraTables.MODE_RAW,true,true);
				ec.createNewTable(7, "IAT Enrich", iat, ExtraTables.MODE_BYTE,ExtraTables.MODE_TEMP,ExtraTables.MODE_RAW,true,true);	
				
				if(itb > -1)
					ec.createNewTable(13, "ITB column headers", itb, ExtraTables.MODE_BYTE,ExtraTables.MODE_RAW,ExtraTables.MODE_RAW,true,true);
			}
		}
	}//end class
}