using System;
using System.Text;
using System.Windows.Forms;

//namespaces from bre.exe 
using bre20;
using RomRep;

//css_reference ..\..\bre.exe;
//css_import RomNotesDlg.cs;

namespace BensScripts
{
	//class can be named anything.
	public class RomNotes
	{
		Form1 mainWind;
		child romWind;

        RomNotesDlg dlg;

		int loc = 0x7e80;
		int len = 128; //dont edit this unless you move the 
					   //loc back a few or you will mess up other features.

		public static object AppliesTo()
		{
			return "pr3:pw0";
		}

		public static object ScriptTitle()
		{
			return "RomNotes by Ben Ogle";
		}

		public object ScriptMain(params object[] args)
		{
			mainWind = (Form1)args[0];
			romWind = (child)args[1];

			MenuItem item = romWind.AddMenuItem("Scripts", "ROM Notes...", "BensScripts.RomNotes.mnu_click");
			item.Shortcut = Shortcut.CtrlShiftN;
			return null;
		}

		public object mnu_click(params object[] objs)
		{
			string str = getString();

			dlg = new RomNotesDlg();
			dlg.MaxChars = len;
			dlg.RomNotes = str;
			
			if(dlg.ShowDialog() == DialogResult.OK)
				setString(dlg.RomNotes);

			return null;
		}

		private string getString()
		{
			HondaEcu ecu = romWind.getRom();
			StringBuilder sb = new StringBuilder();

			for(int i = 0; i< len; i++)
			{
				byte b = ecu.getByte(loc+i);
				if(b == 0 || b == 255)
					break;
				sb.Append((char)b);
			}
			return sb.ToString();
		}

		private void setString(String str)
		{
			HondaEcu ecu = romWind.getRom();

			int max = Math.Min(str.Length, len);

			int i = 0;
			for(; i< max; i++)
				ecu.setByte(loc+i, (int)str[i]);
			if(i<128)
				ecu.setByte(loc+i,0); //null terminate if possible
		}
	}
}