
using System;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

using bre20;
//css_reference ..\..\bre.exe;

namespace BensScripts
{
	public class AddLogging
	{
		child romWind;
		MenuItem item;

		public static object AppliesTo(){return "pr3:pw0";}
		public static object ScriptTitle(){return "Add Datalogging by Ben Ogle";}
		public object ScriptMain(params object[] args)
		{
			romWind = (child)args[1];
			//subscribe to the event
			if(!Common.isMatch("dev",romWind.getRomType(),false))
				item = romWind.AddMenuItem("Scripts", "Add Datalogging", "BensScripts.AddLogging.addLogging");
			
			return null;
		}
		public object addLogging(params object[] args)
		{	
			string chpath = null;
			string type = romWind.getRomType();

			DialogResult res = MessageBox.Show("Note that this is an irreversable operation short of reopening the bin file. Are you sure you want to continue?",
				"Add Datalogging", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

			if(res != DialogResult.Yes)
				return null;

			if(Common.isMatch("jdm pr3",type,false) || Common.isMatch("pr3 itb",type,false))
				chpath = "\\JPr3Logging.txt";
			else if(Common.isMatch("pr3-93",type,false))
				chpath = "\\Pr393Logging.txt";
			else if(Common.isMatch("jdm pw0",type,false))
				chpath = "\\JPw0Logging.txt";
			else if(Common.isMatch("euro pw0",type,false))
				chpath = "\\EPw0Logging.txt";

			if(chpath != null)
			{
				Assembly asm = Assembly.GetAssembly(this.GetType());
				romWind.parseByteChanges(Path.GetDirectoryName(asm.Location) + chpath, true);
			}

			return null;
		}
	}//end class
}