using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using bre20;
using RomRep;

//css_reference ..\bre.exe;

//you do not NEED a namespace but it keeps everything nice and separated.
namespace BensScripts
{
	//class can be named anything.
	public class Tester
	{
		Form1 mainWind;

		//each child window is of type 'child'
		child romWind;
		CheckBox chk;

		//this is ABSOLUTELY necessary. It tells BRE what rom types this script applies to
		//The string returned is split from the ':' and then BRE tries to match each string
		//with the rom type. The matching is case insensitive and if the type just contains
		//one of these strings then the script is assumed to apply. 
		//
		//i.e. returning "pr3:pw0" would, among others, work with "pr3 dev" roms.
		public static object AppliesTo()
		{
			return "pr3:pw0";
		}
		
		public static object ScriptTitle()
		{
			return "Test BRE Script";
		}

		//ScriptMain is the main entry point into your script. When the script is 
		//instantiated for the first time this is called. 
		//
		//Passed in through args are the objects you should need:
		//args[0] = main window of type bre20.Form1
		//args[1] = child window of type bre20.child
		public object ScriptMain(params object[] args)
		{
			mainWind = (Form1)args[0];
			romWind = (child)args[1];
			
			// with each object that BRE creates for you, you must add a handler 
			// function parameter 4 in this function call sets up that handler. 
			// The string must be the name of the function WITH the 
			// Namespace.className.FunctionName
			//
			chk = new CheckBox();
			this.chk.Location = new System.Drawing.Point(5, 5);
			this.chk.Size = new System.Drawing.Size(80, 16);
			this.chk.Text = "test";
			chk.CheckedChanged += new System.EventHandler(this.chk_Checked);

			Control[] c = new Control[1];
			c[0]=chk;//romWind.CreateCheckBox(5,20,"tester","BensScripts.Tester.chk_Click");
			
			romWind.AddControlGroup(romWind.CreateGroupBox(100 ,20,"TestBox", "BensScripts.Tester", 200,100,c));


			//this method must return something
			return null;
		}

		//the params are:
		//args[0] = rom window
		//args[1] = object that sent the event
		//args[2] = event object
		private void chk_Checked(object sender, System.EventArgs  e)
		{
			CheckBox c = null;
			MessageBox.Show("checked: " + c.Checked.ToString());
		}
	}
}