#include "StdAfx.h"
#include "DataLogForm.h"
#include "Engine.h"

bre20::DataLogForm::DataLogForm(String * head, child * romm)
{
	InitializeComponent();


	AppSettings* as = new AppSettings();

	this->timer1 = new System::Windows::Forms::Timer();
	timer1->Interval = tminterval = Common::getIntParam(S"logInterval",as);
	this->timer1->Tick += new System::EventHandler(this, timer_Tick);

	port = PortSetupDialog::getPortName(Common::getParam(S"logPort",as));

	this->o2type = Common::getIntParam(S"logSensor",as);

	String* str = Common::getParam(S"logTrace",as)->ToLower();
	if(str->Equals(S"afr"))
		this->maptracetype = DatalogOptions::AFRTRACE;
	else if(str->Equals(S"knock"))
		this->maptracetype = DatalogOptions::KNOCKTRACE;
	else
		this->maptracetype = DatalogOptions::NOTRACE;

	str = Common::getParam(S"logUnits",as)->ToLower();
	if(str->Equals(S"metric"))
		this->maptracetype = DatalogOptions::METRIC;
	else
		this->maptracetype = DatalogOptions::SAE;


	header = head;

	rom = romm;

	if(rom == NULL)
	{
		this->menuItem4->Enabled = false;
		this->loggerAnalyze->Enabled = false;
		this->incFuel->Enabled = false;
		this->incFuelLg->Enabled = false;
		this->decFuel->Enabled = false;
		this->decFuelLg->Enabled = false;

	}

	dash = NULL;

	start->Enabled = false;

	//setup the port:

	comport = new DatalogCom();

	tofile = false;
	fname = new String(S"");
	replay = false;

	lgchange = 1.0;
	smchange = 1.0;

	percentchange = true;

	atmin = 1.0;
	atmax = 1.0;
	autotune = false;
			
}

void bre20::DataLogForm::setHeaders()
{
	for(int i=0; i<gridLog->getWidth(); i++)
		gridLog->setGridColumnHeader(i,i.ToString());
	for(int i=0; i<gridLog->getHeight(); i++)
		gridLog->setRowHeader(i,i.ToString());
}



int bre20::DataLogForm::readInterval(System::IO::StreamReader *sr)
{
	String* s = replayin->ReadLine();
	Char delim[] = {','};
	try
	{
		return System::Convert::ToInt32(s->Split(delim)[0]);
	}
	catch(...)
	{
		return -1;
	}
}


float bre20::DataLogForm::pickO2(unsigned char cmd)
{
	int value1;
	float val;
	//WB processing here...
	if(o2type == DatalogOptions::TENARROW)
	{
		//techedge narrow out.
		float volts __gc[] = {(float)5.1 ,(float)0.8739 ,(float)0.8735 ,(float)0.873 ,(float)0.8725 ,
		(float)0.8720 ,(float)0.8718 ,(float)0.8712 ,(float)0.869 ,(float)0.852 ,(float)0.841 ,
		(float)0.832 ,(float)0.818 ,
		0.805f ,0.792f ,0.779f ,0.763f ,0.741f ,0.718f ,
		0.683f ,0.606f ,0.231f ,0.171f ,0.107f ,0.063f ,
		0.050f ,0.038f ,0.033f ,0.031f ,0.0f };
		
		float afr __gc[] = {0.0f ,10.78f ,10.93f ,11.08f ,11.24f ,11.39f ,11.54f ,11.69f ,11.86f ,
		12.04f ,12.23f ,12.39f ,12.62f ,
		12.83f ,13.03f ,13.21f ,13.40f ,13.59f ,13.82f ,14.10f ,14.43f ,14.83f ,15.31f ,15.85f ,16.47f ,
		17.15f ,17.90f ,18.70f ,19.57f ,3000.0f };		
	
		value1 = cmd;//txAndRx(cmd, 100); //secondary, raw
		val = RomRep::Engine::rawToAfr(value1, volts, afr);
	}
	else if(o2type == DatalogOptions::TEWIDEABND)
	{
		value1 = cmd;//txAndRx(cmd, 100); //secondary, raw
		val = (RomRep::Engine::rawToVolts(value1)*2.0F) +9.0F;
		//value1 = RomRep::Engine::rawToAfr(value1);
	}
	else if(o2type == DatalogOptions::INNOVATELM1)
	{
		value1 = cmd;//txAndRx(cmd, 100); //secondary, raw
		val = (RomRep::Engine::rawToVolts(value1)*2.0F) +9.0F;
		//value1 = RomRep::Engine::rawToAfr(value1);
	}
	else if(o2type == DatalogOptions::ZEITRONIX)
	{

		float volts __gc[] = {5.1f ,3.27f ,3.12f ,3.0f ,2.96f ,2.80f ,2.65f ,2.5f ,2.34f ,2.18f,2.02f ,1.87f ,1.71f ,1.56f ,
						1.4f ,1.24f ,1.09f ,0.93f ,0.78f ,0.62f ,0.46f ,0.31f ,0.15f ,0.0f };

		float afr __gc[] = {3000.0f ,21.2f ,19.9f ,18.8f ,18.5f ,16.9f ,15.6f ,14.7f ,14.2f ,13.7f ,13.2f ,12.8f ,12.4f ,12.1f ,
						11.7f ,11.4f ,11.0f ,10.7f ,10.5f ,10.3f ,10.1f ,9.9f ,9.7f ,0.0f };
		value1 = cmd;//txAndRx(cmd, 100); //secondary, raw
		val = (RomRep::Engine::rawToAfr(value1,volts,afr));
		//value1 = RomRep::Engine::rawToAfr(value1);
	}
	else if(o2type == DatalogOptions::PLX)
	{

		float volts __gc[] = {5.1f ,4.0f ,3.5f ,3.0f ,2.75f ,2.5f ,2.38f ,2.25f ,2.13f ,2.0f ,1.75f ,1.5f ,1.25f ,1.0f ,.75f ,.5f ,0.0f };

		float afr __gc[] = {3000.0f ,18.0f ,17.0f ,16.0f ,15.5f ,15.0f ,14.75f ,14.5f ,14.25f ,14.0f ,13.5f ,13.0f ,12.5f ,12.0f ,11.5f ,11.0f ,10.0f };
		value1 = cmd;//txAndRx(cmd, 100); //secondary, raw
		val = (RomRep::Engine::rawToAfr(value1,volts,afr));
	}
	else
		val = (float)cmd;//txAndRx(cmd, 100); //secondary

	return val;
}

////////////////////////////////////////////////////////////////////////////////////////////////
////////
////////		Code for realtime updating. 
////////
////////////////////////////////////////////////////////////////////////////////////////////////

void bre20::DataLogForm::changeFuel(float change)
{
	//change is in the format percentChange/100 for percentage.
	if(rom != NULL && !this->replay && this->start->Text->Equals(S"Stop"))
	{
		int index = 0;
		if(curvtec)
			index = 1;

		int width = rom->getRom()->getWidth();
		int height = rom->getRom()->getHeight();

		int col = curcol;
		int row = currow;

		//compute avg
		//need to take interp into account...
		float curcolpercent = (float)(15-colinterp)/15.0F;
		float nextcolpercent = (float)(colinterp)/15.0F;
		
		int rowsize = rom->getRom()->getRpmScalarValue(currow,true,index>0)-1;
		if(rowsize<=0)
		{
		//	MessageBox::Show(String::Concat(S"line: ",iterations.ToString(),S" rowsize: ", rowsize.ToString(),S" interp: ", rowinterp.ToString()));
			rowsize = 1;
		}
		float currowpercent = (float)(rowsize-rowinterp)/(float)rowsize;
		float nextrowpercent = (float)(rowinterp)/(float)rowsize;

		if(currowpercent > 1.0)
		{
		//	MessageBox::Show(String::Concat(S"line: ",iterations.ToString(),S"current row percent: ",currowpercent.ToString(),S" rowsize: ", rowsize.ToString(),S" interp: ", rowinterp.ToString()));
			currowpercent = 1.0;
		}
		if(nextrowpercent > 1.0)
		{
		//	MessageBox::Show(String::Concat(S"line: ",iterations.ToString(),S"next row percent: ",nextrowpercent.ToString(),S" rowsize: ", rowsize.ToString(),S" interp: ", rowinterp.ToString()));
			nextrowpercent = 1.0;
		}

		bool refresh = false;
		if(currow >= 0 && curcol>=0 && currow+1<height && curcol+1<width)
		{
		//	float perc;
			//current cell
			if(curcolpercent > 0.05 && currowpercent > 0.05)
			{
				float num = rom->getFuelCell(curcol,currow,index);

				if(percentchange)
					num = num*(change*curcolpercent*currowpercent+1);
				else
					num = num+change*curcolpercent*currowpercent;

				rom->setFuelCell(curcol,currow,num,index);

			}

			//east cell
			if(nextcolpercent > 0.05 && currowpercent > 0.05)
			{
				float num = rom->getFuelCell(curcol+1,currow,index);

				if(percentchange)
					num = num*(change*nextcolpercent*currowpercent+1);
				else
					num = num+change*nextcolpercent*currowpercent;

				rom->setFuelCell(curcol+1,currow,num,index);
			}

			//south cell
			if(curcolpercent > 0.05 && nextrowpercent > 0.05)
			{
				float num = rom->getFuelCell(curcol,currow+1,index);

				if(percentchange)
					num = num*(change*curcolpercent*nextrowpercent+1);
				else
					num = num+change*curcolpercent*nextrowpercent;

				rom->setFuelCell(curcol,currow+1,num,index);
			}

			//south east cell
			if(nextcolpercent > 0.05 && nextrowpercent > 0.05)
			{
				float num = rom->getFuelCell(curcol+1,currow+1,index);

				if(percentchange)
					num = num*(change*nextcolpercent*nextrowpercent+1);
				else
					num = num+change*nextcolpercent*nextrowpercent;

				rom->setFuelCell(curcol+1,currow+1,num,index);
			}
		}//end bigif

		rom->Refresh();

	}
}

//end change fuel

//realtime auto tune menu item
void bre20::DataLogForm::menuItem4_Click(System::Object *  sender, System::EventArgs *  e)
{
	if(menuItem4->Text->IndexOf(S"Start") >= 0)
	{
		int index = 0;
		if(curvtec)
			index = 1;
		afrmap = rom->getRom()->getLambdaMap(index);

		int width = rom->getRom()->getWidth();
		int height = rom->getRom()->getHeight();
		int nummaps = rom->getRom()->getNumMaps();
		goodsamples = new int __gc[nummaps,width,height];//[rom->getRom()->getWidth(),rom->getRom()->getHeight()];

		if(afrmap != NULL)
		{
			try
			{
				intervalcount = 0;
				numintervals = Common::getIntParam(S"atLatencyIntervals",true);
				
				atavg = new float __gc[nummaps,width,height];
				atfreq = new float __gc[nummaps,width,height];

				atminfreq = Convert::ToSingle(Common::getParam(S"atRtFrequency",true));
				
				atmin = Convert::ToSingle(Common::getParam(S"atMinDifference",true))/100.0F;
				atmax = Convert::ToSingle(Common::getParam(S"atMaxDifference",true))/100.0F;
				atmincell = Convert::ToSingle(Common::getParam(S"atMinCellWeight",true));

				atmaxcoldev = Convert::ToSingle(Common::getParam(S"atMaxColDeviation",true));
				atmaxrowdev = Convert::ToSingle(Common::getParam(S"atMaxRowDeviation",true));

				menuItem4->Text = S"Stop Real-time Autotune";
				autotune = true;
			}
			catch(...)
			{}					
		}
	}
	else
	{
		menuItem4->Text = S"Start Real-time Autotune";
		autotune = false;

		atavg = NULL;
		atfreq = NULL;
		goodsamples = NULL;

		System::GC::Collect();
	}
}
//_____________________________________________________________________________________

//perc is the weight (percent; 0-1) of this cells fuel value on the measured afr 
bool bre20::DataLogForm::setFuelCell(int col, int row, float perc, float afrmeasure, float afrtarget)
{
	int index = 0;
	if(curvtec)
		index = 1;

	//if enough intervals have not passed, do nothing
	if(intervalcount-goodsamples[index,col,row]<=numintervals)
		return false;
	else
		goodsamples[index,col,row] = intervalcount;

	//if this sample is less than the minimum cell weight, then do nothing.
	if(perc < atmincell)
		return false;

	atavg[index,col,row] = (atavg[index,col,row] * atfreq[index,col,row]) + afrmeasure*perc;
	atfreq[index,col,row]+= perc;
	atavg[index,col,row] = atavg[index,col,row]/atfreq[index,col,row];

	if(atfreq[index,col,row]<atminfreq)
		return false;

	float div = atavg[index,col,row]/afrtarget-1.0F;

	// post interp checking
	if(atfreq[index,col,row] >= 1.0F)
		perc = div;
	else
		perc = atfreq[index,col,row]*div;

	if(Math::Abs(perc) < atmin)
		return false;

	if(Math::Abs(perc) > atmax)
	{
		if(div<0.0)
			perc = -atmax;
		else
			perc = atmax;
	}

	//end post interp checking

	/* 
	//pre interp checking

	if(Math::Abs(div) < atmin)
		return;

	if(Math::Abs(div) > atmax)
	{
		if(div<0.0)
			div = -atmax;
		else
			div = atmax;
	}

	perc *= div;

	//end pre interp checking
	*/

	perc+= 1.0;

	//pretty much if we hit the mark more than 5 times we are done with that cell.
//	if(goodsamples[col,row] > 5)
//	{
//		rom->Refresh();
//		return false;
//	}

	float curcell = rom->getFuelCell(col,row,index);

	float newcurcell = curcell*perc;

	if(newcurcell <0)
		return false;

	bool ok = true;

	float surcells __gc[] = new float __gc[4];
	surcells[0] = rom->getFuelCell(col+1,row,index);//east
	surcells[1] = rom->getFuelCell(col-1,row,index);//west
	surcells[2] = rom->getFuelCell(col,row+1,index);//north
	surcells[3] = rom->getFuelCell(col,row-1,index);//south

	for(int i = 0; i<surcells->Length; i++)
	{
		float max = atmaxcoldev;
		if(i>=2)
			max = atmaxrowdev;
		if(surcells[i] > 1.0)
		{
			perc = (surcells[i]/newcurcell)-1.0F;
			if(Math::Abs(perc)>max)
				ok = false;
		}
	}

	rom->setFuelCell(col,row,newcurcell,index);

	atfreq[index,col,row] = 0.0F;
	atavg[index,col,row] = 0.0F;

	return true;
}

void bre20::DataLogForm::runDL()
{
	//r-t auto tune...
	if(autotune && afrmap != NULL)
	{
		intervalcount++;

		int index = 0;
		if(curvtec)
			index = 1;

		int width = rom->getRom()->getWidth();
		int height = rom->getRom()->getHeight();

		//compute avg
		//need to take interp into account...
		float curcolpercent = (float)(15-colinterp)/15.0F;
		float nextcolpercent = (float)(colinterp)/15.0F;
		
		int rowsize = rom->getRom()->getRpmScalarValue(currow,true,index>0)-1;
		if(rowsize<=0)
			rowsize = 1;

		float currowpercent = (float)(rowsize-rowinterp)/(float)rowsize;
		float nextrowpercent = (float)(rowinterp)/(float)rowsize;

		if(currowpercent > 1.0)
			currowpercent = 1.0;
	
		if(nextrowpercent > 1.0)
			nextrowpercent = 1.0;

		bool refresh = false;
		if(currow >= 0 && curcol>=0 && currow+1<height && curcol+1<width)
		{
			float perc;//, div ;
			float mult = 1.0;
			//current cell
			if(curcolpercent > 0.05 && currowpercent > 0.05)
			{
				perc = curcolpercent*currowpercent;//*mult;

				if(setFuelCell(curcol,currow,perc,afr,afrmap[curcol,currow]))
					refresh = true;

			}

			//east cell
			if(nextcolpercent > 0.05 && currowpercent > 0.05)
			{
				perc = nextcolpercent*currowpercent;//*mult;

				if(setFuelCell(curcol+1,currow,perc,afr,afrmap[curcol+1,currow]))
					refresh = true;
			}

			//south cell
			if(curcolpercent > 0.05 && nextrowpercent > 0.05)
			{
				perc = curcolpercent*nextrowpercent;//*mult;

				if(setFuelCell(curcol,currow+1,perc,afr,afrmap[curcol,currow+1]))
					refresh = true;
			}

			//south east cell
			if(nextcolpercent > 0.05 && nextrowpercent > 0.05)
			{
				perc = nextcolpercent*nextrowpercent;//*mult;

				if(setFuelCell(curcol+1,currow+1,perc,afr,afrmap[curcol+1,currow+1]))
					refresh = true;
			}
		}//end bigif

	}
}