#include "StdAfx.h"
#include "DevPage.h"
#include "child.h"
#include "ParamPage.h"

//#include "HondaEcu.h"
//#include "RomRep::DevUtil.h"

bre20::DevPage::DevPage():TabPage()
{
	setupPage();
}
bre20::DevPage::DevPage(String* tname, RomRep::HondaEcu * hecu): TabPage()
{
	this->Text = type = tname;
	
//	rom = ecu;
	honecu = hecu;

	setupPage();

//	unsigned char limit = hecu->getMaxMapValue();

//	maxpressbox->Text = limit.ToString();

	fillGrid();

	int map = RomRep::DevUtil::getMapSensor(hecu->getFile());
	
	if(map == 1)
		map2bar->Checked = true;
	else if(map == 2)
		map25bar->Checked = true;
	else if(map == 3)
		map3bar->Checked = true;
	else if(map == 4)
		motorola25bar->Checked = true;
	else
		stock->Checked = true;

//	doing this after we set them so we dont fire an event.
	this->stock->CheckedChanged += new System::EventHandler(this, stock_CheckedChanged);
	this->map2bar->CheckedChanged += new System::EventHandler(this, map2bar_CheckedChanged);
	this->map25bar->CheckedChanged += new System::EventHandler(this, map25bar_CheckedChanged);
	this->motorola25bar->CheckedChanged += new System::EventHandler(this, motorola25bar_CheckedChanged);
	this->map3bar->CheckedChanged += new System::EventHandler(this, map3bar_CheckedChanged);

}

void bre20::DevPage::setupPage()
{
	x = RomRep::DevUtil::getRomWidth(honecu->getFile());


	grid = new SimpleGrid::Grid();
	maxpresslab = new Label();
	maxpressbox = new TextBox();

	this->maxgroup = new GroupBox();
	this->mapgroup = new GroupBox();
	this->stock = new RadioButton();
	this->map2bar = new RadioButton();
	this->map25bar = new RadioButton();
	this->motorola25bar = new RadioButton();
	this->map3bar = new RadioButton();


	this->Controls->Add(this->maxgroup);
	this->Controls->Add(this->mapgroup);
	this->Controls->Add(this->grid);
// 
	// mapgroup
	// 
	this->mapgroup->Controls->Add(this->stock);
	this->mapgroup->Controls->Add(this->map2bar);
	this->mapgroup->Controls->Add(this->map25bar);
	this->mapgroup->Controls->Add(this->motorola25bar);
	this->mapgroup->Controls->Add(this->map3bar);
	this->mapgroup->Location = System::Drawing::Point(140, 24);
	this->mapgroup->Name = S"mapgroup";
	this->mapgroup->Size = System::Drawing::Size(116, 112);
	this->mapgroup->TabIndex = 6;
	this->mapgroup->TabStop = false;
	this->mapgroup->Text = S"Map Sensor";
	this->mapgroup->FlatStyle = FlatStyle::System;
	// 
	// stock
	// 
	this->stock->Location = System::Drawing::Point(10, 16);
	this->stock->Name = S"stock";
	this->stock->Size = System::Drawing::Size(72, 16);
	this->stock->TabIndex = 0;
	this->stock->Text = S"Stock";
	this->stock->FlatStyle = FlatStyle::System;
	// 
	// 2bar
	// 
	this->map2bar->Location = System::Drawing::Point(10, 34);
	this->map2bar->Name = S"map2bar";
	this->map2bar->Size = System::Drawing::Size(72, 16);
	this->map2bar->TabIndex = 1;
	this->map2bar->Text = S"2 Bar";
	this->map2bar->FlatStyle = FlatStyle::System;
	// 
	// motorola
	// 
	this->motorola25bar->Location = System::Drawing::Point(10, 52);
	this->motorola25bar->Name = S"motorola25bar";
	this->motorola25bar->Size = System::Drawing::Size(104, 16);
	this->motorola25bar->TabIndex = 2;
	this->motorola25bar->Text = S"Motorola 2.5 bar";
	this->motorola25bar->FlatStyle = FlatStyle::System;
	// 
	// map25bar
	// 
	this->map25bar->Location = System::Drawing::Point(10, 70);
	this->map25bar->Name = S"map25bar";
	this->map25bar->Size = System::Drawing::Size(72, 16);
	this->map25bar->TabIndex = 2;
	this->map25bar->Text = S"2.5 Bar";
	this->map25bar->FlatStyle = FlatStyle::System;
	// 
	// stock
	// 
	this->map3bar->Location = System::Drawing::Point(10, 88);
	this->map3bar->Name = S"map3bar";
	this->map3bar->Size = System::Drawing::Size(72, 20);
	this->map3bar->TabIndex = 3;
	this->map3bar->Text = S"3 Bar";
	this->map3bar->FlatStyle = FlatStyle::System;
	
	// 
	// maxgroup
	// 
	this->maxgroup->Controls->Add(this->maxpressbox);
	this->maxgroup->Controls->Add(this->maxpresslab);
	this->maxgroup->Location = System::Drawing::Point(16, 24);
	this->maxgroup->Name = S"maxgroup";
	this->maxgroup->Size = System::Drawing::Size(104, 112);
	this->maxgroup->TabIndex = 5;
	this->maxgroup->TabStop = false;
	this->maxgroup->Text = S"";
	this->maxgroup->Enabled = false;
	this->maxgroup->FlatStyle = FlatStyle::System;
	// 
	// label1
	// 
	this->maxpresslab->Location = System::Drawing::Point(16, 24);
	this->maxpresslab->Name = S"maxpresslab";
	this->maxpresslab->Size = System::Drawing::Size(72, 16);
	this->maxpresslab->TabIndex = 5;
	this->maxpresslab->Text = S"Max Press:";
	// 
	// textBox1
	// 
	this->maxpressbox->Location = System::Drawing::Point(16, 40);
	this->maxpressbox->Name = S"maxpressbox";
	this->maxpressbox->Size = System::Drawing::Size(72, 20);
	this->maxpressbox->TabIndex = 2;
	this->maxpressbox->Text = S"";
	this->maxpressbox->Leave += new System::EventHandler(this, maxpressbox_Leave);
	this->maxpressbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, rev_KeyPress);
	// 
	// grid1
	// 
	this->grid->GridSize = System::Drawing::Size(x, 1);
	this->grid->LastSelectedColumn = -1;
	this->grid->LastSelectedRow = -1;
	this->grid->Location = System::Drawing::Point(16, 224);
	this->grid->Name = S"grid";
	this->grid->RowHeaderWidth = 64;
	this->grid->RowHeight = 17;
	this->grid->SelectedColumn = -1;
	this->grid->SelectedForeColor = System::Drawing::Color::White;
	this->grid->SelectedRow = -1;
	this->grid->SelectedRowColor = System::Drawing::Color::Blue;
	
	this->grid->TabIndex = 4;
	this->grid->TabStop = false;
	this->grid->setAllColumnWidths(38);
	grid->Mode = 1;

	int wid = grid->RowHeaderWidth + (grid->getColumnWidth(0)*x)+1;
	
	this->grid->Size = System::Drawing::Size(wid, 35);
	this->grid->add_CellChanged(new SimpleGrid::GridChangedHandler(this, grid_CellChanged));
}

void bre20::DevPage::fillGrid()
{
	grid->getColumnWidth(0);
	grid->setRowHeader(0,S"Pressure");

	for(int i = 0; i<x; i++)
	{
		int inhg = 0;
		float psi = 0.0;
		//broken!!
		String* str= honecu->getColHeader(0,0,i); //the the column header
		if(str->Length <3) //inhg
		{
			try
			{
				inhg = Convert::ToInt32(str);
				grid->setValue(i,0,inhg);
			}
			catch(...)
			{
			}
		}
		else if(str->Length > 5) //psi with label
		{
			try
			{
				psi = Convert::ToSingle(str->Substring(0,str->Length-3));
				grid->setValue(i,0,psi);
			}
			catch(...)
			{
			}
		}
		else //psi with no label
		{
			try
			{
				psi = Convert::ToSingle(str);
				grid->setValue(i,0,psi);
			}
			catch(...)
			{
			}
		}
		grid->setHeader(i, (i+1).ToString());

	}
}

void bre20::DevPage::updateColHeaders()
{
	child* frm = (static_cast<child*>(this->Parent->Parent));
	if(frm!=NULL && grid!=NULL)
	{
		int i;
		for(i = 0; i<= honecu->getLastNaCol(); i++)
		{
			String* s = honecu->getColHeader(0,0,i);
			frm->changeColHeader(true,i,s);
			grid->setValue(i,0,Convert::ToInt32(s));

		}
		for(; i< RomRep::DevUtil::getRomWidth(honecu->getFile())-1; i++)
		{
			String* s = honecu->getColHeader(0,0,i); //broken
			frm->changeColHeader(true,i,s);
			grid->setValue(i,0,Convert::ToSingle(s));
		}
		//i = RomRep::DevUtil::getRomWidth()-1;
		String* s = honecu->getColHeader(0,0,i);
		frm->changeColHeader(true,i,s);
		grid->setValue(i,0,Convert::ToSingle(s));//s->Substring(0,s->Length-3)));

		grid->Refresh();
	}

}
//events...

System::Void bre20::DevPage::stock_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(stock->Checked == true)
	{
		RomRep::DevUtil::recalcPressureHeaders(RomRep::DevUtil::MAPSTOCK, honecu);
		updateColHeaders();
		
	}
}

System::Void bre20::DevPage::map2bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(map2bar->Checked == true)
	{
		RomRep::DevUtil::recalcPressureHeaders(RomRep::DevUtil::MAP2BAR, honecu);
		updateColHeaders();
		
	}

}

System::Void bre20::DevPage::map25bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(map25bar->Checked == true)
	{
		RomRep::DevUtil::recalcPressureHeaders(RomRep::DevUtil::MAP25BAR, honecu);
		updateColHeaders();
		
	}

}

System::Void bre20::DevPage::motorola25bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(motorola25bar->Checked == true)
	{
		RomRep::DevUtil::recalcPressureHeaders(RomRep::DevUtil::MAPMOTOROLA25BAR, honecu);
		updateColHeaders();
		
	}

}

System::Void bre20::DevPage::map3bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(map3bar->Checked == true)
	{
		RomRep::DevUtil::recalcPressureHeaders(RomRep::DevUtil::MAP3BAR, honecu);
		updateColHeaders();
		
	}

}

System::Void bre20::DevPage::maxpressbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int limit = 0;// = ((RomRep::VT0Ecu*)rom)->getRevlimit();
	int newrpm = ParamPage::getBoxVal(maxpressbox);

	if(limit == newrpm)
		return;
	if(newrpm<1000)
	{
		maxpressbox->Text = limit.ToString();
		return;
	}

//	((RomRep::VT0Ecu*)rom)->setRevlimit(newrpm);
//	limit = ((RomRep::VT0Ecu*)rom)->getRevlimit();
	maxpressbox->Text = limit.ToString();
}

//needs to 
System::Void bre20::DevPage::grid_CellChanged(System::Object *  sender, SimpleGrid::CellEvent *  e)
{
	int lnac = honecu->getLastNaCol();

//	MessageBox::Show(S"Hello!");
	int x = e->Column;
	int y = e->Row;

	if(x == grid->GridSize.Width-1 || x == 0)
	{	
		String *s = honecu->getColHeader(0,0,x);
		if(x == 0)
			grid->setValue(x,y,Convert::ToInt32(s));
		else if(s->Length>6)
			grid->setValue(x,y,Convert::ToSingle(s->Substring(0,s->Length-3)));
		else
			grid->setValue(x,y,Convert::ToSingle(s));
		MessageBox::Show(S"You can't change the first or last pressure values. They are 'set in stone' for now.", "BRE");
		return;
	}

	int val = grid->getIntValue(x,y);
	
	if(val == 0 && x<=lnac)
	{	
		grid->setValue(x,y,Convert::ToInt32(honecu->getColHeader(0,0,x)));
		MessageBox::Show(S"Value must be integer for NA values");
		return;
	}

	float psi = 0.0;
	float left = 0.0;
	float right = 0.0;
	if(x>lnac) //we have float
	{
		if(x>lnac+1)
			left = grid->getValue(x-1,y);
		
		right = grid->getValue(x+1,y);
		psi = grid->getValue(x,y);

	//	MessageBox::Show(String::Concat(left.ToString(),psi.ToString(),right.ToString()));
		if(psi>left && psi<right)
		{
			//broken
//			psi = RomRep::DevUtil::setPressureVal(x,psi+.01F, honecu);
			(static_cast<child*>(this->Parent->Parent))->changeColHeader(true,x,psi.ToString("0.00"));
		}
		grid->setValue(x,y,Convert::ToSingle(honecu->getColHeader(0,0,x)));
	}
	else //int
	{
		float left = grid->getValue(x-1,y);
		if(x<lnac)	
			float right = grid->getValue(x+1,y);
		psi = grid->getValue(x,y);
	//	MessageBox::Show(String::Concat(S"int: ",left.ToString(),psi.ToString(),right.ToString()));
		if(psi<left && psi>right)
		{
			//broken
//			val = RomRep::DevUtil::setPressureVal(x,val, honecu);
			(static_cast<child*>(this->Parent->Parent))->changeColHeader(true,x,val.ToString());
		}
		grid->setValue(x,y,Convert::ToInt32(honecu->getColHeader(0,0,x)));
	}
}