#include "StdAfx.h"
#include "Obd0Logger.h"
#include "Obd0vtecLogger.h"

bre20::Obd0Logger::Obd0Logger(child * romm):bre20::DataLogForm(S"rpm,speed,tps,map,x,y,afr",romm)
{
	na = true;
	divisions = 5;
	realtick = 0;
	iteration = 0;

	textLog = new DataLogger();
	tabControl1->Controls->Add(textLog);

	if(!na)
	{
		gridLog = new LogGridPage(21,17);
		title = new String(S"OBD0 NG Turbo Logger");
	}
	else
	{	
		gridLog = new LogGridPage();
		title = new String(S"OBD0 NG Logger");
	}

	setHeaders();

	tabControl1->Controls->Add(gridLog);
	this->Text = title;

//	port = 5;
	baudrate = 38400;
	parity = 0; //0 for none, 1 for odd, 2 for even
}



void bre20::Obd0Logger::runDL()
{
	int value, value1, rpm;
//	unsigned char bytes __gc[];
	String* str;

	int rpmscale[] = {500,600,700,800,900,1100,1300,1600,1900,2200,2600,3100,3700,4400,5300,6300,7400};

//	rpm,speed,tps,map,x,y,afr

	
//;-38400 Baud
//;-Uses the "old" send the byte you want to recieve, wait for response protocol 
//;-Safely stores RPMLO byte corresponding to the RPMHI (047h) byte requested in RAM 0FAh. 
//;-Proper sequence to log RPM is to send 047h (high byte) followed by 0FAh to retrieve low byte. 
//;-Able to log raw O2 sensor signal by using command 0FBh 
//;-Able to log raw ELD sensor signal by using command 0FCh 
//;-Able to log raw MAP sensor signal by using command 0F8h 
//;-Able to log "stocklike" MAP sensor signal by using command 036h 
//;-Able to log "remapped" MAP boost table reference using command 0F9h 
//;-Able to log VSS using command 06Ch 
//;-Able to log TPS using 039h / 03Ah 
//;-Able to log Barometric pressure using 034h 
//;-Able to log IAT using 032h 
//;-Able to log ECT using 030h 
//;-Able to log any codes that the ECU is throwing by logging bytes 02Bh, 02Ch, 02Dh. */
//
//TBL_COL			EQU	0FDH		;Column of table	}fuel/ign indexing
//TBL_ROW			EQU	0FEH		;Row of table		}

	unsigned char commands __gc[] = new unsigned char __gc[1];//{0x47,0xfa,0x6c,0x39,0xf8,0xfd,0xfe,0xfb};

//	commands = comport->sendBlock1b(commands);

//	if(commands == NULL)
//	{
//		start_Click(NULL,NULL);
//		return;
//	}

	//***rpm
	commands[0] = 0x47;
	value1 = comport->sendBlock1b(commands)[0];//commands[0];//txAndRx(0x47, 100);//should be rpmhigh
	commands[0] = 0xfa;
	value = comport->sendBlock1b(commands)[0];//commands[1];//txAndRx(0xfa, 100);//should be rpmlow

	value = value + (256*value1);
	rpm = 1920000/value;
	str = rpm.ToString();
	textLog->setRpm(str);
	if(tofile)
		logout->Write(String::Concat(str,S","));
	//***

	//**speed 2 byte test
	commands[0] = 0x6c;
	value = comport->sendBlock1b(commands)[0];//commands[2];//txAndRx(0x6c, 100);
//	value = System::Convert::ToInt32(bytes[0]);
//	value1 = System::Convert::ToInt32(bytes[1]);

//	value = 2.7*(65535/(256*value+value1)-1);
	str = value.ToString();
	textLog->setSpeed(str);
	if(tofile)
		logout->Write(String::Concat(str,S","));
	//**

	//**tps
	commands[0] = 0x39;
	value = comport->sendBlock1b(commands)[0];//commands[3];//txAndRx(0x39, 100);//should be tps
	value = (value-50)/2;
	str = value.ToString();
	textLog->setTps(str);
	if(tofile)
		logout->Write(String::Concat(str,S","));
	//**

	//**map
	commands[0] = 0xf8;
	value = comport->sendBlock1b(commands)[0];//commands[4];//txAndRx(0xf8, 100);//should be map
	str = value.ToString();
	textLog->setMap(str);
	if(tofile)
		logout->Write(String::Concat(str,S","));
//	float map = ((float)value/255.0)*2.85; //voltage
	//**

	//**cell
	//if(value>=0x70)
	//	value+=0x40;
	//else
	//	value = value*2 -0x30;

	//value = value/16;
	//
	//if(value<0)
	//	value = 0;
	//if(value>13)
	//	value = 13;

	//TBL_COL			EQU	0FDH		;Column of table	}fuel/ign indexing
	//TBL_ROW			EQU	0FEH		;Row of table		}

//	value/=16;

	//**map trace
	commands[0] = 0xfd;
	value = comport->sendBlock1b(commands)[0];//commands[5];//txAndRx(0xfd, 100);//should be x
	commands[0] = 0xfe;
	value1 = comport->sendBlock1b(commands)[0];//commands[6];//txAndRx(0xfe, 100);//should be y
	str = value.ToString();
	String* str1 = value1.ToString();
	gridLog->setSelection(value,value1,2,2);
	if(tofile)
		logout->Write(String::Concat(str,S",",str1,","));
	//**
	
	//***afr
	commands[0] = 0xfb;
	float afr = pickO2(comport->sendBlock1b(commands)[0]);//commands[0]);
	str = afr.ToString();
	textLog->setCell(str);
	if(tofile)
		logout->Write(String::Concat(str,S""));
	
	//**


	if(tofile)
	{
		logout->WriteLine();
		logout->Flush();
	}
}

void bre20::Obd0Logger::runReplay()
{
	if(iteration == 0)
	{
		curline = nextline;
		nextline = replayin->ReadLine();
	}

	Char delim[] = {','};
//rpm,speed,tps,map,x,y
	if(nextline != NULL && !nextline->Equals(S""))
	{
		
		int value;

		String* token[] = curline->Split(delim);
		String* tokennext[] = nextline->Split(delim);

		value = getAverage(token[0],tokennext[0]);
		textLog->setRpm(value.ToString());
	
		value = getAverage(token[1],tokennext[1]);
		textLog->setSpeed(value.ToString());

		value = getAverage(token[2],tokennext[2]);
		textLog->setTps(value.ToString());

		value = getAverage(token[3],tokennext[3]);
		textLog->setMap(value.ToString());

		textLog->setCell(String::Concat(token[4],S" , ",token[5]));
		int c = System::Convert::ToInt32(token[4]);
		int r = System::Convert::ToInt32(token[5]);
		gridLog->setSelection(c,r,2,2);

		if(token->Length>6)
		{
		if(maptracetype == DatalogOptions::AFRTRACE)
			gridLog->setValue(c,r,System::Convert::ToSingle(token[6]));
		}
		
	}
	else
	{
		
		clickStart(); //stop
		replayin->Close();
		replayin = new StreamReader(fname);
		timer1->Interval = System::Convert::ToInt32(replayin->ReadLine());
		replayin->ReadLine();

		iteration = 0;
	}

	iteration++;
	if(iteration>=5)
		iteration = 0;
}

void bre20::Obd0Logger::logStart()
{
	setHeaders();
	if(replay)
	{
		realtick = timer1->Interval;
		timer1->Interval = realtick/divisions;

		nextline = replayin->ReadLine();
	}
}
void bre20::Obd0Logger::logStop()
{
	if(replay)
		timer1->Interval = realtick;
}

int bre20::Obd0Logger::getAverage(String * s,String * s2)
{
	int curportion = divisions-iteration;
	int value = System::Convert::ToInt32(s)*curportion;
	value = (value + System::Convert::ToInt32(s2)*iteration)/divisions;

	return value;
}
