#include "StdAfx.h"
#include "Obd0VtecLogger.h"

bre20::Vt0Logger::Vt0Logger(child * romm):bre20::DataLogForm(S"rpm,speed,tps,map,map image no correction,map image,test1,test2,vtec,x,y,pri o2,sec o2,final ign,final fuel,y fuel interpolation,y ign interpolation",romm)
{
	na = true;
	init();
}

bre20::Vt0Logger::Vt0Logger(bool NA,child * romm):bre20::DataLogForm(S"rpm,speed,tps,map,map image no correction,map image,test1,test2,vtec,x,y,pri o2,sec o2,final ign,final fuel,y fuel interpolation,y ign interpolation",romm)//S"rpm,speed,tps,map,b3h,b4h,b2h,b5h,vtec,x,y,b4h"
{
	na = NA;
	init();
}
void bre20::Vt0Logger::init()
{
	divisions = 5;
	realtick = 0;
	iteration = 0;

	textLog = new Vt0LogPage();
	tabControl1->Controls->Add(textLog);

	dash = new DigiDash();
	tabControl1->Controls->Add(dash);


	if(!na)
	{
		gridLog = new LogGridPage(rom->getRom()->getWidth(),rom->getRom()->getHeight());
		title = new String(S"OBD0 Vtec Turbo Logger");
	}
	else
	{	
		gridLog = new LogGridPage();
		title = new String(S"OBD0 Vtec Logger");
	}
	gridLog->clearGrid();
	setHeaders();

	tabControl1->Controls->Add(gridLog);
	this->Text = title;

//	port = 5;
	baudrate = 19200;
	parity = 1; //0 for none, 1 for odd, 2 for even

	this->Size = System::Drawing::Size(70 + (gridLog->getColumns()*40), 150+(gridLog->getRows()*17));

}
String * bre20::Vt0Logger::intToBin(int num)
{
	int val = num;
	String * result = new String(S"");

	if(num <= 0 || num>255)
		return S"00000000";

	while(val > 0)
	{
		int mod = val%2;
		if(mod == 0)
			result = String::Concat(S"0",result);
		if(mod ==1)
			result = String::Concat(S"1",result);
		val/=2;
	}

	val = result->Length;
	val = 8 - val; //num of zeros

	for(int i = 0; i<val; i++)
		result = String::Concat(S"0",result);

	return result;
}

void bre20::Vt0Logger::runDL()
{
	int value, value1, value2;
	String * str;
	String * str1;
//	unsigned char bytes __gc[];

//	rpm,speed,tps,map,178h|179h,17ah|17bh,9eh,9fh,vtec,x,y

	unsigned char commands __gc[] = {0x1a,0x16,0x17,0x1f,0x15,0x14,0x20,0x1b,0x12,0x13,
		0x18,0x25,0x27,0x23,0x24,0x22,0x21,0x29,0x2a};

	commands = comport->sendBlock1b(commands);

	if(commands == NULL)
	{
		clickStart();
		return;
	}

//	value1 = txAndRx(0x1a, 100);//
	//**rpm
	value = commands[1];//txAndRx(0x16, 100);
	value1 = commands[2];//txAndRx(0x17, 100); //high byte
	value = value + (256*value1);
	value = (1852000/value)-50;
	str = value.ToString();
	textLog->setRpm(str);
	dash->setRpm((float)value);
	if(tofile)
		logout->Write(String::Concat(str,S","));
	//**

	//**speed
	value = commands[3];//txAndRx(0x1f, 100);//speed is 1fh

	str = value.ToString();
	textLog->setSpeed(str);
	dash->setSpeed((float)value);
	if(tofile)
		logout->Write(String::Concat(str,S","));
	//**

	//**tps
	value = commands[4];//txAndRx(0x15, 150);//should be tps

	//value = (value-50)/2;
	//
	//if(value<0)
	//	value = 0;
	//if(value>100)
	//	value = 100;
	str = value.ToString();
	textLog->setTps(str);
	dash->setTps((float)value);
	if(tofile)
		logout->Write(String::Concat(str,S","));
	//**

	//**map
	value = commands[5];//txAndRx(0x14, 150);//should be map

	str = value.ToString();
	textLog->setMap(str);
	dash->setMap((float)value);
	if(tofile)
		logout->Write(String::Concat(str,S","));
	//**

	//**calculated map values
	value = commands[6];//txAndRx(0x20, 100);//should be map image b3h

	value2 = commands[7];//txAndRx(0x1b, 100); //b4h

	if(na)
		curcol = value2/16;

	colinterp = value2%16;

	str = value.ToString();
	str1 = value2.ToString();
	textLog->setMapImage(String::Concat(str,S" | ",str1));
	if(tofile)
		logout->Write(String::Concat(str,S",",str1,S","));
	//**

	//**map related stuff
	value = commands[8];//txAndRx(0x12, 100); //b2h
	value1 = commands[9];//txAndRx(0x13, 100); //b5h

	if(!na)
		curcol = value1;

	str = value.ToString();
	str1 = value1.ToString();
	textLog->setKnock(String::Concat(str,S" | ",str1));
	if(tofile)
		logout->Write(String::Concat(str,S",",str1,S","));
	//**

	//**vtec
	value = commands[10];//txAndRx(0x18, 100); //vtec
	str = intToBin(value);
	textLog->setVtec(str);
	if(tofile)
		logout->Write(String::Concat(str,S","));

	if(value >= 128)
		curvtec = true;
	else
		curvtec = false;
	//**

	//**map trace/cell position

	
	value = curcol; //column

	value1 = currow = commands[11];//txAndRx(0x25, 100); //row
	str = value.ToString();
	str1 = value1.ToString();
	int r = value1,c = value;
	textLog->setCell(c,r);
	gridLog->setSelection(c,r,2,2);
	if(tofile)
	{
		logout->Write(String::Concat(str,S",",str1,S","));
		logout->Flush();
	}
	//**


	//**o2 sensors
	
	value = commands[12];//txAndRx(0x27, 100);//primary
	str = value.ToString();
	textLog->setPrimaryO2(str);

	this->afr = pickO2(commands[13]);


	if(maptracetype == DatalogOptions::AFRTRACE)
		gridLog->setValue(c,r,afr);

	str1 = afr.ToString();
	textLog->setSecondaryO2(str1);

	if(tofile)
	{
		logout->Write(String::Concat(str,S",",str1,S","));
		logout->Flush();
	}
	//**

	//***ignition val
	value = commands[14];//txAndRx(0x24, 100);//final ignition value
//	float ign = (((float)value - 15.0) * 9.0) / 25.0;
//	str = ign.ToString(S"0.00");
	str = value.ToString();
	//****

	//***fuel val
	value1 = commands[15];//txAndRx(0x22, 100);//final fuel value
	value1 = value1*256 + commands[16];//txAndRx(0x21, 100);
	str1 = value1.ToString();
	//****
	
	if(tofile)
	{
		logout->Write(String::Concat(str,S",",str1,S","));
		logout->Flush();
	}

	//***fuel interp val
	value = this->rowinterp = commands[17];//txAndRx(0x29, 100);//fuel row interp
	str = value.ToString();
	//****

	//***ignition interp val
	value = commands[18];//txAndRx(0x2a, 100);//ign row interp
	str1 = value.ToString();
	//****

	if(tofile)
	{
		logout->WriteLine(String::Concat(str,S",",str1));
		logout->Flush();
	}
//	value = txAndRx(0x19, 100) * 32.5;//should be a6h
//	value1 = txAndRx(0x1a, 100) * 34.5;//should be a7h
//	value = (4096 / txAndRx(0x10, 100)* (9/5) +32);//should be ect

	DataLogForm::runDL();
}



void bre20::Vt0Logger::runReplay()
{

	if(iteration == 0)
	{
		curline = nextline;
		nextline = replayin->ReadLine();
	}
	Char delim[] = {','};
//rpm,speed,tps,map,179h178h,17bh17ah,9eh,9fh,vtec,x,y
	if(nextline != NULL && !nextline->Equals(S""))
	{
		try
		{
			String* token[] = curline->Split(delim);
			String* tokennext[] = nextline->Split(delim);

			int value = getAverage(token[0],tokennext[0]);
			textLog->setRpm(value.ToString());
			dash->setRpm((float)value);

			value = getAverage(token[1],tokennext[1]);
			textLog->setSpeed(value.ToString());
			dash->setSpeed((float)value);

			value = getAverage(token[2],tokennext[2]);
			textLog->setTps(value.ToString());
			dash->setTps((float)value);

			value = getAverage(token[3],tokennext[3]);
			textLog->setMap(value.ToString());
			dash->setMap((float)value);


			textLog->setMapImage(String::Concat(token[4],S" | ",token[5]));
			textLog->setKnock(String::Concat(token[6],S" | ",token[7]));
			textLog->setVtec(token[8]);
			textLog->setCell(String::Concat(token[9],S" , ",token[10]));
			gridLog->setSelection(System::Convert::ToInt32(token[9]),System::Convert::ToInt32(token[10]),2,2);

			if(token->Length > 12)//this means we have o2 sensor data
			{
				value = getAverage(token[11],tokennext[11]);
				textLog->setPrimaryO2(value.ToString());

				//secondary
				float val = getAverageD(token[12],tokennext[12]);
				textLog->setSecondaryO2(val.ToString());

				if(maptracetype == DatalogOptions::AFRTRACE)
					gridLog->setValue(System::Convert::ToInt32(token[9]),System::Convert::ToInt32(token[10]),val);
			}
		}
		catch(...)
		{
		}
		
	}
	else
	{
		
		clickStart(); //stop
		replayin->Close();
		replayin = new StreamReader(fname);
		timer1->Interval = readInterval(replayin);
	//	String* s = replayin->ReadLine();
	//	Char delim[] = {','};
	//	timer1->Interval = System::Convert::ToInt32(s->Split(delim)[0]);
		replayin->ReadLine();

		iteration = 0;
	}
	iteration++;
	if(iteration>=5)
		iteration = 0;
}

void bre20::Vt0Logger::logStart()
{
	setHeaders();
	if(replay)
	{
		realtick = timer1->Interval;
		timer1->Interval = realtick/divisions;

		nextline = replayin->ReadLine();
	}
}

void bre20::Vt0Logger::logStop()
{
	if(replay)
		timer1->Interval = realtick;
}

int bre20::Vt0Logger::getAverage(String * s,String * s2)
{
	int value = 0;
	int curportion = divisions-iteration;
	try
	{
		value = System::Convert::ToInt32(s)*curportion;
		value = (value + System::Convert::ToInt32(s2)*iteration)/divisions;
	}
	catch(...)
	{
	}
	return value;
}

float bre20::Vt0Logger::getAverageD(String * s,String * s2)
{
	float val = -1.0;
	int curportion = divisions-iteration;
	try
	{
		val = System::Convert::ToSingle(s)*(float)curportion;
		val = (val + System::Convert::ToSingle(s2)*(float)iteration)/(float)divisions;
	}
	catch(...)
	{
	}
	return val;
}