#include "stdafx.h"
#include "DevMaps.h"
#include "obd0vtececu.h"
#include "devutil.h"

RomRep::DevHeaderCalculator::DevHeaderCalculator(Object* map, Object* hondaecu) : HeaderCalculator(map,hondaecu){}

bool RomRep::DevHeaderCalculator::canEditHeader(bool column, int columnOrRow){
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	return RomRep::DevUtil::canEditHeader(fil, column, columnOrRow); 
}

RomRep::MapHeaderChangeArgs* RomRep::DevHeaderCalculator::calculateHeaders(bool col, int columnOrRow)
{
	if(!col || columnOrRow != RomRep::Map::HEADER_EVENT_ALL)
		return NULL;

	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);

	int maxmapadd = 0;
	int mode = map->getMode();
	if(mode == Map::MODE_FUEL)
		maxmapadd = static_cast<DevFuelMap*>(map)->getMaxMapAddress();
	else if(mode == Map::MODE_IGNITION)
		maxmapadd = static_cast<DevIgnMap*>(map)->getMaxMapAddress();

	String* headers[];

	//we are going to recalculate All the headers all the time.
	headers = RomRep::DevUtil::calcHeaders(fil[maxmapadd],fil);

	return new MapHeaderChangeArgs(RomRep::Map::HEADER_EVENT_ALL,RomRep::Map::HEADER_EVENT_NONE,headers);
}
float RomRep::DevHeaderCalculator::getReferenceArray() __gc[]
{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);

	int maxmapadd = 0;
	int mode = map->getMode();
	if(mode == Map::MODE_FUEL)
		maxmapadd = static_cast<DevFuelMap*>(map)->getMaxMapAddress();
	else if(mode == Map::MODE_IGNITION)
		maxmapadd = static_cast<DevIgnMap*>(map)->getMaxMapAddress();

	//we are going to recalculate All the headers all the time.
	int inth __gc[] = RomRep::DevUtil::getRawHeaders(fil[maxmapadd],fil);
	int len = inth->Length;
	float f __gc[] = new float __gc[len];
	for(int i = 0; i< len; i++)
		f[i] = (float)inth[i];
	return f;
}

RomRep::MapHeaderChangeArgs* RomRep::DevHeaderCalculator::byteChangeNotify(ByteChange* bc)
{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);
	int maxmapadd = 0;
	int mode = map->getMode();
	if(mode == Map::MODE_FUEL)
		maxmapadd = static_cast<DevFuelMap*>(map)->getMaxMapAddress();
	else if(mode == Map::MODE_IGNITION)
		maxmapadd = static_cast<DevIgnMap*>(map)->getMaxMapAddress();

	return DevUtil::devNotify(bc,fil,maxmapadd);
}

RomRep::ByteChange* RomRep::DevHeaderCalculator::setColumnHeader(int col, String* val)[]
{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	ByteChange* bc[] = new ByteChange*[1];
	bc[0] = RomRep::DevUtil::setHeader(true,col,val,fil);
	return bc;
}
///////***********************************************************************************

RomRep::DevIgnMap::DevIgnMap(int x1, int y1, unsigned int loc, unsigned char themap __gc[,], 
							 unsigned char fil __gc[], int maxmapadd, int rscalarloc, int ind, 
							 int mod):VT0IgnMap(false,x1,y1,loc,themap,fil,
							 DevUtil::mapscalarloc,rscalarloc,ind,mod)
{
    this->maxmapadd = maxmapadd;
}
////*********************************************
////*********************************************
////*********************************************
////*********************************************

RomRep::DevFuelMap::DevFuelMap(int x1, int y1,unsigned int loc, unsigned char themap __gc[,], 
							   unsigned int multloc1, unsigned char mltarray __gc[], 
							   unsigned char fil __gc[], int maxmapadd, int rscalarloc, 
							   int ind, int mod):
								VT0FuelMap(false,x1,y1,loc,themap,multloc1,mltarray,
									fil,DevUtil::mapscalarloc,rscalarloc,ind,mod)
{
	this->maxmapadd = maxmapadd;
}