#pragma once
using namespace System;

#include "obd0maps.h"
#include "obd0vtecmaps.h"
#include "devutil.h"

namespace RomRep
{
	///see HeaderCalculator
	public __gc class DevHeaderCalculator: public HeaderCalculator
	{
	public:
		DevHeaderCalculator(Object* map, Object* hondaecu);
		virtual bool canEditHeader(bool column, int columnOrRow);
		virtual RomRep::MapHeaderChangeArgs* calculateHeaders(bool col, int columnOrRow);
		virtual RomRep::MapHeaderChangeArgs* byteChangeNotify(ByteChange* bc);
		virtual RomRep::ByteChange* setColumnHeader(int col, String* val)[];
		virtual float getReferenceArray() __gc[];
	};

	[Serializable] public __gc class DevIgnMap : public RomRep::VT0IgnMap
	{
	private:
		int maxmapadd;
	public:
		
		DevIgnMap(int x, int y, unsigned int loc, unsigned char themap __gc[,], 
			unsigned char fil __gc[], int maxmapadd, int rscalarloc, int ind, int mod);

		int getMaxMapAddress(){return maxmapadd;};
	};

	[Serializable] public __gc class DevFuelMap : public RomRep::VT0FuelMap
	{
	private:
		int maxmapadd;
	public:
		
		DevFuelMap(int x, int y,unsigned int loc, unsigned char themap __gc[,], 
			unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[],
			int maxmapadd, int rowScalarLoc, int ind, int mod);

		int getMaxMapAddress(){return maxmapadd;};
	};
}