#pragma once
using namespace System;

#include "obd0maps.h"
#include "obd0vtecmaps.h"
#include "devutil.h"

namespace RomRep
{
	[Serializable] public __gc class DevIgnMap : public RomRep::VT0IgnMap
	{
	private:
		int maxmapadd;
	public:
		
		DevIgnMap(int x, int y, unsigned int loc, unsigned char themap __gc[,], 
			unsigned char fil __gc[], int maxmapadd, int rscalarloc, int ind, int mod);

		///Sets the header text for the specified column
		virtual void setColumnHeader(int col, String* val);

		virtual bool canEditHeader(bool column, int columnOrRow)
		{ return RomRep::DevUtil::canEditHeader(thefile, column, columnOrRow); }

		virtual void byteChangeNotify(ByteChange* bc){ 
			RomRep::Obd0IgnMap::byteChangeNotify(bc);
			int col = DevUtil::devNotify(bc,thefile,vac,maxmapadd);
			if(col == Map::HEADER_EVENT_ALL)
				MapHeaderChanged(Map::HEADER_EVENT_ALL,-1,vac);
			else if(col != Map::HEADER_EVENT_NONE){
				String* noo[] = new String*[1];
				noo[0] = vac[col];
				MapHeaderChanged(col,-1,noo);
			}
		};
	};

	[Serializable] public __gc class DevFuelMap : public RomRep::VT0FuelMap
	{
	private:
		int maxmapadd;
	public:
		
		DevFuelMap(int x, int y,unsigned int loc, unsigned char themap __gc[,], 
			unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[],
			int maxmapadd, int rowScalarLoc, int ind, int mod);

		///Sets the header text for the specified column
		virtual void setColumnHeader(int col, String* val);

		virtual bool canEditHeader(bool column, int columnOrRow)
		{ return RomRep::DevUtil::canEditHeader(thefile, column, columnOrRow); }		

		virtual void byteChangeNotify(ByteChange* bc){ 
			RomRep::Obd0FuelMap::byteChangeNotify(bc);
			int col = DevUtil::devNotify(bc,thefile,vac,maxmapadd);
			if(col == Map::HEADER_EVENT_ALL)
				MapHeaderChanged(Map::HEADER_EVENT_ALL,-1,vac);
			else if(col != Map::HEADER_EVENT_NONE){
				String* noo[] = new String*[1];
				noo[0] = vac[col];
				MapHeaderChanged(col,-1,noo);
			}
		};
	};
}