#include "stdafx.h"
#include "devUtil.h"
#include "obd0vtececu.h"
#include "obd0vtecmaps.h"

//editor must make sure that the pressure value is between the 
//previous and next column's values

void RomRep::DevUtil::recalcPressureHeaders(int mapsensor, HondaEcu* f)
{
	
	int lastNACol = f->getLastNaCol();
//	String * colhead [,] = f->getColHeaders();

	unsigned char file __gc[] = f->getFile();

	int xover = (int)(getXOver(mapsensor)*255.0/5.0);
	int val;
	int x = getRomWidth(file);
	
//	setMapSensor(f,mapsensor);
	int i;
	for(i = 0; i<= lastNACol; i++)
	{
		int sptr = mapscalarloc + 6 + (x-2-i)*3;
		val = (i*xover)/lastNACol;
		if(val >= xover)
			val = xover-3;
		file[sptr] = val;
	
	//	float volts = Engine::rawToVolts(val);
	//	int vac = Engine::voltsToInHg(volts,mapsensor);
	//	colhead[0,i] = vac.ToString();
	//	colhead[1,i] = vac.ToString();//Engine::toStr(vac);
	}
	for(; i<getRomWidth(file); i++)
	{
		int deltaR = 255-xover;
		int bcolumn = i- (lastNACol+1);
		int numcolumn = getRomWidth(file) - (lastNACol+2);

		int sptr = mapscalarloc + 6 + (x-2-i)*3;
		val = ((deltaR*bcolumn)/numcolumn) + xover;
		if(val <= xover)
			val = xover+1;
		else if(val>255)
			val = 255;
		file[sptr] = val;
	
	//	float volts = Engine::rawToVolts(val);
	//	float vac = Engine::voltsToPsi(volts,mapsensor);
	//	colhead[0,i] = vac.ToString("0.00");
	//	colhead[1,i] = vac.ToString("0.00");//Engine::toStr(vac);

	}
	setMapSensor(f,mapsensor);
}

//****************

void RomRep::DevUtil::calcHeaders(int maxmap, unsigned char thefile __gc[], String* colheaders[])
{
	int lastNACol = DevUtil::findLastNACol(thefile);

	int x = DevUtil::getRomWidth(thefile);
	int y = DevUtil::getRomHeight(thefile);

	//column headers...
	int natoboost = (int)(DevUtil::getXOver(DevUtil::getMapSensor(thefile))*255.0/5.0);// = 146; 
	//float xovervolts = 3.0; // = 2.85;

	float volts = Engine::rawToVolts(maxmap);
	if(maxmap<natoboost)//calc inches of mercury. vacuum, y0
	{
		
		int inhg = Engine::voltsToInHg(volts,DevUtil::getMapSensor(thefile));//(int)((volts - xovervolts) / (-.1));
		String * s = inhg.ToString();
		colheaders[x-1] = s;
	}
	else //boost in psi
	{
		//2.85 volts with key on engine off and 4.5xx volts at 10.6 psi
		//psi = (v - 2.85)/.1557;
		float psi = Engine::voltsToPsi(volts,DevUtil::getMapSensor(thefile));//(volts - xovervolts)/.1557;
		String * s = psi.ToString("0.00");
		String * p = S"psi";
		s = String::Concat(s,p);
		colheaders[x-1] = s;
	}

	for(int i = x-2; i>=0; i--)
	{
		int sptr = mapscalarloc + 6 + (x-2-i)*3;
		int mapval = thefile[sptr];

		float volts = Engine::rawToVolts(mapval);
		String * s;
		
		if(mapval<natoboost)//calc inches of mercury. vacuum, y0
			s = Engine::voltsToInHg(volts,DevUtil::getMapSensor(thefile)).ToString();
		else //boost in psi
			s = Engine::voltsToPsi(volts,DevUtil::getMapSensor(thefile)).ToString("0.00");

		colheaders[i] = s;
	}

}

int RomRep::DevUtil::devNotify(RomRep::ByteChange* bc, unsigned char file __gc[],String* headers[], int maxmapadd)
{
	if(bc->getLocation() == DevUtil::mapsensorloc)
	{
		DevUtil::calcHeaders(file[maxmapadd],file,headers);
		return Map::HEADER_EVENT_ALL;
	}

	int x = DevUtil::getRomWidth(file);
	//find out if its ours
	if(bc->getLocation() < mapscalarloc || bc->getLocation() > x*3+mapscalarloc)
		return Map::HEADER_EVENT_NONE;

	int col = bc->getLocation() - mapscalarloc - 6;
	if(col%3 != 0)
		return Map::HEADER_EVENT_NONE;

	col = (col/(-3))+x-2; //find the column

	if(col > -1 && col<x-1)
	{
		int natoboost = (int)(DevUtil::getXOver(DevUtil::getMapSensor(file))*255.0/5.0);
		int b = (int)bc->getByte();
		float volts = Engine::rawToVolts(b);
		String * s;
		
		if(b<natoboost)//calc inches of mercury. vacuum, y0
			s = Engine::voltsToInHg(volts,DevUtil::getMapSensor(file)).ToString();
		else //boost in psi
			s = Engine::voltsToPsi(volts,DevUtil::getMapSensor(file)).ToString("0.00");

		headers[col] = s;

		return col;
	}

	return Map::HEADER_EVENT_NONE;
}

//****************

bool RomRep::DevUtil::canEditHeader(unsigned char file __gc[], bool column, int columnOrRow)
{
	if(!column)
		return false;

	if(columnOrRow > -1 && columnOrRow < RomRep::DevUtil::getRomWidth(file))
		return true;
	return false;
}

RomRep::ByteChange* RomRep::DevUtil::setHeader( bool column, int roworcol, String* val, unsigned char file __gc[], String* headers[])
{
	if(!column)
		return NULL;

	int lastNACol = DevUtil::findLastNACol(file);
	if(roworcol > lastNACol && roworcol < getRomWidth(file))
		return setPressureVal(roworcol,bre20::Common::extractDouble(val),file,headers);
	else if(roworcol >= 0 && roworcol <= lastNACol)
		return setPressureVal(roworcol,bre20::Common::extractInt(val),file,headers);
	else
		return NULL;
}

//need to make sure a neg pressure is not entered...
RomRep::ByteChange* RomRep::DevUtil::setPressureVal(int col, int inhg, unsigned char file __gc[], String* headers[])
{
	int x = getRomWidth(file);
	int sptr = mapscalarloc + 6 + (x-2-col)*3;
	int raw = Engine::inHgToRaw(inhg,getMapSensor(file));
	//file[sptr] = raw;
	RomRep::ByteChange* bc = new RomRep::ByteChange(sptr,(unsigned char) raw);
	
	float volts = Engine::rawToVolts(raw);
	int vac = Engine::voltsToInHg(volts,getMapSensor(file));
	headers[col] = vac.ToString();
	return bc;
	
}

//need to make sure a pos pressure is not entered...
RomRep::ByteChange* RomRep::DevUtil::setPressureVal(int col, float psi, unsigned char file __gc[], String* headers[])
{
	int x = getRomWidth(file);
	int sptr = mapscalarloc + 6 + (x-2-col)*3;
	int raw = Engine::psiToRaw(psi,getMapSensor(file));
	//file[sptr] = raw;
	RomRep::ByteChange* bc = new RomRep::ByteChange(sptr,(unsigned char) raw);

	float volts = Engine::rawToVolts(raw);
	float pres = Engine::voltsToPsi(volts,getMapSensor(file));
	headers[col] = pres.ToString("0.00");
	return bc;
}
int RomRep::DevUtil::findLastNACol(unsigned char file __gc[])
{
	int i,x = getRomWidth(file);
	int xover = (int)(getXOver(getMapSensor(file))*255.0/5.0);
	for(i = x-2; i>=0; i--)
	{
		int sptr = mapscalarloc + 6 + (x-2-i)*3;
		int mapval = file[sptr];

		if(mapval<xover)
			break;
		
	}
	return i;
}
int RomRep::DevUtil::getRomWidth(unsigned char file __gc[])
{
	return file[0x7ffc];

}
int RomRep::DevUtil::getRomHeight(unsigned char file __gc[])
{
	return file[0x7ffd];
}
//int RomRep::DevUtil::getRomWidth()
//{
//	return romfile[0x7ffc];
//
//}
//int RomRep::DevUtil::getRomHeight()
//{
//	return romfile[0x7ffd];
//}
//int RomRep::DevUtil::getMaxMapVal()
//{
//	return romfile[maxmapadd];
//}
int RomRep::DevUtil::getMapSensor(unsigned char file __gc[])
{
	//0 for stock
	//1 for 2 bar
	//2 for 2.5 bar
	//4 for motorola2.5 bar
	//3 for 3 bar

	int num = file[mapsensorloc];
	if(num>MAXMAPSENSOR)
		num = 0;
	return num;
}
void RomRep::DevUtil::setMapSensor(RomRep::HondaEcu* ecu,int num)
{
	ecu->setByte(DevUtil::mapsensorloc, num);
}
//int RomRep::DevUtil::getMapSensor()
//{
//	//0 for stock
//	//1 for 2 bar
//	//2 for 2.5 bar
//	//3 for 3 bar
//
//	return getMapSensor(romfile);
//}
//void RomRep::DevUtil::setMapSensor(int num)
//{
//	setMapSensor(romfile, num);
//	
//}