#include "StdAfx.h"
#include "DigiDash.h"

bre20::DigiDash::DigiDash(): TabPage()
{
	sae = true;

	this->Location = System::Drawing::Point(4, 22);
	this->Text = S"Digital Dash";

	this->tach = new Gauge::Gauge();
	this->speedo = new Gauge::Gauge();
	this->tps = new Gauge::Gauge();
	this->pressure = new Gauge::Gauge();

	this->Controls->Add(this->pressure);
	this->Controls->Add(this->tps);
	this->Controls->Add(this->speedo);
	this->Controls->Add(this->tach);

	// 
	// tach
	// 
	this->tach->CurrentValue = 0;
	this->tach->GaugeSize = System::Drawing::Size(200, 200);
	this->tach->Location = System::Drawing::Point(136, 32);
	this->tach->MaxValue = 8;
	this->tach->MinValue = 0;
	this->tach->Name = S"tach";
	this->tach->NumberDivisions = 8;
	this->tach->NumberIntermediateLines = 5;
	this->tach->NumberOfDecimals = 0;
	this->tach->Size = System::Drawing::Size(200, 200);
	this->tach->TabIndex = 0;
	this->tach->Title = S"RPM";
	this->tach->Units = S"x1000";
	// 
	// speedo
	// 
	this->speedo->CurrentValue = 0;
	this->speedo->GaugeSize = System::Drawing::Size(200, 200);
	this->speedo->Location = System::Drawing::Point(344, 32);
	this->speedo->Name = S"speedo";
	this->speedo->NumberIntermediateLines = 5;
	this->speedo->NumberOfDecimals = 0;
	this->speedo->Size = System::Drawing::Size(200, 200);
	this->speedo->TabIndex = 1;
	// 
	// tps
	// 
	this->tps->CurrentValue = 0;
	this->tps->GaugeSize = System::Drawing::Size(120, 120);
	this->tps->Location = System::Drawing::Point(8, 8);
	this->tps->MaxValue = 100;
	this->tps->MinValue = 0;
	this->tps->Name = S"tps";
	this->tps->NumberDivisions = 10;
	this->tps->NumberIntermediateLines = 5;
	this->tps->NumberOfDecimals = 0;
	this->tps->Size = System::Drawing::Size(120, 120);
	this->tps->TabIndex = 2;
	this->tps->Title = S"TPS";
	this->tps->Units = S"%";
	// 
	// pressure
	// 
	this->pressure->CurrentValue = 0;
	this->pressure->GaugeSize = System::Drawing::Size(120, 120);
	this->pressure->Location = System::Drawing::Point(8, 136);
	this->pressure->MaxValue = 160;
	this->pressure->MinValue = 0;
	this->pressure->Name = S"pressure";
	this->pressure->NumberDivisions = 8;
	this->pressure->NumberIntermediateLines = 5;
	this->pressure->NumberOfDecimals = 0;
	this->pressure->Size = System::Drawing::Size(120, 120);
	this->pressure->TabIndex = 3;
	this->pressure->Title = S"MAP";
	this->pressure->Units = S"Raw";

	makeSae();
}

void bre20::DigiDash::convertUnits(bool std)
{
	if(sae == std)
		return;

	if(std)
		makeSae();
	else
		makeMetric();

}

//changes the interface to be standard units
void bre20::DigiDash::makeSae()
{
	sae = true;
	// 
	// speedo
	// 
	speedconv = 0.4F;
	this->speedo->MaxValue = 130;
	this->speedo->MinValue = 0;
	this->speedo->NumberDivisions = 13;
	this->speedo->Title = S"Speed";
	this->speedo->Units = S"MPH";

}

//changes the interface to be metric units
void bre20::DigiDash::makeMetric()
{
	sae = false;
	// 
	// speedo
	// 
	speedconv = 0.6436F;
	this->speedo->MaxValue = 220;
	this->speedo->MinValue = 0;
	this->speedo->NumberDivisions = 11;
	this->speedo->Title = S"Speed";
	this->speedo->Units = S"KPH";
}