#pragma once

using namespace System;
using namespace System::Windows::Forms;


namespace bre20
{
	/// <summary> 
	/// tab page with a grid
	/// </summary>
	public __gc class DigiDash : public System::Windows::Forms::TabPage
	{

	public:
		DigiDash();
		~DigiDash(){};

		virtual void convertUnits(bool sae);
		virtual int getUnits()
		{
			if(sae) return 0;
			else	return 1;
		}

		virtual void setSpeed(float raw)
		{
			speedo->CurrentValue = raw*speedconv;
		}
		virtual void setMap(float raw)
		{
			pressure->CurrentValue = raw;
		}
		virtual void setRpm(float rpm)
		{
			tach->CurrentValue = rpm/1000.0F;
		}
		virtual void setTps(float raw)
		{
			float val = raw-20;
			if(val<0)
				val = 0;
			val = (val/207.0F)*100.0F;
			tps->CurrentValue = val;
		}


		private: Gauge::Gauge *  tach;
		private: Gauge::Gauge *  speedo;
		private: Gauge::Gauge *  tps;
		private: Gauge::Gauge *  pressure;

		

	protected:

		bool sae;
		float speedconv;

		virtual void makeSae();
		virtual void makeMetric();



	};

}