#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "dynorule.h"
#include "common.h"
#include "DynoParameters.h"

namespace bre20
{
	/// <summary> 
	/// Summary for DynoOptions
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class DynoOptions : public System::Windows::Forms::Form
	{
	public: 
		DynoOptions(DynoRule* rule);
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}

	private: System::Windows::Forms::GroupBox *  runGrp;
	private: System::Windows::Forms::Label *  colorBox;
	private: System::Windows::Forms::Label *  runColor;
	private: System::Windows::Forms::Button *  addRun;

	private: System::Windows::Forms::TabControl *  tabControl1;
	private: System::Windows::Forms::TabPage *  runData;
	private: System::Windows::Forms::Button *  applyBtn;
	private: System::Windows::Forms::Button *  okBtn;
	private: System::Windows::Forms::CheckedListBox *  runBox;
	private: System::Windows::Forms::Button *  deleteRun;

	private: System::Windows::Forms::CheckBox *  powerChk;
	private: System::Windows::Forms::TrackBar *  powerSlider;
	private: System::Windows::Forms::Label *  label1;
	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::TrackBar *  torqueSlider;
	private: System::Windows::Forms::CheckBox *  torqueChk;
	private: System::Windows::Forms::Label *  label3;
	private: System::Windows::Forms::TrackBar *  mixSlider;
	private: System::Windows::Forms::CheckBox *  mixChk;

	private:
		DynoRule* m_dyno;
		ArrayList* m_runs;
		DynoParameters* m_dynoparam;
	private: System::Windows::Forms::GroupBox *  graphGrp;
	private: System::Windows::Forms::Button *  btnCancel;

			 /// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->runBox = new System::Windows::Forms::CheckedListBox();
			this->runGrp = new System::Windows::Forms::GroupBox();
			this->deleteRun = new System::Windows::Forms::Button();
			this->addRun = new System::Windows::Forms::Button();
			this->runColor = new System::Windows::Forms::Label();
			this->colorBox = new System::Windows::Forms::Label();
			this->tabControl1 = new System::Windows::Forms::TabControl();
			this->runData = new System::Windows::Forms::TabPage();
			this->graphGrp = new System::Windows::Forms::GroupBox();
			this->label3 = new System::Windows::Forms::Label();
			this->mixSlider = new System::Windows::Forms::TrackBar();
			this->mixChk = new System::Windows::Forms::CheckBox();
			this->label2 = new System::Windows::Forms::Label();
			this->torqueSlider = new System::Windows::Forms::TrackBar();
			this->torqueChk = new System::Windows::Forms::CheckBox();
			this->label1 = new System::Windows::Forms::Label();
			this->powerSlider = new System::Windows::Forms::TrackBar();
			this->powerChk = new System::Windows::Forms::CheckBox();
			this->applyBtn = new System::Windows::Forms::Button();
			this->okBtn = new System::Windows::Forms::Button();
			this->btnCancel = new System::Windows::Forms::Button();
			this->runGrp->SuspendLayout();
			this->tabControl1->SuspendLayout();
			this->runData->SuspendLayout();
			this->graphGrp->SuspendLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->mixSlider))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->torqueSlider))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->powerSlider))->BeginInit();
			this->SuspendLayout();
			// 
			// runBox
			// 
			this->runBox->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->runBox->Location = System::Drawing::Point(16, 24);
			this->runBox->Name = S"runBox";
			this->runBox->Size = System::Drawing::Size(192, 139);
			this->runBox->TabIndex = 0;
			this->runBox->Click += new System::EventHandler(this, runBox_Click);
			this->runBox->SelectedIndexChanged += new System::EventHandler(this, runBox_SelectedIndexChanged);
			this->runBox->ItemCheck += new System::Windows::Forms::ItemCheckEventHandler(this, runBox_ItemCheck);
			// 
			// runGrp
			// 
			this->runGrp->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->runGrp->Controls->Add(this->deleteRun);
			this->runGrp->Controls->Add(this->addRun);
			this->runGrp->Controls->Add(this->runColor);
			this->runGrp->Controls->Add(this->runBox);
			this->runGrp->Controls->Add(this->colorBox);
			this->runGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->runGrp->Location = System::Drawing::Point(8, 8);
			this->runGrp->Name = S"runGrp";
			this->runGrp->Size = System::Drawing::Size(224, 240);
			this->runGrp->TabIndex = 1;
			this->runGrp->TabStop = false;
			this->runGrp->Text = S"Run options";
			// 
			// deleteRun
			// 
			this->deleteRun->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left);
			this->deleteRun->Enabled = false;
			this->deleteRun->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->deleteRun->Location = System::Drawing::Point(112, 176);
			this->deleteRun->Name = S"deleteRun";
			this->deleteRun->Size = System::Drawing::Size(96, 32);
			this->deleteRun->TabIndex = 5;
			this->deleteRun->Text = S"Delete Run";
			this->deleteRun->Click += new System::EventHandler(this, deleteRun_Click);
			// 
			// addRun
			// 
			this->addRun->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left);
			this->addRun->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->addRun->Location = System::Drawing::Point(16, 176);
			this->addRun->Name = S"addRun";
			this->addRun->Size = System::Drawing::Size(88, 32);
			this->addRun->TabIndex = 4;
			this->addRun->Text = S"Add Run";
			this->addRun->Click += new System::EventHandler(this, addRun_Click);
			// 
			// runColor
			// 
			this->runColor->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left);
			this->runColor->Enabled = false;
			this->runColor->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->runColor->Location = System::Drawing::Point(16, 216);
			this->runColor->Name = S"runColor";
			this->runColor->Size = System::Drawing::Size(64, 16);
			this->runColor->TabIndex = 3;
			this->runColor->Text = S"Run Color:";
			// 
			// colorBox
			// 
			this->colorBox->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left);
			this->colorBox->BackColor = System::Drawing::SystemColors::Control;
			this->colorBox->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->colorBox->Enabled = false;
			this->colorBox->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->colorBox->Location = System::Drawing::Point(80, 216);
			this->colorBox->Name = S"colorBox";
			this->colorBox->Size = System::Drawing::Size(16, 16);
			this->colorBox->TabIndex = 2;
			this->colorBox->DoubleClick += new System::EventHandler(this, colorBox_Click);
			// 
			// tabControl1
			// 
			this->tabControl1->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->tabControl1->Controls->Add(this->runData);
			this->tabControl1->Location = System::Drawing::Point(0, 0);
			this->tabControl1->Name = S"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(480, 288);
			this->tabControl1->TabIndex = 2;
			// 
			// runData
			// 
			this->runData->Controls->Add(this->graphGrp);
			this->runData->Controls->Add(this->runGrp);
			this->runData->Location = System::Drawing::Point(4, 22);
			this->runData->Name = S"runData";
			this->runData->Size = System::Drawing::Size(472, 262);
			this->runData->TabIndex = 0;
			this->runData->Text = S"Dyno Run Data";
			// 
			// graphGrp
			// 
			this->graphGrp->Anchor = (System::Windows::Forms::AnchorStyles)((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->graphGrp->Controls->Add(this->label3);
			this->graphGrp->Controls->Add(this->mixSlider);
			this->graphGrp->Controls->Add(this->mixChk);
			this->graphGrp->Controls->Add(this->label2);
			this->graphGrp->Controls->Add(this->torqueSlider);
			this->graphGrp->Controls->Add(this->torqueChk);
			this->graphGrp->Controls->Add(this->label1);
			this->graphGrp->Controls->Add(this->powerSlider);
			this->graphGrp->Controls->Add(this->powerChk);
			this->graphGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->graphGrp->Location = System::Drawing::Point(248, 8);
			this->graphGrp->Name = S"graphGrp";
			this->graphGrp->Size = System::Drawing::Size(216, 240);
			this->graphGrp->TabIndex = 2;
			this->graphGrp->TabStop = false;
			this->graphGrp->Text = S"Graph control";
			// 
			// label3
			// 
			this->label3->Location = System::Drawing::Point(128, 184);
			this->label3->Name = S"label3";
			this->label3->Size = System::Drawing::Size(48, 16);
			this->label3->TabIndex = 8;
			this->label3->Text = S"Opacity";
			// 
			// mixSlider
			// 
			this->mixSlider->Enabled = false;
			this->mixSlider->LargeChange = 20;
			this->mixSlider->Location = System::Drawing::Point(104, 160);
			this->mixSlider->Maximum = 255;
			this->mixSlider->Name = S"mixSlider";
			this->mixSlider->Size = System::Drawing::Size(88, 45);
			this->mixSlider->SmallChange = 5;
			this->mixSlider->TabIndex = 7;
			this->mixSlider->TickFrequency = 0;
			this->mixSlider->TickStyle = System::Windows::Forms::TickStyle::None;
			this->mixSlider->Scroll += new System::EventHandler(this, mixSlider_Scroll);
			// 
			// mixChk
			// 
			this->mixChk->Checked = true;
			this->mixChk->CheckState = System::Windows::Forms::CheckState::Checked;
			this->mixChk->Enabled = false;
			this->mixChk->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->mixChk->Location = System::Drawing::Point(24, 168);
			this->mixChk->Name = S"mixChk";
			this->mixChk->Size = System::Drawing::Size(80, 16);
			this->mixChk->TabIndex = 6;
			this->mixChk->Text = S"Mixture";
			this->mixChk->CheckedChanged += new System::EventHandler(this, mixChk_CheckedChanged);
			// 
			// label2
			// 
			this->label2->Location = System::Drawing::Point(128, 120);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(48, 16);
			this->label2->TabIndex = 5;
			this->label2->Text = S"Opacity";
			// 
			// torqueSlider
			// 
			this->torqueSlider->Enabled = false;
			this->torqueSlider->LargeChange = 20;
			this->torqueSlider->Location = System::Drawing::Point(104, 96);
			this->torqueSlider->Maximum = 255;
			this->torqueSlider->Name = S"torqueSlider";
			this->torqueSlider->Size = System::Drawing::Size(88, 45);
			this->torqueSlider->SmallChange = 5;
			this->torqueSlider->TabIndex = 4;
			this->torqueSlider->TickFrequency = 0;
			this->torqueSlider->TickStyle = System::Windows::Forms::TickStyle::None;
			this->torqueSlider->Scroll += new System::EventHandler(this, torqueSlider_Scroll);
			// 
			// torqueChk
			// 
			this->torqueChk->Checked = true;
			this->torqueChk->CheckState = System::Windows::Forms::CheckState::Checked;
			this->torqueChk->Enabled = false;
			this->torqueChk->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->torqueChk->Location = System::Drawing::Point(24, 104);
			this->torqueChk->Name = S"torqueChk";
			this->torqueChk->Size = System::Drawing::Size(80, 16);
			this->torqueChk->TabIndex = 3;
			this->torqueChk->Text = S"Torque";
			this->torqueChk->CheckedChanged += new System::EventHandler(this, torqueChk_CheckedChanged);
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(128, 56);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(48, 16);
			this->label1->TabIndex = 2;
			this->label1->Text = S"Opacity";
			// 
			// powerSlider
			// 
			this->powerSlider->Enabled = false;
			this->powerSlider->LargeChange = 20;
			this->powerSlider->Location = System::Drawing::Point(104, 32);
			this->powerSlider->Maximum = 255;
			this->powerSlider->Name = S"powerSlider";
			this->powerSlider->Size = System::Drawing::Size(88, 45);
			this->powerSlider->SmallChange = 5;
			this->powerSlider->TabIndex = 1;
			this->powerSlider->TickFrequency = 0;
			this->powerSlider->TickStyle = System::Windows::Forms::TickStyle::None;
			this->powerSlider->Scroll += new System::EventHandler(this, powerSlider_Scroll);
			// 
			// powerChk
			// 
			this->powerChk->Checked = true;
			this->powerChk->CheckState = System::Windows::Forms::CheckState::Checked;
			this->powerChk->Enabled = false;
			this->powerChk->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->powerChk->Location = System::Drawing::Point(24, 40);
			this->powerChk->Name = S"powerChk";
			this->powerChk->Size = System::Drawing::Size(80, 16);
			this->powerChk->TabIndex = 0;
			this->powerChk->Text = S"Power";
			this->powerChk->CheckedChanged += new System::EventHandler(this, powerChk_CheckedChanged);
			// 
			// applyBtn
			// 
			this->applyBtn->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right);
			this->applyBtn->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->applyBtn->Location = System::Drawing::Point(200, 296);
			this->applyBtn->Name = S"applyBtn";
			this->applyBtn->Size = System::Drawing::Size(80, 32);
			this->applyBtn->TabIndex = 3;
			this->applyBtn->Text = S"Apply";
			this->applyBtn->Click += new System::EventHandler(this, applyBtn_Click);
			// 
			// okBtn
			// 
			this->okBtn->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right);
			this->okBtn->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->okBtn->Location = System::Drawing::Point(392, 296);
			this->okBtn->Name = S"okBtn";
			this->okBtn->Size = System::Drawing::Size(80, 32);
			this->okBtn->TabIndex = 4;
			this->okBtn->Text = S"OK";
			this->okBtn->Click += new System::EventHandler(this, okBtn_Click);
			// 
			// btnCancel
			// 
			this->btnCancel->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right);
			this->btnCancel->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->btnCancel->Location = System::Drawing::Point(296, 296);
			this->btnCancel->Name = S"btnCancel";
			this->btnCancel->Size = System::Drawing::Size(80, 32);
			this->btnCancel->TabIndex = 5;
			this->btnCancel->Text = S"Cancel";
			this->btnCancel->Click += new System::EventHandler(this, btnCancel_Click);
			// 
			// DynoOptions
			// 
			this->AcceptButton = this->applyBtn;
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(480, 333);
			this->ControlBox = false;
			this->Controls->Add(this->btnCancel);
			this->Controls->Add(this->okBtn);
			this->Controls->Add(this->applyBtn);
			this->Controls->Add(this->tabControl1);
			this->Name = S"DynoOptions";
			this->Text = S"Analyzer Options";
			this->runGrp->ResumeLayout(false);
			this->tabControl1->ResumeLayout(false);
			this->runData->ResumeLayout(false);
			this->graphGrp->ResumeLayout(false);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->mixSlider))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->torqueSlider))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->powerSlider))->EndInit();
			this->ResumeLayout(false);

		}		
	private: 

		void changeRunVisibility(int graphIndex, bool show);
		void changeRunOpacity(int graphIndex, int opacity);

		void setRunDataEnable(bool enable);
		void getCurrentRunData();

		DynoLib::DynoRun* getRun(ArrayList* list, int index);
		void getRuns();

		void dyno_RunsChanged(Object* sender, DynoLib::RunsChangedArgs* args);
		void runBox_SelectedIndexChanged(System::Object *  sender, System::EventArgs *  e);
		void colorBox_Click(System::Object *  sender, System::EventArgs *  e);
		void applyBtn_Click(System::Object *  sender, System::EventArgs *  e);
		void okBtn_Click(System::Object *  sender, System::EventArgs *  e);
		void powerChk_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		void torqueChk_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		void mixChk_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		void powerSlider_Scroll(System::Object *  sender, System::EventArgs *  e);
		void torqueSlider_Scroll(System::Object *  sender, System::EventArgs *  e);
		void mixSlider_Scroll(System::Object *  sender, System::EventArgs *  e);
		void addRun_Click(System::Object *  sender, System::EventArgs *  e);
		void deleteRun_Click(System::Object *  sender, System::EventArgs *  e);
		void runBox_Click(System::Object *  sender, System::EventArgs *  e);
		void runBox_ItemCheck(System::Object *  sender, System::Windows::Forms::ItemCheckEventArgs *  e);
		void btnCancel_Click(System::Object *  sender, System::EventArgs *  e);

};
}