#include "stdafx.h"
#include "dynoparameters.h"

bre20::DynoParameters::DynoParameters()
{
	init();
	loadProperties();
}

void bre20::DynoParameters::loadProperties()
{
	this->txtArea->Text = Globals::Props->getFloatParam(S"dynFrontArea").ToString();
	this->txtDrag->Text = Globals::Props->getFloatParam(S"dynCd").ToString();
	this->txtFDR->Text = Globals::Props->getFloatParam(S"dynFDR").ToString();
	this->txtRatio->Text = Globals::Props->getFloatParam(S"dynGearRatio").ToString();
	this->txtTire->Text = Globals::Props->getFloatParam(S"dynTireHeight").ToString();
	this->txtWeight->Text = Globals::Props->getFloatParam(S"dynCarWeight").ToString();
	this->txtMinTps->Text = Globals::Props->getFloatParam(S"dynMinTps").ToString();

	String* str = Globals::Props->getParam(S"logUnits")->ToLower();
	if(str->Equals("sae"))
		changeUnits(true);
	else //if(str->Equals("metric"))
		changeUnits(false);
}
void bre20::DynoParameters::persistPreferences()
{
	Globals::Props->setParam(this,S"dynEnabled",this->dynoEnable->Checked.ToString());
	Globals::Props->setParam(this,S"dynCarWeight",this->txtWeight->Text);
	Globals::Props->setParam(this,S"dynGearRatio",this->txtRatio->Text);
	Globals::Props->setParam(this,S"dynFDR",this->txtFDR->Text);
	Globals::Props->setParam(this,S"dynTireHeight",this->txtTire->Text);
	Globals::Props->setParam(this,S"dynFrontArea",this->txtArea->Text);
	Globals::Props->setParam(this,S"dynCd",this->txtDrag->Text);
	Globals::Props->setParam(this,S"dynMinTps",this->txtMinTps->Text);
}
void bre20::DynoParameters::changeUnits(bool std)
{
	if(std)
	{
		this->unitLabFArea->Text = "cu.in.";
		this->unitLabTire->Text = "in.";
		this->unitLabWeight->Text = "lbs.";
	}
	else
	{
		this->unitLabFArea->Text = "cu.m";
		this->unitLabTire->Text = "m";
		this->unitLabWeight->Text = "kg";
	}
}
void bre20::DynoParameters::prop_Changed(Object * sender, bre20::PropertyEventArgs* e)
{
	if(e->getName()->Equals("logUnits"))
	{
		if(e->getValue()->ToLower()->Equals("metric"))
			changeUnits(false);
		else
			changeUnits(true);
	}
}
void bre20::DynoParameters::init()
{
	Globals::Props->add_OnPropertyChanged(new PropertyEventHandler(this,prop_Changed));

	this->dynGenGrp = new System::Windows::Forms::GroupBox();
	this->dynoEnable = new System::Windows::Forms::CheckBox();
	this->carParamGrp = new System::Windows::Forms::GroupBox();
	this->unitLabWeight = new System::Windows::Forms::Label();
	this->unitLabFArea = new System::Windows::Forms::Label();
	this->labdrag = new System::Windows::Forms::Label();
	this->labarea = new System::Windows::Forms::Label();
	this->labtire = new System::Windows::Forms::Label();
	this->labFDR = new System::Windows::Forms::Label();
	this->labratio = new System::Windows::Forms::Label();
	this->labMinTps = new System::Windows::Forms::Label();
	this->txtMinTps = new System::Windows::Forms::TextBox();
	this->txtDrag = new System::Windows::Forms::TextBox();
	this->txtArea = new System::Windows::Forms::TextBox();
	this->txtTire = new System::Windows::Forms::TextBox();
	this->txtFDR = new System::Windows::Forms::TextBox();
	this->txtRatio = new System::Windows::Forms::TextBox();
	this->txtWeight = new System::Windows::Forms::TextBox();
	this->labweight = new System::Windows::Forms::Label();
	this->unitLabTire = new System::Windows::Forms::Label();
	this->unitLabMinTps = new System::Windows::Forms::Label();
	this->dynGenGrp->SuspendLayout();
	this->carParamGrp->SuspendLayout();
	this->SuspendLayout();

	// 
	// dynoTab
	// 
	this->Controls->Add(this->dynGenGrp);
	this->Controls->Add(this->carParamGrp);
	this->Location = System::Drawing::Point(4, 22);
	this->Name = S"dynoTab";
	this->Size = System::Drawing::Size(472, 262);
	this->TabIndex = 2;
	this->Text = S"Dyno Parameters";

	// 
	// dynGenGrp
	// 
	this->dynGenGrp->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
	this->dynGenGrp->Controls->Add(this->dynoEnable);
	this->dynGenGrp->Controls->Add(this->txtMinTps);
	this->dynGenGrp->Controls->Add(this->labMinTps);
	this->dynGenGrp->Controls->Add(this->unitLabMinTps);
	this->dynGenGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->dynGenGrp->Location = System::Drawing::Point(8, 8);
	this->dynGenGrp->Name = S"dynGenGrp";
	this->dynGenGrp->Size = System::Drawing::Size(456, 50);
	this->dynGenGrp->TabIndex = 0;
	this->dynGenGrp->TabStop = false;
	this->dynGenGrp->Text = S"General";
	// 
	// dynoEnable
	// 
	this->dynoEnable->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->dynoEnable->Location = System::Drawing::Point(36, 20);
	this->dynoEnable->Name = S"dynoEnable";
	this->dynoEnable->Size = System::Drawing::Size(160, 16);
	this->dynoEnable->TabIndex = 0;
	this->dynoEnable->Enabled = false;
	this->dynoEnable->Text = S"Dyno Enabled";

	// 
	// unitLabWeight
	// 
	this->unitLabMinTps->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->unitLabMinTps->Location = System::Drawing::Point(364, 20);
	this->unitLabMinTps->Name = S"unitLabMinTps";
	this->unitLabMinTps->Size = System::Drawing::Size(40, 16);
	this->unitLabMinTps->TabIndex = 14;
	this->unitLabMinTps->Text = S"%";
	this->unitLabMinTps->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// labratio
	// 
	this->labMinTps->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->labMinTps->Location = System::Drawing::Point(212, 20);
	this->labMinTps->Name = S"labMinTps";
	this->labMinTps->Size = System::Drawing::Size(72, 16);
	this->labMinTps->TabIndex = 7;
	this->labMinTps->Text = S"Min Tps:";
	this->labMinTps->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// txtDrag
	// 
	this->txtMinTps->Location = System::Drawing::Point(284, 20);
	this->txtMinTps->Name = S"txtMinTps";
	this->txtMinTps->Size = System::Drawing::Size(72, 20);
	this->txtMinTps->TabIndex = 1;
	this->txtMinTps->Text = S"";
	this->txtMinTps->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, box_KeyPress);
	
	// 
	// carParamGrp
	// 
	this->carParamGrp->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
	this->carParamGrp->Controls->Add(this->unitLabWeight);
	this->carParamGrp->Controls->Add(this->unitLabFArea);
	this->carParamGrp->Controls->Add(this->labdrag);
	this->carParamGrp->Controls->Add(this->labarea);
	this->carParamGrp->Controls->Add(this->labtire);
	this->carParamGrp->Controls->Add(this->labFDR);
	this->carParamGrp->Controls->Add(this->labratio);
	this->carParamGrp->Controls->Add(this->txtDrag);
	this->carParamGrp->Controls->Add(this->txtArea);
	this->carParamGrp->Controls->Add(this->txtTire);
	this->carParamGrp->Controls->Add(this->txtFDR);
	this->carParamGrp->Controls->Add(this->txtRatio);
	this->carParamGrp->Controls->Add(this->txtWeight);
	this->carParamGrp->Controls->Add(this->labweight);
	this->carParamGrp->Controls->Add(this->unitLabTire);
	this->carParamGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->carParamGrp->Location = System::Drawing::Point(8, 72);
	this->carParamGrp->Name = S"carParamGrp";
	this->carParamGrp->Size = System::Drawing::Size(456, 182);
	this->carParamGrp->TabIndex = 1;
	this->carParamGrp->TabStop = false;
	this->carParamGrp->Text = S"Car Parameters";
	// 
	// unitLabWeight
	// 
	this->unitLabWeight->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->unitLabWeight->Location = System::Drawing::Point(364, 148);
	this->unitLabWeight->Name = S"unitLabWeight";
	this->unitLabWeight->Size = System::Drawing::Size(40, 16);
	this->unitLabWeight->TabIndex = 14;
	this->unitLabWeight->Text = S"lbs.";
	this->unitLabWeight->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// unitLabFArea
	// 
	this->unitLabFArea->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->unitLabFArea->Location = System::Drawing::Point(364, 40);
	this->unitLabFArea->Name = S"unitLabFArea";
	this->unitLabFArea->Size = System::Drawing::Size(40, 16);
	this->unitLabFArea->TabIndex = 13;
	this->unitLabFArea->Text = S"cu.in.";
	this->unitLabFArea->Enabled = false;
	this->unitLabFArea->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// unitLabTire
	// 
	this->unitLabTire->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->unitLabTire->Location = System::Drawing::Point(364, 92);
	this->unitLabTire->Name = S"unitLabTire";
	this->unitLabTire->Size = System::Drawing::Size(40, 16);
	this->unitLabTire->TabIndex = 84;
	this->unitLabTire->Text = S"in.";
	this->unitLabTire->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// labdrag
	// 
	this->labdrag->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->labdrag->Location = System::Drawing::Point(36, 36);
	this->labdrag->Name = S"labdrag";
	this->labdrag->Size = System::Drawing::Size(72, 16);
	this->labdrag->TabIndex = 83;
	this->labdrag->Text = S"Coeff. drag:";
	this->labdrag->Enabled = false;
	this->labdrag->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// labarea
	// 
	this->labarea->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->labarea->Location = System::Drawing::Point(212, 36);
	this->labarea->Name = S"labarea";
	this->labarea->Size = System::Drawing::Size(72, 16);
	this->labarea->TabIndex = 82;
	this->labarea->Text = S"Frontal Area:";
	this->labarea->Enabled = false;
	this->labarea->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// labtire
	// 
	this->labtire->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->labtire->Location = System::Drawing::Point(212, 92);
	this->labtire->Name = S"labtire";
	this->labtire->Size = System::Drawing::Size(72, 16);
	this->labtire->TabIndex = 91;
	this->labtire->Text = S"Tire Height:";
	this->labtire->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// labFDR
	// 
	this->labFDR->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->labFDR->Location = System::Drawing::Point(36, 148);
	this->labFDR->Name = S"labFDR";
	this->labFDR->Size = System::Drawing::Size(72, 16);
	this->labFDR->TabIndex = 81;
	this->labFDR->Text = S"Final Drive:";
	this->labFDR->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// labratio
	// 
	this->labratio->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->labratio->Location = System::Drawing::Point(36, 92);
	this->labratio->Name = S"labratio";
	this->labratio->Size = System::Drawing::Size(72, 16);
	this->labratio->TabIndex = 71;
	this->labratio->Text = S"Gear Ratio:";
	this->labratio->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
	// 
	// txtDrag
	// 
	this->txtDrag->Location = System::Drawing::Point(108, 36);
	this->txtDrag->Name = S"txtDrag";
	this->txtDrag->Size = System::Drawing::Size(72, 20);
	this->txtDrag->TabIndex = 2;
	this->txtDrag->Text = S"";
	this->txtDrag->Enabled = false;
	this->txtDrag->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, decbox_KeyPress);
	// 
	// txtArea
	// 
	this->txtArea->Location = System::Drawing::Point(284, 36);
	this->txtArea->Name = S"txtArea";
	this->txtArea->Size = System::Drawing::Size(72, 20);
	this->txtArea->TabIndex = 3;
	this->txtArea->Text = S"";
	this->txtArea->Enabled = false;
	this->txtArea->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, decbox_KeyPress);
	// 
	// txtTire
	// 
	this->txtTire->Location = System::Drawing::Point(284, 92);
	this->txtTire->Name = S"txtTire";
	this->txtTire->Size = System::Drawing::Size(72, 20);
	this->txtTire->TabIndex = 5;
	this->txtTire->Text = S"";
	this->txtTire->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, decbox_KeyPress);
	// 
	// txtFDR
	// 
	this->txtFDR->Location = System::Drawing::Point(108, 148);
	this->txtFDR->Name = S"txtFDR";
	this->txtFDR->Size = System::Drawing::Size(72, 20);
	this->txtFDR->TabIndex = 6;
	this->txtFDR->Text = S"";
	this->txtFDR->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, decbox_KeyPress);
	// 
	// txtRatio
	// 
	this->txtRatio->Location = System::Drawing::Point(108, 92);
	this->txtRatio->Name = S"txtRatio";
	this->txtRatio->Size = System::Drawing::Size(72, 20);
	this->txtRatio->TabIndex = 4;
	this->txtRatio->Text = S"";
	this->txtRatio->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, decbox_KeyPress);
	// 
	// txtWeight
	// 
	this->txtWeight->Location = System::Drawing::Point(284, 148);
	this->txtWeight->Name = S"txtWeight";
	this->txtWeight->Size = System::Drawing::Size(72, 20);
	this->txtWeight->TabIndex = 7;
	this->txtWeight->Text = S"";
	this->txtWeight->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, decbox_KeyPress);
	// 
	// labweight
	// 
	this->labweight->FlatStyle = System::Windows::Forms::FlatStyle::System;
	this->labweight->Location = System::Drawing::Point(212, 148);
	this->labweight->Name = S"labweight";
	this->labweight->Size = System::Drawing::Size(72, 16);
	this->labweight->TabIndex = 80;
	this->labweight->Text = S"Weight:";
	this->labweight->TextAlign = System::Drawing::ContentAlignment::BottomLeft;

	this->dynGenGrp->ResumeLayout();
	this->carParamGrp->ResumeLayout();
	this->ResumeLayout();
}