#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Text;

#include "common.h"
#include "global.h"

namespace bre20
{
	/// <summary> 
	/// Has fields for the dyno calculation. It deals with reading from the config file,
	///	displaying, and updating the config file.
	/// </summary>
	public __gc class DynoParameters : public System::Windows::Forms::TabPage
	{
	private:
		GroupBox *  dynGenGrp;
		GroupBox *  carParamGrp;
		TextBox *  txtWeight;
		TextBox *  txtRatio;
		TextBox *  txtFDR;
		TextBox *  txtTire;
		TextBox *  txtArea;
		TextBox *  txtDrag;
		TextBox *  txtMinTps;
		Label *  labMinTps;
		Label *  unitLabMinTps;
		Label *  labweight;
		Label *  labratio;
		Label *  labFDR;
		Label *  labtire;
		Label *  labarea;
		Label *  labdrag;
		Label *  unitLabTire;
		Label *  unitLabFArea;
		Label *  unitLabWeight;
		CheckBox *  dynoEnable;

	private:
		void init();
		void loadProperties();

		void prop_Changed(Object * sender, bre20::PropertyEventArgs* e);
		void decbox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
		{Common::handleDoubleKeyPress(static_cast<TextBox*>(sender),e,false);}
		void box_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
		{Common::handleIntKeyPress(static_cast<TextBox*>(sender),e,false);}

	public:
		DynoParameters();
		void changeUnits(bool sae);
		void persistPreferences();
	};
}