#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace DynoLib;

#include "rule.h"
#include "dynopage.h"
#include "dynocalculation.h"
#include "logfileReader.h"

namespace bre20
{
	/// <summary> 
	/// tab page with a grid
	/// </summary>
	public __gc class DynoRule : public Rule
	{
	protected:
		__int64 lasttime;
		float lastitem __gc[];
		Form* ana;
		DynoPage* graph;
		bool isSetup;
		bool fromAnalyzer;

        IgnoreRule* mintps;
		DynoCalculation* calcs;

        ArrayList* curData;
		DynoRun* curRun;

	private:
		void prop_changed(Object* sender, PropertyEventArgs* pe);
		void assembleAllRunData();
		void assembleRunData(DynoRun* run);

		String* getRunName(String* path){return Path::GetFileName(path);}

	public:
		DynoRule();

		virtual void RecalculateRun(int runIndex);
		virtual void RecalculateAllRuns();

		virtual void addFile(String* fname);
		virtual void setupRule(LogFileReader* rd);
		virtual bool executeRule(LogFileReader* rd);

		virtual void setupRule(Form* frm);
		virtual void finishRule(Form* frm);
		virtual bool executeRule(Form* frm);
		virtual bool updateRule(Form* frm);
		virtual bool executeReplay(String* keys[], Hashtable* values);
		virtual String* modifiedFields(){return "dyno";}

		virtual DynoPage* getDynoPage(){return graph;}
	};
}