#include "StdAfx.h"
#include "EmulatorUtil.h"

bre20::EmulatorUtil::EmulatorUtil(): SerialCom()
{
	//setup the port:
	lookforconnect = runthread = true;

	sending = false;

	readPreferences();

	Globals::Props->add_OnPropertyChanged(new PropertyEventHandler(this,prop_Changed));

//	Thread* th = new Thread(new ThreadStart(this,eventThread));
//	th->Priority = ThreadPriority::BelowNormal;
//	th->Start();
}

void bre20::EmulatorUtil::readPreferences()
{
	device = Globals::Props->getIntParam("emuDevice");
	if(device < 0 || device > DEVICE_MAX)
		device = DEVICE_OSTRICH;
}

void bre20::EmulatorUtil::prop_Changed(Object* sender,PropertyEventArgs* pe)
{
	String* name = pe->getName();
	if(name->Equals("emuDevice"))
		readPreferences();
}

void bre20::EmulatorUtil::eventThread()
{
	//so were polling in here. sucky.
/*
	while(runthread)
	{
		//try to find a disconnect
		if(!sending && connected && !lookforconnect)
		{
			sending = true;
			
			unsigned char ch __gc[] = new unsigned char __gc[2];
			ch[0] = 'k';
			ch[1] = 'a';

			unsigned char b __gc[];
			b = send(ch,1);
			
			sending = false;

			if(b == NULL)
			{
				EventArgs * e = new EventArgs();
				this->close();
				onDisconnect(e);

				lookforconnect = true;
			}

			
		}

		if(!sending && !connected && lookforconnect)
		{
			if(port!=NULL && portnum >0)
			{
				int baud = 115200;

				port->Cnfg->BaudRate = (SerialPorts::LineSpeed)baud;
				port->Cnfg->PortName = String::Concat(S"COM",portnum.ToString());
				port->Cnfg->Parity = getParity(0);
				port->Cnfg->ReceiveMode = true;

				bool good = false;
				if(port!= NULL && !port->IsOpen && port->Available(String::Concat(S"COM",portnum.ToString())))
				{
					EventArgs * e = new EventArgs();
					onReconnect(e);
					lookforconnect = false;
					good = true;
				}

				baud = 920000;
				port->Cnfg->BaudRate = (SerialPorts::LineSpeed)baud;
				if(port!= NULL && !port->IsOpen && port->Available(String::Concat(S"COM",portnum.ToString())) && !good)
				{
					EventArgs * e = new EventArgs();
					onReconnect(e);
					lookforconnect = false;
				}
			}//end if NULL
		}//end if !sending && !connected

		Thread::Sleep(2000);
	}//end infinite while
	*/
}

/*
bool bre20::EmulatorUtil::testConnect(String* com)
{
	int pnum = getPortName(com);
	int baud = 115200;

	port->Cnfg->BaudRate = (SerialPorts::LineSpeed)baud;
	port->Cnfg->PortName = String::Concat(S"COM",pnum.ToString());
	port->Cnfg->Parity = getParity(0);
	port->Cnfg->ReceiveMode = true;

	if(port->Open(portnum))
	{


		unsigned char init __gc[] = new unsigned char __gc[2];
		init[0] = init[1] = 'V';

		unsigned char chars __gc[] = send(init,3);

		if(chars == NULL)
		{
			//try 920000 baud
			port->Close();
			baud = 920000;
			port->Cnfg->BaudRate = (SerialPorts::LineSpeed)baud;

			if(port->Open(portnum))
			{

				chars = send(init,3);

				port->Close();
				if(chars == NULL)
					return false;
			}
			else
				return false;

		}
	}

	return false;

}
*/
unsigned char bre20::EmulatorUtil::connectAtBaud(SerialPorts::LineSpeed baud, int tries) __gc[]
{
	unsigned char chars __gc[] = NULL;
	unsigned char init __gc[] = new unsigned char __gc[2];
				init[0] = init[1] = 'V';

	for(int trynum = 0; trynum<tries; trynum++)
	{
		//LOG(this, String::Concat("outer conn: ", trynum.ToString()));

		port->Close();

		port->Cnfg->BaudRate = baud; //bauds[baudnum];

		if(port->Open(portnum))
		{
			for(int i = 0; i< tries; i++)
			{
				//LOG(this, String::Concat("inner conn: ", i.ToString()));
				//send the init stuff...
				sending = true;
				chars = send(init,3);
				sending = false;

				System::Threading::Thread::Sleep(1);
				//if we get something back and we arent already at our 
				//target baud, then we set the baud and connect at target baud.
				if(chars != NULL)
					return chars;	
			}
		}//end if connected
		else
			System::Threading::Thread::Sleep(2);
	}//end tries for.

	return chars;
}

bool bre20::EmulatorUtil::sendSetupByte(int baudset, int tries)
{
	for(int i = 0; i<tries; i++)
	{
		//LOG(this, String::Concat("setup byte: ", i.ToString()));
		unsigned char init __gc[];
		int numback = 0;
		if(device == DEVICE_ROMULATOR)
		{
			init = new unsigned char __gc[2];
			init[0] = 'S';
			init[1] = 'S';
			numback = 2;
		}
		else
		{
			init = new unsigned char __gc[3];
			int chksum = (83 + (int)baudset)%256;
			init[0] = 83;
			init[1] = baudset;
			init[2] = (unsigned char)chksum;
			numback = 1;
		}

		sending = true;
		unsigned char chars __gc[] = send(init,numback);
		sending = false;

		if(chars != NULL && chars[0] == 79)
			return true;
	}
	return false;
}

String* bre20::EmulatorUtil::connectToOstrich(bool highspeed)
{
	//LOG(this, "attempt to connect to ostrich");
	SerialPorts::LineSpeed rbaud = SerialPorts::Baud_115200;
	unsigned char rbaudset = 7;
	SerialPorts::LineSpeed tbaud = SerialPorts::Baud_921600;
	unsigned char tbaudset = 0;

	if(!highspeed)
	{
		tbaud = rbaud;
		tbaudset = rbaudset;
	}

	SerialPorts::LineSpeed iconbaud = SerialPorts::Baud_115200;

	bool conn = false;
	int tries = 10;

	unsigned char chars __gc[] = NULL;
	for(int tnum = 0; tnum<tries/2; tnum++)
	{
		//LOG(this, String::Concat("Outer: ", tnum.ToString()));
		conn = false;
		bool hispdconn = false;

		chars = connectAtBaud(rbaud, 4);

		if(chars == NULL)
		{
			//LOG(this, String::Concat("high speed override: ", tnum.ToString()));
			//try the high speed...
			//override the highspeed bool...
			System::Threading::Thread::Sleep(5);
			tbaud = SerialPorts::Baud_921600;
			tbaudset = 0;
			chars = connectAtBaud(tbaud, tries*2);

			if(chars == NULL)
			{
				port->Close();
				return NULL;
			}
			else
				hispdconn = true;
		}
		
		String * version = getVersion(chars);
		
		/*
		String::Concat(S"v",chars[0].ToString());
		if(chars->Length > 1)
			version = String::Concat(version,
			S".",chars[1].ToString());

		if(chars->Length > 2)
			version = String::Concat(version,S".",chars[2].ToString());
		*/

		//we want to continue and set the baud to something else.
		conn = sendSetupByte(tbaudset,tries);
		if(conn && (iconbaud == tbaud || hispdconn))
		{
			lookforconnect = false;
			connected = true;
			return version;
		}
		else if(!conn){
			port->Close();
			//LOG(this, "ostrich conn failed.");
			return NULL;
		}

		conn = false;
		System::Threading::Thread::Sleep(5);
		chars = connectAtBaud(tbaud, tries);
		if(chars != NULL)
			conn = sendSetupByte(tbaudset,tries);

		if(conn)
		{
			lookforconnect = false;
			connected = true;
			return version;
		}
	}//end outer for

	port->Close();
	//LOG(this, "ostrich conn failed.");
	return NULL;
}

String* bre20::EmulatorUtil::connectToRomulator()
{
	SerialPorts::LineSpeed baud;
	try
	{
		baud = (SerialPorts::LineSpeed)Globals::Props->getIntParam("emuBaud");
	}
	catch(Exception * e)
	{
		Globals::LogFile->WriteLine(this,String::Concat("romulator connection Exception: ", e->Message));
		return NULL;
	}

	int tries = 10;

	for(int tnum = 0; tnum<tries/2; tnum++)
	{
		bool conn = false;

		String* version = getVersion(connectAtBaud(baud, tries));

		if(version != NULL)
		{
			conn = this->sendSetupByte(0,tries);
			if(conn)
			{
				lookforconnect = false;
				connected = true;
				return version;
			}
		}//end if
	}//end for

	port->Close();
	return NULL;
}

String* bre20::EmulatorUtil::getVersion(unsigned char chars __gc[])
{
	if(chars == NULL || chars->Length < 1)
		return NULL;

	String * version = String::Concat(S"v",chars[0].ToString());

	if(chars->Length > 1)
		version = String::Concat(version,
		S".",chars[1].ToString());

	if(chars->Length > 2)
		version = String::Concat(version,S".",chars[2].ToString());

	return version;
}

String* bre20::EmulatorUtil::connectToEmulator(String* com, bool highspeed)
{
	connected = false;

	portnum = getPortName(com);

	port->Cnfg->PortName = String::Concat(S"COM",portnum.ToString());
	port->Cnfg->Parity = getParity(0);
	port->Cnfg->ReceiveMode = true;
	port->Cnfg->DataBits = SerialPorts::ByteSize::Eight;
	port->Cnfg->FlowCtrl = SerialPorts::Handshake::None;
	port->Cnfg->RtsControl = SerialPorts::PinState::Disable;
	if(device == DEVICE_ROMULATOR)
		port->Cnfg->DtrControl = SerialPorts::PinState::Enable;
	else
		port->Cnfg->DtrControl = SerialPorts::PinState::Disable;

	bytestosend = 250;

	while(sending)
		Thread::Sleep(10);

	if(device == DEVICE_OSTRICH)
		return this->connectToOstrich(highspeed);
	else if(device == DEVICE_ROMULATOR)
		return this->connectToRomulator();
	return NULL;
}


//**********************************************************
//read

unsigned char bre20::EmulatorUtil::readBlock(int start, int length, int counter __gc[]) __gc[]
{
//	'R'+n+MSB+LSB+CS
//	return: B1+..+Bn+CS

	if(!connected)
		return NULL;

	while(sending)
	{
		Thread::Sleep(10);
	}

	sending = true;

	recv->Clear();
	badsends = 0;

	int index = 0;
	int address = start+0x8000;
	int bytestorecv = 0xff;

	unsigned char result __gc[] = new unsigned char __gc[length];

	for(index = 0; index<length; index+=bytestorecv)
	{
		
		unsigned char addy __gc[] = getAddress(address);
		unsigned char cmd __gc[] = {'R',(unsigned char)bytestorecv,addy[0],addy[1],0};
		int chk = (int)('R' + (unsigned char)bytestorecv + 
				addy[0] + addy[1])%256;

		cmd[cmd->Length-1] = (unsigned int)chk;

		int len;
		if(length-index <= bytestorecv)
			len = length-index;
		else
			len = bytestorecv;

		unsigned char b __gc[] = send(cmd,len+1);

		chk = 0;
		for(int i = 0; i< b->Length-1 && i+index<result->Length; i++)
		{
			chk+= (int)b[i];
			result[i+index] = b[i];
		}

		chk=chk%256;

		b = NULL;

		address+= bytestorecv;
		if(counter != NULL && counter->Length>0)
			counter[0]++;
	}

	sending = false;

	return result;
}


//**********************************************************
//write
bool bre20::EmulatorUtil::writeInitialBlock(unsigned char bytes __gc[], int start, int counter __gc[])
{
	return writeHiddenBlock(bytes,start,counter);
}

bool bre20::EmulatorUtil::writeHiddenBlock(unsigned char bytes __gc[], int start, int counter __gc[])
{
	if(device == DEVICE_ROMULATOR)
		return sendBlock('w',bytes,start,counter,79);
	else
		return sendBlock('W',bytes,start,counter,79); //79 is 'O' for OK
}
// Command Format - 'X' (57h) + # of Bytes + 1AF0h(Start Address 2 Bytes) + (# Bytes of Data) + Checksum
bool bre20::EmulatorUtil::sendBlock(unsigned char command, unsigned char bytes __gc[], int start, int counter __gc[], int returnOk)
{
	//X - 1B
	//#bytes - 1B
	//addy - 2B
	//info - 255B
	//chksum - 1B

	while(sending)
	{
		Thread::Sleep(10);
	}

	sending = true;

	recv->Clear();
	badsends = 0;

	int index = 0;
	int address = start+0x8000;

	for(index = 0; index<bytes->Length; index+=bytestosend)
	{
		unsigned char b __gc[];
		unsigned char numbytes;
		unsigned char checksum;
		unsigned char addy __gc[] = getAddress(address);

		if(bytes->Length-index <= bytestosend)
			b = new unsigned char __gc[bytes->Length-index];
		else
			b = new unsigned char __gc[bytestosend];

		int chk = 0;
		for(int i = 0; i<b->Length; i++)
		{
			b[i] = bytes[i+index];

			chk += (int)b[i];
		}

		numbytes = (unsigned char)(b->Length);

		unsigned char checksumData = (unsigned char)(chk%256);

		if(returnOk >= 0)
			checksumData = returnOk;

		unsigned char cmd __gc[] = new unsigned char __gc[numbytes+5]; 

		cmd[0] = command; //'X'
		cmd[1] = numbytes;
		cmd[2] = addy[0];
		cmd[3] = addy[1];

		chk+= (int)cmd[0];
		chk+= (int)cmd[1];
		chk+= (int)cmd[2];
		chk+= (int)cmd[3];
		checksum = (unsigned char)(chk%256);

		for(int i = 0; i<b->Length; i++)
			cmd[i+4] = b[i];

		cmd[cmd->Length-1] = checksum;

		b = send(cmd,1);
		if(b == NULL)
		{
			MessageBox::Show(S"Timed out");
			return false;
		}

		unsigned char checksumFromEm = 0;
		if( b!= NULL && b->Length > 1) //2byte chk sum
		{
			checksumFromEm = (unsigned char)b[1];//((int)b[1])*256 + ((int)b[0]);

			if(checksumData!=checksumFromEm)
				checksumFromEm = (unsigned char)b[0];
		}
		else if( b!= NULL && b->Length > 0) //2byte chk sum
			checksumFromEm = (unsigned char)b[0];

		if(b!=NULL && b->Length >1 && b[0] == 63 && b[1] == 63)
			MessageBox::Show("Unknown Command: write");

		address += bytestosend;
		if(counter != NULL && counter->Length > 0)
			counter[0]++;
	}

	sending = false;

	return true;
}

int bre20::EmulatorUtil::getNumIterations(unsigned char bytes __gc[])
{
	return bytes->Length/bytestosend;
}

void bre20::EmulatorUtil::closeAll()
{
	runthread = false;

	if(port != NULL)
		this->sendSetupByte(7,4);

	close();
	recv->Clear();
}



