#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;

#include "PortSetupDialog.h"
#include "CharWrap.h"
#include "SerialCom.h"
#include "global.h"

namespace bre20
{
	/// <summary> 
	/// Class that controls Emulator Communications
	/// </summary>
	public __gc class EmulatorUtil: public SerialCom
	{
    //my data members...
	protected:
		bool sending, lookforconnect, runthread;
		int device;

		void eventThread();

		void readPreferences();
		
		String* getVersion(unsigned char bytes __gc[]);
		String* connectToOstrich(bool highspeed);
		String* connectToRomulator();
		unsigned char connectAtBaud(SerialPorts::LineSpeed baud, int tries) __gc[];
		bool sendSetupByte(int baudset, int tries);

		void prop_Changed(Object* sender,PropertyEventArgs* pe);

		static int DEVICE_MAX = 1;

	public:
		EmulatorUtil();

		virtual String * connectToEmulator(String * com, bool highspeed);
	//	virtual bool testConnect(String* com);
		void closeAll();

		virtual unsigned char readBlock(int start, int length, int counter __gc[]) __gc[];
		virtual bool sendBlock(unsigned char command, unsigned char bytes __gc[], int start, int counter __gc[], int returnOk);
		virtual bool writeInitialBlock(unsigned char bytes __gc[], int start, int counter __gc[]);
		virtual bool writeHiddenBlock(unsigned char bytes __gc[], int start, int counter __gc[]);

		virtual int getNumIterations(unsigned char bytes __gc[]);

        static int DEVICE_OSTRICH = 0;
		static int DEVICE_ROMULATOR = 1;
	};
}