
//#pragma once
//#if !defined BENSs_EUROPW0ECU_H
//#define BENSs_EUROPW0ECU_H

#pragma once
using namespace System;

#include "Obd0VtecEcu.h"
namespace RomRep
{
	[Serializable] public __gc class EuroPw0: public VT0Ecu
	{
	public:
		EuroPw0();
		EuroPw0(unsigned char rom __gc[], int flen);
		EuroPw0(unsigned char rom __gc[], int flen,int revlim,int restrt,int vitek,int numvt,int igtbl1,int igtbl2,int fueltbl1,int fueltbl2,String * tname,int xtbl);
		
		virtual void disableChecksum(bool disable); 
		virtual void disableOxygenSensors(bool disable);
		virtual void disable2ndOxygenSensor(bool disable);

		virtual void setLaunchRpm(int val);
		virtual void setLaunchSpeed(int val);
		virtual void enableLaunch(bool enable);
		virtual void disableSpeedLimiter(bool disable); 
		virtual void disableVssCheck(bool disable); 
		virtual void disableTempCheck(bool disable); 
		virtual void disablePsCheck(bool disable); 
		virtual void disableCelCheck(bool disable);
		virtual int isKnockSensorDisabled();
		virtual void disableKnockSensor(bool disable);
		virtual void disableCodes(bool disable);

		virtual int getLaunchRpm();
		virtual int getLaunchSpeed();

		virtual int isSpeedLimiterDisabled();
		virtual int isVssCheckDisabled();
		virtual int isTempCheckDisabled();
		virtual int isCelCheckDisabled();
		virtual int isPsCheckDisabled();
		virtual int isLaunchDisabled();
		virtual int isCodesDisabled();


		virtual int isChecksumDisabled();
		virtual int isOxygenSensorsDisabled();
		virtual int is2ndOxygenSensorDisabled();

		virtual int isCodeBitDisable(int code);
		virtual int codeBitDisable(int code, bool disable);
		virtual int isCodeBitDisabled(int code);

		static bool validate(unsigned char h __gc[]);
	};
}

//#endif