#include "stdafx.h"
#include "EuroPw0Dev.h"
#include "devmaps.h"

RomRep::EuroPw0Dev::EuroPw0Dev(): EuroPw0(){}//,DevUtil(){}

RomRep::EuroPw0Dev::EuroPw0Dev(unsigned char rom __gc[], int flen): EuroPw0(rom, flen, 0x3928, 0x3930, 0x3AEC, 4,
		DevUtil::igmap, DevUtil::igmapvtec,DevUtil::fmap, DevUtil::fmapvtec, "Euro Pw0 dev",DevUtil::getRomWidth(rom))
{
	lastNACol = DevUtil::findLastNACol(thefile);

	y = DevUtil::getRomHeight(rom);
	mapscalarloc = 0x63d2;
	widthloc = 0x7ffc;
	heightloc = 0x7ffd;
	tablesizeloc = 0x7ffe;
}

RomRep::FuelMap* RomRep::EuroPw0Dev::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new DevFuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,maxmapadd, maploc->mapRevScalarLoc,index,Map::MODE_FUEL);
	
	fm->setName(RomRep::VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::EuroPw0Dev::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new DevIgnMap(xx,yy,maploc->mapLoc,map,thefile,maxmapadd,maploc->mapRevScalarLoc,
		index,Map::MODE_IGNITION);
	
	im->setName(RomRep::VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

void RomRep::EuroPw0Dev::insertColumn(int column)
{
//	HondaEcu::insertColumn(column); //x has been incremented...
//
//	this->setByte(widthloc,x);
//	this->setByte(tablesizeloc,(x*y)%256);
//	this->setByte(tablesizeloc+1,(x*y)/256);
//
//	//fix the column scalars
//	
//
//	int* oldscalars = this->getArray(thefile,mapscalarloc,x*3);
//
//    int scalarptr = ((x-1)*3)-(column*3);//this is pointing at the map value of the column in the array
//
//	//adjusts the scalars for the columns above the inserted column 
//	//and sets the new column's ivalue
//	for(int i = 0; i<=scalarptr; i+=3)
//	{
//		int ivalue = oldscalars[i+1] + oldscalars[i+2]*256;
//
//		ivalue+=0x10;
//
//		this->setByte(mapscalarloc+i+1,ivalue%256);
//		this->setByte(mapscalarloc+i+2,ivalue/256);
//
//	}
//
//	//set the new column's map value
//	int ivalue = (oldscalars[scalarptr] + oldscalars[scalarptr-3])/2;
//
//	this->setByte(mapscalarloc+scalarptr,ivalue);
//
//	//sets the rest of the values...
//	for(int i = scalarptr; i<x*3; i++)
//	{
//		this->setByte(mapscalarloc+i+3,oldscalars[i]);
//	}
//
//	//setup the new headers...
//	String * oldheaders[,] = colheaders;
//	colheaders = new String *[2,x];
//
////	colheaders[0] = new string[x];
////	colheaders[1] = new string[x];
//
//	DevUtil::calcHeaders(thefile[maxmapadd],thefile,lastNACol,colheaders,rowheaders);
//
//	delete[] oldscalars;
	
}

///static stuff........
bool RomRep::EuroPw0Dev::validate(unsigned char h __gc[])
{
	bool good = true;
	int head[10] = {0x73,0x16,0x9A,0x16,0x96,0x16,0x8F,0x00,0x1F,0x15};

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			good = false;
		}

	int boost[5] = {0xCF,0x02,0x77,0xDF,0x01};

	for(int i = 0; i<4; i++)
		if(boost[i] != h[0x33d0 + i])
			good = false;

	return good;
}