//#pragma once
//#if !defined BENSs_EUROPW0DEVECU_H
//#define BENSs_EUROPW0DEVECU_H

#pragma once
using namespace System;

#include "EuroPw0.h"
#include "devutil.h"
namespace RomRep
{
	[Serializable] public __gc class EuroPw0Dev: public EuroPw0//, public DevUtil
	{
	protected:
		static int maxmapadd = 0x4d5;

		int mapscalarloc;
		int widthloc;
		int heightloc;
		int tablesizeloc;

		///overridden to properly
		///create a fuel map.
		///
		///If mapname == null, this function will give the map a name.
		///
		///colscalarloc parameter is ignored.\n
		///vtec parameter ignored if index <= 1 
		virtual FuelMap* createFuelMap(int xx, int yy, int index, String* mapname,
			RomRep::MapLocs* maploc,unsigned char map __gc[,],unsigned char mlt __gc[], bool vtec);

		///overridden to properly
		///create an ignition map.
		///
		///If mapname == null, this function will give the map a name.
		///
		///colscalarloc parameter is ignored.\n
		///vtec parameter ignored if index <= 1
		virtual Map* createIgnitionMap(int xx, int yy, int index, String* mapname,
			RomRep::MapLocs* maploc,unsigned char map __gc[,],bool vtec);

	public:
		EuroPw0Dev();
		EuroPw0Dev(unsigned char rom __gc[], int flen);

		virtual void insertColumn(int column);

		static bool validate(unsigned char h __gc[]);
		//static int getRomWidth(int* file);
		//static int getRomHeight(int* file);
		//static int getMaxMapVal(int* file);
	};
}

//#endif