#include "stdafx.h"
#include "EuroPw0ITB.h"
#include "ITBmaps.h"

RomRep::EuroPw0ITB::EuroPw0ITB(): EuroPw0(){}

RomRep::EuroPw0ITB::EuroPw0ITB(unsigned char rom __gc[], int flen): EuroPw0(rom, flen)
{
	type = "Euro PW0 ITB";
}

RomRep::FuelMap* RomRep::EuroPw0ITB::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new VT0FuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,ITBMapHelper::TPS_SCALAR_LOC, maploc->mapRevScalarLoc,index,Map::MODE_FUEL);
	
	fm->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::EuroPw0ITB::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new VT0IgnMap(xx,yy,maploc->mapLoc,map,thefile,ITBMapHelper::TPS_SCALAR_LOC,
		maploc->mapRevScalarLoc,index,Map::MODE_IGNITION);
	
	im->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

//overridden to get the tps xover.
int RomRep::EuroPw0ITB::getLastNaCol()
{
	return lastNACol;
}

int RomRep::EuroPw0ITB::getXoverCol(){
	return ITBMapHelper::getXoverCol(thefile, x);
}
void RomRep::EuroPw0ITB::setXoverCol(int col){
	return setTPSXover((int)RomRep::ITBMapHelper::calcXoverCol(thefile,col,x)->getByte());
}
int RomRep::EuroPw0ITB::getTPSXover(){
	return (int)thefile[RomRep::ITBMapHelper::TPS_XOVER_LOC];
}
void RomRep::EuroPw0ITB::setTPSXover(int mapval){ 
	setByte(RomRep::ITBMapHelper::TPS_XOVER_LOC,mapval);
}

bool RomRep::EuroPw0ITB::validate(unsigned char h __gc[])
{
	bool good = EuroPw0::validate(h);

	int itbtest __gc[] = {0x60,0x2f,0x64,0x10,0xCB,0x25};
	int loc = 0x4d4;
	for(int i = 0; i<itbtest->Length; i++)
		if(itbtest[i] != h[loc+i])
			good = false;

	return good;
}