#pragma once
#include "GridPage.h"
#include "HondaEcu.h"
#include "global.h"
#include "properties.h"

using namespace System;
using namespace System::Windows::Forms;

namespace bre20
{
	/// <summary> 
	/// TODO: 
	/// sae property event
	///	byte change event to catch changes in the table
	/// finish all the support for rpm etc. 
	/// </summary>
	public __gc struct Addys
	{
		int highAddy;
		int lowAddy;
	};
	public __gc class ExtraTableGrid : public bre20::GridPage
	{
	public:
		///right now this is for vcal tables only...
		ExtraTableGrid(RomRep::HondaEcu* rom,int x, String * str, int address, int addressMode,int keyMode,int valMode, bool vcal, bool hasakey):GridPage(str, x, 2, 2)
		{
			haskey = hasakey;
			this->rom = rom;
			this->vcal = vcal;
			addy = address;
			addmode = addressMode;
			keymode = keyMode;
			valmode = valMode;
			headers = NULL;

			init(-1,NULL);
		}

		ExtraTableGrid(RomRep::HondaEcu* rom,int x, String * str, int address, int addressMode,int keyMode,int valMode, bool vcal, bool hasakey, int colwidth, String* headernames[]):GridPage(str, x, 2, 2)
		{
			haskey = hasakey;
			this->rom = rom;
			this->vcal = vcal;
			addy = address;
			addmode = addressMode;
			keymode = keyMode;
			valmode = valMode;
			headers = headernames;

			init(colwidth,headernames);
		}


		virtual int getWidth();
		virtual int getHeight();

		virtual void setPaintMode(bool colors)
		{
			if(colors)
				this->grid->PaintMode = SimpleGrid::Grid::M_PAINT_ALL;
			else
				this->grid->PaintMode = SimpleGrid::Grid::M_PAINT_NO_COLORS;
		}

	private:
		static const int MODE_BYTE = 0;
		static const int MODE_WORD = 1;

		static const int MODE_RAW = 2;
		static const int MODE_RPM = 3;
		static const int MODE_TEMP = 4;

		int addmode,keymode,valmode, addy;
		RomRep::HondaEcu* rom;
		bool sae,vcal, haskey;
		String* headers[];

		void fillGrid(String* titles[]);
		int calcKey(int col);
		int calcVal(int col);
		String* getUnits(int mode);
		bre20::Addys* calcAddys(int col);

		void grid_Click(System::Object *  sender, System::EventArgs *  e);
		void byte_Changed(Object* sender, RomRep::ByteChangeArgs* e);
		void prop_Changed(System::Object *  sender, PropertyEventArgs *  e);

		void init(int width, String* titles[]);
	};
}