#pragma once

#include "Global.h"
#include "child.h"
#include "PwBox.h"
#include "DevParam.h"
#include "PM6Param.h"
#include "GhdPM6Param.h"
#include "Obd0vtecParam.h"
#include "NGParam.h"
#include "About.h"
#include "ManagedUtil.h"
#include "StartupFile.h"
#include "splash.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace bre20
{
	/// <summary> 
	/// 
	/// This is the main application class...
	/// 
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		~Form1()
		{Globals::LogFile->Close();}
		//!constructor
		Form1(void)
		{
			InitializeComponent();
			Globals::LogFile = new LogFileObj("brelogs.txt");
			Globals::Props = new Properties();
			this->Text = About::BRETITLE;
		}
		
		//!Constructor which should open all the files in the array
		Form1(String * fname[]);

		///opens the startup file.
		String* openStartupFile(String* files[])[];
		//!Opens the files whos file names are in the file array
		void openFiles(String* files[]);

		//!Saves the active MDI bre20.child form. Length of the binary file in bytes is len.
		void saveActive(String * fname, int len);
		//!Saves the file contained in form. Form must be of Type bre20.child
		void save(String * fname, int len, Form * form);
		
		//!Returns the CSScriptLibrary.ScriptManager object
		CSScriptLibrary::ScriptManager* getScriptManager(){return scriptManager;}
	private: System::Windows::Forms::MenuItem *  mnuToggleTopMost;



	protected:
		CSScriptLibrary::ScriptManager* scriptManager;

		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}

	private: System::Windows::Forms::MainMenu *  mainMenu1;
	private: System::Windows::Forms::MenuItem *  openMenu;
	private: System::Windows::Forms::MenuItem *  saveItem;
	private: System::Windows::Forms::MenuItem *  fileMenu;
	private: System::Windows::Forms::MenuItem *  windowMenu;
	private: System::Windows::Forms::MenuItem *  saveAsItem;
	private: System::Windows::Forms::OpenFileDialog *  openFileDialog1;
	private: System::Windows::Forms::SaveFileDialog *  saveFileDialog1;
	private: System::Windows::Forms::StatusBar *  statusBar1;
	private: System::Windows::Forms::MenuItem *  openNgLogger;
	private: System::Windows::Forms::MenuItem *  menuItem3;
	private: System::Windows::Forms::MenuItem *  menuItem1;
	private: System::Windows::Forms::MenuItem *  openLog;
	private: System::Windows::Forms::MenuItem *  menuItem4;
	private: System::Windows::Forms::MenuItem *  scriptManage;
	private: System::Windows::Forms::ToolBar *  toolBar1;
	private: System::Windows::Forms::ImageList *  imageList1;
	private: System::Windows::Forms::ToolBarButton *  sepbegin;
	private: System::Windows::Forms::ToolBarButton *  openBtn;
	private: System::Windows::Forms::ToolBarButton *  saveBtn;
	private: System::Windows::Forms::ToolBarButton *  saveAsBtn;
	private: System::Windows::Forms::ToolBarButton *  sep1;
	private: System::Windows::Forms::MenuItem *  startupFile;
	private: System::ComponentModel::IContainer *  components;



	private:
		Form* frmTopMost;
		int frmTopMostParent;
		/// <summary>
		/// Required designer variable.
		/// </summary>


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = new System::ComponentModel::Container();
			System::Resources::ResourceManager *  resources = new System::Resources::ResourceManager(__typeof(bre20::Form1));
			System::Configuration::AppSettingsReader *  configurationAppSettings = new System::Configuration::AppSettingsReader();
			this->mainMenu1 = new System::Windows::Forms::MainMenu();
			this->fileMenu = new System::Windows::Forms::MenuItem();
			this->openMenu = new System::Windows::Forms::MenuItem();
			this->saveAsItem = new System::Windows::Forms::MenuItem();
			this->saveItem = new System::Windows::Forms::MenuItem();
			this->menuItem1 = new System::Windows::Forms::MenuItem();
			this->openLog = new System::Windows::Forms::MenuItem();
			this->startupFile = new System::Windows::Forms::MenuItem();
			this->menuItem3 = new System::Windows::Forms::MenuItem();
			this->openNgLogger = new System::Windows::Forms::MenuItem();
			this->scriptManage = new System::Windows::Forms::MenuItem();
			this->windowMenu = new System::Windows::Forms::MenuItem();
			this->mnuToggleTopMost = new System::Windows::Forms::MenuItem();
			this->menuItem4 = new System::Windows::Forms::MenuItem();
			this->openFileDialog1 = new System::Windows::Forms::OpenFileDialog();
			this->saveFileDialog1 = new System::Windows::Forms::SaveFileDialog();
			this->statusBar1 = new System::Windows::Forms::StatusBar();
			this->toolBar1 = new System::Windows::Forms::ToolBar();
			this->sepbegin = new System::Windows::Forms::ToolBarButton();
			this->openBtn = new System::Windows::Forms::ToolBarButton();
			this->saveBtn = new System::Windows::Forms::ToolBarButton();
			this->saveAsBtn = new System::Windows::Forms::ToolBarButton();
			this->sep1 = new System::Windows::Forms::ToolBarButton();
			this->imageList1 = new System::Windows::Forms::ImageList(this->components);
			this->SuspendLayout();
			// 
			// mainMenu1
			// 
			System::Windows::Forms::MenuItem* __mcTemp__1[] = new System::Windows::Forms::MenuItem*[4];
			__mcTemp__1[0] = this->fileMenu;
			__mcTemp__1[1] = this->menuItem3;
			__mcTemp__1[2] = this->windowMenu;
			__mcTemp__1[3] = this->menuItem4;
			this->mainMenu1->MenuItems->AddRange(__mcTemp__1);
			// 
			// fileMenu
			// 
			this->fileMenu->Index = 0;
			System::Windows::Forms::MenuItem* __mcTemp__2[] = new System::Windows::Forms::MenuItem*[6];
			__mcTemp__2[0] = this->openMenu;
			__mcTemp__2[1] = this->saveAsItem;
			__mcTemp__2[2] = this->saveItem;
			__mcTemp__2[3] = this->menuItem1;
			__mcTemp__2[4] = this->openLog;
			__mcTemp__2[5] = this->startupFile;
			this->fileMenu->MenuItems->AddRange(__mcTemp__2);
			this->fileMenu->Text = S"&File";
			// 
			// openMenu
			// 
			this->openMenu->Index = 0;
			this->openMenu->Shortcut = System::Windows::Forms::Shortcut::CtrlO;
			this->openMenu->Text = S"&Open Bin...";
			this->openMenu->Click += new System::EventHandler(this, openMenu_Click);
			// 
			// saveAsItem
			// 
			this->saveAsItem->Index = 1;
			this->saveAsItem->Text = S"Save Bin &As...";
			this->saveAsItem->Click += new System::EventHandler(this, saveAsMenu_Click);
			// 
			// saveItem
			// 
			this->saveItem->Index = 2;
			this->saveItem->Shortcut = System::Windows::Forms::Shortcut::CtrlS;
			this->saveItem->Text = S"&Save Bin";
			this->saveItem->Click += new System::EventHandler(this, saveMenu_Click);
			// 
			// menuItem1
			// 
			this->menuItem1->Index = 3;
			this->menuItem1->Text = S"-";
			// 
			// openLog
			// 
			this->openLog->Enabled = false;
			this->openLog->Index = 4;
			this->openLog->Text = S"Open Log File";
			this->openLog->Click += new System::EventHandler(this, openLog_Click);
			// 
			// startupFile
			// 
			this->startupFile->Index = 5;
			this->startupFile->Text = S"Edit Startup File...";
			this->startupFile->Click += new System::EventHandler(this, startupFile_Click);
			// 
			// menuItem3
			// 
			this->menuItem3->Index = 1;
			System::Windows::Forms::MenuItem* __mcTemp__3[] = new System::Windows::Forms::MenuItem*[2];
			__mcTemp__3[0] = this->openNgLogger;
			__mcTemp__3[1] = this->scriptManage;
			this->menuItem3->MenuItems->AddRange(__mcTemp__3);
			this->menuItem3->MergeOrder = 298;
			this->menuItem3->Text = S"E&xtras";
			// 
			// openNgLogger
			// 
			this->openNgLogger->Index = 0;
			this->openNgLogger->Text = S"PM6 NG Logger...";
			this->openNgLogger->Visible = false;
			this->openNgLogger->Click += new System::EventHandler(this, openNgLogger_Click);
			// 
			// scriptManage
			// 
			this->scriptManage->Index = 1;
			this->scriptManage->Shortcut = System::Windows::Forms::Shortcut::F5;
			this->scriptManage->Text = S"Script Manager...";
			this->scriptManage->Click += new System::EventHandler(this, scriptManage_Click);
			// 
			// windowMenu
			// 
			this->windowMenu->Index = 2;
			this->windowMenu->MdiList = true;
			System::Windows::Forms::MenuItem* __mcTemp__4[] = new System::Windows::Forms::MenuItem*[1];
			__mcTemp__4[0] = this->mnuToggleTopMost;
			this->windowMenu->MenuItems->AddRange(__mcTemp__4);
			this->windowMenu->MergeOrder = 299;
			this->windowMenu->Text = S"&Window";
			// 
			// mnuToggleTopMost
			// 
			this->mnuToggleTopMost->Enabled = false;
			this->mnuToggleTopMost->Index = 0;
			this->mnuToggleTopMost->Shortcut = System::Windows::Forms::Shortcut::CtrlT;
			this->mnuToggleTopMost->Text = S"Toggle Top Most ";
			this->mnuToggleTopMost->Visible = false;
			this->mnuToggleTopMost->Click += new System::EventHandler(this, mnuToggleTopMost_Click);
			// 
			// menuItem4
			// 
			this->menuItem4->Index = 3;
			this->menuItem4->MergeOrder = 999;
			this->menuItem4->Text = S"About";
			this->menuItem4->Click += new System::EventHandler(this, menuItem4_Click);
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->Multiselect = true;
			// 
			// statusBar1
			// 
			this->statusBar1->Location = System::Drawing::Point(0, 333);
			this->statusBar1->Name = S"statusBar1";
			this->statusBar1->Size = System::Drawing::Size(576, 16);
			this->statusBar1->TabIndex = 1;
			// 
			// toolBar1
			// 
			System::Windows::Forms::ToolBarButton* __mcTemp__5[] = new System::Windows::Forms::ToolBarButton*[5];
			__mcTemp__5[0] = this->sepbegin;
			__mcTemp__5[1] = this->openBtn;
			__mcTemp__5[2] = this->saveBtn;
			__mcTemp__5[3] = this->saveAsBtn;
			__mcTemp__5[4] = this->sep1;
			this->toolBar1->Buttons->AddRange(__mcTemp__5);
			this->toolBar1->DropDownArrows = true;
			this->toolBar1->ImageList = this->imageList1;
			this->toolBar1->Location = System::Drawing::Point(0, 0);
			this->toolBar1->Name = S"toolBar1";
			this->toolBar1->ShowToolTips = true;
			this->toolBar1->Size = System::Drawing::Size(576, 28);
			this->toolBar1->TabIndex = 3;
			this->toolBar1->ButtonClick += new System::Windows::Forms::ToolBarButtonClickEventHandler(this, toolBar1_ButtonClick);
			// 
			// sepbegin
			// 
			this->sepbegin->Style = System::Windows::Forms::ToolBarButtonStyle::Separator;
			// 
			// openBtn
			// 
			this->openBtn->ImageIndex = 0;
			this->openBtn->ToolTipText = S"Open a bin file...";
			// 
			// saveBtn
			// 
			this->saveBtn->ImageIndex = 1;
			this->saveBtn->ToolTipText = S"Save the current bin file";
			// 
			// saveAsBtn
			// 
			this->saveAsBtn->ImageIndex = 2;
			this->saveAsBtn->ToolTipText = S"Save the current file as...";
			// 
			// sep1
			// 
			this->sep1->Style = System::Windows::Forms::ToolBarButtonStyle::Separator;
			// 
			// imageList1
			// 
			this->imageList1->ColorDepth = System::Windows::Forms::ColorDepth::Depth32Bit;
			this->imageList1->ImageSize = System::Drawing::Size(16, 16);
			this->imageList1->ImageStream = (__try_cast<System::Windows::Forms::ImageListStreamer *  >(resources->GetObject(S"imageList1.ImageStream")));
			this->imageList1->TransparentColor = System::Drawing::Color::Transparent;
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->AutoScroll = (*__try_cast<__box System::Boolean *  >(configurationAppSettings->GetValue(S"Form1.AutoScroll", __typeof(System::Boolean))));
			this->ClientSize = System::Drawing::Size(576, 349);
			this->Controls->Add(this->toolBar1);
			this->Controls->Add(this->statusBar1);
			this->Icon = (__try_cast<System::Drawing::Icon *  >(resources->GetObject(S"$this.Icon")));
			this->IsMdiContainer = true;
			this->Menu = this->mainMenu1;
			this->Name = S"Form1";
			this->WindowState = System::Windows::Forms::FormWindowState::Maximized;
			this->Closing += new System::ComponentModel::CancelEventHandler(this, Form1_Closing);
			this->Load += new System::EventHandler(this, Form1_Load);
			this->ResumeLayout(false);

		}	

		//;
		//;
		//;

		//This code is only here because MC++ is stupid and wont let me have a forms messagebox
		//when windows.h is included.
		void bre20::Form1::child_closing(Object* sender, CancelEventArgs* args)
		{
			try
			{	
				child* rombox = dynamic_cast<child*>(sender);
				//remove child from scriptmanager
				scriptManager->RemoveChild(static_cast<Form*>(sender));

				if(rombox->getWasEdited() && MessageBox::Show(String::Concat("Do you want to save ",rombox->getFileName(),"?"),"BRE",MessageBoxButtons::YesNo,MessageBoxIcon::Question,
					MessageBoxDefaultButton::Button1) == DialogResult::Yes)
					saveActive(rombox->getFileName(), rombox->getFileLength());
			}
			catch(...){}

		}

		void child_function_called(Object* sender, ScriptFunctionCallArgs * e);
		void openMenu_Click(System::Object *  sender, System::EventArgs *  e);

		ParamPage* getParamPage(String * type, RomRep::HondaEcu* ecu);


		int Checksum(unsigned char thefile __gc[]);

		void saveMenu_Click(System::Object *  sender, System::EventArgs *  e);
		void saveAsMenu_Click(System::Object *  sender, System::EventArgs *  e);

		void Form1_Load(System::Object *  sender, System::EventArgs *  e);


//**********************************************
//******* 

		void bre20::Form1::openNgLogger_Click(System::Object *  sender, System::EventArgs *  e){}
		void bre20::Form1::openLog_Click(System::Object *  sender, System::EventArgs *  e){}
		void menuItem4_Click(System::Object *  sender, System::EventArgs *  e);
		
		void bre20::Form1::scriptManage_Click(System::Object *  sender, System::EventArgs *  e)
		{this->scriptManager->Visible = true;}
		void bre20::Form1::Form1_Closing(System::Object *  sender, System::ComponentModel::CancelEventArgs *  e)
		{e->Cancel = false;}
		
		void toolBar1_ButtonClick(System::Object *  sender, System::Windows::Forms::ToolBarButtonClickEventArgs *  e);
		void startupFile_Click(System::Object *  sender, System::EventArgs *  e);

		void mnuToggleTopMost_Click(System::Object *  sender, System::EventArgs *  e);

		void child_activated(System::Object *  sender, System::EventArgs *  e);
};
}


