#include "stdafx.h"
#include "formwithrules.h"

bre20::FormWithRules::FormWithRules(): Form()
{
	rules = new ArrayList(5);

	InitializeComponent();
}

bre20::FormWithRules::FormWithRules(ArrayList* rulearray): Form()
{
	rules = rulearray;
}

//*****************************************

bool bre20::FormWithRules::executeRules()
{
	try
	{
		for(int i =0; rules!= NULL && i<rules->Count; i++) 
		{
			Rule* r = static_cast<Rule*>(rules->get_Item(i));
			r->executeRule(this);
		}
		return true;
	}
	catch(...)
	{
		return false;
	}
}

bool bre20::FormWithRules::executeReplays(String* keys[], Hashtable* values)
{
	try
	{
		for(int i =0; rules!= NULL && i<rules->Count; i++) 
		{
			Rule* r = static_cast<Rule*>(rules->get_Item(i));
			r->executeReplay(keys,values);
		}
		return true;
	}
	catch(...)
	{
		return false;
	}
}

//called when the logger options are changed
bool bre20::FormWithRules::updateRules()
{
	try
	{
		for(int i =0; rules!= NULL && i<rules->Count; i++) 
		{
			Rule* r = static_cast<Rule*>(rules->get_Item(i));
			r->updateRule(this);
		}
		return true;
	}
	catch(...)
	{
		return false;
	}
}


//called when start button is pushed?
bool bre20::FormWithRules::setupRules()
{
	try
	{
		for(int i =0; rules!= NULL && i<rules->Count; i++) 
		{
			Rule* r = static_cast<Rule*>(rules->get_Item(i));
			r->setupRule(this);
		}
		return true;
	}
	catch(...)
	{
		return false;
	}
}

bool bre20::FormWithRules::finishRules()
{
	try
	{
		for(int i =0; rules!= NULL && i<rules->Count; i++) 
		{
			Rule* r = static_cast<Rule*>(rules->get_Item(i));
			r->finishRule(this);
		}
		return true;
	}
	catch(...)
	{
		return false;
	}
}
//*****************************************

//bool bre20::FormWithRules::addRule(Rule* rule)
//{
//	if(rule != NULL)
//	{
//		rules->Add(rule);
//		return true;
//	}
//	else
//		return false;
//}

int bre20::FormWithRules::findRule(String* modified, bool all)
{
	try
	{
		modified = modified->Trim()->ToLower();
		String* delim = ":";
		for(int i =0; i<rules->Count; i++) 
		{
			Rule* r = static_cast<Rule*>(rules->get_Item(i));
			String* str = r->modifiedFields()->Trim()->ToLower();

			if(all && modified->Equals(str))
				return i;
			else if(!all)
			{
				String* any[] = modified->Split(delim->ToCharArray());
				for(int j = 0; j<any->Length; j++)
					if(str->IndexOf(any[j]->Trim()) >= 0)
						return i;
			}

		}
		return ERR_NOT_FOUND;
	}
	catch(...)
	{
		return ERR_ERROR;
	}
}
int bre20::FormWithRules::replaceRule(String* modified, bool all, Rule* rule)
{
	int index = findRule(modified,all);
	if(index < 0)
		return index;

	try
	{
		rules->set_Item(index,rule);
		return REPLACED;
	}
	catch(...)
	{return ERR_ERROR;}
}

bool bre20::FormWithRules::removeRule(String* modified, bool all)
{
	int index = findRule(modified,all);
	if(index < 0)
		return false;

	try
	{
		rules->RemoveAt(index);
		return true;
	}
	catch(...)
	{return false;}
}

bool bre20::FormWithRules::removeRule(Rule* rule)
{
	try
	{
		rules->Remove(rule);
		return true;
	}
	catch(...)
	{return false;}
}

bool bre20::FormWithRules::hasRule(String* modified, bool all)
{
	if(findRule(modified,all) >= 0)
		return true;
	return false;
}
