#include "stdafx.h"
#include "FuelMap.h"

RomRep::FuelMap::FuelMap(int crap):Map()
{
	mult = new unsigned char __gc[1];
	mult[0] = crap;
}

RomRep::FuelMap::FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, int ind, int mode):Map(x1,y1,loc,ind,mode)
{
	mult = new unsigned char __gc[x1];
	multloc = multloc1;
}

RomRep::FuelMap::FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, unsigned char mltarray __gc[], int ind, int mode):Map(x1,y1,loc,ind,mode)
{
	mult = new unsigned char __gc[x1];

	for(int i = 0; i<x1; i++)
		mult[i] = mltarray[i];

	multloc = multloc1;
}

RomRep::FuelMap::FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, unsigned char mltarray __gc[],unsigned char fil __gc[], int ind, int mode):Map(x1,y1,loc,fil,ind,mode)
{
	mult = new unsigned char __gc[x1];

	for(int i = 0; i<x1; i++)
		mult[i] = mltarray[i];

	multloc = multloc1;
}

RomRep::FuelMap::~FuelMap()
{

}

void RomRep::FuelMap::byteChangeNotify(ByteChange* bc)
{
	if(bc->getLocation() >= (int)multloc && bc->getLocation() < (int)multloc+x)
	{
		int col = bc->getLocation() - multloc;
		mult[col];
	//	setMultiplier(col, (int)bc->getByte());
		for(int i = 0; i<y; i++)
			RealMapChanged(col,i,(int)map[col,i]);
	}

	RomRep::Map::byteChangeNotify(bc);
}

RomRep::ByteChange* RomRep::FuelMap::setVal(int x1, int y1, float val)
{
	int noo = calculate(x1,y1,val);
	if(x1<x && x1>(-1) && y1<y && y1>(-1) && noo>=0 && noo<256) //if its inside the map's bounds
	{
		return Map::setVal(x1,y1,val);
	}
	else if(noo>255 || noo<0) //increase/decrease the mult
	{
		//TODO: make the old values the same as what they were before the multiplier change

		//save the old row
		float oldvals __gc[] = new float __gc[this->y];
		for(int i = 0; i<oldvals->Length; i++)
			oldvals[i] = this->getVal(x1,i);//+.01F;

		//find the new multiplier
		while(noo>255 && mult[x1]<256)
		{
			mult[x1]++;
			noo = calculate(x1,y1,val);
		}

		while(noo<0 && mult[x1]>0)
		{
			mult[x1]--;
			noo = calculate(x1,y1,val);
		}

		//set the new multiplier
		setMultiplier(x1, mult[x1]);
		RomRep::ByteChange* bc = Map::setVal(x1,y1,val);

		for(int i = 0; i<oldvals->Length; i++)
			if(i != y1)
				Map::setVal(x1,i,calculate(x1,i,findBestMatch(x1,i,oldvals[i])));

		return bc;
	}
	return NULL;
}

int RomRep::FuelMap::findBestMatch(int x, int y, float target)
{
	int direct = 1; //are the values directly related?
	int base = calculate(x,y,target);
	bool bad = true;

	while(bad)
	{
		if(base > 0 && base < 255)
		{
			float tmp __gc[] = {/*calculate(x,y,base-1),*/calculate(x,y,base)*(float)direct,calculate(x,y,base+1)*(float)direct};
			
			if(tmp[0] > tmp[1])
				direct = -1;

			target = target*(float)direct;

			if(target < tmp[0])
				base -= direct;
			else if(target > tmp[1])
				base += direct;
			else if(target == tmp[0])
				return base;
			else if(target == tmp[1])
				return base+1;
			else
				return base+1;
		}
		else
			bad = false;
	}
	//if(tmp < target)
	return base;
}

RomRep::ByteChange* RomRep::FuelMap::setMultiplier(int column, int val)
{

	if(column>=0 && column<x && val >= 0 && val < 256)
	{
		mult[column] = val;
		MultiplierChanged(column,val);
		return new ByteChange(getMultiplierLocation(column),val);
	}
	else
		return NULL;
}

int RomRep::FuelMap::getMultiplierLocation(int column)
{
	return multloc + column;
}

//void RomRep::FuelMap::insertColumn(int column) //column inserted AFTER 'column'
//{
//	//Map::insertColumn(column);
//
//	//unsigned char tmpmult __gc[]= mult;
//
//	//mult = new unsigned char __gc[x];
//
//	//for(int col = 0; col<x; col++)
//	//{
//	//	if(col<=column)
//	//	{
//	//		mult[col] = tmpmult[col];
//	//		thefile[this->getCellLocation(col,y)] = tmpmult[col];
//	//	}
//	//	else if(col == column+1)
//	//	{
//	//		mult[col] = tmpmult[column];
//	//		thefile[this->getCellLocation(col,y)] = tmpmult[column];
//	//	}
//	//	else if(col> column+1)
//	//	{
//	//		mult[col] = tmpmult[col-1];
//	//		thefile[this->getCellLocation(col,y)] = tmpmult[col-1];
//	//	}
//	//}
//
//}