#pragma once
using namespace System;

#include "map.h"


namespace RomRep
{
	///all maps that are fuel will be derived from this...
	public __gc class FuelMap : public Map
	{

	public:
		
		FuelMap(int crap);
		FuelMap(int x, int y, unsigned int loc, unsigned int multloc, int ind, int mode);
		FuelMap(int x, int y, unsigned int loc, unsigned int multloc, unsigned char mltarray __gc[], int ind, int mode);
		FuelMap(int x, int y, unsigned int loc, unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[], int ind, int mode);

		virtual ~FuelMap();

		__event MapChangeHandler * OnMultiplierChanged;

		virtual void setMultiplierLocation(unsigned int loc){multloc = loc;};
		virtual unsigned int getMultiplierLocation(unsigned int loc){return multloc;};

		//virtual void insertColumn(int column); //column inserted AFTER 'column'

		//children MUST have these
		virtual void populate(unsigned char map __gc[,], unsigned char mltarray __gc[]) = 0;
		virtual void getMultipliers(int x, float mlts __gc[]) = 0;
		virtual unsigned char getIntMultipliers() __gc[] = 0;
		virtual float calculate(int x, int y, int intval) = 0;
		virtual int calculate(int x, int y, float mapval) = 0;

		virtual RomRep::ByteChange* setMultiplier(int column, int val);
		virtual int getMultiplierLocation(int column);

		virtual RomRep::ByteChange* setVal(int x, int y, float val);

		///For each inherited class, this will see if the byte location
		///applies to their object and then make the appropriate updates.
		virtual void byteChangeNotify(ByteChange* bc);
	protected:

		unsigned char mult __gc[] ;
		unsigned int multloc;

		void MultiplierChanged(int xx, int byte)
		{
			if (OnMultiplierChanged != NULL)
				OnMultiplierChanged(this, new MapChangeArgs(multloc+xx,xx,-1,byte));
		}

		int findBestMatch(int x, int y, float target);
	};
}