#include "stdafx.h"
#include "ITBMaps.h"
#include "Obd0VtecMaps.h"
#include "Common.h"
#include "Engine.h"
#include "HondaEcu.h"

RomRep::ITBHeaderCalculator::ITBHeaderCalculator(Object* map, Object* hondaecu):HeaderCalculator(map, hondaecu){}
bool RomRep::ITBHeaderCalculator::canEditHeader(bool column, int columnOrRow){
	int x = static_cast<RomRep::Map*>(m_map)->getX();
	return RomRep::ITBMapHelper::canEditHeader(x,column,columnOrRow);
}

RomRep::MapHeaderChangeArgs* RomRep::ITBHeaderCalculator::calculateHeaders(bool col, int columnOrRow)
{
	if(!col || columnOrRow != RomRep::Map::HEADER_EVENT_ALL)
		return NULL;

	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);

	String* headers[] = new String*[map->getX()];

	//we are going to recalculate All the headers all the time.
	RomRep::ITBMapHelper::setColumnHeaders(fil,headers);

	return new MapHeaderChangeArgs(RomRep::Map::HEADER_EVENT_ALL,RomRep::Map::HEADER_EVENT_NONE,headers);
}
RomRep::MapHeaderChangeArgs* RomRep::ITBHeaderCalculator::byteChangeNotify(ByteChange* bc){
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);
	String* headers[] = new String*[map->getX()];
	if(ITBMapHelper::recalcHeaders(fil,headers,bc))
		return new MapHeaderChangeArgs(Map::HEADER_EVENT_ALL,-1,headers);
	return NULL;
}
float RomRep::ITBHeaderCalculator::getReferenceArray() __gc[]
{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);
	int x = map->getX();
	float headers __gc[] = new float __gc[x];
	int loc = RomRep::ITBMapHelper::MAP_SCALAR_LOC+2;
	for(int i = 0; i<x; i++)
		headers[i] = (float)fil[loc+(x-1-i)*2];
	return headers;
}
RomRep::ByteChange* RomRep::ITBHeaderCalculator::setColumnHeader(int col, String* val)[]
{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	int x = static_cast<RomRep::Map*>(m_map)->getX();
	ByteChange* bc[] = new ByteChange*[1];
	bc[0] = RomRep::ITBMapHelper::calcColumnHeader(fil,col,x,val);
	if(bc[0] == NULL) return NULL;
	return bc;
}

//************************************************************************************

bool RomRep::ITBMapHelper::canEditHeader(int width, bool column, int columnOrRow)
{
    if(!column)
		return false;
	if(columnOrRow> 0 && columnOrRow < width-1)
		return true;
	return false;
}


bool RomRep::ITBMapHelper::recalcHeaders(unsigned char file __gc[],String* headers[], 
										ByteChange* bc)
{
	int loc = bc->getLocation();
	//this recalcs ALL of the headers if an outside source changes something.
	//really it shouldonly be all calced if the XOVER_LOC val is changed.
	if((loc == TPS_XOVER_LOC || (loc>=TPS_SCALAR_LOC+4 && loc<=TPS_SCALAR_LOC+34) || 
		(loc>=MAP_SCALAR_LOC+4 && loc<=MAP_SCALAR_LOC+34)))
	{
		setColumnHeaders(file,headers);
		return true;
	}
	return false;
}

//width is the with of the map
//mapvalue is the map value of the crossover
int RomRep::ITBMapHelper::getXoverCol(unsigned char thefile __gc[], int width)
{
	int mapval = thefile[TPS_XOVER_LOC];
	int i;
	width--;
	int loc = MAP_SCALAR_LOC+2;
	for(i = width-1; i>=0; i--)
		if( mapval >= ((int)thefile[loc + (width-i)*2]) )
			break;
	return i; //the column where the ecu starts using the tps;
}
RomRep::ByteChange* RomRep::ITBMapHelper::calcXoverCol(unsigned char thefile __gc[], int col, int width)
{
	if( col >= width ) return NULL;
	int loc = MAP_SCALAR_LOC+2;
	return new ByteChange(TPS_XOVER_LOC,thefile[loc+(width-1-col)*2]);
}
RomRep::ByteChange* RomRep::ITBMapHelper::calcColumnHeader( unsigned char thefile __gc[], int col, int width, String* val )
{
	int xover = getXoverCol(thefile,width);

	int loc = TPS_SCALAR_LOC;
	if(col<xover)
		loc = MAP_SCALAR_LOC;
	loc += 2;
	loc += (width-1-col)*2;

	RomRep::ByteChange* bc = NULL;
	int num = bre20::Common::extractInt(val);
	if(col >= xover && col < width)
		bc = new ByteChange(loc,(unsigned char)(num*2+50));//(num*206/100+24));
	else if(col >= 0 && col < xover)
		bc = new ByteChange(loc,(unsigned char)Engine::inHgToRaw(num,0));
		
	//protect the user from themselves!! If these map vectors 
	//arent decreasing, bad shit will happen.
	if(bc != NULL && (int)bc->getByte() >= thefile[loc-2])
		bc = new ByteChange(loc,thefile[loc-2]-1);
	else if(bc != NULL && (int)bc->getByte() < thefile[loc+2])
		bc = new ByteChange(loc,thefile[loc+2]+1);
	return bc;
}
//returns the lastNACol
String* RomRep::ITBMapHelper::calcColumnHeader(unsigned char thefile __gc[],int col,int width,int xovercol)
{
	int loc = TPS_SCALAR_LOC;
	if(col<xovercol)
		loc = MAP_SCALAR_LOC;
	loc+=2;
	int val = (int)thefile[loc + (width-1-col)*2];

	if(col<xovercol){
		int inhg = Engine::voltsToInHg(Engine::rawToVolts(val),0);
		return inhg.ToString();
	}
	else{
		int per = (val-50)/2;//((val-24)*100)/206;
		return String::Concat(per.ToString(),S"%");
	}
}
int RomRep::ITBMapHelper::setColumnHeaders(unsigned char thefile __gc[],String* headers[])
{
	int width = headers->Length;
	int index = getXoverCol(thefile,width);

	headers[headers->Length-1] = "100%"; //always!

	int len = headers->Length-2; 
	for(int i = 0; i<=len; i++)
		headers[i] = calcColumnHeader(thefile,i,width,index);

	return index-1;
}