#include "stdafx.h"
#include "ITBMaps.h"
#include "Obd0VtecMaps.h"

RomRep::ITBIgnMap::ITBIgnMap(int x1, int y1, unsigned int loc, unsigned char themap __gc[,], 
							 unsigned char fil __gc[], int cscalarloc, int rscalarloc,int xover,
							 int ind, int mod):Obd0IgnMap(x1,y1,loc,themap,fil,ind,mod)
{
	populate(themap);

	xoverloc = xover;

	this->vtec = false;
	if( ind > 0 )
		this->vtec = true;

	this->revscalarloc = rscalarloc;
	this->pressscalarloc = cscalarloc;

	RomRep::VT0MapHelper::setRpmScalars(rscalarloc,rpm,fil,vtec);
	RomRep::ITBMapHelper::setColumnHeaders(fil,vac,xoverloc,cscalarloc);
}

void RomRep::ITBIgnMap::setColumnHeader(int col, String* val)
{
	/*
	RomRep::ByteChange* bc = DevUtil::setHeader(col,val,this->thefile,vac);
	if(bc != NULL)
	{
		this->SendByteChangeRequest(bc->getLocation(), (unsigned char)bc->getByte());
		this->MapHeaderChanged(col,-1,vac[col]);
	}*/
}
////*********************************************
////*********************************************
////*********************************************
////*********************************************

RomRep::ITBFuelMap::ITBFuelMap(int x1, int y1,unsigned int loc, unsigned char themap __gc[,], 
							   unsigned int multloc1, unsigned char mltarray __gc[], 
							   unsigned char fil __gc[], int cscalarloc, int rscalarloc, int xover,
							   int ind, int mod):Obd0FuelMap(x1,y1,loc,themap,multloc1,mltarray,fil,ind,mod)
{
	this->populate(themap,mltarray);

	xoverloc = xover;

	this->vtec = false;
	if( ind > 0 )
		this->vtec = true;
	revscalarloc = rscalarloc;
	pressscalarloc = cscalarloc;

	RomRep::VT0MapHelper::setRpmScalars(rscalarloc,rpm,fil,vtec);
	RomRep::ITBMapHelper::setColumnHeaders(fil,vac,xoverloc,cscalarloc);
}

void RomRep::ITBFuelMap::setColumnHeader(int col, String* val)
{
	/*RomRep::ByteChange* bc = DevUtil::setHeader(col,val,thefile,vac);
	if(bc != NULL)
	{
		this->SendByteChangeRequest(bc->getLocation(), (unsigned char)bc->getByte());
		this->MapHeaderChanged(col,-1,vac[col]);
	}*/
}

//*********************
//*** helper functions

bool RomRep::ITBMapHelper::canEditHeader(int lastNACol, int width, bool column, int columnOrRow)
{
    if(!column)
		return false;

	if(columnOrRow > lastNACol && columnOrRow < width)
		return true;
	return false;
}


bool RomRep::ITBMapHelper::recalcHeaders(unsigned char file __gc[],String* headers[], 
										ByteChange* bc, int xoverloc, int scalarloc)
{
	int loc = bc->getLocation();
	if((loc == xoverloc || (loc>=scalarloc+4 && loc<=scalarloc+34)))// && ITBMapHelper::lastHandled != bc)
	{
	//	ITBMapHelper::lastHandled = bc;
		setColumnHeaders(file,headers,xoverloc,scalarloc);
		return true;
	}
	return false;
}

//width is the with of the map
//mapvalue is the map value of the crossover
int RomRep::ITBMapHelper::getXoverCol(int mapval, int width)
{
	int i;
	for(i = 0; i<width && mapval>=mapcolumns[i]; i++);
	return i-1; //the column where the ecu starts using the tps;
}
//returns the lastNACol
int RomRep::ITBMapHelper::setColumnHeaders(unsigned char thefile __gc[],String* headers[], int xoverloc, int scalarloc)
{
	int offset = scalarloc+4;
	//unsigned char scalars __gc[]= getArray(thefile,scalarloc+4,30);
	int xover = thefile[xoverloc];

	int i;
	for(i = 0; i<14 && xover>=mapcolumns[i]; i++);
	int index = i-1; //the column where the ecu starts using the tps;

	RomRep::VT0MapHelper::setPressScalars(0,headers,NULL);
	headers[14] = "100%";
//10 - 30 5% jumps
//						   100%  13   95%  13   90%  12   85%  11   80%  10
//	DB           0ffh,0dfh,0e5h,0dfh,0dah,0d0h,0cfh,0c0h,0c3h,0b0h,0b8h,0a0h
//				  70%  9    60%  8    50%  7    40%  6    30%  5    25%  4
//	DB           0a1h,090h,08ah,080h,073h,070h,05ch,060h,045h,050h,039h,040h
//				  20%  3    15%  2    10%  1
//	DB			 02eh,030h,022h,020h,017h,010h,0h,0h,0h,0h

	for(int i = 13; i>=index; i--)
	{
		int per = ((thefile[offset+((13-i)*2)]-24)*100)/206;
		headers[i] = String::Concat(per.ToString(),S"%");
	}

	return index-1;
}