#pragma once
using namespace System;

#include "obd0maps.h"
#include "obd0vtecmaps.h"
#include "bytechange.h"

namespace RomRep
{
	///see HeaderCalculator
	public __gc class ITBHeaderCalculator: public HeaderCalculator
	{
	public:
		ITBHeaderCalculator(Object* map, Object* hondaecu);
		virtual bool canEditHeader(bool column, int columnOrRow);
		virtual RomRep::MapHeaderChangeArgs* calculateHeaders(bool col, int columnOrRow);
		virtual RomRep::MapHeaderChangeArgs* byteChangeNotify(ByteChange* bc);
		virtual RomRep::ByteChange* setColumnHeader(int col, String* val)[];
		virtual float getReferenceArray() __gc[];
	};

	public __gc class ITBMapHelper
	{
	public:
		static int TPS_XOVER_LOC = 0x7ff0;
		static int TPS_SCALAR_LOC = 0x642f;
		static int MAP_SCALAR_LOC = 0x63d2;

		static int getXoverCol(unsigned char thefile __gc[], int width);
		static RomRep::ByteChange* calcXoverCol(unsigned char thefile __gc[], int col, int width);
		static bool canEditHeader(int width, bool column, int columnOrRow);
		static RomRep::ByteChange* calcColumnHeader( unsigned char thefile __gc[], int col, int width, String* val );
		static String* calcColumnHeader(unsigned char thefile __gc[],int col,int width,int xovercol);
		static int setColumnHeaders(unsigned char file __gc[],String* headers[]);
		static bool recalcHeaders(unsigned char file __gc[],String* headers[], ByteChange* bc);
	};
}