#pragma once
using namespace System;

#include "obd0maps.h"
#include "obd0vtecmaps.h"
#include "bytechange.h"

namespace RomRep
{
	public __gc class ITBMapHelper
	{
	public:
		static int mapcolumns __gc[] = {0xb,0x20,0x28,0x30,0x38,0x40,0x48,0x50,0x58,0x60,0x68,0x70,0x80,0x90};
	
		static RomRep::ByteChange* lastHandled;

		static int getXoverCol(int mapval, int width);
		static bool canEditHeader(int lastNACol, int width, bool column, int columnOrRow);
		static int setColumnHeaders(unsigned char file __gc[],String* headers[], 
			int xoverloc, int scalarloc);
		static bool recalcHeaders(unsigned char file __gc[],String* headers[], 
			ByteChange* bc, int xoverloc, int scalarloc);
	};

	[Serializable] public __gc class ITBIgnMap : public RomRep::Obd0IgnMap
	{
	private:
		int xoverloc;
	public:
		
		ITBIgnMap(int x, int y, unsigned int loc, unsigned char themap __gc[,], 
			unsigned char fil __gc[], int cscalarloc, int rscalarloc, int xoverloc, int ind, int mod);

		///Sets the header text for the specified column
		virtual void setColumnHeader(int col, String* val);

		virtual bool canEditHeader(bool column, int columnOrRow)
		{return RomRep::ITBMapHelper::canEditHeader(ITBMapHelper::getXoverCol(this->thefile[xoverloc],x), x,column,columnOrRow);};

		virtual void byteChangeNotify(ByteChange* bc){ 
			if(ITBMapHelper::recalcHeaders(thefile,vac,bc,xoverloc,pressscalarloc))
				this->MapHeaderChanged(Map::HEADER_EVENT_ALL,-1,vac);
			RomRep::Obd0IgnMap::byteChangeNotify(bc);
		};
	};

	[Serializable] public __gc class ITBFuelMap : public RomRep::Obd0FuelMap
	{
	private:
		int xoverloc;
	public:	
		ITBFuelMap(int x, int y,unsigned int loc, unsigned char themap __gc[,], 
			unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[],
			int cscalarloc, int rowScalarLoc, int xoverloc, int ind, int mod);

		///Sets the header text for the specified column
		virtual void setColumnHeader(int col, String* val);

		virtual bool canEditHeader(bool column, int columnOrRow)
		{return RomRep::ITBMapHelper::canEditHeader(ITBMapHelper::getXoverCol(this->thefile[xoverloc],x), x,column,columnOrRow);};

		virtual void byteChangeNotify(ByteChange* bc){ 
			if(ITBMapHelper::recalcHeaders(thefile,vac,bc,xoverloc,pressscalarloc))
				this->MapHeaderChanged(Map::HEADER_EVENT_ALL,-1,vac);
			RomRep::Obd0FuelMap::byteChangeNotify(bc);
		};
	};
}