#include "stdafx.h"
#include "JdmPr3Dev.h"
#include "devmaps.h"

RomRep::JdmPr3Dev::JdmPr3Dev(): JdmPr3(){}//,DevUtil(){}

RomRep::JdmPr3Dev::JdmPr3Dev(unsigned char rom __gc[], int flen): JdmPr3(rom, flen, 0x31DE, 0x41DD, 0x3414, 8,
		DevUtil::igmap, DevUtil::igmapvtec,DevUtil::fmap, DevUtil::fmapvtec, "Jdm Pr3 dev",DevUtil::getRomWidth(rom))
{
	lastNACol = DevUtil::findLastNACol(thefile);

	y = DevUtil::getRomHeight(rom);
	mapscalarloc = 0x63d2;
	widthloc = 0x7ffc;
	heightloc = 0x7ffd;
	tablesizeloc = 0x7ffe;
}

RomRep::FuelMap* RomRep::JdmPr3Dev::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new DevFuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,maxmapadd, maploc->mapRevScalarLoc,index,Map::MODE_FUEL);
	
	fm->setName(RomRep::VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::JdmPr3Dev::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new DevIgnMap(xx,yy,maploc->mapLoc,map,thefile,maxmapadd,maploc->mapRevScalarLoc,
		index,Map::MODE_IGNITION);
	
	im->setName(RomRep::VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

void RomRep::JdmPr3Dev::insertColumn(int column)
{
	//HondaEcu::insertColumn(column); //x has been incremented...

	//this->setByte(widthloc,x);
	//this->setByte(tablesizeloc,(x*y)%256);
	//this->setByte(tablesizeloc+1,(x*y)/256);

	////fix the column scalars
	//

	//unsigned char oldscalars __gc[] = this->getArray(thefile,mapscalarloc,x*3);

 //   int scalarptr = ((x-1)*3)-(column*3);//this is pointing at the map value of the column in the array

	////adjusts the scalars for the columns above the inserted column 
	////and sets the new column's ivalue
	//for(int i = 0; i<=scalarptr; i+=3)
	//{
	//	int ivalue = oldscalars[i+1] + oldscalars[i+2]*256;

	//	ivalue+=0x10;

	//	this->setByte(mapscalarloc+i+1,ivalue%256);
	//	this->setByte(mapscalarloc+i+2,ivalue/256);

	//}

	////set the new column's map value
	//int ivalue = (oldscalars[scalarptr] + oldscalars[scalarptr-3])/2;

	//this->setByte(mapscalarloc+scalarptr,ivalue);

	////sets the rest of the values...
	//for(int i = scalarptr; i<x*3; i++)
	//{
	//	this->setByte(mapscalarloc+i+3,oldscalars[i]);
	//}

	////setup the new headers...
	//String* oldheaders[,] = colheaders;
	//colheaders = new String *[2,x];

	//DevUtil::calcHeaders(thefile[maxmapadd],thefile,lastNACol,colheaders,rowheaders);
	//delete[] oldscalars;
	
}

///static stuff........
bool RomRep::JdmPr3Dev::validate(unsigned char h __gc[])
{
	bool good = true;
	int head[10] = {0x73,0x16,0x96,0x16,0x92,0x16,0x8F,0x00,0x03,0x16};

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			good = false;
		}

	int boost[5] = {0xCF,0x02,0x77,0xDF,0x01};

	for(int i = 0; i<5; i++)
		if(boost[i] != h[0x4406 + i])
			good = false;

	return good;
}