#pragma once
using namespace System;

#include "JdmPr3.h"
#include "devMaps.h"
namespace RomRep
{
	[Serializable] public __gc class JdmPr3Dev: public JdmPr3
	{
	protected:
		static int maxmapadd = 0x4f9;

		int mapscalarloc;
		int widthloc;
		int heightloc;
		int tablesizeloc;
		
		///overridden to properly
		///create a fuel map.
		///
		///If mapname == null, this function will give the map a name.
		///
		///colscalarloc parameter is ignored.\n
		///vtec parameter ignored if index <= 1 
		virtual FuelMap* createFuelMap(int xx, int yy, int index, String* mapname,
			RomRep::MapLocs* maploc,unsigned char map __gc[,],unsigned char mlt __gc[], bool vtec);

		///overridden to properly
		///create an ignition map.
		///
		///If mapname == null, this function will give the map a name.
		///
		///colscalarloc parameter is ignored.\n
		///vtec parameter ignored if index <= 1
		virtual Map* createIgnitionMap(int xx, int yy, int index, String* mapname,
			RomRep::MapLocs* maploc,unsigned char map __gc[,],bool vtec);

		virtual RomRep::HeaderCalculator* GetColumnHeaderCalculator(RomRep::Map* map){
			return new RomRep::DevHeaderCalculator(map,this);
		}
	public:
		JdmPr3Dev();
		JdmPr3Dev(unsigned char rom __gc[], int flen);

		virtual void insertColumn(int column);

		static bool validate(unsigned char h __gc[]);
	};
}