#include "stdafx.h"
#include "JdmPr3ITB.h"
#include "ITBmaps.h"

RomRep::JdmPr3ITB::JdmPr3ITB(): JdmPr3(){}

RomRep::JdmPr3ITB::JdmPr3ITB(unsigned char rom __gc[], int flen): JdmPr3(rom, flen)
{
	type = "PR3 ITB ROM";
}

RomRep::FuelMap* RomRep::JdmPr3ITB::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new VT0FuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,ITBMapHelper::TPS_SCALAR_LOC, maploc->mapRevScalarLoc,index,Map::MODE_FUEL);
	
	fm->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::JdmPr3ITB::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new VT0IgnMap(xx,yy,maploc->mapLoc,map,thefile,ITBMapHelper::TPS_SCALAR_LOC,
		maploc->mapRevScalarLoc,index,Map::MODE_IGNITION);
	
	im->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

//overridden to get the tps xover.
int RomRep::JdmPr3ITB::getLastNaCol()
{
	return lastNACol;
}

int RomRep::JdmPr3ITB::getXoverCol(){
	return ITBMapHelper::getXoverCol(thefile, x);
}
void RomRep::JdmPr3ITB::setXoverCol(int col){
	return setTPSXover((int)RomRep::ITBMapHelper::calcXoverCol(thefile,col,x)->getByte());
}
int RomRep::JdmPr3ITB::getTPSXover(){
	return (int)thefile[RomRep::ITBMapHelper::TPS_XOVER_LOC];
}
void RomRep::JdmPr3ITB::setTPSXover(int mapval){ 
	setByte(RomRep::ITBMapHelper::TPS_XOVER_LOC,mapval);
}

bool RomRep::JdmPr3ITB::validate(unsigned char h __gc[])
{
	bool good = JdmPr3::validate(h);

	int itbtest __gc[] = {0xF5,0xAC,0x60,0x2F,0x64,0x10,0xCB,0x29};
	int loc = 0x4e0;
	for(int i = 0; i<itbtest->Length; i++)
		if(itbtest[i] != h[loc+i])
			good = false;

	return good;
}