#include "stdafx.h"
#include "JdmPr3ITB.h"
#include "ITBmaps.h"

RomRep::JdmPr3ITB::JdmPr3ITB(): JdmPr3(){}

RomRep::JdmPr3ITB::JdmPr3ITB(unsigned char rom __gc[], int flen): JdmPr3(rom, flen)
{
	type = "PR3 ITB ROM";
}

RomRep::FuelMap* RomRep::JdmPr3ITB::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new ITBFuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,scalarloc, maploc->mapRevScalarLoc,xoverloc,index,Map::MODE_FUEL);
	
	fm->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::JdmPr3ITB::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new ITBIgnMap(xx,yy,maploc->mapLoc,map,thefile,scalarloc,
		maploc->mapRevScalarLoc,xoverloc,index,Map::MODE_IGNITION);
	
	im->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

//overridden to get the tps xover.
int RomRep::JdmPr3ITB::getLastNaCol()
{
	return lastNACol;
}

int RomRep::JdmPr3ITB::getXoverCol()
{
	return ITBMapHelper::getXoverCol(getTPSXover(), this->x);
}
void RomRep::JdmPr3ITB::setXoverCol(int col)
{
	return setTPSXover(ITBMapHelper::mapcolumns[col]);
}
int RomRep::JdmPr3ITB::getTPSXover()
{
	return (int)thefile[xoverloc];
}

void RomRep::JdmPr3ITB::setTPSXover(int mapval)
{ 
	setByte(this->xoverloc,mapval);
}
bool RomRep::JdmPr3ITB::validate(unsigned char h __gc[])
{

	int head[10] = {0x73,0x16,0x96,0x16,0x92,0x16,0x8F,0x00,0x03,0x16};

	bool good = true;

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
//			cout<<head[i]<<" shit "<< h[i];
			good = false;
		}

	int itbtest[6] = {0x60,0x2f,0x64,0x10,0xCB,0x25};
	int loc = 0x4e6;
	for(int i = 0; i<6; i++)
		if(itbtest[i] != h[loc+i])
			good = false;

	return good;
}