#include "stdafx.h"
#include "JdmPw0Dev.h"
#include "devutil.h"
#include "devmaps.h"

RomRep::JdmPw0Dev::JdmPw0Dev(): JdmPw0(){}//,DevUtil(){}

RomRep::JdmPw0Dev::JdmPw0Dev(unsigned char rom __gc[], int flen): JdmPw0(rom, flen, 0x391A, 0x3922, 0x3AD8, 4,
		DevUtil::igmap, DevUtil::igmapvtec,DevUtil::fmap, DevUtil::fmapvtec, "Jdm Pw0 dev",DevUtil::getRomWidth(rom))
{
	lastNACol = DevUtil::findLastNACol(thefile);

	y = DevUtil::getRomHeight(rom);
	mapscalarloc = 0x63d2;
	widthloc = 0x7ffc;
	heightloc = 0x7ffd;
	tablesizeloc = 0x7ffe;
}

RomRep::FuelMap* RomRep::JdmPw0Dev::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new DevFuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,maxmapadd, maploc->mapRevScalarLoc,index,Map::MODE_FUEL);
	
	fm->setName(RomRep::VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::JdmPw0Dev::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new DevIgnMap(xx,yy,maploc->mapLoc,map,thefile,maxmapadd,maploc->mapRevScalarLoc,
		index,Map::MODE_IGNITION);
	
	im->setName(RomRep::VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

void RomRep::JdmPw0Dev::insertColumn(int column)
{
	//HondaEcu::insertColumn(column); //x has been incremented...

	//this->setByte(widthloc,x);
	//this->setByte(tablesizeloc,(x*y)%256);
	//this->setByte(tablesizeloc+1,(x*y)/256);

	////fix the column scalars
	//

	//int* oldscalars = this->getArray(thefile,mapscalarloc,x*3);

 //   int scalarptr = ((x-1)*3)-(column*3);//this is pointing at the map value of the column in the array

	////adjusts the scalars for the columns above the inserted column 
	////and sets the new column's ivalue
	//for(int i = 0; i<=scalarptr; i+=3)
	//{
	//	int ivalue = oldscalars[i+1] + oldscalars[i+2]*256;

	//	ivalue+=0x10;

	//	this->setByte(mapscalarloc+i+1,ivalue%256);
	//	this->setByte(mapscalarloc+i+2,ivalue/256);

	//}

	////set the new column's map value
	//int ivalue = (oldscalars[scalarptr] + oldscalars[scalarptr-3])/2;

	//this->setByte(mapscalarloc+scalarptr,ivalue);

	////sets the rest of the values...
	//for(int i = scalarptr; i<x*3; i++)
	//{
	//	this->setByte(mapscalarloc+i+3,oldscalars[i]);
	//}

	////setup the new headers...
	//string ** oldheaders = colheaders;
	//colheaders = new string*[2];

	//colheaders[0] = new string[x];
	//colheaders[1] = new string[x];

	//calcHeaders(JdmPw0Dev::getMaxMapVal(thefile));
	
}

///static stuff........
bool RomRep::JdmPw0Dev::validate(unsigned char h __gc[])
{
	bool good = true;
	int head[10] = {0xD8,0x16,0xFF,0x16,0xFB,0x16,0x8F,0x00,0x84,0x15};

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			good = false;
		}

	int boost[5] = {0xff,0xff,0xff,0xff,0xff};

	for(int i = 0; i<5; i++)
		if(boost[i] == h[0x63d7 + i])
			good = false;

	return good;
}