#include "stdafx.h"
#include "JdmPw0ITB.h"
#include "ITBmaps.h"

RomRep::JdmPw0ITB::JdmPw0ITB(): JdmPw0(){}

RomRep::JdmPw0ITB::JdmPw0ITB(unsigned char rom __gc[], int flen): JdmPw0(rom, flen)
{
	type = "JDM PW0 ITB";
}

RomRep::FuelMap* RomRep::JdmPw0ITB::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new ITBFuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,scalarloc, maploc->mapRevScalarLoc,xoverloc,index,Map::MODE_FUEL);
	
	fm->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::JdmPw0ITB::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new ITBIgnMap(xx,yy,maploc->mapLoc,map,thefile,scalarloc,
		maploc->mapRevScalarLoc,xoverloc,index,Map::MODE_IGNITION);
	
	im->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

//overridden to get the tps xover.
int RomRep::JdmPw0ITB::getLastNaCol()
{
	return lastNACol;
}

int RomRep::JdmPw0ITB::getXoverCol()
{
	return ITBMapHelper::getXoverCol(getTPSXover(), this->x);
}
void RomRep::JdmPw0ITB::setXoverCol(int col)
{
	return setTPSXover(ITBMapHelper::mapcolumns[col]);
}
int RomRep::JdmPw0ITB::getTPSXover()
{
	return (int)thefile[xoverloc];
}

void RomRep::JdmPw0ITB::setTPSXover(int mapval)
{ 
	setByte(this->xoverloc,mapval);
}
bool RomRep::JdmPw0ITB::validate(unsigned char h __gc[])
{
	bool good = JdmPw0::validate(h);

	int itbtest __gc[] = {0x60,0x2f,0x64,0x10,0xCB,0x28};
	int loc = 0x4da;
	for(int i = 0; i<itbtest->Length; i++)
		if(itbtest[i] != h[loc+i])
			good = false;

	return good;
}