//
//#pragma once
//#if !defined BENSs_JDMOBD0PR3ITBECU_H
//#define BENSs_JDMOBD0PR3ITBECU_H


#pragma once
using namespace System;

#include "JdmPw0.h"
#include "ITBMaps.h"
namespace RomRep
{
	[Serializable] public __gc class JdmPw0ITB: public JdmPw0
	{
	protected:
		///overridden to properly
		///create a fuel map.
		///
		///If mapname == null, this function will give the map a name.
		///
		///colscalarloc parameter is ignored.\n
		///vtec parameter ignored if index <= 1 
		virtual FuelMap* createFuelMap(int xx, int yy, int index, String* mapname,
			RomRep::MapLocs* maploc,unsigned char map __gc[,],unsigned char mlt __gc[], bool vtec);

		///overridden to properly
		///create an ignition map.
		///
		///If mapname == null, this function will give the map a name.
		///
		///colscalarloc parameter is ignored.\n
		///vtec parameter ignored if index <= 1
		virtual Map* createIgnitionMap(int xx, int yy, int index, String* mapname,
			RomRep::MapLocs* maploc,unsigned char map __gc[,],bool vtec);

		virtual HeaderCalculator* GetColumnHeaderCalculator(RomRep::Map* map){
			return new RomRep::ITBHeaderCalculator(map,this);
		}

	public:
		JdmPw0ITB();
		JdmPw0ITB(unsigned char rom __gc[], int flen);

		///overridden to get the tps xover.
		virtual int getLastNaCol();

		virtual int getXoverCol();
		virtual void setXoverCol(int col);

		virtual int getTPSXover();
		virtual void setTPSXover(int mapval);

		static bool validate(unsigned char h __gc[]);
	};
}