#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "child.h"
#include "LogGridPage.h"
#include "appsettings.h"
#include "global.h"
#include "AfrEstimation.h"
#include "formwithrules.h"
#include "logfilereader.h"
#include "DynoOptions.h"

namespace bre20
{
	/// <summary> 
	/// Summary for LogAnalyzer
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class LogAnalyzer : public FormWithRules
	{
	protected:
		child * rom;
		LogFileReader* reader;
		DynoRule* dynoRule;
		//String * filename;
		//System::IO::StreamReader * file;
		int nummaps;
		int x, y;//, interval;

		//__wchar_t delimArr __gc[];

		bool afr;

		AutoEdit* ae;
		//Hashtable* hash;
		//String* labels[];
        
	//	int rpmindex, mapindex, xindex, yindex, wbindex, vtecindex, yfuelinterpindex,yigninterpindex;

		float minDisplayFactor;

		bool autotuned;
		bool estimate;

		//dir: 0 right, 1 down, 2 left, 3 up
		//count: number of blanks so far in this dir.
		bre20::AfrEstimation* estimateCell(int tbl, int col, int row, int count, int dir);
		float estimateCell(int tbl, int col, int row);
	private: 
		System::Windows::Forms::MainMenu *  mainMenu1;
		System::Windows::Forms::MenuItem *  menuItem1;
		System::Windows::Forms::MenuItem *  dynoOptions;
		System::Windows::Forms::MenuItem *  openLogFile;
		System::Windows::Forms::Label *  label1;
		System::Windows::Forms::TextBox *  minDispBox;
		System::Windows::Forms::Button *  applyBttn;
		System::Windows::Forms::MenuItem *  atOptions;

		LogGridPage* measuredTabs[];
		GridPage* targetTabs[];
		LogGridPage* differenceTabs[];

		void fillAnalyzer();

        //void getIndicies(String * header);
		void createGraphs();

		///returns the measured afr
		float readLog() __gc[,,]; //fills the measured graphs

		///returns the target afr
		float fillExtraGraphs(float measured __gc[,,]) __gc[,,];

		float finalafr __gc[,,];
		void fillFinalArray(float measured __gc[,,],float target __gc[,,]);
		float parseWeights(String* w) __gc[,];

		bre20::LogFileReader* openLog(String* fname);

	public: 
		LogAnalyzer(ArrayList* rules, child * romm, String * fname, AutoEdit* autoEdit);
		/*
		///\param key the heading/label/key of the value you want to retrieve
		///\returns a value from the log file corresponding to the key. null 
		///if something goes wrong
		String* getValue(String* key){
			try{
				return static_cast<String*>(hash->get_Item(key));
			}catch(...){return NULL;}
		}
		///\returns the keys/labels/headers you have to work with 
		String* getKeys()[]{return labels;}
		*/

		LogFileReader* getFileReader(){return reader;};
		///\returns the tab control so you can add new tabs for more functionality
		TabControl* getTabControl(){return this->tabControl1;}

		/*
		String* getFileName(){return filename;};
		int getInterval(){return interval;};
		*/
//****************************************************************
//****************************************************************
//****************************************************************
//****************************************************************
//windows forms stuff...

	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::TabControl *  tabControl1;
	private: System::Windows::Forms::Button *  autoTune;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->tabControl1 = new System::Windows::Forms::TabControl();
			this->autoTune = new System::Windows::Forms::Button();
			this->mainMenu1 = new System::Windows::Forms::MainMenu();
			this->menuItem1 = new System::Windows::Forms::MenuItem();
			this->dynoOptions = new System::Windows::Forms::MenuItem();
			this->openLogFile = new System::Windows::Forms::MenuItem();
			this->label1 = new System::Windows::Forms::Label();
			this->minDispBox = new System::Windows::Forms::TextBox();
			this->applyBttn = new System::Windows::Forms::Button();
			this->atOptions = new System::Windows::Forms::MenuItem();
			this->SuspendLayout();
			// 
			// tabControl1
			// 
			this->tabControl1->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->tabControl1->Location = System::Drawing::Point(0, 0);
			this->tabControl1->Name = S"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(664, 320);
			this->tabControl1->TabIndex = 0;
			// 
			// autoTune
			// 
			this->autoTune->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left);
			this->autoTune->Location = System::Drawing::Point(8, 336);
			this->autoTune->Name = S"autoTune";
			this->autoTune->Size = System::Drawing::Size(112, 24);
			this->autoTune->TabIndex = 1;
			this->autoTune->Text = S"Auto Tune";
			this->autoTune->FlatStyle = FlatStyle::System;
			this->autoTune->Click += new System::EventHandler(this, autoTune_Click);
			// 
			// mainMenu1
			// 
			System::Windows::Forms::MenuItem* __mcTemp__1[] = new System::Windows::Forms::MenuItem*[1];
			__mcTemp__1[0] = this->menuItem1;
			this->mainMenu1->MenuItems->AddRange(__mcTemp__1);
			// 
			// menuItem1
			// 
			this->menuItem1->Index = 0;
			System::Windows::Forms::MenuItem* __mcTemp__2[] = new System::Windows::Forms::MenuItem*[3];
			__mcTemp__2[0] = this->openLogFile;
			__mcTemp__2[1] = this->atOptions;
			__mcTemp__2[2] = this->dynoOptions;
			this->menuItem1->MenuItems->AddRange(__mcTemp__2);
			this->menuItem1->MergeOrder = 1;
			this->menuItem1->Text = S"Analyzer";
			// 
			// openLogFile
			// 
			this->openLogFile->Index = 0;
			this->openLogFile->Text = S"Open Log File...";
			this->openLogFile->Shortcut = Shortcut::CtrlShiftO;
			this->openLogFile->Click += new System::EventHandler(this, openLogFile_Click);
			// 
			// openLogFile
			// 
			this->dynoOptions->Index = 2;
			this->dynoOptions->Text = S"Analyzer Options...";
			this->dynoOptions->Shortcut = Shortcut::F9;
			this->dynoOptions->Click += new System::EventHandler(this, dynoOptions_Click);
			this->dynoOptions->Visible = false;
			this->dynoOptions->Enabled = false;
			// 
			// label1
			// 
			this->label1->Anchor = System::Windows::Forms::AnchorStyles::Bottom;
			this->label1->Location = System::Drawing::Point(480, 328);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(96, 16);
			this->label1->TabIndex = 2;
			this->label1->Text = S"Min Freq. Factor:";
			// 
			// minDispBox
			// 
			this->minDispBox->Anchor = System::Windows::Forms::AnchorStyles::Bottom;
			this->minDispBox->Location = System::Drawing::Point(480, 344);
			this->minDispBox->Name = S"minDispBox";
			this->minDispBox->Size = System::Drawing::Size(96, 20);
			this->minDispBox->TabIndex = 3;
			this->minDispBox->Text = S"2.0";
			this->minDispBox->KeyDown += new System::Windows::Forms::KeyEventHandler(this, minDispBox_KeyDown);
			this->minDispBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, minDispBox_KeyPress);
			// 
			// applyBttn
			// 
			this->applyBttn->Anchor = System::Windows::Forms::AnchorStyles::Bottom;
			this->applyBttn->Location = System::Drawing::Point(584, 336);
			this->applyBttn->Name = S"applyBttn";
			this->applyBttn->Size = System::Drawing::Size(72, 24);
			this->applyBttn->TabIndex = 4;
			this->applyBttn->Text = S"Apply";
			this->applyBttn->FlatStyle = FlatStyle::System;
			this->applyBttn->Click += new System::EventHandler(this, applyBttn_Click);
			// 
			// atOptions
			// 
			this->atOptions->Index = 1;
			this->atOptions->Text = S"Autotune Options...";
			this->atOptions->Shortcut = Shortcut::CtrlShiftA;
			this->atOptions->Click += new System::EventHandler(this, atOptions_Click);
			// 
			// LogAnalyzer
			// 
			//this->AcceptButton = this->applyBttn;
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(664, 370);
			this->Controls->Add(this->applyBttn);
			this->Controls->Add(this->minDispBox);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->autoTune);
			this->Controls->Add(this->tabControl1);
			this->Menu = this->mainMenu1;
			this->Name = S"LogAnalyzer";
			this->Text = S"Log Analyzer";
			this->ResumeLayout(false);

			this->ClientSize = System::Drawing::Size(664, 500);
		}		

		
		void targetTabs_CellChanged(System::Object *  sender, System::EventArgs *  e);
		void targetTabs_AfrChanged(Object* sender, RomRep::AfrChangeArgs* e);
		void props_AfrToLambda(Object* sender, bre20::PropertyEventArgs* e);

	private: System::Void autoTune_Click(System::Object *  sender, System::EventArgs *  e)
			 {
				 float min,max;
				 try
				 {
					min = Globals::Props->getFloatParam(S"atMinDifference");
					max = Globals::Props->getFloatParam(S"atMaxDifference");
				 }
				 catch(...)
				 {
					 MessageBox::Show(S"The values in the config file could not be converted",S"BRE");
					 return;
				 }

				 for(int tbl = 0; tbl<this->nummaps; tbl++)
				 {
					 for(int col = 0; col<x; col++)
						 for(int row = 0; row<y; row++)
						 {
							 if(differenceTabs[tbl]->getValue(col,row)!= 0.0)
							 {
								 float cellval = differenceTabs[tbl]->getValue(col,row);
								 float percent = (cellval/100.0F)+1.0F;

								 float num = Math::Abs(differenceTabs[tbl]->getValue(col,row));

								 if(num>max)
								 {
									 if(cellval < 0)
										 percent = (-max/100)+1;
									 else
										 percent = (max/100)+1;
								 }
								 if(num >= min && !ae->getBlockOut(tbl,col,row))
									rom->setFuelCell(col,row,rom->getFuelCell(col,row,tbl)*percent,tbl);

							 }
							 else
							 {
								 //here we do some guessing...
							 }
						 }
					

				 }

				 rom->Refresh();

				 this->autoTune->Enabled = false;
			 }

	private: System::Void dynoOptions_Click(System::Object *  sender, System::EventArgs *  e)
			 {
				 DynoOptions* dyn = new DynoOptions(dynoRule);
				 dyn->MdiParent = this->MdiParent;
				 dyn->Show();
			 }
	private: System::Void openLogFile_Click(System::Object *  sender, System::EventArgs *  e)
			 {
				 OpenFileDialog* ofd = new OpenFileDialog();
				 ofd->Filter = S"CSV files (*.csv)|*.csv|All files (*.*)|*.*";
				 ofd->FileName = reader->getFileName();

				 if(ofd->ShowDialog() == DialogResult::OK)
				 {
					LogFileReader* rd = openLog(ofd->FileName);
					if(rd != NULL)
					{
						reader = rd;
						autotuned = false;
						this->autoTune->Enabled = true;
						fillAnalyzer();
					}
				 }
			 }

private: System::Void applyBttn_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 try
			 {
				 this->minDisplayFactor = Convert::ToSingle(this->minDispBox->Text);
				 fillAnalyzer();
			 }
			 catch(...)
			 {
			 }
		 }

private: System::Void minDispBox_KeyDown(System::Object *  sender, System::Windows::Forms::KeyEventArgs *  e)
		 {
			
		 }

private: System::Void minDispBox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
		 {
			 Common::handleDoubleKeyPress(static_cast<TextBox*>(sender),e,false);
		 }

private: System::Void atOptions_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 rom->openAutoTuneOptions();
		 }

};
}