#pragma once

using namespace System;
using namespace System::IO;

namespace bre20
{

	/// <summary> 
	/// The Log file object that actually does the logging.
	/// </summary>
	public __gc class LogFileObj
	{
	private:
		StreamWriter* writer;

	public:
		LogFileObj(String* fname)
		{
			writer = new StreamWriter(new FileStream(fname,FileMode::Append));
		}

		void WriteLine(Object* sender, String* message)
		{
			writer->WriteLine(String::Concat(System::DateTime::Now.TimeOfDay.ToString(), S" ",
				sender->GetType()->Name, S": ", message));
			writer->Flush();
		}

		void Close()
		{
			writer->Close();
		}
	};

	// <summary> 
	// The static object that will be globally available.
	// </summary>
//	public __gc class LogFile
//	{
//	public:
//		static LogFileObj* logFile;
//
//		LogFile(){}
//	};
}