#include "stdafx.h"
#include "logfilereader.h"

bre20::LogFileReader::LogFileReader(String* fname)
{
	filename = fname;

	file = new System::IO::StreamReader(filename);


	if(file != NULL)
	{
		try{
			interval = Convert::ToInt32(file->ReadLine());
		}
		catch(...){
			interval = 100;
		}

		String * header = file->ReadLine();
		getIndicies(header);
	}
}
bre20::LogFileReader* bre20::LogFileReader::openLogFile(String* fname)
{
	try
	{
		LogFileReader* rd = new LogFileReader(fname);
		return rd;
	}
	catch(...)
	{
		LogFileReader::displayError(fname);
		return NULL;
	}
}
void bre20::LogFileReader::displayError(String* fname)
{
	MessageBox::Show(String::Concat("Error while trying to open ",fname,
		". Please make sure another application doesn't already have it open."),"BRE");
}
//should be called with the header string ONLY
String* bre20::LogFileReader::findDelim(String* line)[]
{
	String * delim = ";";
	String* strs[] = line->Split(delim->ToCharArray());
    
	if(strs->Length <2)
	{
		delim = ",";
		strs = line->Split(delim->ToCharArray());
	}

	delimArr = delim->ToCharArray();

	return strs;
}

void bre20::LogFileReader::getIndicies(String * header)
{
	labels = findDelim(header);
	hash = new Hashtable();

	for(int i = 0; i<labels->Length; i++)
	{
		hash->Add(labels[i]->Trim(),NULL);
	}
}

String* bre20::LogFileReader::readLine()
{
	String* str = NULL;
	if(file != NULL)
	{
		str = file->ReadLine();
		fillHashtable(str);
	}
	return str;
}

void bre20::LogFileReader::fillHashtable(String* vals)
{
	if(vals != NULL)
	{
		String* tokens[] = vals->Split(delimArr);

		int max = Math::Min(tokens->Length, labels->Length);

		for(int i = 0; i<max; i++)
			hash->set_Item(labels[i],tokens[i]);
	}
}