#pragma once
using namespace System;

#include "global.h"
//#include "LoggerData.h"

namespace bre20
{
	/*!
	*/
	public __gc class LogFileReader
	{
	private:
		String * filename;
		System::IO::StreamReader * file;

		int x, y, interval;
		__wchar_t delimArr __gc[];
		Hashtable* hash;
		String* labels[];

		void getIndicies(String * header);
		String* findDelim(String* line)[];
		void fillHashtable(String* vals);

	public:
		LogFileReader(String* fname);
		String* readLine();

		String* getFileName(){return filename;};
		int getInterval(){return interval;};
		String* getLabels()[]{return labels;};

		void closeFile(){if(file!=NULL) file->Close();};

		///\returns a the Hashtable's value based on the key 
		String* getValue(String* key){
			try{
				return static_cast<String*>(hash->get_Item(key));
			}catch(...){return NULL;}
		}
		///\returns the keys/labels/headers you have to work with 
		String* getKeys()[]{return labels;}

		static bre20::LogFileReader* openLogFile(String* fname);
		static void displayError(String* fname);
	};
}