#pragma once
#include "GridPage.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace bre20
{
	/// <summary> 
	/// tab page with a grid
	/// </summary>
	public __gc class LogGridPage : public bre20::GridPage
	{
	public:
		LogGridPage():GridPage(S"Map Trace", 15, 17, 2)
		{
			init();
		}
		
		LogGridPage(int x, int y):GridPage(S"Map Trace", x, y, 2)
		{
			init();
		}

		LogGridPage(int x, int y, String * str):GridPage(str, x, y, 2)
		{
			init();
		}
		
		//now in gridPage.
		//virtual void setSelection(int x, int y, int w, int h);
		virtual int getWidth();
		virtual int getHeight();

		virtual void setPaintMode(bool colors)
		{
			if(colors)
				this->grid->PaintMode = SimpleGrid::Grid::M_PAINT_ALL;
			else
				this->grid->PaintMode = SimpleGrid::Grid::M_PAINT_NO_COLORS;
		}

	private:
		System::Windows::Forms::ContextMenu* contextMenu;
		MenuItem* clear;
		void clear_Click(System::Object *  sender, System::EventArgs *  e);
		
		void init()
		{
			this->grid->PaintMode = SimpleGrid::Grid::M_PAINT_NO_COLORS;
			grid->ReadOnly = true;

			this->contextMenu = new System::Windows::Forms::ContextMenu();
			this->clear = new System::Windows::Forms::MenuItem();
			this->clear->Index = 0;
			this->clear->Text = S"Clear Grid";
			this->clear->Shortcut = System::Windows::Forms::Shortcut::CtrlDel;
			this->clear->Click += new System::EventHandler(this, clear_Click);
			this->contextMenu->MenuItems->Add(clear);

			this->ContextMenu = contextMenu;
		}
	};
}