#include "stdafx.h"
#include "LoggerData.h"
#include "common.h"
#include "primitivewrap.h"
#include "global.h"


bre20::LoggerData::LoggerData(String* type)
{

	cs_IniHandlerDevelop::IniStructure* inis = cs_IniHandlerDevelop::IniStructure::ReadIni(String::Concat(Application::StartupPath,"\\", fname));
	if(inis == NULL)
	{
		Globals::LogFile->WriteLine(this,S"LoggerData ctor: INI file not there!");
		throw new Exception("Problem with the INI file!");
	}

	hash = new Hashtable();
	
	String* strs[] = inis->GetCategories();
	String* category = NULL;

	for(int i = 0; i<strs->Length; i++){
		if(Common::isMatch(strs[i], type, false)){
			category = strs[i];
			break;
		}
	}
	
	if(category == NULL)
		throw new Exception(String::Concat("No definition for the type ",type, " was found."));

	strs = inis->GetKeys(category);

	commands = new unsigned char __gc[strs->Length];
	labels = new String*[strs->Length];

	for(int i = 0; i<strs->Length; i++){
		labels[i] = inis->GetValue(category,strs[i]);
		commands[i] = Convert::ToInt32(strs[i],16);

		hash->Add(labels[i], NULL);
	}
	inis = NULL;

	outLoggerKeys = new ArrayList();
	//afr key is special
	addLoggerKey(new LoggerKey("Afr",false,true));
}

void bre20::LoggerData::setResultsArray(unsigned char results __gc[])
{
//	Globals::LogFile->WriteLine(this,String::Concat("setResultsArray: results: ", (results==NULL).ToString()," labels: ", (labels==NULL).ToString()));

	if(results->Length != labels->Length)
	{
		Globals::LogFile->WriteLine(this,String::Concat(S"setResultsArray: arrays NOT the same length. results: ", 
			results->Length.ToString(), S", labels: ", labels->Length.ToString()));
//		return;
	}

	try
	{
		for(int i = 0; i<labels->Length; i++)
			hash->set_Item(labels[i],new Integer((int)results[i]));
	}
	catch(Exception* ex)
	{
		Globals::LogFile->WriteLine(this,String::Concat(S"setResultsArray: hash set Exception. hash: ", 
			(hash==NULL).ToString(), S", message: ", ex->Message));
	}
}

void bre20::LoggerData::addCommand(int cmd, String* label)
{
}

void bre20::LoggerData::addLoggerKey(LoggerKey* key)
{
	if(!locked)
		this->outLoggerKeys->Add(key);
}

int bre20::LoggerData::getNumLoggerKeys()
{
	return outLoggerKeys->Count;
}

bre20::LoggerKey* bre20::LoggerData::getLoggerKey(int index)
{
	if(outLoggerKeys->Count > index)
		return static_cast<LoggerKey*>(outLoggerKeys->get_Item(index));
	return NULL;
}
void bre20::LoggerData::removeLoggerKey(LoggerKey* key)
{
	if(!locked)
		outLoggerKeys->Remove(key);
}