#include "stdafx.h"
#include "ManagedUtil.h"

Object* bre20::ManagedUtil::getRealObject(Object* obj)
{
	MemoryStream* ms = new MemoryStream();
	BinaryFormatter* bf = new BinaryFormatter();
	bf->Serialize(ms,obj);
	return bf->Deserialize(ms);
}

float bre20::ManagedUtil::stringToSingle(String* str)
{
	Regex* regex = new Regex("-?\\d*(\\.\\d+)?");
	Match* m = regex->Match(str);
	String* s = m->ToString();
	float res;
	
	try
	{
		s = m->ToString();
		res = Convert::ToSingle(s);
	}
	catch(...)
	{return Single::MaxValue;}

	return res;
}

bool bre20::ManagedUtil::checkHandlerName(CSScriptLibrary::ScriptManager* manager, String* handler)
{
	return manager->CSScript->hasMethod(handler);
}

bool bre20::ManagedUtil::checkHandlerType(CSScriptLibrary::ScriptManager* manager, String* type)
{
	CSScriptLibrary::Script* sc = manager->CSScript->getScript(type);
	if(type != NULL && sc != NULL)
		return true;
	return false;
}

MenuItem* bre20::ManagedUtil::findMenuItem(String* text, Menu* menu)
{
	text = text->ToLower();

	for(int i = 0; i< menu->MenuItems->Count; i++)
	{
		MenuItem* mi = menu->MenuItems->get_Item(i);
		if(mi->Text->ToLower()->Equals(text))
			return mi;
		else
		{
			mi = findMenuItem(text,mi);
			if(mi != NULL)
				return mi;
		}
	}//end for

	return NULL;
}

ArrayList* bre20::ManagedUtil::parseByteChanges(RomRep::HondaEcu* ecu, String* fname, bool makeChangeOnRight)
{
	int base = -1;
	StreamReader* fr = new StreamReader(fname);
	String* line = NULL;

	Regex* offset = new Regex("offset[s]?[ \t]*:[ \t]*(?<offs>[a-z]+)(\\.)?", RegexOptions::Compiled);

	while((line = fr->ReadLine()) != NULL)
	{
		if(offset->IsMatch(line->ToLower()))
		{
			String* s = offset->Match(line->ToLower())->Result("${offs}");
			s = s->Trim()->ToLower();

			if(s->Equals(S"decimal") || s->Equals(S"dec"))
				base = 10;
			else if(s->Equals(S"hex") || s->Equals(S"hexadec") || s->Equals(S"hexadecimal"))
				base = 16;

			break;
		}//end if
	}//end while

	//should have the base here...

	if(base == -1)
	{
		fr->Close();
		System::Windows::Forms::MessageBox::Show("No proper base specified in the file. It must be specified before the byte changes as: \n\n 'offsets: hexadec' or 'offset: decimal' \n\n Hex, hexadec, hexadecimal, dec, decimal are all valid and case does not matter. Note that the base specified only applies to the OFFSETS, not the bytes (which are ALWAYS hex).");
		return NULL;
	}

	ArrayList* list = new ArrayList(100);


	//lets parse the rest of the file: the byte changes!

	String* addy = "[0-9a-fA-f]+(h)?)|(0[Xx][0-9a-fA-f]+";
	if(base == 10)
		addy = "\\d+";
	offset = new Regex(String::Concat("^[ \t]*(?<location>(",
		addy,//[0-9a-fA-f]+(h)?)|(0[Xx][0-9a-fA-f]+,
		")):[ \t]*(?<lbyte>(0x)?[0-9a-f]{2}(h)?)[ \t]+(?<rbyte>(0x)?[0-9a-f]{2}(h)?)"),
		RegexOptions::Compiled);

	while((line = fr->ReadLine()) != NULL)
	{
		if(offset->IsMatch(line->ToLower()))
		{
			Match* m = offset->Match(line->ToLower());
			addy = m->Result("${location}");

			String* byte = m->Result("${lbyte}");
			if(makeChangeOnRight)
				byte = m->Result("${rbyte}");

			byte = byte->Replace("h","");
			addy = addy->Replace("h","");

			RomRep::ByteChange* bc = ecu->setByteEx(Convert::ToInt32(addy,base),Convert::ToInt32(byte,16));

			if(bc != NULL)
				list->Add(bc);
		}//end if
	}//end while

	fr->Close();

	return list;
}