#pragma once

using namespace System;
using namespace System::Text::RegularExpressions;
using namespace System::IO;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Runtime::Serialization::Formatters::Binary;


#include "HondaEcu.h"
#include "ParamPage.h"
//#include "ByteChange.h"

	// This file ended up with the event args and related small classes

namespace bre20
{
	/// <summary> 
	/// Utility class for BRE.
	/// </summary>
	public __gc class ManagedUtil
	{

	public:
		ManagedUtil(){};
		static float stringToSingle(String* str);
		static ArrayList* parseByteChanges(RomRep::HondaEcu* ecu, String* fname, bool makeChangeOnRight);
		static bool checkHandlerName(CSScriptLibrary::ScriptManager* manager, String* handler);
		static bool checkHandlerType(CSScriptLibrary::ScriptManager* manager, String* type);
		//menu has to be of type MainMenu or MenuItem
		static MenuItem* findMenuItem(String* text, Menu* menu);

		static Object* getRealObject(Object*);
	};
//-------------------------------------------------------------
	public __gc class EventSubscription
	{
	protected:
		String* eventName;
		String* eventFn;

	public:
		EventSubscription(String* name, String* function)
		{
			eventName = name;
			eventFn = function;
		}

		String* getEventName(){return eventName;}
		String* getMethodName(){return eventFn;}
	};
//---------------------------------------------------------------
	public __gc class ScriptFunctionCallArgs: public EventArgs
	{

	protected:
		String* method;
		Object* obj;
		EventArgs* args;

	public:
		ScriptFunctionCallArgs(String* methodName, Object* component, EventArgs* args)
		{
			this->method = methodName;
			this->obj = component;
			this->args = args;
		};
		String* getMethod(){return method;}

		Object* getComponent(){return obj;}

		EventArgs* getEventArgs(){return args;}
	};
//-------------------------------------------------------------------
	[Serializable] public __gc class OnOpenRomArgs: public EventArgs
	{

	protected:
		bool open;
		RomRep::HondaEcu* rom;
		String* fname;
		ParamPage* ppage;

	public:
		OnOpenRomArgs(String* filename)
		{
			this->fname = filename;
			this->open = false;
			this->rom = NULL;
			this->ppage = NULL;
		};
		bool isOpenable(){return open;}
		void setOpenable(bool opena){open = opena;}

		String* getFilename(){return fname;}

		RomRep::HondaEcu* getRom(){return rom;}
		void setRom(RomRep::HondaEcu* r){rom = r;}

		ParamPage* getParamPage(){return ppage;}
		void setParamPage(ParamPage* page){ppage = page;}
	};
}