#include "stdafx.h"
#include "NGMaps.h"

RomRep::NGIgnMap::NGIgnMap(int x1, int y1, unsigned int loc, unsigned char themap __gc[,], 
						   unsigned char fil __gc[], int cscalarloc, int rscalarloc, 
						   int ind, int mod):Obd0IgnMap(x1,y1,loc,themap,fil,ind,mod)
{
	populate(themap);

	this->vtec = false;

	this->boost = false;
	if(ind > 0)
		this->boost = true;
	
	revscalarloc = rscalarloc;
	pressscalarloc = cscalarloc;

	RomRep::Pm6Ng::calcPressureHeaders(cscalarloc,vac,fil,boost);
	RomRep::Pm6Ng::calcRpmHeaders(rscalarloc,rpm,fil,boost);
}

//******************
//******************
//******************
//******************

RomRep::NGFuelMap::NGFuelMap(int x1, int y1,unsigned int loc, unsigned char themap __gc[,], 
	unsigned int multloc1, unsigned char mltarray __gc[], unsigned char fil __gc[], 
	int cscalarloc, int rscalarloc, int ind, int mod):Obd0FuelMap(x1,y1,loc,themap,multloc1,
	mltarray,fil,ind,mod)
{
	this->populate(themap,mltarray);

	this->vtec = false;
	this->boost = false;
	if(ind > 0)
		this->boost = true;
	revscalarloc = rscalarloc;
	pressscalarloc = cscalarloc;

	RomRep::Pm6Ng::calcPressureHeaders(cscalarloc,vac,fil,boost);
	RomRep::Pm6Ng::calcRpmHeaders(rscalarloc,rpm,fil,boost);

}

void RomRep::NGRemap::remapColumns(RomRep::HondaEcu* ecu, unsigned char remapData __gc[],int mapSize, int xover)
{
	int loc = NGMapGlobal::getRemapStart();
	for(int i = 0; i<remapData->Length; i++)
		ecu->setByte(loc+i,(int)remapData[i]);

	ecu->setByte(NGMapGlobal::getMapSensorLoc(),mapSize);
	ecu->setByte(NGMapGlobal::getMaxXOverLocReal(),xover);

	//order dependent! This one triggers the event to recalc the headers.
	ecu->setByte(NGMapGlobal::getMaxXOverLocEd(),xover);
}