#include "stdafx.h"
#include "NGMaps.h"

RomRep::NGIgnMap::NGIgnMap(int x1, int y1, unsigned int loc, unsigned char themap __gc[,], 
						   unsigned char fil __gc[], int cscalarloc, int rscalarloc, 
						   int ind, int mod):Obd0IgnMap(x1,y1,loc,themap,fil,ind,mod)
{
	populate(themap);

	this->vtec = false;

	this->boost = false;
	if(ind > 0)
		this->boost = true;
	
	revscalarloc = rscalarloc;
	pressscalarloc = cscalarloc;
}

//******************
//******************
//******************
//******************

RomRep::NGFuelMap::NGFuelMap(int x1, int y1,unsigned int loc, unsigned char themap __gc[,], 
	unsigned int multloc1, unsigned char mltarray __gc[], unsigned char fil __gc[], 
	int cscalarloc, int rscalarloc, int ind, int mod):Obd0FuelMap(x1,y1,loc,themap,multloc1,
	mltarray,fil,ind,mod)
{
	this->populate(themap,mltarray);

	this->vtec = false;
	this->boost = false;
	if(ind > 0)
		this->boost = true;
	revscalarloc = rscalarloc;
	pressscalarloc = cscalarloc;
}
RomRep::NGRowHeaderCalculator::NGRowHeaderCalculator(Object* map, 
				Object* hondaecu):HeaderCalculator(map,hondaecu){}
RomRep::MapHeaderChangeArgs* RomRep::NGRowHeaderCalculator::calculateHeaders(bool col, int columnOrRow)
{
	if(col) return NULL;
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);

	String* headers[];

	//we are going to recalculate All the headers all the time.
	bool boost = map->getIndex() > 0 ? true : false;
	int loc = map->getRowScalarLoc();
	headers = RomRep::Pm6Ng::calcRpmHeaders(loc,fil,boost);

	return new MapHeaderChangeArgs(RomRep::Map::HEADER_EVENT_NONE,RomRep::Map::HEADER_EVENT_ALL,headers);
}
float RomRep::NGRowHeaderCalculator::getReferenceArray() __gc[]{
	return RomRep::Pm6Ng::getRpmHeaders();
}

RomRep::NGHeaderCalculator::NGHeaderCalculator(Object* map, 
				Object* hondaecu):HeaderCalculator(map,hondaecu){}
RomRep::MapHeaderChangeArgs* RomRep::NGHeaderCalculator::calculateHeaders(bool col, int columnOrRow)
{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);

	String* headers[];

	//we are going to recalculate All the headers all the time.
	bool boost = map->getIndex() > 0 ? true : false;

	int loc = map->getColumnScalarLoc();
	headers = RomRep::Pm6Ng::calcPressureHeaders(loc,fil,boost);

	return new MapHeaderChangeArgs(RomRep::Map::HEADER_EVENT_ALL,RomRep::Map::HEADER_EVENT_NONE,headers);
}
RomRep::MapHeaderChangeArgs* RomRep::NGHeaderCalculator::byteChangeNotify(ByteChange* bc)
{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);
	bool boost = map->getIndex() > 0 ? true : false;
	if(bc->getLocation() == NGMapGlobal::getMaxXOverLocEd()){
		String* head[] = RomRep::Pm6Ng::calcPressureHeaders(map->getColumnScalarLoc(),fil,boost);
		return new RomRep::MapHeaderChangeArgs(Map::HEADER_EVENT_ALL,Map::HEADER_EVENT_NONE,head);
	}
	return NULL;
}
float RomRep::NGHeaderCalculator::getReferenceArray() __gc[]{
	unsigned char fil __gc[] = static_cast<RomRep::HondaEcu*>(m_hondaecu)->getFile();
	RomRep::Map* map = static_cast<RomRep::Map*>(m_map);
	bool boost = map->getIndex() > 0 ? true : false;
	int inth __gc[] = RomRep::Pm6Ng::rawPressureHeaders(map->getColumnScalarLoc(),fil,boost);
	int len = inth->Length;
	float f __gc[] = new float __gc[len];

	for(int i = 0; i<len; i++)
		f[i] = (float)inth[i];
	return f;
}

void RomRep::NGRemap::remapColumns(RomRep::HondaEcu* ecu, unsigned char remapData __gc[],int mapSize, int xover)
{
	int loc = NGMapGlobal::getRemapStart();
	for(int i = 0; i<remapData->Length; i++)
		ecu->setByte(loc+i,(int)remapData[i]);

	ecu->setByte(NGMapGlobal::getMapSensorLoc(),mapSize);
	ecu->setByte(NGMapGlobal::getMaxXOverLocReal(),xover);

	//order dependent! This one triggers the event to recalc the headers.
	ecu->setByte(NGMapGlobal::getMaxXOverLocEd(),xover);
}