#pragma once

using namespace System;

#include "obd0maps.h"
#include "pm6ng.h"

namespace RomRep
{
	public __gc class NGHeaderCalculator : public HeaderCalculator
	{
	public:
		NGHeaderCalculator(Object* map, Object* hondaecu);
		virtual RomRep::MapHeaderChangeArgs* calculateHeaders(bool col, int columnOrRow);
		virtual RomRep::MapHeaderChangeArgs* byteChangeNotify(ByteChange* bc);
		virtual float getReferenceArray() __gc[];
	};
	public __gc class NGRowHeaderCalculator : public HeaderCalculator
	{
	public:
		NGRowHeaderCalculator(Object* map, Object* hondaecu);
		virtual RomRep::MapHeaderChangeArgs* calculateHeaders(bool col, int columnOrRow);
		virtual float getReferenceArray() __gc[];
	};
	public __gc class NGRemap
	{
	public:
		static void remapColumns(RomRep::HondaEcu* ecu, unsigned char remapData __gc[],
			int mapSize, int xover);
	};

	public __gc class NGMapGlobal
	{
	private:
		static int mapXoverLocReal = 0x7fe9;
		static int mapXoverLocEd = 0x7fea;
		static int mapSensorLoc = 0x7fdc;
		static int remapStart = 0x4600;
		static int remapEnd = 0x46ff;
	public:
		static int getMaxXOverLocReal(){return mapXoverLocReal;};
		static int getMaxXOverLocEd(){return mapXoverLocEd;};
		static int getMapSensorLoc(){return mapSensorLoc;};
		static int getRemapStart(){return remapStart;};
		static int getRemapEnd(){return remapEnd;};
	};

	[Serializable] public __gc class NGIgnMap : public RomRep::Obd0IgnMap
	{
	private:
		bool boost;
	public:
		NGIgnMap(int x, int y, unsigned int loc, unsigned char themap __gc[,], 
			unsigned char fil __gc[], int cscalarloc, int rscalarloc, int ind, int mod);
	};

	[Serializable] public __gc class NGFuelMap : public RomRep::Obd0FuelMap
	{
	private:
		bool boost;
	public:
		NGFuelMap(int x, int y,unsigned int loc, unsigned char themap __gc[,], 
			unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[],
			int colScalarLoc, int rowScalaorLoc, int ind, int mod);
	};
}