#pragma once

//#include "HondaEcu.h"
//#include "FuelMap.h"
#include "ParamPage.h"
#include "pm6ng.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace bre20
{
	/// <summary> 
	/// tab page with a grid
	/// </summary>
	public __gc class NGParam : public ParamPage
	{
	public:
		NGParam();
		NGParam(RomRep::HondaEcu* ecu);
	protected: 
		void setupPage();

	private:
		bre20::LabeledText* revbox;
		bre20::LabeledText* coldrevbox;
		bre20::LabeledText* launchbox;
		bre20::LabeledText* launchspeed;
		System::Windows::Forms::GroupBox *  revGrp;
		System::Windows::Forms::GroupBox *  launchGrp;
		System::Windows::Forms::GroupBox *  genGrp;
		System::Windows::Forms::CheckBox *  boostEnabled;
		System::Windows::Forms::RadioButton *  o2On;
		System::Windows::Forms::RadioButton *  o2OffBoost;
		System::Windows::Forms::RadioButton *  o2Off;
		System::Windows::Forms::CheckBox *  launchEnabled;

		System::Windows::Forms::Label * namelabel;

		System::Windows::Forms::GroupBox * discodesgroup;
		System::Windows::Forms::ComboBox * discodesbox;
		System::Windows::Forms::Button * discodesadd;
		System::Windows::Forms::Button * discodesrem;

		System::Windows::Forms::GroupBox * mapGrp;
		System::Windows::Forms::Label * maplabel;
		System::Windows::Forms::ComboBox * mapsensor;

		System::Windows::Forms::GroupBox* grpVtec;
		System::Windows::Forms::TextBox* txtVtEngage;
		System::Windows::Forms::TextBox* txtMinTps;
		System::Windows::Forms::Label* labVtEn;
		System::Windows::Forms::Label* labMinTps;
		System::Windows::Forms::Label* labVtDis;
		System::Windows::Forms::Label* labPerc;
		System::Windows::Forms::TextBox* txtVtDis;
		System::Windows::Forms::CheckBox* chkVtecEnable;
        
		virtual void init();
		void populateCodes();
		void addExtraFeatures();
		//event shit
		System::Void revbox_Changed(System::Object *  sender, System::EventArgs *  e);
		System::Void coldrevbox_Changed(System::Object *  sender, System::EventArgs *  e);
		System::Void launchspeed_Changed(System::Object *  sender, System::EventArgs *  e);
		System::Void launchbox_Changed(System::Object *  sender, System::EventArgs *  e);
		System::Void boostEnabled_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void o2On_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void o2OffBoost_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void o2Off_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void launchEnabled_CheckedChanged(System::Object *  sender, System::EventArgs *  e);

		System::Void discoderemove_Click(System::Object *  sender, System::EventArgs *  e);
		System::Void discodeadd_Click(System::Object *  sender, System::EventArgs *  e);

		void intBox_KeyPress(Object* sender, KeyPressEventArgs* e){
			Common::handleIntKeyPress(static_cast<TextBox*>(sender),e,false);
		};
		void chkVtecEnable_CheckedChanged(Object* sender, EventArgs* e){
			static_cast<RomRep::Pm6Ng*>(rom)->setVtecEnabled(chkVtecEnable->Checked);
		};

		void combo_SelectedIndexChanged(Object * sender, EventArgs* args);

		void txtVtEngage_Leave(System::Object *  sender, System::EventArgs *  e);
		void txtMinTps_Leave(System::Object *  sender, System::EventArgs *  e);
		void txtVtDis_Leave(System::Object *  sender, System::EventArgs *  e);

		void txtVtEngage_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e){
			if(e->KeyChar == (char)13) txtVtEngage_Leave(NULL,NULL);
		}
		void txtMinTps_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e){
			if(e->KeyChar == (char)13) txtMinTps_Leave(NULL,NULL);
		}
		void txtVtDis_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e){
			if(e->KeyChar == (char)13) txtVtDis_Leave(NULL,NULL);
		}
	};
}