#include "stdafx.h"
#include "Obd0Maps.h"

RomRep::Obd0IgnMap::Obd0IgnMap(int crap):Map(){}
RomRep::Obd0IgnMap::Obd0IgnMap(int x1, int y1, unsigned int loc,int ind, int mod):Map(x1,y1,loc,ind,mod){}
RomRep::Obd0IgnMap::Obd0IgnMap(int x1, int y1, unsigned int loc, unsigned char themap __gc[,],
							   unsigned char fil __gc[],int ind, int mod):Map(x1,y1,loc,fil,ind,mod)
{
	Map::populate(themap);
}
RomRep::Obd0IgnMap::~Obd0IgnMap(){}
//---------------------------------------------------
float RomRep::Obd0IgnMap::calculate(int x1, int y1, int intval)
{
	return (((float)intval - 15.0F) * 9.0F) / 25.0F;
}
int RomRep::Obd0IgnMap::calculate(int x1, int y1, float mapval)
{
	return (int)(((mapval * 25) / 9) + 15);
}

/////**************************


RomRep::Obd0FuelMap::Obd0FuelMap(int crap):FuelMap(crap){}
RomRep::Obd0FuelMap::Obd0FuelMap(int x1, int y1, int ind, int mod):FuelMap(x1,y1,0,0,ind,mod){}
//must call populate(int ** map, int * multipliers) sometime after constructor call
RomRep::Obd0FuelMap::Obd0FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, 
								 int ind, int mod):FuelMap(x1,y1,loc,multloc1,ind,mod){}
//must call populate(int **map) sometime after EVC call
RomRep::Obd0FuelMap::Obd0FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, 
								 unsigned char mltarray __gc[], int ind, 
								 int mod):FuelMap(x1,y1,loc,multloc1,mltarray,ind,mod){}
RomRep::Obd0FuelMap::Obd0FuelMap(int x1, int y1,unsigned int loc, unsigned char themap __gc[,], 
								 unsigned int multloc1, unsigned char mltarray __gc[],
								 unsigned char fil __gc[], int ind, int mod):FuelMap(x1,y1,
								 loc,multloc1, mltarray,fil,ind,mod)
{
	Map::populate(themap);
}

RomRep::Obd0FuelMap::~Obd0FuelMap(){}

//---------------------------------------------------

void RomRep::Obd0FuelMap::populate(unsigned char mapp __gc[,], unsigned char mltarray __gc[])
{
	int i, j;

	for(i = 0; i<x; i++)
		mult[i] = mltarray[i];

	for(i = 0; i<x; i++)
		for(j = 0; j<y; j++)
			map[i,j] = mapp[i,j];
}

void RomRep::Obd0FuelMap::getMultipliers(int x1, float mlts __gc[])
{

	if(mult[x1] != 0)
	{
		mlts[0] = 208.0F / (pow(2.0F,mult[x1]) - 0.1F);
		mlts[1] = 224.0F / (pow(2.0F,mult[x1]) - 0.1F);
	}
	else
	{
		mlts[0] = 208.0F;
		mlts[1] = 224.0F;
	}

}
unsigned char RomRep::Obd0FuelMap::getIntMultipliers() __gc[]{ return mult; }

float RomRep::Obd0FuelMap::calculate(int x1, int y1, int intval)
{
	//#  a = 2 ^ Column Multiplier
	//# pulsewidth in ms = (Dec At Addy + (224/a))/(208/a)

	float mults __gc[]= new float __gc[2];
	float temp;

	getMultipliers(x1, mults);

	temp = (intval + mults[1]) / mults[0];

	return temp;
}

int RomRep::Obd0FuelMap::calculate(int x1, int y1, float mapval)
{
	float mults __gc[]= new float __gc[2];
	int temp;

	getMultipliers(x1, mults);

	temp = (int)((mapval * mults[0]) - mults[1]);

	return temp;
}