#pragma once
using namespace System;

#include "map.h"
#include "FuelMap.h"

namespace RomRep
{
	[Serializable] public __gc class Obd0IgnMap : public Map
	{
	public:
		Obd0IgnMap(int crap);
		Obd0IgnMap(int x, int y, unsigned int loc, int ind, int mod);
		Obd0IgnMap(int x, int y, unsigned int loc, unsigned char themap __gc[,],unsigned char fil __gc[], int ind, int mod);

		virtual ~Obd0IgnMap();

		virtual float calculate(int x, int y, int intval);
		virtual int calculate(int x, int y, float mapval);	

		virtual RomRep::ByteChange* setMultiplier(int column, int val){return NULL;}
		virtual int getMultiplierLocation(int column){return 0;}

		virtual void byteChangeNotify(ByteChange* bc){RomRep::Map::byteChangeNotify(bc);}
	};

	[Serializable] public __gc class Obd0FuelMap : public FuelMap
	{

	public:
		
		Obd0FuelMap(int crap);
		Obd0FuelMap(int x, int y, int ind, int mod);
		Obd0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc, int ind, int mod);
		Obd0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc, 
					unsigned char mltarray __gc[], int ind, int mod);
		Obd0FuelMap(int x, int y, unsigned int loc, unsigned char themap __gc[,], 
					unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[], 
					int ind, int mod);

		virtual ~Obd0FuelMap();

		///--------- override musts:-----------///
		virtual float calculate(int x, int y, int intval);
		virtual int calculate(int x, int y, float mapval);

		virtual void getMultipliers(int x, float mlts __gc[]);
		virtual unsigned char getIntMultipliers() __gc[];
		virtual void populate(unsigned char map __gc[,], unsigned char mltarray __gc[]);	

		virtual void byteChangeNotify(ByteChange* bc){RomRep::FuelMap::byteChangeNotify(bc);}
	};
}