#include "stdafx.h"
#include "Obd0NonVtecEcu.h"

RomRep::Obd0Ecu::Obd0Ecu():HondaEcu("OBD0 Non-VTEC"), revlimit(), revrestart()
{
	revconst = 1920000;
	x = 15;
	y = 17;
	//setupHeaders();
}

//the file, location, location, location of first one, number of vtec values.
RomRep::Obd0Ecu::Obd0Ecu(unsigned char rom __gc[], int flen, int revloc, int restartloc, int fuelmaploc, int fuelmltloc, int ignmaplocation, int fuelmaploc1, int fuelmltloc1, int ignmaploc1, int nummaps, String *  type):HondaEcu(rom, flen, 0, false, nummaps, type), revlimit(), revrestart()
{

	x = 15;
	y = 17;
	fmaploc = fuelmaploc;
	fmltloc = fuelmltloc;
	igmaploc = ignmaplocation;

	fmaploc1 = fuelmaploc1;
	fmltloc1 = fuelmltloc1;
	igmaploc1 = ignmaploc1;



	revconst = 1920000;

	revlimit = new RpmTwoByteValue(revloc, rom[revloc], revloc+2, rom[revloc+2]);
	revrestart = new RpmTwoByteValue(restartloc, rom[restartloc+2],restartloc, rom[restartloc+2]);

//	setupMaps();
//	setupHeaders();

}

RomRep::Obd0Ecu::~Obd0Ecu()
{
}

//void RomRep::Obd0Ecu::setupMaps()
//{
////	int i;
//	unsigned char map __gc[,];
//	unsigned char mlt __gc[];
//	//nummaps = 1;
//
//
//
//	//go get the maps from the rom and put the arrays into the map constructors...
//	map = HondaEcu::get2DArray(thefile, fmaploc, x,y);
//	mlt = HondaEcu::getArray(thefile, fmltloc, x);
//	
//	fuelmaps[0] = new Obd0FuelMap(x, y, fmaploc, map, fmltloc, mlt,thefile);
//
////--------------
////****************************MUST delete cause the map constructors dont do 
////****************************shallow copies.
//	//delete map and mlt
//	//for(i = 0; i<x; i++)//i<x
//	//	delete[] map[i];
//	//delete[] map;
//	//delete[] mlt;
//
////for boost pm6...
//	if(nummaps>1)
//	{
//		//go get the maps from the rom and put the arrays into the map constructors...
//		map = HondaEcu::get2DArray(thefile, fmaploc1, x,y);
//		mlt = HondaEcu::getArray(thefile, fmltloc1, x);
//		
//		fuelmaps[1] = new Obd0FuelMap(x, y, fmaploc1, map, fmltloc1, mlt,thefile);
//
//	//--------------
//	//****************************MUST delete cause the map constructors dont do 
//	//****************************shallow copies.
//		//delete map and mlt
//		//for(i = 0; i<x; i++)//i<x
//		//	delete[] map[i];
//		//delete[] map;
//		//delete[] mlt;
//	}
/////
//
//	map = HondaEcu::get2DArray(thefile, igmaploc, x,y);
//
//	ignmaps[0] = new Obd0IgnMap(x,y,igmaploc,map,thefile);
////--------------
//
//	//delete map
//	//for(i = 0; i<x; i++)//i<x
//	//	delete[] map[i];
//	//delete[] map;
//
//	//for boost pm6
//	if(nummaps>1)
//	{
//		map = HondaEcu::get2DArray(thefile, igmaploc1, x,y);
//
//		ignmaps[1] = new Obd0IgnMap(x,y,igmaploc1,map,thefile);
//	//--------------
//
//		//delete map
//		//for(i = 0; i<x; i++)//i<x
//		//	delete[] map[i];
//		//delete[] map;
//	}
//	///
//}

//int RomRep::Obd0Ecu::addMapPair(int loc, int x, int y)
//{
//
//}

//*********USE HondaEcu::setByte! it will set the byte in the rom
//setByte eventually will contain the undo stuff

void RomRep::Obd0Ecu::setTwoByteRpm(int loc, int rpm)
{
	int val = revconst/rpm;
	setByte(loc, val%256);
	setByte(loc+1,val/256);
}

int RomRep::Obd0Ecu::getTwoByteRpm(int loc)
{
	return revconst/((int)thefile[loc] + (int)thefile[loc+1]*256);
}

void RomRep::Obd0Ecu::setRevlimit(int val)
{
	setRpmValue(revlimit, val);
}

void RomRep::Obd0Ecu::setRevRestart(int val)
{
	setRpmValue(revrestart, val);
}

int RomRep::Obd0Ecu::getRevlimit()
{
	return getRpmValue(revlimit);
}

int RomRep::Obd0Ecu::getRevRestart()
{
	return getRpmValue(revrestart);
}
void RomRep::Obd0Ecu::setRpmValue(RomRep::RpmTwoByteValue* limit, int rpm)
{
	int bytes;
	if(rpm>0)
		bytes = revconst/rpm;
	else
		return;

	limit->setByte1(getHighByte(bytes));
	limit->setByte2(getLowByte(bytes));
	if(limit->getLocation1() != 0)
	{
		RomRep::HondaEcu::setByte(limit->getLocation1(), getHighByte(bytes));
		RomRep::HondaEcu::setByte(limit->getLocation2(), getLowByte(bytes));
	}
}

int RomRep::Obd0Ecu::getRpmValue(RomRep::RpmTwoByteValue* limit)
{
	int bytes = limit->getTwoByte();

	if(bytes >0)
		return revconst/bytes;
	else
		return -1;
}