//#pragma unmanaged
//
//#if !defined BENS_OBD0ECU_H
//#define BENS_OBD0ECU_H

#pragma once
using namespace System;

#include "HondaEcu.h"
#include "RpmValue.h"
#include "Obd0Maps.h"

namespace RomRep
{
	[Serializable] public __gc class Obd0Ecu: public HondaEcu
	{
	protected:
		//revlimit, restart, idle

		int revconst;
		int fmaploc, fmltloc, igmaploc,fmaploc1, fmltloc1, igmaploc1;
		RpmTwoByteValue* revlimit;
		RpmTwoByteValue* revrestart;
		//need an idle array too

		virtual int getHighByte(int bytes)
		{return bytes/256;}
		virtual int getLowByte(int bytes)
		{return bytes%256;}

		virtual void setRpmValue(RpmTwoByteValue* limit, int rpm);
		virtual int getRpmValue(RpmTwoByteValue* limit);

	public:
		Obd0Ecu();

		//the file, location, location, location of first one, number of vtec values.
		Obd0Ecu(unsigned char rom __gc[], int flen, int revloc, int restartloc, int fmaploc, int fmltloc, int imaploc, int fmaploc1, int fmltloc1, int imaploc1, int nummaps, String* type);

		virtual ~Obd0Ecu();

		//values will come in and go out as real world values
		virtual void setRevlimit(int val);
		virtual void setRevRestart(int val);

		virtual void setTwoByteRpm(int loc, int rpm);
		virtual int getTwoByteRpm(int loc); //returns rpm

		//return rpm
		virtual int getRevlimit();
		virtual int getRevRestart();
	};
}

//	ostream& operator<<(ostream& out, VT0Ecu& ecu);

//#endif