#include "stdafx.h"
#include "Obd0Pr3.h"

//pr3-93
//RomRep::Obd0Pr3::scalarLoc = {0x3ba6,0x3bb6,0x3bc6,0x3bd6};
RomRep::Obd0Pr3::Obd0Pr3(): VT0Ecu(){}

RomRep::Obd0Pr3::Obd0Pr3(unsigned char rom __gc[], int flen): VT0Ecu(rom, flen, 0x3543, 0x3553, 0x384D, 8, 0x449A,0x4599, 0x4698,0x47A6, Obd0Pr3::scalarLoc, "PR3-93",15)
{
	checksumaddy = 0x3fff;
	checksumlen = 0x8000;
}

bool RomRep::Obd0Pr3::validate(unsigned char h __gc[])
{
	int head[10] = {0x3A,0x19,0x61,0x19,0x5D,0x19,0x8F,0,0xCA,0x18}; //pr3

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
			return false;
	return true;
}

void RomRep::Obd0Pr3::disableChecksum(bool disable)
{
	aDisableChecksum(0x21F7,disable);
}
void RomRep::Obd0Pr3::disableOxygenSensors(bool disable)
{
	aDisableOxygenSensors(0x314E,disable);
}
void RomRep::Obd0Pr3::disable2ndOxygenSensor(bool disable)
{
	aDisable2ndOxygenSensor(0x3116,disable);
}
int RomRep::Obd0Pr3::isChecksumDisabled()
{
	return aisChecksumDisabled(0x21F7);
}
int RomRep::Obd0Pr3::isOxygenSensorsDisabled()
{
	return aisOxygenSensorsDisabled(0x314E);
}
int RomRep::Obd0Pr3::is2ndOxygenSensorDisabled()
{
	return ais2ndOxygenSensorDisabled(0x3116);
}

//*******new


void RomRep::Obd0Pr3::setLaunchRpm(int val)
{
	asetLaunchRpm(0x39f2, val);
}

void RomRep::Obd0Pr3::setLaunchSpeed(int val)
{
	asetLaunchSpeed(0x39f2, val);
}
void RomRep::Obd0Pr3::enableLaunch(bool enable)
{
	int loc = 0xE75;
	if(enable)
	{
		setByte(loc, 0x32);
		setByte(loc+1, 0xF2);
		setByte(loc+2, 0x39);

		loc = 0x39f2;
		setByte(loc, 0xC5);
		setByte(loc+1, 0xCB);
		setByte(loc+2, 0xC0);
		setByte(loc+3, 0x0A);
		setByte(loc+4, 0xC8);
		setByte(loc+5, 0x0B);
		setByte(loc+6, 0x67);
		setByte(loc+7, 0x02);
		setByte(loc+8, 0x02);
		setByte(loc+9, 0xC5);
		setByte(loc+10, 0xF6);
		setByte(loc+11, 0x2F);
		setByte(loc+12, 0xC8);
		setByte(loc+13, 0x03);
		setByte(loc+14, 0x86);
		setByte(loc+15, 0x01);
		setByte(loc+16, 0x00);
		setByte(loc+17, 0xC5);
		setByte(loc+18, 0x24);
		setByte(loc+19, 0x2C);
		setByte(loc+20, 0x01);
	}
	else
	{
		setByte(loc, 0xC5);
		setByte(loc+1, 0x24);
		setByte(loc+2, 0x2C);

		for(int i = 0x39f2; i<0x3A07; i++)
			setByte(i, 0xFF);
	}
}

void RomRep::Obd0Pr3::disableSpeedLimiter(bool disable) 
{
	int loc = 0xe53;
	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0xe5d;
		setByte(loc, 2);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xcA);
		setByte(loc+1, 3);

		loc = 0xe5d;
		setByte(loc, 0xe0);
		setByte(loc+1, 3);
	}
}

void RomRep::Obd0Pr3::disableVssCheck(bool disable) 
{
	int loc = 0xCBA;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xDB);
		setByte(loc+1, 0x29);
		setByte(loc+2, 0x0e);
	}
}

void RomRep::Obd0Pr3::disableTempCheck(bool disable) 
{
	int loc = 0xCB8;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCD);
		setByte(loc+1, 0x11);
	}
}

void RomRep::Obd0Pr3::disablePsCheck(bool disable) 
{
	int loc = 0x8D7;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		
		loc = 0xCB2;
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0x23f8;
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xCA);
		setByte(loc+1, 0x13);
		
		loc = 0xCB2;
		setByte(loc, 0xCA);
		setByte(loc+1, 0x17);

		loc = 0x23f8;
		setByte(loc, 0xc4);
		setByte(loc+1, 0x2d);
		setByte(loc+2, 0x3f);
	}
}

void RomRep::Obd0Pr3::disableCelCheck(bool disable)
{
	int loc = 0xca4;
	adisableCelCheck(loc, disable);

}

int RomRep::Obd0Pr3::isKnockSensorDisabled()
{
	return aisKnockSensorDisabled(0x8f9);
}
void RomRep::Obd0Pr3::disableKnockSensor(bool disable)
{
	adisableKnockSensor(0x8f9,0xb4d,0x1334,disable);
}

void RomRep::Obd0Pr3::disableCodes(bool disable)
{
	//aDisableCodes(0x2ec0,disable);
}
int RomRep::Obd0Pr3::isCodesDisabled()
{
	//sisCodesDisabled(0x304a);
	return -1;
}

int RomRep::Obd0Pr3::isSpeedLimiterDisabled()
{
	return aisSpeedLimiterDisabled(0xE53);
}
int RomRep::Obd0Pr3::isVssCheckDisabled()
{
	return aisVssCheckDisabled(0xCBA);
}
int RomRep::Obd0Pr3::isTempCheckDisabled()
{
	return aisTempCheckDisabled(0xCB8);
}
int RomRep::Obd0Pr3::isCelCheckDisabled()
{
	return aisCelCheckDisabled(0xCA4);
}
int RomRep::Obd0Pr3::isPsCheckDisabled()
{
	return aisPsCheckDisabled(0x8D7);
}
int RomRep::Obd0Pr3::isLaunchDisabled()
{
	return aisLaunchDisabled(0x39f2);
}

int RomRep::Obd0Pr3::getLaunchRpm()
{
	return agetLaunchRpm(0x39F2);
}
int RomRep::Obd0Pr3::getLaunchSpeed()
{
	return agetLaunchSpeed(0x39F2);
}

int RomRep::Obd0Pr3::isCodeBitDisable(int code)
{
//    if(code == 5 || code == 17 || code == 21 || code == 22 || code == 10 || code == 6 || code == 14 || code == 20)
//		return 1;
//	else
		return 0;
}
int RomRep::Obd0Pr3::codeBitDisable(int code, bool disable)
{
	
	return 0;
}
int RomRep::Obd0Pr3::isCodeBitDisabled(int code)
{
	return -1;
}
//****************************************************************
