#include "stdafx.h"
#include "Obd0VtecEcu.h"

RomRep::VT0Ecu::VT0Ecu():HondaEcu("OBD0 VTEC")
{
	revconst = 1852000;
	numvtec = 1;
	vtec = new RpmByteValue*[numvtec];
	x = 15;
	y = 17;
	celvecloc = 0x7f00;

	target_afr_loc[0] = 0x72c6;
	target_afr_loc[1] = 0x74e2;
	//setupHeaders();
}

//the file, location, location, location of first one, number of vtec values.
RomRep::VT0Ecu::VT0Ecu(unsigned char rom __gc[], int flen, int revloc, int restartloc, int vtecloc, int vtecnum, int ignmapad1, int ignmapad2, int fuelmapad1, int fuelmapad2, String *  type,int width):HondaEcu(rom, flen, 0, true, 2, type)
{
	int scalarLoc __gc[] = {0x3ba6,0x3bb6,0x3bc6,0x3bd6};
	setup(rom , flen, revloc, restartloc, vtecloc, vtecnum, ignmapad1, ignmapad2, fuelmapad1, fuelmapad2,scalarLoc, type,width);
}
RomRep::VT0Ecu::VT0Ecu(unsigned char rom __gc[], int flen, int revloc, int restartloc, int vtecloc, int vtecnum, int ignmapad1, int ignmapad2, int fuelmapad1, int fuelmapad2, int revscalars __gc[], String *  type,int width):HondaEcu(rom, flen, 0, true, 2, type)
{
	setup(rom , flen, revloc, restartloc, vtecloc, vtecnum, ignmapad1, ignmapad2, fuelmapad1, fuelmapad2,revscalars, type,width);
}
//the file, location, location, location of first one, number of vtec values.
void RomRep::VT0Ecu::setup(unsigned char rom __gc[], int flen, int revloc, int restartloc, int vtecloc, int vtecnum, int ignmapad1, int ignmapad2, int fuelmapad1, int fuelmapad2, int revscalars __gc[], String *  type,int width)
{
	int i;

	x = width;
	y = 17;
	target_afr_loc[0] = 0x72c6;
	target_afr_loc[1] = 0x74e2;

	lastNACol = width-2;

	revconst = 1852000;
	numvtec = vtecnum;

	revlimit = new RpmTwoByteValue(revloc, rom[revloc],revloc+1,rom[revloc+1]);
	revrestart = new RpmTwoByteValue(restartloc, rom[restartloc],restartloc+1, rom[restartloc+1]);
	vtec = new RpmByteValue*[vtecnum];

	for(i = 0; i<vtecnum; i++)
		vtec[i] = new RpmByteValue(vtecloc+i, rom[vtecloc+i]);

	if(revscalars->Length != 4)
		return;

	MapLocs* mapinfo[] = new MapLocs*[4];

	//revscalar_ig = 0x3ba6;
	//revscalar_igv = 0x3bb6;
	//revscalar_fu = 0x3bc6;
	//revscalar_fuv = 0x3bd6;

	mapinfo[0] = new MapLocs(fuelmapad1,0,revscalars[2]);
	mapinfo[1] = new MapLocs(fuelmapad2,0,revscalars[3]);
	mapinfo[2] = new MapLocs(ignmapad1,0,revscalars[0]);
	mapinfo[3] = new MapLocs(ignmapad2,0,revscalars[1]);

	try
	{
		VT0Ecu::setupMaps(mapinfo);
	}
	catch(Exception* e)
	{
		System::Windows::Forms::MessageBox::Show(String::Concat(e->get_InnerException(),S"\n\n",e->get_Message(),S"\n\n", e->get_HelpLink(), "\n\n",e->get_StackTrace(),"::::", e->get_Source()));
	}

	celvecloc = 0x7f00;

//	setupHeaders();

}

RomRep::VT0Ecu::~VT0Ecu()
{
}

RomRep::FuelMap* RomRep::VT0Ecu::createFuelMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   unsigned char mlt __gc[], bool vtec)
{
	FuelMap* fm = new VT0FuelMap(xx, yy, maploc->mapLoc, map, maploc->mapLoc+(xx*yy), 
		mlt,thefile,0, maploc->mapRevScalarLoc,index,Map::MODE_FUEL);
	
	fm->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_FUEL));

	return fm;
}
RomRep::Map* RomRep::VT0Ecu::createIgnitionMap(int xx, int yy, int index, String* mapname,
											   RomRep::MapLocs* maploc,unsigned char map __gc[,],
											   bool vtec)
{
	Map* im = new VT0IgnMap(xx,yy,maploc->mapLoc,map,thefile,0,maploc->mapRevScalarLoc,index,Map::MODE_IGNITION);
	
	im->setName(VT0MapHelper::getMapName(mapname,index,Map::MODE_IGNITION));
	return im;
}

//***UTILITIES
void RomRep::VT0Ecu::setTwoByteRpm(int highloc, int lowloc, int rpm)
{
	int val = revconst/rpm;
	setByte(lowloc, val%256);
	setByte(highloc,val/256);
}

int RomRep::VT0Ecu::getTwoByteRpm(int highloc, int lowloc)
{
	int denom = ((int)thefile[lowloc] + (int)thefile[highloc]*256);
	if(denom != 0)
		return revconst/denom;
	return revconst;
}

int RomRep::VT0Ecu::getRpmScalarValue(int row, bool fuel, bool vtec)
{
	int loc;

	int index = 0;
	if(vtec)
		index = 1;
	if(fuel)
		loc = fuelmaps[index]->getRowScalarLoc();
	else
		loc = ignmaps[index]->getRowScalarLoc();

	return thefile[loc+row];
}

//*********USE HondaEcu::setByte! it will set the byte in the rom
//setByte eventually will contain the undo stuff

void RomRep::VT0Ecu::setVtecEngage(int i, int val)
{
	//i == addition past normal location
	//loc = absolute loc

	//first vtec location 
	int loc = vtec[0]->getLocation() + i;

//	int i = loc - loc1;
	//[a7h] = d000h/rev count 
//	int bite = (int)((double)val * .02875);
	int bite = (int)((float)val/57.2)+128;
	
	if(i>=0 && i<numvtec && bite<256 && bite>=0)
	{	
		vtec[i]->setByte(bite);

		RomRep::HondaEcu::setByte(loc, bite);
	}
	else
	{}
//		cout<<"VTEC location out of bounds"<<endl;
}

void RomRep::VT0Ecu::setVtecDisengage(int loc, int val)
{
	setVtecEngage(loc,val);
}

void RomRep::VT0Ecu::setRpm(RpmTwoByteValue * stor, int val)
{
	int hbyte, lbyte; 

	//val is in rpm
	//min revlimit == 7219rpm

	val = revconst/val;

	hbyte = val/256;
	lbyte = val%256;

	if(stor->getLocation1() != 0 && lbyte<256 && lbyte>=0 && hbyte<256 && hbyte>=0)
	{
		stor->setByte1(lbyte);
		stor->setByte2(hbyte);
		RomRep::HondaEcu::setByte(stor->getLocation1(), lbyte);
		RomRep::HondaEcu::setByte(stor->getLocation1()+1, hbyte);
	}

}
void RomRep::VT0Ecu::setRevlimit(int val)
{
	setRpm(revlimit, val);
}

void RomRep::VT0Ecu::setRevRestart(int val)
{
	setRpm(revrestart, val);
}

int RomRep::VT0Ecu::getVtecEngage(int loc)
{
	//return an RPM value

	//first vtec location 
	int loc1 = vtec[0]->getLocation();

	//get index
	//int i = loc - loc1; //if you want to use the actual rom location
	int i = loc;
	int bite = -1;
	
	//convert the bite into an rpm val
	//80h + 10000h/(rev count*2)
	if(i>=0 && i<numvtec)
//		bite = (int)((double)vtec[i]->getByte() / .02875);
		bite = (int)((float)(vtec[i]->getByte()-128)*57.2);
//	else
//		cout<<"VTEC location out of bounds (getVTEC...); "<< "loc = " << i <<endl;
	
	return bite; //will be -1 if theres an error
}

int RomRep::VT0Ecu::getVtecDisengage(int loc)
{
	return getVtecEngage(loc);
}

int RomRep::VT0Ecu::getRevlimit()
{
	if(revlimit->getByte1() != 0)
		return revconst/(revlimit->getByte2()*256 + revlimit->getByte1());
	else
		return 0;
}

int RomRep::VT0Ecu::getRevRestart()
{
	if(revrestart->getByte1() != 0)
		return revconst/(revrestart->getByte2()*256+revrestart->getByte1());
	else
		return 0;
}


///************parameters
int  RomRep::VT0Ecu::aisCodesDisabled(int loca)  
{
	if(this->thefile[loca] == 0xc0)
		return 0;
	else
		return 1;

}
void  RomRep::VT0Ecu::aDisableCodes(int loca, bool disable)  
{
	if(disable)
	{
		unsigned char nums __gc[]= {0x62,0x00,0x7F,0x92,0xAA,0xC6,0x00,0xC9,0x0A,0xC6,0xFF,0xC9,0x06,0x4E,0xC9,0x0D,0x72,0xCB,0xF0,0x79,0xC0,0x30,0x01,0x11,0xC0,0x7B,0x02,0x11,0x01,0x01,0xFF};
		
		setArray(nums,0x5000,nums->Length);

		setByte(loca,0x32);
		setByte(loca+1,0x00);
		setByte(loca+2,0x50);
		setByte(loca+3,0x00);
		setByte(loca+4,0x00);
		setByte(loca+5,0x00);
		setByte(loca+6,0x00);
		setByte(loca+7,0x00);

		unsigned char vec __gc[] = {0x17,0x01,0x02,0x00};
		setArray(vec,celvecloc,vec->Length);
	}
	else
	{
		int nums[33];
		for(int i = 0; i<33; i++)
			nums[i] = 0xff;

		setByte(loca,0xc0);
		setByte(loca+1,0x30);
		setByte(loca+2,0x01);
		setByte(loca+3,0x11);
		setByte(loca+3,0xc0);
		setByte(loca+3,0x7b);
		setByte(loca+3,0x02);
		setByte(loca+3,0x11);

	}
}

//adds a cel disable the the disable vector
int RomRep::VT0Ecu::addCelDisable(int code)
{
	if(this->isCodesDisabled())
	{
		int loc = celvecloc;
		int i;

		for(i = 0; thefile[loc+i] != 0 && thefile[loc+i] != 0xff && thefile[loc+i] != code; i++);

		if(thefile[loc+i] == code)
			return -1;
		setByte(loc+i,code);
		setByte(loc+i+1,0);
		return 1;
	}
	else
	{
		return -1;
	}
}

int RomRep::VT0Ecu::removeCelDisable(int code) //return negative for fail, 1 for success
{

	if(this->isCodesDisabled())
	{
		int loc = celvecloc;
		int i,j;

		for(i = 0; thefile[loc+i] != code && thefile[loc+i] != 0 && thefile[loc+i] != 0xff; i++);

		 //i has the code
		if(thefile[loc+i] == 0 || thefile[loc+i] == 255)
			return -2; //cant find code

//		setByte(loc+i+1,0);

		for(j = i+1; thefile[loc+j] != 0 && thefile[loc+j] != 0xff; j++)
			setByte(loc+j-1,thefile[loc+j]);

		setByte(loc+j-1,0);
		return 1;
	}
	else
		return -1;
	

}
//*********************
void  RomRep::VT0Ecu::aDisableChecksum(int loca, bool disable)  
{
	if(disable)
		setByte(loca,0xCB);
	else
		setByte(loca,0xC9);
}
void  RomRep::VT0Ecu::aDisableOxygenSensors(int loca, bool disable)  
{
	if(disable)
	{
		setByte(loca,0xCB);//disable the sensors
		setByte(loca+1,0x1D);
	}
	else
	{
		setByte(loca,0xCA);
		setByte(loca+1,0x0D);
	}
}

void  RomRep::VT0Ecu::aDisable2ndOxygenSensor(int loca, bool disable)  
{
	if(disable)
	{
		setByte(loca,0x65);//disable the sensor
	}
	else
	{
		setByte(loca,0x67);
	}
}
int RomRep::VT0Ecu::aisChecksumDisabled(int loca)
{
	int tmp = thefile[loca];
	return (tmp == 0xCB && true);// == 0xCB;
}
int RomRep::VT0Ecu::aisOxygenSensorsDisabled(int loca)
{
	int tmp1, tmp2;
	tmp1 = thefile[loca];
	tmp2 = thefile[loca+1];
	if(tmp1 == 0xCB && tmp2 == 0x1D)
		return 1;
	else
		return 0;
}

int RomRep::VT0Ecu::ais2ndOxygenSensorDisabled(int loca)
{
	if(thefile[loca] == 0x67)
		return 0;
	else
		return 1;
}

//******for launch stuff loc is the location of the 
//beginning of the launch code
void RomRep::VT0Ecu::asetLaunchRpm(int loc, int val)
{
	int hbyte, lbyte;
	if(thefile[loc] != 0xC5)
		return;
	int word = revconst/val;
	hbyte = word/256;
	lbyte = word%256;

	setByte(loc+8, hbyte);
	setByte(loc+7, lbyte);
}

void RomRep::VT0Ecu::asetLaunchSpeed(int loc, int val)
{
	int lbyte;
	if(thefile[loc] != 0xC5)
		return;
	
	lbyte = (int)((float)val*1.609)%256;

	setByte(loc+3, lbyte);
}
int RomRep::VT0Ecu::agetLaunchRpm(int loc)
{
	int lrpm = thefile[loc+7] + (thefile[loc+8]*256);
	lrpm = revconst/lrpm;

	return lrpm;
}
int RomRep::VT0Ecu::agetLaunchSpeed(int loc)
{
	int mph = (int)((float)thefile[loc+3]/1.609);

	return mph;
}
//void RomRep::VT0Ecu::aenableLaunch(int loc, bool enable)
//void RomRep::VT0Ecu::adisableSpeedLimiter(int loc, bool disable) 
//void RomRep::VT0Ecu::adisableVssCheck(int loc, bool disable) 


//void RomRep::VT0Ecu::adisableTempCheck(int loc, bool disable)


//void RomRep::VT0Ecu::adisablePsCheck(int loc, bool disable) 
int RomRep::VT0Ecu::aisKnockSensorDisabled(int loc)
{
	if(thefile[loc] == 0x00 && thefile[loc+1] == 0x00)
		return 1;
	else
		return 0;
}
void RomRep::VT0Ecu::adisableKnockSensor(int loc1,int loc2,int loc3, bool disable)
{
	if(disable)
	{
		setByte(loc1, 0x00);
		setByte(loc1+1, 0x00);

		setByte(loc2, 0xCB);

		setByte(loc3, 0);
		setByte(loc3+1, 0);
		setByte(loc3+2, 0);
	}
	else
	{
		setByte(loc1, 0xCD);
		setByte(loc1+1, 0x03);

		setByte(loc2, 0xCA);

		setByte(loc3, 0xC4);
		setByte(loc3+1, 0x2D);
		setByte(loc3+2, 0x3C);
	}
}
void RomRep::VT0Ecu::adisableCelCheck(int loc, bool disable)
{
	if(disable)
	{
		setByte(loc, 0xCB);
	}
	else
	{
		setByte(loc, 0xC9);
	}
}

int RomRep::VT0Ecu::aisSpeedLimiterDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisVssCheckDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisTempCheckDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisCelCheckDisabled(int loc)
{
	if(thefile[loc] == 0xCB)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisPsCheckDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisLaunchDisabled(int loc)
{
	if(thefile[loc] != 0xC5)
		return 1;
	else
		return 0;
}

//*****************************************************
//*** calc functions

float RomRep::VT0Ecu::calcTPS(int raw)
{
	float tmp = (float)raw - 25.0f;
	if(tmp < 0.0f) tmp = 0.0f;
	if(tmp > 205.0f) tmp = 205.0f;

	return tmp *100.0f / 205.0f;
}
int RomRep::VT0Ecu::calcTPS(float percentage)
{
	if(percentage < 0.0f) percentage = 0.0f;
	if(percentage > 100.0f) percentage = 100.0f;

	return (int)(percentage * 205.0f / 100.0f + 25.0f);
}
 
float RomRep::VT0Ecu::calcTemp(int raw, bool sae)
{
	if(sae && raw>45)
		return -.8334F*(float)raw + 194.25F;
	else if(sae && raw<=45)
		return -2.3529F*(float)raw + 263.0F;
	else if(!sae && raw>66)
		return -.463F*(float)raw + 125.693F;
	else //if(!sae && raw<=45)
		return -1.037F*(float)raw + 163.888F;
}
int RomRep::VT0Ecu::calcTemp(float temp, bool sae)
{
	if(sae && temp<156.8f)
		return (int)(temp - 194.25F / -.8334F);
	else if(sae && temp>=156.8f)
		return (int)(temp - 263.0F / -2.3529F);
	else if(!sae && temp<95.1f)
		return (int)(temp - 125.693F / -.463F);
	else 
		return (int)(temp - 163.888F / -1.037F);
}

float RomRep::VT0Ecu::calcRpm(int raw)
{
	if(raw > 0)
		return (float)revconst/(float)raw;
	else
		return (float)revconst;
}
int RomRep::VT0Ecu::calcRpm(float rpm)
{
	if(rpm > 0)
		return revconst/(int)rpm;
	else
		return revconst;
}