#pragma once
using namespace System;

#include "obd0maps.h"
//#include "obd0vtececu.h"

namespace RomRep
{
	public __gc class VT0MapHelper
	{
	public:
		///Chooses the proper name for the map based on the index and mode if.
		///mapname is null. If mapname is not null, mapname is returned.
		static String* getMapName(String* mapname, int index, int mode);

		static String *  calcNonVtecRow(int val);
		static String *  calcVtecRow(int val);
		static void setRpmScalars(int rpmscalarloc, String* header[], unsigned char fil __gc[], bool vtec);
		static void setPressScalars(int presscalarloc, String* header[], unsigned char fil __gc[]);
	};

	[Serializable] public __gc class VT0IgnMap : public RomRep::Obd0IgnMap
	{
	public:
		
		VT0IgnMap(int x, int y, unsigned int loc, unsigned char themap __gc[,], 
			unsigned char fil __gc[], int cscalarloc, int rscalarloc, int ind, int mod);
		VT0IgnMap(bool calchead, int x, int y, unsigned int loc, unsigned char themap __gc[,], 
			unsigned char fil __gc[], int cscalarloc, int rscalarloc, int ind, int mod);
		
		virtual void recalcRpmScalars();
		virtual void byteChangeNotify(ByteChange* bc){RomRep::Obd0IgnMap::byteChangeNotify(bc);}

	private:
		void setup(bool calchead, unsigned char themap __gc[,], 
			unsigned char fil __gc[], int cscalarloc, int rscalarloc, int ind);
	};

	[Serializable] public __gc class VT0FuelMap : public RomRep::Obd0FuelMap
	{

	public:
		
		VT0FuelMap(int x, int y,unsigned int loc, unsigned char themap __gc[,], 
			unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[],
			int colScalarLoc, int rowScalarLoc, int ind, int mod);
		VT0FuelMap(bool calchead, int x, int y,unsigned int loc, unsigned char themap __gc[,], 
			unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[],
			int colScalarLoc, int rowScalarLoc, int ind, int mod);

		virtual void recalcRpmScalars();

		virtual float calculate(int x, int y, int intval);
		virtual int calculate(int x, int y, float mapval);

		///Calculates the milliseconds of injector duration from a raw value.
		///\param value should be raw_map_value* 2^multiplier
		static float calculateInjMs(int value);
		///Calculates the byte from the milliseconds.
		///\param injMs is the cell's duration in milliseconds
		///\param multCoeff is 2^multiplier for that column
		static int calculateInjByte(float injMs, int multCoeff);

		virtual void byteChangeNotify(ByteChange* bc){RomRep::Obd0FuelMap::byteChangeNotify(bc);}

	private:
		void setup(bool calchead, unsigned char themap __gc[,], 
					unsigned char mltarray __gc[], unsigned char fil __gc[], 
					int cscalarloc, int rscalarloc, int ind);
	};
}