#include "StdAfx.h"
#include "Obd0VtecParam.h"
#include "child.h"


bre20::VT0Param::VT0Param():ParamPage()
{
	setupPage();
}
bre20::VT0Param::VT0Param(RomRep::HondaEcu* ecu,int vtecbytenum, int numvtech): ParamPage(ecu)
{

	vtecbyte = vtecbytenum;
	numvtec = numvtech;
	int limit = (static_cast<RomRep::VT0Ecu*>(rom))->getRevlimit();
	int limit1 = (static_cast<RomRep::VT0Ecu*>(rom))->getRevRestart();
	int launchrpm = (static_cast<RomRep::VT0Ecu*>(rom))->getRevRestart();
	int vtecen = (static_cast<RomRep::VT0Ecu*>(rom))->getVtecEngage(vtecbytenum);
	int vtecdis = (static_cast<RomRep::VT0Ecu*>(rom))->getVtecDisengage(vtecbytenum-1);

	setupPage();

		//check boxes:
	setCheckBox(speedlimiter,(static_cast<RomRep::VT0Ecu*>(rom))->isSpeedLimiterDisabled());
	setCheckBox(knock,(static_cast<RomRep::VT0Ecu*>(rom))->isKnockSensorDisabled());
	setCheckBox(vssCheck,(static_cast<RomRep::VT0Ecu*>(rom))->isVssCheckDisabled());
	setCheckBox(tempCheck,(static_cast<RomRep::VT0Ecu*>(rom))->isTempCheckDisabled());
	setCheckBox(celCheck,(static_cast<RomRep::VT0Ecu*>(rom))->isCelCheckDisabled());
	setCheckBox(psCheck,(static_cast<RomRep::VT0Ecu*>(rom))->isPsCheckDisabled());

	revbox->Text = limit.ToString();
	vtecdisbox->Text = vtecdis.ToString();
	vtecenbox->Text = vtecen.ToString();
	restartbox->Text = limit1.ToString();
}

void bre20::VT0Param::setupPage()
{

	namelabel = new Label();
	vtecdislabel = new Label();
	vtecenlabel = new Label();
	revlabel = new Label();
	restartlabel = new Label();
	vtecenbox = new TextBox();
	revbox = new TextBox();
	restartbox = new TextBox();
	vtecdisbox = new TextBox();

	knock = new CheckBox();
	o2sensors = new CheckBox();
	o2sensor2 = new CheckBox();
	
	discodes = new CheckBox();
	discodesgroup = new GroupBox();
	discodesbox = new ComboBox();
	discodesadd = new Button();
	discodesrem = new Button();

	checksum = new CheckBox();
	speedlimiter = new CheckBox();

	this->vtecGroup = new GroupBox();
	this->vssCheck = new CheckBox();
	this->tempCheck = new CheckBox();
	this->celCheck = new CheckBox();
	this->psCheck = new CheckBox();

	this->revGroup = new GroupBox();
	this->launchGroup = new GroupBox();
	this->genGroup = new GroupBox();
	this->launchEnable = new CheckBox();
	this->launchSpeedBox = new TextBox();
	this->launchRpmBox = new TextBox();
	this->speedLabel = new Label();
	this->rpmLabel = new Label();

	this->vtecGroup->SuspendLayout();
	this->discodesgroup->SuspendLayout();
	this->launchGroup->SuspendLayout();
	this->revGroup->SuspendLayout();
	this->genGroup->SuspendLayout();

	this->Controls->Add(this->namelabel);
	this->Controls->Add(this->genGroup);
	this->Controls->Add(this->launchGroup);
	this->Controls->Add(this->revGroup);
	this->Controls->Add(this->vtecGroup);
	this->Controls->Add(this->discodesgroup);

	// 
	// vtecGroup
	// 
	this->vtecGroup->Controls->Add(this->vtecdislabel);
	this->vtecGroup->Controls->Add(this->vtecenlabel);
	this->vtecGroup->Controls->Add(this->vtecenbox);
	this->vtecGroup->Controls->Add(this->vtecdisbox);
	this->vtecGroup->Controls->Add(this->psCheck);
	this->vtecGroup->Controls->Add(this->celCheck);
	this->vtecGroup->Controls->Add(this->tempCheck);
	this->vtecGroup->Controls->Add(this->vssCheck);
	this->vtecGroup->Location = System::Drawing::Point(400, 24);
	this->vtecGroup->Name = S"vtecGroup";
	this->vtecGroup->Size = System::Drawing::Size(216, 136);
	this->vtecGroup->TabIndex = 3;
	this->vtecGroup->TabStop = false;
	this->vtecGroup->Text = S"VTEC";
	this->vtecGroup->FlatStyle = FlatStyle::System;
	// 
	// vssCheck
	// 
	this->vssCheck->Location = System::Drawing::Point(112, 24);
	this->vssCheck->Name = S"vssCheck";
	this->vssCheck->Size = System::Drawing::Size(80, 16);
	this->vssCheck->TabIndex = 2;
	this->vssCheck->Text = S"Vss check";
	this->vssCheck->FlatStyle = FlatStyle::System;
	vssCheck->add_CheckStateChanged(new System::EventHandler(this, vsscheck_CheckStateChanged));
	// 
	// tempCheck
	// 
	this->tempCheck->Location = System::Drawing::Point(112, 48);
	this->tempCheck->Name = S"tempCheck";
	this->tempCheck->Size = System::Drawing::Size(88, 16);
	this->tempCheck->TabIndex = 3;
	this->tempCheck->Text = S"Temp check";
	this->tempCheck->FlatStyle = FlatStyle::System;
	tempCheck->add_CheckStateChanged(new System::EventHandler(this, tempcheck_CheckStateChanged));
	// 
	// celCheck
	// 
	this->celCheck->Location = System::Drawing::Point(112, 72);
	this->celCheck->Name = S"celCheck";
	this->celCheck->Size = System::Drawing::Size(96, 16);
	this->celCheck->TabIndex = 4;
	this->celCheck->Text = S"Cel check";
	this->celCheck->FlatStyle = FlatStyle::System;
	celCheck->add_CheckStateChanged(new System::EventHandler(this, celcheck_CheckStateChanged));
	// 
	// psCheck
	// 
	this->psCheck->Location = System::Drawing::Point(112, 96);
	this->psCheck->Name = S"psCheck";
	this->psCheck->Size = System::Drawing::Size(96, 16);
	this->psCheck->TabIndex = 5;
	this->psCheck->Text = S"Press. switch";
	this->psCheck->FlatStyle = FlatStyle::System;
//	this->psCheck->ToolTip = S"This will disable the check for the pressure switch and its related CEL code";
	psCheck->add_CheckStateChanged(new System::EventHandler(this, pscheck_CheckStateChanged));

	// 
	// revGroup
	// 
	this->revGroup->Controls->Add(this->revbox);
	this->revGroup->Controls->Add(this->restartbox);
	this->revGroup->Controls->Add(this->revlabel);
	this->revGroup->Controls->Add(this->restartlabel);
	this->revGroup->Location = System::Drawing::Point(16, 24);
	this->revGroup->Name = S"revGroup";
	this->revGroup->Size = System::Drawing::Size(104, 136);
	this->revGroup->TabIndex = 5;
	this->revGroup->TabStop = false;
	this->revGroup->Text = S"Revlimit";
	this->revGroup->FlatStyle = FlatStyle::System;
	// 
	// launchGroup
	// 
	this->launchGroup->Controls->Add(this->rpmLabel);
	this->launchGroup->Controls->Add(this->speedLabel);
	this->launchGroup->Controls->Add(this->launchRpmBox);
	this->launchGroup->Controls->Add(this->launchSpeedBox);
	this->launchGroup->Controls->Add(this->launchEnable);
	this->launchGroup->Location = System::Drawing::Point(136, 24);
	this->launchGroup->Name = S"launchGroup";
	this->launchGroup->Size = System::Drawing::Size(104, 136);
	this->launchGroup->TabIndex = 6;
	this->launchGroup->TabStop = false;
	this->launchGroup->Text = S"Launch";
	this->launchGroup->FlatStyle = FlatStyle::System;
	// 
	// genGroup
	// 
	this->genGroup->Controls->Add(knock);
	this->genGroup->Controls->Add(o2sensor2);
	this->genGroup->Controls->Add(o2sensors);
	this->genGroup->Controls->Add(checksum);
	this->genGroup->Controls->Add(speedlimiter);
	this->genGroup->Location = System::Drawing::Point(256, 24);
	this->genGroup->Name = S"genGroup";
	this->genGroup->Size = System::Drawing::Size(128, 136);
	this->genGroup->TabIndex = 7;
	this->genGroup->TabStop = false;
	this->genGroup->Text = S"General";
	this->genGroup->FlatStyle = FlatStyle::System;
	
	//
	//  knock
	//
	this->knock->Location = System::Drawing::Point(12, 110);
	this->knock->Name = S"knock";
	this->knock->Size = System::Drawing::Size(100, 16);
	this->knock->TabIndex = 10;
	this->knock->Text = S"Knocksensor";
	this->knock->FlatStyle = FlatStyle::System;
	knock->add_CheckStateChanged(new System::EventHandler(this, knock_CheckStateChanged));
	
	String * type = (static_cast<RomRep::VT0Ecu*>(rom))->getType();
	if(type->Equals(S"Euro PW0"))
		knock->Enabled = false;

	//
	//  2nd o2 sensor
	//
	this->o2sensor2->Location = System::Drawing::Point(12, 30);
	this->o2sensor2->Name = S"o2sensor2";
	this->o2sensor2->Size = System::Drawing::Size(100, 16);
	this->o2sensor2->TabIndex = 10;
	this->o2sensor2->Text = S"2nd O2 sensor";
	this->o2sensor2->FlatStyle = FlatStyle::System;
//	this->o2sensors->ToolTip = S"This will use the 1st o2 sensor in place of the second o2 sensor, but it will NOT disable the CEL code";
	o2sensor2->add_CheckStateChanged(new System::EventHandler(this, o2sensor2_CheckStateChanged));
	int disabled = (static_cast<RomRep::VT0Ecu*>(rom))->is2ndOxygenSensorDisabled();
	
	o2sensor2->Visible = true;
	if(disabled == 1)
		o2sensor2->Checked = false;
	else if(disabled == 0)
		o2sensor2->Checked = true;
	else
		o2sensor2->Visible = false;
	//
	//  02sensors
	//
	this->o2sensors->Location = System::Drawing::Point(12, 50);
	this->o2sensors->Name = S"o2sensors";
	this->o2sensors->Size = System::Drawing::Size(110, 16);
	this->o2sensors->TabIndex = 10;
	this->o2sensors->Text = S"Oxygen Sensors";
	this->o2sensors->FlatStyle = FlatStyle::System;
//	this->o2sensors->ToolTip = S"This will disable the check for BOTH o2 sensors, but it will NOT disable the CEL codes";

	o2sensors->add_CheckStateChanged(new System::EventHandler(this, o2sensors_CheckStateChanged));
	disabled = (static_cast<RomRep::VT0Ecu*>(rom))->isOxygenSensorsDisabled();
	if(disabled == 1)
		this->o2sensors->Checked = false;
	else
		this->o2sensors->Checked = true;

	//
	//  speedlimiter
	//
	this->speedlimiter->Location = System::Drawing::Point(12, 70);
	this->speedlimiter->Name = S"speedlimiter";
	this->speedlimiter->Size = System::Drawing::Size(110, 16);
	this->speedlimiter->TabIndex = 10;
	this->speedlimiter->Checked = true;
	this->speedlimiter->Text = S"Speed Limiter";
	this->speedlimiter->FlatStyle = FlatStyle::System;
	speedlimiter->add_CheckStateChanged(new System::EventHandler(this, speedlimiter_CheckStateChanged));

	//
	// checksum
	//
	this->checksum->Location = System::Drawing::Point(12, 90);
	this->checksum->Name = S"checksum";
	this->checksum->Size = System::Drawing::Size(100, 16);
	this->checksum->TabIndex = 10;
	this->checksum->Text = S"Checksum";
	this->checksum->FlatStyle = FlatStyle::System;
	checksum->add_CheckStateChanged(new System::EventHandler(this, checksum_CheckStateChanged));
	disabled = (static_cast<RomRep::VT0Ecu*>(rom))->isChecksumDisabled();
	if(disabled == 1)
		this->checksum->Checked = false;
	else
		this->checksum->Checked = true;


	// 
	// launchSpeedBox
	// 
	this->launchSpeedBox->Location = System::Drawing::Point(16, 56);
	this->launchSpeedBox->Name = S"launchSpeedBox";
	this->launchSpeedBox->Size = System::Drawing::Size(72, 20);
	this->launchSpeedBox->TabIndex = 1;
//	this->launchSpeedBox->Text = S"";
	this->launchSpeedBox->Leave += new System::EventHandler(this,launchspeedbox_Leave);
	this->launchSpeedBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, launchspeed_KeyPress);
	// 
	// launchRpmBox
	// 
	this->launchRpmBox->Location = System::Drawing::Point(16, 104);
	this->launchRpmBox->Name = S"launchRpmBox";
	this->launchRpmBox->Size = System::Drawing::Size(72, 20);
	this->launchRpmBox->TabIndex = 2;
//	this->launchRpmBox->Text = S"";
	this->launchRpmBox->Leave += new System::EventHandler(this,launchrevbox_Leave);
	this->launchRpmBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, launchrev_KeyPress);

	// 
	// launchEnable
	// 
	this->launchEnable->Location = System::Drawing::Point(16, 16);
	this->launchEnable->Name = S"launchEnable";
	this->launchEnable->Size = System::Drawing::Size(72, 16);
	this->launchEnable->TabIndex = 0;
	this->launchEnable->Text = S"Enabled";
	this->launchEnable->FlatStyle = FlatStyle::System;

	if((static_cast<RomRep::VT0Ecu*>(rom))->isLaunchDisabled() == 1)
	{
		launchEnable->Checked = false;
		launchSpeedBox->Enabled = false;
		launchRpmBox->Enabled = false;
	}
	else
	{	
		int lrpm = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchRpm();
		int lspeed = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchSpeed();
		launchEnable->Checked = true;
		launchSpeedBox->Text = lspeed.ToString();
		launchRpmBox->Text = lrpm.ToString();

	}

	launchEnable->add_CheckStateChanged(new System::EventHandler(this, launchenable_CheckStateChanged));
	// 
	// speedLabel
	// 
	this->speedLabel->Location = System::Drawing::Point(16, 40);
	this->speedLabel->Name = S"speedLabel";
	this->speedLabel->Size = System::Drawing::Size(72, 16);
	this->speedLabel->TabIndex = 3;
	this->speedLabel->Text = S"Speed (mph)";
	// 
	// rpmLabel
	// 
	this->rpmLabel->Location = System::Drawing::Point(16, 88);
	this->rpmLabel->Name = S"rpmLabel";
	this->rpmLabel->Size = System::Drawing::Size(72, 16);
	this->rpmLabel->TabIndex = 4;
	this->rpmLabel->Text = S"RPM";
	// 
	// label1
	// 
	this->revlabel->Location = System::Drawing::Point(24, 24);
	this->revlabel->Name = S"revlabel";
	this->revlabel->Size = System::Drawing::Size(48, 16);
	this->revlabel->TabIndex = 5;
	this->revlabel->Text = S"Revlimit:";
	// 
	// label1
	// 
	this->restartlabel->Location = System::Drawing::Point(24, 72);
	this->restartlabel->Name = S"restartlabel";
	this->restartlabel->Size = System::Drawing::Size(65, 16);
	this->restartlabel->TabIndex = 6;
	this->restartlabel->Text = S"Revrestart:";
	// 
	// label2
	// 
	this->vtecdislabel->Location = System::Drawing::Point(24, 72);
	this->vtecdislabel->Name = S"vtecdislabel";
	this->vtecdislabel->Size = System::Drawing::Size(65, 16);
	this->vtecdislabel->TabIndex = 7;
	this->vtecdislabel->Text = S"Disengage:";
	// 
	// textBox1
	// 
	this->revbox->Location = System::Drawing::Point(24, 40);
	this->revbox->Name = S"revbox";
	this->revbox->Size = System::Drawing::Size(64, 20);
	this->revbox->TabIndex = 2;
	this->revbox->Text = S"";
	this->revbox->Leave += new System::EventHandler(this, revbox_Leave);
	this->revbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, rev_KeyPress);
	// 
	// textBox1
	// 
	this->restartbox->Location = System::Drawing::Point(24, 88);
	this->restartbox->Name = S"restartbox";
	this->restartbox->Size = System::Drawing::Size(64, 20);
	this->restartbox->TabIndex = 3;
	this->restartbox->Text = S"";
	this->restartbox->Leave += new System::EventHandler(this, restartbox_Leave);
	this->restartbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, restart_KeyPress);
		// 
	// label2
	// 
	this->vtecenlabel->Location = System::Drawing::Point(24,24);
	this->vtecenlabel->Name = S"vtecenlabel";
	this->vtecenlabel->Size = System::Drawing::Size(55, 16);
	this->vtecenlabel->TabIndex = 8;
	this->vtecenlabel->Text = S"Engage:";
	// 
	// textBox1
	// 
	this->vtecenbox->Location = System::Drawing::Point(24, 40);
	this->vtecenbox->Name = S"vtecenbox";
	this->vtecenbox->Size = System::Drawing::Size(64, 20);
	this->vtecenbox->TabIndex = 0;
	this->vtecenbox->Text = S"";
	this->vtecenbox->Leave += new System::EventHandler(this, vtecenbox_Leave);
	this->vtecenbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, vtecen_KeyPress);
	// 
	// textBox2
	// 
	this->vtecdisbox->Location = System::Drawing::Point(24, 88);
	this->vtecdisbox->Name = S"vtecdisbox";
	this->vtecdisbox->Size = System::Drawing::Size(64, 20);
	this->vtecdisbox->TabIndex = 1;
	this->vtecdisbox->Text = S"";
	this->vtecdisbox->Leave += new System::EventHandler(this, vtecdisbox_Leave);
	this->vtecdisbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, vtecdis_KeyPress);
	// 
	// label3
	// 
	this->namelabel->Location = System::Drawing::Point(376, 8);
	this->namelabel->Name = S"namelabel";
	this->namelabel->Size = System::Drawing::Size(136, 16);
	this->namelabel->TabIndex = 9;
	this->namelabel->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
	this->namelabel->Text =rom->getType();

	// 
	// vtecGroup
	// 
	this->discodesgroup->Controls->Add(this->discodes);
	this->discodesgroup->Controls->Add(this->discodesbox);
	this->discodesgroup->Controls->Add(this->discodesadd);
	this->discodesgroup->Controls->Add(this->discodesrem);
	this->discodesgroup->Location = System::Drawing::Point(16, 172);
	this->discodesgroup->Name = S"discodesgroup";
	this->discodesgroup->Size = System::Drawing::Size(220, 70);
	this->discodesgroup->TabIndex = 3;
	this->discodesgroup->TabStop = false;
	this->discodesgroup->Text = S"Disable CEL Codes";
	this->discodesgroup->FlatStyle = FlatStyle::System;

	// 
	// disable codes checkbox
	// 
	this->discodes->Location = System::Drawing::Point(16, 16);
	this->discodes->Name = S"discodes";
	this->discodes->Size = System::Drawing::Size(100, 16);
	this->discodes->TabIndex = 0;
	this->discodes->Text = S"Disable Codes";
	this->discodes->FlatStyle = FlatStyle::System;

	// 
	// combobox
	// 
	this->discodesbox->Location = System::Drawing::Point(16, 40);
	this->discodesbox->Name = S"discodesbox";
	this->discodesbox->Size = System::Drawing::Size(118, 16);
	this->discodesbox->TabIndex = 1;
	this->discodesbox->Text = S"";
	this->discodesbox->DropDownStyle = ComboBoxStyle::DropDownList;

	
		// 
	// add button
	// 
	this->discodesadd->Location = System::Drawing::Point(145, 16);
	this->discodesadd->Name = S"discodesadd";
	this->discodesadd->Size = System::Drawing::Size(58, 20);
	this->discodesadd->TabIndex = 2;
	this->discodesadd->Text = S"Add...";
	this->discodesadd->FlatStyle = FlatStyle::System;
	discodesadd->add_Click(new System::EventHandler(this, discodeadd_Click));


		// 
	// remove button
	// 
	this->discodesrem->Location = System::Drawing::Point(145, 42);
	this->discodesrem->Name = S"discodesrem";
	this->discodesrem->Size = System::Drawing::Size(58, 20);
	this->discodesrem->TabIndex = 3;
	this->discodesrem->Text = S"Remove";
	this->discodesrem->FlatStyle = FlatStyle::System;
	discodesrem->add_Click(new System::EventHandler(this, discoderemove_Click));

	disabled = (static_cast<RomRep::VT0Ecu*>(rom))->isCodesDisabled();
	if(disabled == 1)
	{
		discodes->Checked = true;
		enableDisCodesGroup();
	}
	else if(disabled == 0)
	{
		discodes->Checked = false;
		discodesbox->Enabled = false;
		discodesadd->Enabled = false;
		discodesrem->Enabled = false;
	}
	else
		discodesgroup->Visible = false;

	
	discodes->add_CheckStateChanged(new System::EventHandler(this, discodes_CheckStateChanged));

}

//events...
System::Void bre20::VT0Param::discodeadd_Click(System::Object *  sender, System::EventArgs *  e)
{
	AddCode* ac = new AddCode();
	RomRep::VT0Ecu* vte = (static_cast<RomRep::VT0Ecu*>(rom));

	DialogResult res = ac->ShowDialog();
	int code = ac->getCode();
	if(res == DialogResult::OK && code > 0 && code < 24)
	{
		//tell me if its able to disable the bit and it is NOT disabled already then we add it.
		if(vte->isCodeBitDisable(code) == 1 && vte->isCodeBitDisabled(code) == 0)
		{
			vte->codeBitDisable(code,true);
			discodesbox->Items->Add(code.ToString());
			MessageBox::Show("Added bit disable", "BRE");
		}
		else if(vte->isCodeBitDisable(code) == 0)
		{
			if(vte->addCelDisable(code) != -1)
			{
				MessageBox::Show("Added vector disable", "BRE");
				discodesbox->Items->Add(code.ToString());
			}
			else
				MessageBox::Show("The code entered is already disabled", "BRE");

		}
		else
			MessageBox::Show("The code entered is already disabled", "BRE");
				
	}
	else
		MessageBox::Show("You entered an invalid number", "BRE");
}
System::Void bre20::VT0Param::discoderemove_Click(System::Object *  sender, System::EventArgs *  e)
{
	int sel = discodesbox->SelectedIndex;
	String* str = static_cast<String*>(discodesbox->Items->Item[sel]);
	RomRep::VT0Ecu* vte = (static_cast<RomRep::VT0Ecu*>(rom));

	int code = Convert::ToInt32(str);

	if(vte->isCodeBitDisable(code) == 1 && vte->isCodeBitDisabled(code) == 1)
	{
		vte->codeBitDisable(code,false);
		discodesbox->Items->RemoveAt(sel);
		MessageBox::Show(String::Concat("Removed bit disable: ",str),"BRE");
	}
	else if(vte->isCodeBitDisable(code) == 0)
	{
		if(vte->removeCelDisable(code) > 0)
		{
			discodesbox->Items->RemoveAt(sel);
			MessageBox::Show(String::Concat("Removed vector disable: ",str),"BRE");
		}
		else
			MessageBox::Show("The code entered could not be enabled", "BRE");

	}
	else
		MessageBox::Show("The code entered is already enabled", "BRE");

	if(discodesbox->Items->Count>0)
		discodesbox->SelectedIndex = 0;

}

System::Void bre20::VT0Param::knock_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disableKnockSensor(!knock->Checked);//enable
}
System::Void bre20::VT0Param::o2sensors_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disableOxygenSensors(!o2sensors->Checked);//enable
}
System::Void bre20::VT0Param::o2sensor2_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disable2ndOxygenSensor(!o2sensor2->Checked);//enable
}
System::Void bre20::VT0Param::checksum_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disableChecksum(!checksum->Checked);
}
System::Void bre20::VT0Param::speedlimiter_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disableSpeedLimiter(!speedlimiter->Checked);
}
System::Void bre20::VT0Param::vsscheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disableVssCheck(!vssCheck->Checked);
}
System::Void bre20::VT0Param::tempcheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disableTempCheck(!tempCheck->Checked);
}
System::Void bre20::VT0Param::pscheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disablePsCheck(!psCheck->Checked);
}
System::Void bre20::VT0Param::celcheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e){
	(static_cast<RomRep::VT0Ecu*>(rom))->disableCelCheck(!celCheck->Checked);
}

void bre20::VT0Param::enableDisCodesGroup()
{
	RomRep::VT0Ecu* vte = (static_cast<RomRep::VT0Ecu*>(rom));
	discodesbox->Items->Clear();

	//find the vector disables
	int loc = vte->getCelVectorLocation();
//	MessageBox::Show(loc.ToString());
	for(int i = rom->getByte(loc); i!=0 && i!=255; i = rom->getByte(++loc))
	{
//		MessageBox::Show(i.ToString());
		discodesbox->Items->Add(i.ToString());
	}

	//find the bit disables
	for(int i = 1; i<25; i++)
	{
		if(vte->isCodeBitDisabled(i) == 1)
			discodesbox->Items->Add(i.ToString());
	}

	if(discodesbox->Items->Count>0)
		discodesbox->SelectedIndex = 0;

	discodesbox->Enabled = true;
	discodesadd->Enabled = true;
	discodesrem->Enabled = true;

}
System::Void bre20::VT0Param::discodes_CheckStateChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(discodes->Checked)
	{
		(static_cast<RomRep::VT0Ecu*>(rom))->disableCodes(true);//enable
		enableDisCodesGroup();
	}
	else
	{
		discodesbox->Items->Clear();
		(static_cast<RomRep::VT0Ecu*>(rom))->disableCodes(false);//disable them
		discodesbox->Enabled = false;
		discodesadd->Enabled = false;
		discodesrem->Enabled = false;
	}
}

System::Void bre20::VT0Param::revbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int limit = (static_cast<RomRep::VT0Ecu*>(rom))->getRevlimit();
	int newrpm = getBoxVal(revbox);

	if(limit == newrpm)
		return;
	if(newrpm<1000)
	{
		revbox->Text = limit.ToString();
		return;
	}

	(static_cast<RomRep::VT0Ecu*>(rom))->setRevlimit(newrpm);
	limit = (static_cast<RomRep::VT0Ecu*>(rom))->getRevlimit();
	revbox->Text = limit.ToString();
}

System::Void bre20::VT0Param::restartbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int limit = (static_cast<RomRep::VT0Ecu*>(rom))->getRevRestart();
	int newrpm = getBoxVal(restartbox);

	if(limit == newrpm)
		return;
	if(newrpm<1000)
	{
		restartbox->Text = limit.ToString();
		return;
	}

	(static_cast<RomRep::VT0Ecu*>(rom))->setRevRestart(newrpm);
	limit = (static_cast<RomRep::VT0Ecu*>(rom))->getRevRestart();
	restartbox->Text = limit.ToString();
}

System::Void bre20::VT0Param::vtecenbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int vtecen = (static_cast<RomRep::VT0Ecu*>(rom))->getVtecEngage(vtecbyte);
	int newrpm = getBoxVal(vtecenbox);

	if(vtecen == newrpm)
		return;
	if(newrpm<=0)
	{
		vtecenbox->Text = vtecen.ToString();
		return;
	}

	int halfvtec = numvtec/2;
	for(int i = 0; i<halfvtec; i++)
		(static_cast<RomRep::VT0Ecu*>(rom))->setVtecEngage(i*2+1,newrpm);
	
	vtecen = (static_cast<RomRep::VT0Ecu*>(rom))->getVtecEngage(vtecbyte);
	vtecenbox->Text = vtecen.ToString();
}

System::Void bre20::VT0Param::vtecdisbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int vtecdis = (static_cast<RomRep::VT0Ecu*>(rom))->getVtecDisengage(vtecbyte-1);
	int newrpm = getBoxVal(vtecdisbox);

	if(vtecdis == newrpm)
		return;
	if(newrpm<=0)
	{
		vtecdisbox->Text = vtecdis.ToString();
		return;
	}
	int halfvtec = numvtec/2;
	for(int i = 0; i<halfvtec; i++)
		(static_cast<RomRep::VT0Ecu*>(rom))->setVtecDisengage(i*2,newrpm);
	vtecdis = (static_cast<RomRep::VT0Ecu*>(rom))->getVtecDisengage(vtecbyte-1);
	vtecdisbox->Text = vtecdis.ToString();
}

System::Void bre20::VT0Param::launchspeedbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int launchsp = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchSpeed();
	int newsp = getBoxVal(launchSpeedBox);

	if(launchsp == newsp)
		return;
	if(newsp<=0)
	{
		launchSpeedBox->Text = launchsp.ToString();
		return;
	}

	(static_cast<RomRep::VT0Ecu*>(rom))->setLaunchSpeed(newsp);
	launchsp = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchSpeed();
	launchSpeedBox->Text = launchsp.ToString();
}

System::Void bre20::VT0Param::launchrevbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int launchrpm = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchRpm();
	int newrpm = getBoxVal(launchRpmBox);

	if(launchrpm == newrpm)
		return;
	if(newrpm<=0)
	{
		launchRpmBox->Text = launchrpm.ToString();
		return;
	}

	(static_cast<RomRep::VT0Ecu*>(rom))->setLaunchRpm(newrpm);
	launchrpm = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchRpm();
	launchRpmBox->Text = launchrpm.ToString();
}

System::Void bre20::VT0Param::launchenable_CheckStateChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(launchEnable->Checked)
	{
		launchRpmBox->Enabled = true;
		launchSpeedBox->Enabled = true;
		(static_cast<RomRep::VT0Ecu*>(rom))->enableLaunch(true);//enable
		int launchrpm = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchRpm();
		launchRpmBox->Text = launchrpm.ToString();
		int launchsp = (static_cast<RomRep::VT0Ecu*>(rom))->getLaunchSpeed();
		launchSpeedBox->Text = launchsp.ToString();
	}
	else
	{	
		launchRpmBox->Text = "";
		launchSpeedBox->Text = "";
		launchRpmBox->Enabled = false;
		launchSpeedBox->Enabled = false;
		(static_cast<RomRep::VT0Ecu*>(rom))->enableLaunch(false);///disable
	}
}