#pragma once

#include "ParamPage.h"
#include "AddCode.h"
#include "obd0vtececu.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace bre20
{
	/// <summary> 
	/// tab page with a grid
	/// </summary>
	public __gc class VT0Param : public ParamPage
	{
	public:
		VT0Param();
		VT0Param(RomRep::HondaEcu* ecu,int vtecbytenum,int numvtec);
	protected: 
		System::Windows::Forms::Label * revlabel;
		System::Windows::Forms::Label * restartlabel;
		System::Windows::Forms::Label * vtecdislabel;
		System::Windows::Forms::Label * vtecenlabel;
		System::Windows::Forms::TextBox * vtecenbox;//idle
		System::Windows::Forms::TextBox * revbox;
		System::Windows::Forms::TextBox * restartbox;
		System::Windows::Forms::TextBox * vtecdisbox;//launch
		System::Windows::Forms::Label * namelabel;
		
		System::Windows::Forms::GroupBox *  vtecGroup;
		System::Windows::Forms::CheckBox *  vssCheck;
		System::Windows::Forms::CheckBox *  tempCheck;
		System::Windows::Forms::CheckBox *  celCheck;
		System::Windows::Forms::CheckBox *  psCheck;
		System::Windows::Forms::GroupBox *  revGroup;
		System::Windows::Forms::GroupBox *  launchGroup;
		System::Windows::Forms::GroupBox *  genGroup;
		System::Windows::Forms::CheckBox *  launchEnable;
		System::Windows::Forms::TextBox *  launchSpeedBox;
		System::Windows::Forms::TextBox *  launchRpmBox;
		System::Windows::Forms::Label *  speedLabel;
		System::Windows::Forms::Label *  rpmLabel;
		System::Windows::Forms::CheckBox * knock;
		System::Windows::Forms::CheckBox * o2sensors;
		System::Windows::Forms::CheckBox * checksum;
		System::Windows::Forms::CheckBox * speedlimiter;

		System::Windows::Forms::CheckBox * o2sensor2;

		System::Windows::Forms::CheckBox * discodes;
		System::Windows::Forms::GroupBox * discodesgroup;
		System::Windows::Forms::ComboBox * discodesbox;
		System::Windows::Forms::Button * discodesadd;
		System::Windows::Forms::Button * discodesrem;


	protected:
		int vtecbyte;
		int numvtec;

		void enableDisCodesGroup();

		void setCheckBox(CheckBox* box, int val)
		{
			if( val == 1)
				box->Checked = false;
			else if(val == 0)
				box->Checked = true;
			else
				box->Enabled = false;
		}

	private:
		void setupPage();
		//event shit
		
		System::Void discoderemove_Click(System::Object *  sender, System::EventArgs *  e);
		System::Void discodeadd_Click(System::Object *  sender, System::EventArgs *  e);
		System::Void revbox_Leave(System::Object *  sender, System::EventArgs *  e);
		System::Void restartbox_Leave(System::Object *  sender, System::EventArgs *  e);
		System::Void vtecenbox_Leave(System::Object *  sender, System::EventArgs *  e);
		System::Void vtecdisbox_Leave(System::Object *  sender, System::EventArgs *  e);

		System::Void launchspeedbox_Leave(System::Object *  sender, System::EventArgs *  e);
		System::Void launchrevbox_Leave(System::Object *  sender, System::EventArgs *  e);

		System::Void launchenable_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void vsscheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void tempcheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void pscheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void celcheck_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);

		System::Void knock_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void o2sensors_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void o2sensor2_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void discodes_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void checksum_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void speedlimiter_CheckStateChanged(System::Object *  sender, System::EventArgs *  e);

	private: System::Void launchspeed_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 if(e->KeyChar == (char)13)
					 launchspeedbox_Leave(NULL,NULL);
			 }
 	private: System::Void launchrev_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 if(e->KeyChar == (char)13)
					 launchrevbox_Leave(NULL,NULL);
			 }
	private: System::Void rev_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 if(e->KeyChar == (char)13)
					 revbox_Leave(NULL,NULL);
			 }
	private: System::Void restart_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 if(e->KeyChar == (char)13)
					 restartbox_Leave(NULL,NULL);
			 }
	private: System::Void vtecen_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 if(e->KeyChar == (char)13)
					 vtecenbox_Leave(NULL,NULL);
			 }
	private: System::Void vtecdis_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 if(e->KeyChar == (char)13)
					 vtecdisbox_Leave(NULL,NULL);
			 }
	};
}