#include "StdAfx.h"
#include "PM6Param.h"


bre20::PM6Param::PM6Param():ParamPage()
{
	setupPage();
}
bre20::PM6Param::PM6Param(RomRep::HondaEcu* ecu): ParamPage()
{
	
	rom = ecu;

	setupPage();
	init();
	this->Refresh();
}

void bre20::PM6Param::init()
{
	int limit = (static_cast<RomRep::Pm6*>(rom))->getRevlimit();
	int idle = (static_cast<RomRep::Pm6*>(rom))->getIdle();
	revbox->Text = limit.ToString();
	idlebox->Text = idle.ToString();

}

void bre20::PM6Param::setupPage()
{
	namelabel = new Label();
	idlelabel = new Label();
	revlabel = new Label();
	idlebox = new TextBox();
	revbox = new TextBox();

	this->Controls->Add(this->namelabel);
	this->Controls->Add(this->revbox);
	this->Controls->Add(this->revlabel);
	this->Controls->Add(this->idlelabel);
	this->Controls->Add(this->idlebox);

	this->Text = S"PM6 Parameters";
	// 
	// label1
	// 
	this->revlabel->Location = System::Drawing::Point(24, 24);
	this->revlabel->Name = S"revlabel";
	this->revlabel->Size = System::Drawing::Size(48, 16);
	this->revlabel->TabIndex = 0;
	this->revlabel->Text = S"Revlimit:";

	// 
	// textBox1
	// 
	this->revbox->Location = System::Drawing::Point(24, 40);
	this->revbox->Name = S"revbox";
	this->revbox->Size = System::Drawing::Size(64, 20);
	this->revbox->TabIndex = 2;
	this->revbox->Text = S"";
	this->revbox->Leave += new System::EventHandler(this, revbox_Leave);
	this->revbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, rev_KeyPress);
	// 
	// label2
	// 
	this->idlelabel->Location = System::Drawing::Point(108, 24);
	this->idlelabel->Name = S"idlelabel";
	this->idlelabel->Size = System::Drawing::Size(48, 16);
	this->idlelabel->TabIndex = 6;
	this->idlelabel->Text = S"Idle:";
	// 
	// textBox1
	// 
	this->idlebox->Location = System::Drawing::Point(108, 40);
	this->idlebox->Name = S"idlebox";
	this->idlebox->Size = System::Drawing::Size(64, 20);
	this->idlebox->TabIndex = 7;
	this->idlebox->Text = S"";
	this->idlebox->Leave += new System::EventHandler(this, idlebox_Leave);
	this->idlebox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, idle_KeyPress);
	// 
	// label3
	// 
	this->namelabel->Location = System::Drawing::Point(376, 8);
	this->namelabel->Name = S"namelabel";
	this->namelabel->Size = System::Drawing::Size(136, 16);
	this->namelabel->TabIndex = 4;
	this->namelabel->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
	this->namelabel->Text = S"PM6";
}

//events...

System::Void bre20::PM6Param::revbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int limit = (static_cast<RomRep::Pm6*>(rom))->getRevlimit();
	int newrpm = getBoxVal(revbox);

	if(limit == newrpm)
		return;
	if(newrpm<1000)
	{
		revbox->Text = limit.ToString();
		return;
	}
	(static_cast<RomRep::Pm6*>(rom))->setRevlimit(newrpm);
	limit = (static_cast<RomRep::Pm6*>(rom))->getRevlimit();
	revbox->Text = limit.ToString();
}
System::Void bre20::PM6Param::idlebox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int limit = (static_cast<RomRep::Pm6*>(rom))->getIdle();
	int newrpm = getBoxVal(idlebox);

	if(limit == newrpm)
		return;
	if(newrpm<0)
	{
		idlebox->Text = limit.ToString();
		return;
	}
	(static_cast<RomRep::Pm6*>(rom))->setIdle(newrpm);
	limit = (static_cast<RomRep::Pm6*>(rom))->getIdle();
	idlebox->Text = limit.ToString();
}