#include "stdafx.h"
#include "ParamPage.h"


bre20::ParamPage::ParamPage():TabPage()
{
	grid = new SimpleGrid::Grid();
}

bre20::ParamPage::ParamPage(RomRep::HondaEcu* ecu):TabPage()
{
	grid = new SimpleGrid::Grid();
	rom = ecu;

	// 
	// grid1
	// 
	this->Controls->Add(this->grid);
	this->grid->GridSize = System::Drawing::Size(rom->getWidth(), rom->getNumMaps());
	this->grid->LastSelectedColumn = -1;
	this->grid->LastSelectedRow = -1;
	this->grid->Name = S"grid";
	this->grid->RowHeaderWidth = 100;
	this->grid->RowHeight = 17;
	this->grid->SelectedColumn = -1;
	this->grid->SelectedForeColor = System::Drawing::Color::White;
	this->grid->SelectedRow = -1;
	this->grid->SelectedRowColor = System::Drawing::Color::Blue;
	this->grid->TabStop = false;
	this->grid->setAllColumnWidths(25);
	this->grid->Mode = 1;
	this->grid->add_CellChanged(new SimpleGrid::GridChangedHandler(this, grid_CellChanged));
	setGridSize();
	this->grid->Location = System::Drawing::Point(16, this->grid->Parent->Size.Height - this->grid->Size.Height - 12);

	fillGrid();

	this->Text = String::Concat(rom->getType(), S" Params");
}

void bre20::ParamPage::fillGrid()
{
	grid->getColumnWidth(0);
	grid->setRowHeader(0,S"Fuel Multipliers");

	for(int i = 0; i<rom->getNumMaps(); i++)
	{
		unsigned char mult __gc[] = static_cast<RomRep::FuelMap*>(rom->getFuelMap(i))->getIntMultipliers();
		for(int j = 0; j<rom->getWidth(); j++)
			grid->setValue(j,i,(int)mult[j]);
	}

	for(int i = 0; i<rom->getWidth(); i++)
		grid->setHeader(i, (i+1).ToString());
}

System::Void bre20::ParamPage::grid_CellChanged(System::Object *  sender, SimpleGrid::CellEvent *  e)
{
	onCellChanged(e);
}

void bre20::ParamPage::setBoxVal(bre20::LabeledText* box, bre20::intGetFunction* getFn, bre20::intSetFunction* setFn, 
								int min, int max){
	setBoxVal(box->getBox(),getFn,setFn,min,max);
}
void bre20::ParamPage::setBoxVal(TextBox* box, bre20::intGetFunction* getFn, bre20::intSetFunction* setFn, 
								int min, int max)
{
	int oldval = getFn();
	int newval = getBoxVal(box, oldval, min, max);
	if(newval != Int32::MinValue)
	{
		setFn(newval);
		newval = getFn();
		box->Text = newval.ToString();
	}
}

int bre20::ParamPage::getBoxVal(TextBox* box, int oldval, int min, int max)
{
	int newval = getBoxVal(box);

	if(oldval == newval)
		return Int32::MinValue;
	if(newval<min || newval > max)
	{
		box->Text = oldval.ToString();
		return Int32::MinValue;
	}
	return newval;
}

int bre20::ParamPage::getBoxVal(TextBox* box)
{
	String* str = box->Text;
	int newrpm = -1;

	try
	{
		newrpm = System::Convert::ToInt32(str);
	}
	catch(...)
	{
		return -1;
	}

	return newrpm;
}

int bre20::ParamPage::getBoxVal(bre20::LabeledText* box)
{
	int newrpm = -1;

	try
	{
		newrpm = box->getIntValue();
	}
	catch(...)
	{
		return -1;
	}

	return newrpm;
}
