#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "common.h"

namespace bre20
{
	/// <summary> 
	/// Summary for PortSetupDialog
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class PortSetupDialog : public System::Windows::Forms::Form
	{
	public: 
		PortSetupDialog(void)
		{
			InitializeComponent();
		}


	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}

	private: System::Windows::Forms::Label *  label1;

	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::GroupBox *  groupBox1;




	private: System::Windows::Forms::Label *  label3;

	private: System::Windows::Forms::Label *  label4;
	private: System::Windows::Forms::TextBox *  comName;
	private: System::Windows::Forms::ComboBox *  baudRate;
	private: System::Windows::Forms::RadioButton *  noParity;
	private: System::Windows::Forms::RadioButton *  oddParity;
	private: System::Windows::Forms::RadioButton *  evenParity;
	private: System::Windows::Forms::ComboBox *  byteSize;
	private: System::Windows::Forms::ComboBox *  stopBits;
	private: System::Windows::Forms::Button *  ok;


	public:
		int getPortName()
		{
			return getPortName(comName->Text);
		}

		static int getPortName(String * text)
		{
			if(text->Length == 5)
				text = text->Substring(3,2);
			else if(text->Length == 4)
				text = text->Substring(3,1);
			else
				return -1;

			return System::Convert::ToInt32(text);
		}

		char* stringToChar(String* str)
		{
			int len = str->Length;
			char* nstr = new char[len+1];
			for(int i =0; i<len; i++)
				nstr[i] = static_cast<char>(str->Chars[i]);
			nstr[len] = '\0';
			return (char*)nstr;
		}

		int getBaud()
		{
			return System::Convert::ToInt32(baudRate->Text);
		}

		int getParity()
		{
			if(noParity->Checked == true)
				return 0;
			else if(oddParity->Checked == true)
				return 1;
			else// if(evenParity->Checked == true)
				return 2;

		}

		void setPortName(String * name)
		{
			comName->Text = name;
		}

		void setBaud(int baud)
		{

		//	int bsi = baudRate->SelectedIndex;
			for(int i = 0; i<baudRate->Items->Count; i++)
			{
				if(static_cast<String*>(baudRate->Items->Item[i])->Equals(baud.ToString()))
					baudRate->SelectedIndex = i;
			}
		//	baudRate->Text = baud.ToString();
		}
		void setParity(int p)
		{
			
			if(p == 0)
				noParity->Checked = true;
			else if(p == 1)// = SerialPorts::Parity::Odd)
				oddParity->Checked = true;
			else// if(p == SerialPorts::Parity::Odd)
				evenParity->Checked = true;
		}
	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->comName = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->baudRate = new System::Windows::Forms::ComboBox();
			this->label2 = new System::Windows::Forms::Label();
			this->groupBox1 = new System::Windows::Forms::GroupBox();
			this->evenParity = new System::Windows::Forms::RadioButton();
			this->oddParity = new System::Windows::Forms::RadioButton();
			this->noParity = new System::Windows::Forms::RadioButton();
			this->byteSize = new System::Windows::Forms::ComboBox();
			this->label3 = new System::Windows::Forms::Label();
			this->stopBits = new System::Windows::Forms::ComboBox();
			this->label4 = new System::Windows::Forms::Label();
			this->ok = new System::Windows::Forms::Button();
			this->groupBox1->SuspendLayout();
			this->SuspendLayout();
			// 
			// comName
			// 
			this->comName->Location = System::Drawing::Point(16, 32);
			this->comName->Name = S"comName";
			this->comName->Size = System::Drawing::Size(104, 20);
			this->comName->TabIndex = 0;
			this->comName->Text = S"COM2";
			this->comName->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, comName_KeyPress);
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(16, 16);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(120, 16);
			this->label1->TabIndex = 1;
			this->label1->Text = S"Port Name:";
			// 
			// baudRate
			// 
			this->baudRate->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			System::Object* __mcTemp__1[] = new System::Object*[4];
			__mcTemp__1[0] = S"9600";
			__mcTemp__1[1] = S"19200";
			__mcTemp__1[2] = S"38400";
			__mcTemp__1[3] = S"115200";
			this->baudRate->Items->AddRange(__mcTemp__1);
			this->baudRate->Location = System::Drawing::Point(16, 80);
			this->baudRate->Name = S"baudRate";
			this->baudRate->Size = System::Drawing::Size(104, 21);
			this->baudRate->TabIndex = 2;
			// 
			// label2
			// 
			this->label2->Location = System::Drawing::Point(16, 64);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(104, 16);
			this->label2->TabIndex = 3;
			this->label2->Text = S"Baud:";
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->evenParity);
			this->groupBox1->Controls->Add(this->oddParity);
			this->groupBox1->Controls->Add(this->noParity);
			this->groupBox1->Enabled = false;
			this->groupBox1->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->groupBox1->Location = System::Drawing::Point(152, 56);
			this->groupBox1->Name = S"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(80, 96);
			this->groupBox1->TabIndex = 4;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = S"Parity";
			// 
			// evenParity
			// 
			this->evenParity->Enabled = false;
			this->evenParity->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->evenParity->Location = System::Drawing::Point(16, 56);
			this->evenParity->Name = S"evenParity";
			this->evenParity->Size = System::Drawing::Size(48, 16);
			this->evenParity->TabIndex = 2;
			this->evenParity->Text = S"Even";
			// 
			// oddParity
			// 
			this->oddParity->Enabled = false;
			this->oddParity->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->oddParity->Location = System::Drawing::Point(16, 40);
			this->oddParity->Name = S"oddParity";
			this->oddParity->Size = System::Drawing::Size(48, 16);
			this->oddParity->TabIndex = 1;
			this->oddParity->Text = S"Odd";
			// 
			// noParity
			// 
			this->noParity->Checked = true;
			this->noParity->Enabled = false;
			this->noParity->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->noParity->Location = System::Drawing::Point(16, 24);
			this->noParity->Name = S"noParity";
			this->noParity->Size = System::Drawing::Size(56, 16);
			this->noParity->TabIndex = 0;
			this->noParity->TabStop = true;
			this->noParity->Text = S"None";
			// 
			// byteSize
			// 
			this->byteSize->Enabled = false;
			System::Object* __mcTemp__2[] = new System::Object*[3];
			__mcTemp__2[0] = S"8";
			__mcTemp__2[1] = S"7";
			__mcTemp__2[2] = S"6";
			this->byteSize->Items->AddRange(__mcTemp__2);
			this->byteSize->Location = System::Drawing::Point(152, 32);
			this->byteSize->Name = S"byteSize";
			this->byteSize->Size = System::Drawing::Size(56, 21);
			this->byteSize->TabIndex = 5;
			this->byteSize->Text = S"8";
			// 
			// label3
			// 
			this->label3->Location = System::Drawing::Point(152, 16);
			this->label3->Name = S"label3";
			this->label3->Size = System::Drawing::Size(72, 16);
			this->label3->TabIndex = 6;
			this->label3->Text = S"Byte:";
			// 
			// stopBits
			// 
			this->stopBits->Enabled = false;
			System::Object* __mcTemp__3[] = new System::Object*[3];
			__mcTemp__3[0] = S"1";
			__mcTemp__3[1] = S"1.5";
			__mcTemp__3[2] = S"2";
			this->stopBits->Items->AddRange(__mcTemp__3);
			this->stopBits->Location = System::Drawing::Point(16, 128);
			this->stopBits->Name = S"stopBits";
			this->stopBits->Size = System::Drawing::Size(104, 21);
			this->stopBits->TabIndex = 7;
			this->stopBits->Text = S"1";
			// 
			// label4
			// 
			this->label4->Location = System::Drawing::Point(16, 112);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(96, 16);
			this->label4->TabIndex = 8;
			this->label4->Text = S"Stop Bits:";
			// 
			// ok
			// 
			this->ok->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->ok->Location = System::Drawing::Point(128, 176);
			this->ok->Name = S"ok";
			this->ok->Size = System::Drawing::Size(104, 32);
			this->ok->TabIndex = 9;
			this->ok->Text = S"OK";
			this->ok->Click += new System::EventHandler(this, ok_Click);
			// 
			// PortSetupDialog
			// 
			this->AcceptButton = this->ok;
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(250, 224);
			this->ControlBox = false;
			this->Controls->Add(this->ok);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->stopBits);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->byteSize);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->baudRate);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->comName);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = S"PortSetupDialog";
			this->ShowInTaskbar = false;
			this->Text = S"COM port setup";
			this->Load += new System::EventHandler(this, PortSetupDialog_Load);
			this->groupBox1->ResumeLayout(false);
			this->ResumeLayout(false);

		}		
	private: System::Void ok_Click(System::Object *  sender, System::EventArgs *  e)
			 {
				 if(Common::checkCom(comName->Text))
					 this->Close();
				 else
					 MessageBox::Show(S"You need to fix the COM port box",S"BRE");
			 }

private: System::Void comName_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
		 {
			 	 if((e->KeyChar < '0' || e->KeyChar > '9') && !(e->KeyChar == 8)
					 && !(e->KeyChar == 'C') && !(e->KeyChar == 'O') && !(e->KeyChar == 'M'))
				 e->Handled = true;
		 }

private: System::Void PortSetupDialog_Load(System::Object *  sender, System::EventArgs *  e)
		 {
		 }

};
}