#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace bre20
{
	/// <summary> 
	/// Summary for ProgressDialog
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class ProgressDialog : public System::Windows::Forms::Form
	{
	public: 
		ProgressDialog(String * label, int max)
		{
			InitializeComponent();

			// Display the ProgressBar control.
			progressBar->Visible = true;
			// Set Minimum to 1 to represent the first file being copied.
			progressBar->Minimum = 1;
			// Set Maximum to the total number of files to copy.
			progressBar->Maximum = max;
			// Set the initial value of the ProgressBar.
			progressBar->Value = 1;
			// Set the Step property to a value of 1 to represent each file being copied.
			progressBar->Step = 1;

			pLabel->Text = label;
		}

		void setValue(int value)
		{
			while(progressBar->Value < value)
				progressBar->PerformStep();

			this->Text = String::Concat(getPercent().ToString(),S"%");
			this->Refresh();
		}

		int getPercent()
		{
			return (progressBar->Value*100)/progressBar->Maximum;
		}

		void setMax(int max)
		{
			progressBar->Maximum = max;
		}

        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::ProgressBar *  progressBar;
	private: System::Windows::Forms::Label *  pLabel;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->progressBar = new System::Windows::Forms::ProgressBar();
			this->pLabel = new System::Windows::Forms::Label();
			this->SuspendLayout();
			// 
			// progressBar
			// 
			this->progressBar->Location = System::Drawing::Point(24, 48);
			this->progressBar->Name = S"progressBar";
			this->progressBar->Size = System::Drawing::Size(336, 24);
			this->progressBar->TabIndex = 0;
			// 
			// pLabel
			// 
			this->pLabel->Location = System::Drawing::Point(24, 24);
			this->pLabel->Name = S"pLabel";
			this->pLabel->Size = System::Drawing::Size(336, 16);
			this->pLabel->TabIndex = 1;
			this->pLabel->Text = S"progress label";
			// 
			// ProgressDialog
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(386, 110);
			this->ControlBox = false;
			this->Controls->Add(this->pLabel);
			this->Controls->Add(this->progressBar);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = S"ProgressDialog";
			this->ShowInTaskbar = false;
			this->Text = S"Progress";
			this->ResumeLayout(false);

		}		
	};
}