#include "stdafx.h"
#include "properties.h"
#include "common.h"

String * bre20::Properties::getParam(String * name)
{
	return as->GetSetting(name);
}
bool bre20::Properties::getBoolParam(String * name)
{
	String* n = getParam(name);
	if(n != NULL)
		n = n->Trim();
	else 
		return false;

	if(n->Equals("1") || n->ToLower()->Equals("true"))
		return true;
	return false;
}
int bre20::Properties::getIntParam(String * name)
{
	try
	{
		return Convert::ToInt32(getParam(name));
	}
	catch(...)
	{
		return -1;
	}
}
float bre20::Properties::getFloatParam(String * name)
{
	try
	{
		return Common::convertToLocale(getParam(name));
	//	return Convert::ToSingle(getParam(name));
	}
	catch(...)
	{
		return -1.0F;
	}
}
void bre20::Properties::setParam(Object* sender,String * name, String* value)
{
	as->SaveSetting(name,value);
	this->PropertyChanged(sender,name,value);
}

void bre20::Properties::NotifyDialogOpened(Form* dialog, String* dialogType)
{
	this->DialogOpened(dialog,dialogType);
}

//*******************************************
//-------------------------------------------
//*******************************************
bre20::PropertyEventArgs::PropertyEventArgs(String* propName, String* propVal)
{
	type = 0;//PROPERTY_CHANGED;
	name = propName;
	value = propVal;
	dialog = NULL;
}

bre20::PropertyEventArgs::PropertyEventArgs(Form* propDialog, String* dialogName)
{
	type = 1;//PROPERTY_DIALOG_OPENED;
	dialog = propDialog;
	name = dialogName;
	value = NULL;
}