#pragma once

using namespace System;

#include "bytechange.h"

namespace RomRep
{
	[Serializable] public __gc class AfrChangeArgs: public EventArgs
	{
	protected:
		int index, x, y;
		float afr;

	public:
		AfrChangeArgs(int xx, int yy, float afrr, int ind){
			x = xx;
			y = yy;
			afr = afrr;
			index = ind;
		}
		int getX(){return x;}
		int getY(){return y;}
		float getAfr(){return afr;}
		int getIndex(){return index;}

	};

	[Serializable] public __gc class ByteChangeArgs: public EventArgs
	{
	protected:
		RomRep::ByteChange* bc;

	public:
		ByteChangeArgs(RomRep::ByteChange* b){bc = b;}
		RomRep::ByteChange* getByteChange(){return bc;}
	};

	public __gc class MapHeaderChangeArgs: public EventArgs
	{
	protected:
		int x,y;
		String* newval[];

	public:
		MapHeaderChangeArgs(int xx, int yy, String* newvalues[])
		{
			x = xx; y =yy; newval = newvalues;
		}
		int getX(){ return x; }
		int getY(){ return y; }
		String* getValue()[]{ return newval; }
	};

	public __gc class RealMapChangeArgs: public EventArgs
	{
	protected:
		int x,y;
		float newval;

	public:
		RealMapChangeArgs(int xx, int yy, float newvalue)
		{
			x = xx; y =yy; newval = newvalue;
		}
		int getX(){ return x; }
		int getY(){ return y; }
		float getValue(){ return newval; }
	};

	[Serializable] public __gc class MapChangeArgs: public EventArgs
	{
	protected:
		int loc;
		int x, y;
		int byte;

	public:
		MapChangeArgs(int loc, int x, int y, int byte)
		{
			this->loc = loc;
			this->x = x;
			this->y = y;
			this->byte = byte;
		};
		int getX(){return x;}
		int getY(){return y;}
		int getLocation(){return loc;}
		int getByte(){return byte;}
	};
}