#include "StdAfx.h"
#include "RtpOptions.h"

void bre20::RtpOptions::RtpOptions_Load(System::Object *  sender, System::EventArgs *  e)
{
	this->portBox->Text = Globals::Props->getParam(S"emuPort");
	this->hiSpeedChk->Checked = Globals::Props->getBoolParam(S"emuHighSpeed");
	this->chkPutOnCon->Checked = Globals::Props->getBoolParam(S"emuAutoPut");

	if(Globals::Props->getBoolParam(S"emuLiveEdit"))
		this->liveEdit->Checked = true;
	else
		this->manDl->Checked = true;

	int dev = Globals::Props->getIntParam(S"emuDevice");
	if(dev == EmulatorUtil::DEVICE_ROMULATOR)
		this->romulOpt->Checked = true;
	else
		this->ostrichOpt->Checked = true;

	String* ch = Globals::Props->getParam(S"emuSmallChange");
	this->rtPercent->Checked = true;
	int perc = ch->IndexOf("%");
	if(perc>0)
	{
		ch = ch->Substring(0,perc);
		this->percLbl1->Text = S"%";
		this->percLbl2->Text = S"%";
	}
	else
	{
		this->percLbl1->Text = S"";
		this->percLbl2->Text = S"";
		this->rtAdd->Checked = true;
	}

	try{
		this->smChBox->Text = Convert::ToSingle(ch).ToString(S"0.00");
	}
	catch(...){}

	ch = Globals::Props->getParam(S"emuLargeChange");
	perc = ch->IndexOf("%");
	if(perc>0)
		ch = ch->Substring(0,perc);

	try{
		this->lgChBox->Text = Convert::ToSingle(ch).ToString(S"0.00");
	}
	catch(...){}
}

void bre20::RtpOptions::okBtn_Click(System::Object *  sender, System::EventArgs *  e)
{
	//check all options...
	bool good = bre20::Common::checkCom(this->portBox->Text);

	try
	{
		Convert::ToSingle(this->smChBox->Text);
		Convert::ToSingle(this->lgChBox->Text);
	}
	catch(...){good = false;}

	if(good)
	{
		Globals::Props->setParam(this,S"emuPort",this->portBox->Text);

		String* str = S"";
		if(this->rtPercent->Checked)
			str = S"%";

		Globals::Props->setParam(this,S"emuSmallChange",String::Concat(this->smChBox->Text,str));
		Globals::Props->setParam(this,S"emuLargeChange",String::Concat(this->lgChBox->Text,str));

		Globals::Props->setParam(this,S"emuLiveEdit",this->liveEdit->Checked.ToString());
		Globals::Props->setParam(this,S"emuHighSpeed",this->hiSpeedChk->Checked.ToString());
		Globals::Props->setParam(this,S"emuAutoPut",this->chkPutOnCon->Checked.ToString());

		if(this->romulOpt->Checked)
			Globals::Props->setParam(this,S"emuDevice",EmulatorUtil::DEVICE_ROMULATOR.ToString());
		else
			Globals::Props->setParam(this,S"emuDevice",EmulatorUtil::DEVICE_OSTRICH.ToString());

		this->Close();
	}
	else
		MessageBox::Show(S"Fix one or all of the Text Boxes",S"BRE");
}

void bre20::RtpOptions::portBox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
{
	if((e->KeyChar < '0' || e->KeyChar > '9') && !(e->KeyChar == 8)
		&& !(e->KeyChar == 'C') && !(e->KeyChar == 'O') && !(e->KeyChar == 'M'))
	e->Handled = true;
}

void bre20::RtpOptions::rtPercent_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
{
	if(rtPercent->Checked)
	{
		this->percLbl1->Text = S"%";
		this->percLbl2->Text = S"%";
	}
	else
	{
		this->percLbl1->Text = S"";
		this->percLbl2->Text = S"";
	}
}