#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "common.h"
#include "Global.h"
#include "EmulatorUtil.h"

namespace bre20
{
	/// <summary> 
	/// Options dialog for the emulation parameters.
	/// </summary>
	public __gc class RtpOptions : public System::Windows::Forms::Form
	{
	public: 
		RtpOptions(void)
		{
			InitializeComponent();

			Globals::Props->NotifyDialogOpened(this,"RtpOptions");
		}

		bool isLiveEdit()
		{
			return this->liveEdit->Checked;
		}

	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}

	private:

		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;
		System::Windows::Forms::GroupBox *  rtpTypeGrp;
		System::Windows::Forms::TextBox *  portBox;
		System::Windows::Forms::GroupBox *  portGrp;
		System::Windows::Forms::Label *  portLbl;
		System::Windows::Forms::GroupBox *  groupBox1;
		System::Windows::Forms::Label *  label1;
		System::Windows::Forms::Label *  label4;
		System::Windows::Forms::Button *  okBtn;
		System::Windows::Forms::RadioButton *  rtPercent;
		System::Windows::Forms::RadioButton *  rtAdd;
		System::Windows::Forms::RadioButton *  manDl;
		System::Windows::Forms::RadioButton *  liveEdit;
		System::Windows::Forms::TextBox *  lgChBox;
		System::Windows::Forms::Label *  percLbl2;
		System::Windows::Forms::Label *  percLbl1;
		System::Windows::Forms::TextBox *  smChBox;
		System::Windows::Forms::CheckBox *  hiSpeedChk;
		System::Windows::Forms::GroupBox *  deviceGrp;
		System::Windows::Forms::RadioButton *  ostrichOpt;
		System::Windows::Forms::RadioButton *  romulOpt;
		System::Windows::Forms::GroupBox *  grpGen;
		System::Windows::Forms::CheckBox *  chkPutOnCon;
		System::Windows::Forms::Label *  label5;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->rtpTypeGrp = new System::Windows::Forms::GroupBox();
			this->manDl = new System::Windows::Forms::RadioButton();
			this->liveEdit = new System::Windows::Forms::RadioButton();
			this->portBox = new System::Windows::Forms::TextBox();
			this->portGrp = new System::Windows::Forms::GroupBox();
			this->hiSpeedChk = new System::Windows::Forms::CheckBox();
			this->portLbl = new System::Windows::Forms::Label();
			this->groupBox1 = new System::Windows::Forms::GroupBox();
			this->label5 = new System::Windows::Forms::Label();
			this->rtAdd = new System::Windows::Forms::RadioButton();
			this->rtPercent = new System::Windows::Forms::RadioButton();
			this->lgChBox = new System::Windows::Forms::TextBox();
			this->label4 = new System::Windows::Forms::Label();
			this->percLbl2 = new System::Windows::Forms::Label();
			this->percLbl1 = new System::Windows::Forms::Label();
			this->smChBox = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->okBtn = new System::Windows::Forms::Button();
			this->deviceGrp = new System::Windows::Forms::GroupBox();
			this->romulOpt = new System::Windows::Forms::RadioButton();
			this->ostrichOpt = new System::Windows::Forms::RadioButton();
			this->grpGen = new System::Windows::Forms::GroupBox();
			this->chkPutOnCon = new System::Windows::Forms::CheckBox();
			this->rtpTypeGrp->SuspendLayout();
			this->portGrp->SuspendLayout();
			this->groupBox1->SuspendLayout();
			this->deviceGrp->SuspendLayout();
			this->grpGen->SuspendLayout();
			this->SuspendLayout();
			// 
			// rtpTypeGrp
			// 
			this->rtpTypeGrp->Controls->Add(this->manDl);
			this->rtpTypeGrp->Controls->Add(this->liveEdit);
			this->rtpTypeGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->rtpTypeGrp->Location = System::Drawing::Point(8, 88);
			this->rtpTypeGrp->Name = S"rtpTypeGrp";
			this->rtpTypeGrp->Size = System::Drawing::Size(160, 72);
			this->rtpTypeGrp->TabIndex = 0;
			this->rtpTypeGrp->TabStop = false;
			this->rtpTypeGrp->Text = S"Tuning Mode";
			// 
			// manDl
			// 
			this->manDl->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->manDl->Location = System::Drawing::Point(24, 40);
			this->manDl->Name = S"manDl";
			this->manDl->Size = System::Drawing::Size(120, 16);
			this->manDl->TabIndex = 1;
			this->manDl->Text = S"Manual Download";
			// 
			// liveEdit
			// 
			this->liveEdit->Checked = true;
			this->liveEdit->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->liveEdit->Location = System::Drawing::Point(24, 24);
			this->liveEdit->Name = S"liveEdit";
			this->liveEdit->Size = System::Drawing::Size(72, 16);
			this->liveEdit->TabIndex = 0;
			this->liveEdit->TabStop = true;
			this->liveEdit->Text = S"Live Edit";
			// 
			// portBox
			// 
			this->portBox->Location = System::Drawing::Point(56, 24);
			this->portBox->Name = S"portBox";
			this->portBox->Size = System::Drawing::Size(48, 20);
			this->portBox->TabIndex = 1;
			this->portBox->Text = S"COM1";
			this->portBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, portBox_KeyPress);
			// 
			// portGrp
			// 
			this->portGrp->Controls->Add(this->hiSpeedChk);
			this->portGrp->Controls->Add(this->portLbl);
			this->portGrp->Controls->Add(this->portBox);
			this->portGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->portGrp->Location = System::Drawing::Point(176, 88);
			this->portGrp->Name = S"portGrp";
			this->portGrp->Size = System::Drawing::Size(144, 72);
			this->portGrp->TabIndex = 2;
			this->portGrp->TabStop = false;
			this->portGrp->Text = S"Connection";
			// 
			// hiSpeedChk
			// 
			this->hiSpeedChk->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->hiSpeedChk->Location = System::Drawing::Point(24, 48);
			this->hiSpeedChk->Name = S"hiSpeedChk";
			this->hiSpeedChk->Size = System::Drawing::Size(88, 16);
			this->hiSpeedChk->TabIndex = 3;
			this->hiSpeedChk->Text = S"High-Speed";
			// 
			// portLbl
			// 
			this->portLbl->Location = System::Drawing::Point(24, 24);
			this->portLbl->Name = S"portLbl";
			this->portLbl->Size = System::Drawing::Size(32, 16);
			this->portLbl->TabIndex = 2;
			this->portLbl->Text = S"Port:";
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->label5);
			this->groupBox1->Controls->Add(this->rtAdd);
			this->groupBox1->Controls->Add(this->rtPercent);
			this->groupBox1->Controls->Add(this->lgChBox);
			this->groupBox1->Controls->Add(this->label4);
			this->groupBox1->Controls->Add(this->percLbl2);
			this->groupBox1->Controls->Add(this->percLbl1);
			this->groupBox1->Controls->Add(this->smChBox);
			this->groupBox1->Controls->Add(this->label1);
			this->groupBox1->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->groupBox1->Location = System::Drawing::Point(8, 168);
			this->groupBox1->Name = S"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(312, 128);
			this->groupBox1->TabIndex = 3;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = S"Realtime Tuning ";
			// 
			// label5
			// 
			this->label5->Location = System::Drawing::Point(152, 40);
			this->label5->Name = S"label5";
			this->label5->Size = System::Drawing::Size(88, 16);
			this->label5->TabIndex = 8;
			this->label5->Text = S"Change Type:";
			// 
			// rtAdd
			// 
			this->rtAdd->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->rtAdd->Location = System::Drawing::Point(168, 88);
			this->rtAdd->Name = S"rtAdd";
			this->rtAdd->Size = System::Drawing::Size(48, 16);
			this->rtAdd->TabIndex = 7;
			this->rtAdd->Text = S"Add";
			// 
			// rtPercent
			// 
			this->rtPercent->Checked = true;
			this->rtPercent->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->rtPercent->Location = System::Drawing::Point(168, 64);
			this->rtPercent->Name = S"rtPercent";
			this->rtPercent->Size = System::Drawing::Size(80, 16);
			this->rtPercent->TabIndex = 6;
			this->rtPercent->TabStop = true;
			this->rtPercent->Text = S"Percentage";
			this->rtPercent->CheckedChanged += new System::EventHandler(this, rtPercent_CheckedChanged);
			// 
			// lgChBox
			// 
			this->lgChBox->Location = System::Drawing::Point(24, 88);
			this->lgChBox->Name = S"lgChBox";
			this->lgChBox->Size = System::Drawing::Size(64, 20);
			this->lgChBox->TabIndex = 5;
			this->lgChBox->Text = S"5";
			this->lgChBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, lgChBox_KeyPress);
			// 
			// label4
			// 
			this->label4->Location = System::Drawing::Point(24, 72);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(80, 16);
			this->label4->TabIndex = 4;
			this->label4->Text = S"Large Change";
			// 
			// percLbl2
			// 
			this->percLbl2->Location = System::Drawing::Point(96, 88);
			this->percLbl2->Name = S"percLbl2";
			this->percLbl2->Size = System::Drawing::Size(8, 24);
			this->percLbl2->TabIndex = 3;
			this->percLbl2->Text = S"%";
			this->percLbl2->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// percLbl1
			// 
			this->percLbl1->Location = System::Drawing::Point(96, 40);
			this->percLbl1->Name = S"percLbl1";
			this->percLbl1->Size = System::Drawing::Size(8, 24);
			this->percLbl1->TabIndex = 2;
			this->percLbl1->Text = S"%";
			this->percLbl1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// smChBox
			// 
			this->smChBox->Location = System::Drawing::Point(24, 40);
			this->smChBox->Name = S"smChBox";
			this->smChBox->Size = System::Drawing::Size(64, 20);
			this->smChBox->TabIndex = 1;
			this->smChBox->Text = S"1";
			this->smChBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, smChBox_KeyPress);
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(24, 24);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(88, 16);
			this->label1->TabIndex = 0;
			this->label1->Text = S"Small Change";
			// 
			// okBtn
			// 
			this->okBtn->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->okBtn->Location = System::Drawing::Point(216, 304);
			this->okBtn->Name = S"okBtn";
			this->okBtn->Size = System::Drawing::Size(104, 32);
			this->okBtn->TabIndex = 4;
			this->okBtn->Text = S"OK";
			this->okBtn->Click += new System::EventHandler(this, okBtn_Click);
			// 
			// deviceGrp
			// 
			this->deviceGrp->Controls->Add(this->romulOpt);
			this->deviceGrp->Controls->Add(this->ostrichOpt);
			this->deviceGrp->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->deviceGrp->Location = System::Drawing::Point(8, 8);
			this->deviceGrp->Name = S"deviceGrp";
			this->deviceGrp->Size = System::Drawing::Size(160, 72);
			this->deviceGrp->TabIndex = 5;
			this->deviceGrp->TabStop = false;
			this->deviceGrp->Text = S"Device";
			// 
			// romulOpt
			// 
			this->romulOpt->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->romulOpt->Location = System::Drawing::Point(24, 40);
			this->romulOpt->Name = S"romulOpt";
			this->romulOpt->Size = System::Drawing::Size(80, 16);
			this->romulOpt->TabIndex = 1;
			this->romulOpt->Text = S"Romulator";
			// 
			// ostrichOpt
			// 
			this->ostrichOpt->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->ostrichOpt->Location = System::Drawing::Point(24, 24);
			this->ostrichOpt->Name = S"ostrichOpt";
			this->ostrichOpt->Size = System::Drawing::Size(104, 16);
			this->ostrichOpt->TabIndex = 0;
			this->ostrichOpt->Text = S"Ostrich";
			// 
			// grpGen
			// 
			this->grpGen->Controls->Add(this->chkPutOnCon);
			this->grpGen->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->grpGen->Location = System::Drawing::Point(176, 8);
			this->grpGen->Name = S"grpGen";
			this->grpGen->Size = System::Drawing::Size(144, 72);
			this->grpGen->TabIndex = 6;
			this->grpGen->TabStop = false;
			this->grpGen->Text = S"General";
			// 
			// chkPutOnCon
			// 
			this->chkPutOnCon->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->chkPutOnCon->Location = System::Drawing::Point(24, 32);
			this->chkPutOnCon->Name = S"chkPutOnCon";
			this->chkPutOnCon->Size = System::Drawing::Size(104, 16);
			this->chkPutOnCon->TabIndex = 0;
			this->chkPutOnCon->Text = S"Put on Connect";
			// 
			// RtpOptions
			// 
			this->AcceptButton = this->okBtn;
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(330, 351);
			this->ControlBox = false;
			this->Controls->Add(this->grpGen);
			this->Controls->Add(this->deviceGrp);
			this->Controls->Add(this->okBtn);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->portGrp);
			this->Controls->Add(this->rtpTypeGrp);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->Name = S"RtpOptions";
			this->ShowInTaskbar = false;
			this->Text = S"Emulation Options";
			this->Load += new System::EventHandler(this, RtpOptions_Load);
			this->rtpTypeGrp->ResumeLayout(false);
			this->portGrp->ResumeLayout(false);
			this->groupBox1->ResumeLayout(false);
			this->deviceGrp->ResumeLayout(false);
			this->grpGen->ResumeLayout(false);
			this->ResumeLayout(false);

		}		
		//
		////
		void RtpOptions_Load(System::Object *  sender, System::EventArgs *  e);
		void okBtn_Click(System::Object *  sender, System::EventArgs *  e);
		void rtPercent_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		void portBox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e);

		void smChBox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
		{
			Common::handleDoubleKeyPress(static_cast<TextBox*>(sender),e,true);
		}

		void lgChBox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
		{
			Common::handleDoubleKeyPress(static_cast<TextBox*>(sender),e,true);
		}
};
}