#pragma once

using namespace System;
using namespace System::Windows::Forms;
using namespace System::Text::RegularExpressions;

#include "labeledtext.h"
#include "gridpage.h"

namespace bre20
{
	/// <summary> 
	/// Summary for ScriptLabeledText
	/// </summary>
	__gc public class FireScriptEventArgs
	{
	private:
		String * name;
		EventArgs* args;
	public:
		FireScriptEventArgs(String* eventName, EventArgs* e)
		{
			name = eventName;
			args = e;
		}

		String* getName() { return name; }
		EventArgs* getArgs() { return args; }
	};

	public __gc __interface ScriptControl
	{
	public:
		String* getMethodName();
		void setMethodName(String* str);
	};
	/// <summary> 
	/// Summary for ScriptLabeledText
	/// </summary>
	__gc public class ScriptLabeledText :  public LabeledText, public ScriptControl
	{
	protected:
		String * methodName;
	public:
		ScriptLabeledText()
		{
		}

		ScriptLabeledText(String* methodName, String * caption,String* tooltip, int width, int mode): LabeledText(caption, tooltip, width, mode)
		{
			this->methodName = methodName;
		}

		String* getMethodName()
		{
			return methodName;
		}

		void setMethodName(String* str)
		{
			methodName = str;
		}
	};

	/// <summary> 
	/// Summary for ScriptLabeledText
	/// </summary>
	__gc public class ScriptButton :  public Button, public ScriptControl
	{
	protected:
		String * methodName;
	public:
		ScriptButton()
		{
		}
		ScriptButton(String* methodName)
		{
			this->methodName = methodName;
		}

		String* getMethodName()
		{
			return methodName;
		}

		void setMethodName(String* str)
		{
			methodName = str;
		}
	};

	/// <summary> 
	/// Summary for ScriptLabeledText
	/// </summary>
	__gc public class ScriptCheckBox :  public CheckBox, public ScriptControl
	{
	protected:
		String * methodName;
	public:
		ScriptCheckBox()
		{
		}
		ScriptCheckBox(String* methodName)
		{
			this->methodName = methodName;
		}

		String* getMethodName()
		{
			return methodName;
		}

		void setMethodName(String* str)
		{
			methodName = str;
		}
	};

		/// <summary> 
	/// Summary for ScriptLabeledText
	/// </summary>
	__gc public class ScriptMenuItem :  public MenuItem, public ScriptControl
	{
	protected:
		String * methodName;
	public:
		ScriptMenuItem()
		{
		}
		ScriptMenuItem(String* methodName)
		{
			this->methodName = methodName;
		}

		String* getMethodName()
		{
			return methodName;
		}

		void setMethodName(String* str)
		{
			methodName = str;
		}
	};

		/// <summary> 
	/// Summary for ScriptLabeledText
	/// </summary>
	__gc public class ScriptGrid :  public SimpleGrid::Grid, public ScriptControl
	{
	protected:
		String * methodName;
	public:
		ScriptGrid()
		{
		}
		ScriptGrid(String* methodName)
		{
			this->methodName = methodName;
		}

		String* getMethodName()
		{
			return methodName;
		}

		void setMethodName(String* str)
		{
			methodName = str;
		}
	};

	__gc public class ScriptGridPage :  public bre20::GridPage, public ScriptControl
	{
	protected:
		String * methodName;
	public:
		ScriptGridPage()
		{
		}
		ScriptGridPage(String* methodName, String * tabName, int columns, int rows, int mode): GridPage(tabName, columns, rows, mode)
		{
			this->methodName = methodName;
		}

		String* getMethodName()
		{
			return methodName;
		}

		void setMethodName(String* str)
		{
			methodName = str;
		}
	};
}