#pragma once

using namespace System;
using namespace System::IO;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;

#define LOADSCRIPTS "LoadScripts.bre"
#include "child.h"

namespace bre20
{
	/// <summary> 
	/// Summary for ScriptManager
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class ScriptManager : public System::Windows::Forms::Form
	{
	public: 
	//	ScriptManager(void)
	//	{
	//		InitializeComponent();
	//	}

		ScriptManager(void)//CSScriptLibrary::CSScript * sc, bre20::child* par[])
		{
			InitializeComponent();

			scripting = new CSScriptLibrary::CSScript();
			parents = new ArrayList(10);
			paths = new ArrayList(10);
		//	this->args = args;

			//if(sc != NULL)
			//{
			//	ArrayList * al = this->scripting->Scripts;

			//	for(int i = 0; i<al->Count; i++)
			//	{
			//		scripts->Items->Add(static_cast<CSScriptLibrary::Script*>(al->get_Item(i))->ScriptPath);
			//	}
			//}
			//else
			//	this->Close();
		}

		void AddChild(child* ch)
		{
			parents->Add(ch);
			//now instantiate for that child...
			InstantiateObjects(ch);
		}

		child* GetChild(int index)
		{
			return static_cast<child*>(parents->get_Item(index));
		}

		child* GetChildArray()[]
		{
			return static_cast<child*[]>(parents->ToArray()); //__typeof(child*)
		}
		void InstantiateObjects(child* ch)
		{

			ArrayList * al = this->scripting->Scripts;
			for(int i = 0; i<al->Count; i++)
			{
				CSScriptLibrary::Script* sc = static_cast<CSScriptLibrary::Script*>(al->get_Item(i));
				Object* args[] = new Object*[2];
				args[0] = this->MdiParent;
				args[1] = ch;
				sc->CreateInstance(ch,args);
			}

		}

		//returns script name...
		String* CompileAndLoadScript(String* path)
		{
			try
			{
				CSScriptLibrary::Script * sc = 
						scripting->CompileAndLoad(path);//, GetChildArray());

				if(sc != NULL)
				{
					LoadScript(sc);
					return sc->ScriptTitle;
				}
				return NULL;
			}
			catch(Exception* e)
			{
				MessageBox::Show(String::Concat(e->Message,S"\n\n",e->Source, S"\n\n", e->StackTrace));
				return NULL;
			}
		}

		void LoadScript(CSScriptLibrary::Script * sc)
		{
			Object* args[] = new Object*[2];
			args[0] = this->MdiParent;

			//ghetto way to get the appliesTo stuff
		//	sc->CreateInstance(this,args);

			String* applies[] = sc->AppliesTo;

			for(int i = 0; i<parents->Count; i++)
			{
				for(int j = 0; j< applies->Length; j++)
				{

					applies[j] = applies[j]->ToLower();
					if(applies[j]->Equals("all") || GetChild(i)->getRomType()->ToLower()->IndexOf(applies[j]) >= 0)
					{ //
						args[1] = GetChild(i);
						sc->CreateInstance(GetChild(i),args);
						break;
					}//end if
				}//end for
			}//end for
		}//end loadScript

		void LoadScriptsFromFile()
		{
			try
			{
				StreamReader* tr = new StreamReader(LOADSCRIPTS);

				String* line = NULL;
				while((line = tr->ReadLine()) != NULL)
				{
					line = line->Trim();
					
					CompileAndLoadScript(line);
				}
				tr->Close();
			}
			catch(...)
			{
			}
		}

		void SaveScriptsToFile()
		{
			StreamWriter* sw = new StreamWriter(LOADSCRIPTS,false);

			for(int i = 0; i<scripts->Items->Count; i++)
				sw->WriteLine(static_cast<String*>(scripts->Items->get_Item(i)));

			sw->Close();

		}
        
	protected: 
		CSScriptLibrary::CSScript * scripting;

		ArrayList* parents;
		 ArrayList* paths;
	//	child* parents[];
	//	Object* args[];
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::Label *  label1;
	private: System::Windows::Forms::ListBox *  scripts;
	private: System::Windows::Forms::ContextMenu *  contextMenu1;
	private: System::Windows::Forms::MenuItem *  load;
	private: System::Windows::Forms::MenuItem *  reload;
	private: System::Windows::Forms::MenuItem *  selectAll;
	private: System::Windows::Forms::MenuItem *  unload;
	private: System::Windows::Forms::Button *  loadBtn;
	private: System::Windows::Forms::Button *  close;
	private: System::Windows::Forms::OpenFileDialog *  openFileDialog1;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->scripts = new System::Windows::Forms::ListBox();
			this->contextMenu1 = new System::Windows::Forms::ContextMenu();
			this->load = new System::Windows::Forms::MenuItem();
			this->reload = new System::Windows::Forms::MenuItem();
			this->selectAll = new System::Windows::Forms::MenuItem();
			this->unload = new System::Windows::Forms::MenuItem();
			this->loadBtn = new System::Windows::Forms::Button();
			this->close = new System::Windows::Forms::Button();
			this->openFileDialog1 = new System::Windows::Forms::OpenFileDialog();
			this->label1 = new System::Windows::Forms::Label();
			this->SuspendLayout();
			// 
			// scripts
			// 
			this->scripts->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->scripts->ContextMenu = this->contextMenu1;
			this->scripts->Location = System::Drawing::Point(8, 24);
			this->scripts->Name = S"scripts";
			this->scripts->SelectionMode = System::Windows::Forms::SelectionMode::MultiExtended;
			this->scripts->Size = System::Drawing::Size(336, 212);
			this->scripts->TabIndex = 0;
			// 
			// contextMenu1
			// 
			System::Windows::Forms::MenuItem* __mcTemp__1[] = new System::Windows::Forms::MenuItem*[4];
			__mcTemp__1[0] = this->load;
			__mcTemp__1[1] = this->reload;
			__mcTemp__1[2] = this->selectAll;
			__mcTemp__1[3] = this->unload;
			this->contextMenu1->MenuItems->AddRange(__mcTemp__1);
			// 
			// load
			// 
			this->load->Index = 0;
			this->load->Shortcut = System::Windows::Forms::Shortcut::CtrlL;
			this->load->Text = S"Load";
			this->load->Click += new System::EventHandler(this, load_Click);
			// 
			// reload
			// 
			this->reload->Index = 1;
			this->reload->Shortcut = System::Windows::Forms::Shortcut::CtrlR;
			this->reload->Text = S"Reload";
			this->reload->Click += new System::EventHandler(this, reload_Click);
			// 
			// selectAll
			// 
			this->selectAll->Index = 2;
			this->selectAll->Shortcut = System::Windows::Forms::Shortcut::CtrlA;
			this->selectAll->Text = S"Select all";
			this->selectAll->Click += new System::EventHandler(this, selectAll_Click);
			// 
			// unload
			// 
			this->unload->Index = 3;
			this->unload->Shortcut = System::Windows::Forms::Shortcut::Del;
			this->unload->Text = S"Unload";
			this->unload->Click += new System::EventHandler(this, unload_Click);
			// 
			// loadBtn
			// 
			this->loadBtn->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right);
			this->loadBtn->Location = System::Drawing::Point(176, 248);
			this->loadBtn->Name = S"loadBtn";
			this->loadBtn->Size = System::Drawing::Size(80, 32);
			this->loadBtn->TabIndex = 1;
			this->loadBtn->Text = S"Load";
			this->loadBtn->Click += new System::EventHandler(this, loadBtn_Click);
			// 
			// close
			// 
			this->close->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right);
			this->close->Location = System::Drawing::Point(264, 248);
			this->close->Name = S"close";
			this->close->Size = System::Drawing::Size(80, 32);
			this->close->TabIndex = 2;
			this->close->Text = S"Close";
			this->close->Click += new System::EventHandler(this, close_Click);
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(8, 8);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(112, 16);
			this->label1->TabIndex = 3;
			this->label1->Text = S"Loaded Scripts:";
			// 
			// ScriptManager
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(352, 286);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->close);
			this->Controls->Add(this->loadBtn);
			this->Controls->Add(this->scripts);
			this->MaximizeBox = false;
			this->Name = S"ScriptManager";
			this->ShowInTaskbar = false;
			this->Text = S"Script Manager";
			this->Closing += new System::ComponentModel::CancelEventHandler(this, ScriptManager_Closing);
			this->ResumeLayout(false);

		}		
	private: System::Void load_Click(System::Object *  sender, System::EventArgs *  e)
			 {
				 this->openFileDialog1->Filter = S"C# files (*.cs)|*.cs|All files (*.*)|*.*";

				 if(this->openFileDialog1->ShowDialog() == DialogResult::OK)
				 {
					 for(int i = 0; i<this->openFileDialog1->FileNames->Length; i++)
					 {
						 bool found = false;
						 String* fname = this->openFileDialog1->FileNames[i];

						 String* str = CompileAndLoadScript(fname);
						 if(str != NULL)
						 {
							 for(int j = 0; j<scripts->Items->Count; j++)
								 if(str->ToLower()->Equals(
									(static_cast<String*>(scripts->Items->get_Item(j)))->ToLower()))
										found = true;
							 if(!found)
							 {
								 scripts->Items->Add(str);
								 paths->Add(fname);
							 }
						 }
						 else
							 MessageBox::Show(String::Concat(fname," is already on the list"),"BRE");

					 }//end for

					 SaveScriptsToFile();
				 }
			 }

private: System::Void reload_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 for(int i = 0; i<scripts->Items->Count; i++)
			 {
				 if(scripts->GetSelected(i))
				 {
					 CompileAndLoadScript(static_cast<String*>(paths->get_Item(i)));//(scripts->Items->get_Item(i)));
				 }
			 }
		 }

private: System::Void selectAll_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 for(int i = 0; i<scripts->Items->Count; i++)
			 {
				 scripts->SetSelected(i,true);
			 }
		 }

private: System::Void unload_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 for(int i = 0; i<scripts->Items->Count; i++)
			 {
				 if(scripts->GetSelected(i))
				 {
					 scripting->Unload(static_cast<String*>(paths->get_Item(i)));//,this->GetChildArray());
					 scripts->Items->RemoveAt(i);
					 paths->RemoveAt(i);
					 i--;
				 }
			 }

			 this->SaveScriptsToFile();
		 }

private: System::Void close_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 this->Visible = false;
		 }

private: System::Void loadBtn_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 load_Click(NULL,NULL);
		 }

private: System::Void ScriptManager_Closing(System::Object *  sender, System::ComponentModel::CancelEventArgs *  e)
		 {
			 e->Cancel = true;
			 this->Visible = false;
		 }

	};

//	public __gc class ScriptManager : public System::Windows::Forms::Form
//	{

//	};
}