#include "stdafx.h"
#include "Serial.h"
#include "windows.h"

bre20::CSerialPort::CSerialPort(void)
{
	baud = 38400;
	bytesize = 8;
	parity = 0;
	stopbits = 1;
}
System::String * bre20::CSerialPort::getComParams()
{
	String * temp = String::Concat(port, S", ", baud.ToString(), 
		S", ", bytesize.ToString(), S", ", parity.ToString(), S", ",
		stopbits.ToString());

	return temp;

}

bool bre20::CSerialPort::Open( char * szComPort, int baudrate)
{
	HANDLE handle;
	baud = baudrate;
    //int handle;
            
    //handle = MyKernel::CreateFile(
    //    szComPort,
    //    GENERIC_READ | GENERIC_WRITE,
    //    0,
    //    NULL,
    //    OPEN_ALWAYS,
    //    FILE_FLAG_NO_BUFFERING | FILE_FLAG_OVERLAPPED,
    //    NULL);

	port = new String(szComPort);

	handle = CreateFile(
		szComPort,
        GENERIC_READ | GENERIC_WRITE,
        0,
        NULL,
        OPEN_ALWAYS,
        FILE_FLAG_NO_BUFFERING | FILE_FLAG_OVERLAPPED,
        NULL);

    try
    {
        IntPtr    pCom(handle);
        m_MyFileStream = new FileStream(pCom, 
                                        FileAccess::ReadWrite, 
                                        true, 1000, true);        
    }

    catch (Exception  * e ) {
        Console::WriteLine(e->ToString());
          return false;
      }

    
    DCB    * CommSettings = new DCB();
    CommSettings->DCBlength = sizeof(CommSettings);
    CommSettings->BaudRate  = baud;
    CommSettings->ByteSize  = bytesize;
    CommSettings->Parity    = parity;
    CommSettings->StopBits    = stopbits;

    //MyKernel::SetCommState(m_MyFileStream->get_Handle(), 
    //                       CommSettings);

    SetCommState((HANDLE)m_MyFileStream->get_Handle(), 
                           (LPDCB)CommSettings);
    

 //   try
 //   {
 //       m_MyStreamReader = new StreamReader(m_MyFileStream);
 //   }

 //   catch (Exception  * e ) {
 //       Console::WriteLine(e->ToString());
 //         return false;
 //     }

 //   if ( m_MyFileStream->get_CanWrite() )
 //   {
 //       try
 //       {
 //           m_MyStreamWriter = new StreamWriter(m_MyFileStream);
 //       }

 //       catch (Exception  * e ) {
 ////           Console::WriteLine(e->ToString());
 //           return false;
 //       }
 //   }

    return true;
}

bool bre20::CSerialPort::Write(unsigned char buf)
{
    try
    {
//        m_MyStreamWriter->Write(buf);
//      m_MyStreamWriter->Flush();  
		this->m_MyFileStream->WriteByte(buf);
		this->m_MyFileStream->Flush();
        
    }

    catch(...) {
//        Console::WriteLine(e->ToString()); 
		return false;
      }

	return true;
}

int bre20::CSerialPort::Read()
{
    int buf;
    
//	buf = m_MyStreamReader->Read();
	buf = this->m_MyFileStream->ReadByte();

    return (buf);
}

void bre20::CSerialPort::Close()
{
//    m_MyStreamWriter->Close();
  //  m_MyStreamReader->Close();
    m_MyFileStream->Close();
}