#pragma once

using namespace System;
using namespace System::IO;
//using namespace System::Runtime::InteropServices;

namespace bre20
{
__gc class CSerialPort
{
public:
    CSerialPort(void);
    __nogc struct DCB
    {
        int DCBlength;
        int BaudRate;
        int fBinary;
        int fParity;
        int fOutxCtsFlow;
        int fOutxDsrFlow;
        int fDtrControl;
        int fDsrSensitivity;
        int fTXContinueOnXoff;
        int fOutX;
        int fInX;
        int fErrorChar;
        int fNull;
        int fRtsControl;
        int fAbortOnError;
        int fDummy2;
        unsigned short wReserved;
        unsigned short XonLim;
		unsigned short XoffLim;
        unsigned char ByteSize;    //byte
        unsigned char Parity; // byte
        unsigned char StopBits;    //byte
        char XonChar;
        char XoffChar;
        char ErrorChar;
        char EofChar;
        char EvtChar;
        unsigned short wReserved1;
    };

    bool    Open( char *szComPort, int baudrate);
    bool    Write(unsigned char buf);
    int		Read();
    void    Close();
	System::String * getComParams();

private:    
    FileStream    * m_MyFileStream;
//    StreamWriter * m_MyStreamWriter;
  //  StreamReader * m_MyStreamReader;

	String * port;
	int baud;
    unsigned char bytesize;    //byte
    unsigned char parity; // byte
    unsigned char stopbits;
    
    static long GENERIC_READ  = 0x80000000L;
    static long GENERIC_WRITE = 0x40000000L;

    static int OPEN_ALWAYS = 4;

    static int FILE_FLAG_NO_BUFFERING = 0x20000000;
    static int FILE_FLAG_OVERLAPPED   = 0x40000000;

};
}

//namespace MyKernel
//{
//[DllImport("kernel32.dll")]
//extern bool SetCommState(System::IntPtr hFile, bre20::CSerialPort::DCB * lpDBC);
//[DllImport("kernel32.dll")]
//extern int CreateFile( char * lpFileName , int dwDesiredAccess, int dwShareMode,
//  IntPtr lpSecurityAttributes, int dwCreationDisposition,
//  int dwFlagsAndAttributes, IntPtr hTemplateFile );
//
//}