#include "stdafx.h"
#include "serialcom.h"
#include "Global.h"


bre20::SerialCom::SerialCom()
{
	//setup the port:
	// Instantiate base class event handlers.
	func.RxChar = new SerialPorts::ByteFunc(this, port_receive);
	func.TxDone = new SerialPorts::VoidFunc(this, tx_Done);

	port = new SerialPorts::SerialPort(func);
	recv = new Queue();

	connected = false;
	txdone = false;
	timeout = 100;

	badsends = 0;

	portnum = -1;

}


unsigned char bre20::SerialCom::waitAndRecieve(int numback) __gc[]
{

//	for(int i = 0; !txdone && i<100; i++)
//		System::Threading::Thread::Sleep(10);

//	if(!txdone)
//		return NULL;

//	MessageBox::Show((recv->Count).ToString());

	txdone = false;

	
	int i;

	try
	{
		for(i = 0; recv->Count < numback && i<100; i++)
			System::Threading::Thread::Sleep(2);
	}
	catch(...)
	{
		return NULL;
	}

	if(i>90)
	{
//		badsends++;

//	if(badsends>2)
	//	MessageBox::Show(i.ToString());
		Globals::LogFile->WriteLine(this,String::Concat(S"WaitAndRecieve didnt get back expected num. count: ",
			recv->Count.ToString(), ", expected: ", numback.ToString()));
		return NULL;
	}

	unsigned char bytes __gc[] = new unsigned char __gc[recv->Count];
		
//	port->Recv(bytes,3);

	if(recv->Count > 0)
	{
		for(int i = 0; i<bytes->Length; i++)
			bytes[i] = static_cast<CharWrap*>(recv->Dequeue())->GetChar();

		recv->Clear();

		return bytes;
		
	}
	else
		return NULL;

}


unsigned char bre20::SerialCom::send(unsigned char cmd __gc[], int numback) __gc[]
{
	if(port != NULL)
	{
		port->Send(cmd);

		try
		{
			port->WaitForRead(timeout);
		}
		catch(...)
		{
			Globals::LogFile->WriteLine(this,S"Send: wait for read timed out.");
			return NULL;
		}
		//	return NULL;

//		for(int i = 0; !txdone && i<100; i++)
//			System::Threading::Thread::Sleep(10);

//		if(!txdone)
//			return NULL;

		return waitAndRecieve(numback); 
	}
	else{
		Globals::LogFile->WriteLine(this,S"Send: port is null");
		return NULL;
	}
}



//********************************************
//utils
unsigned char bre20::SerialCom::getAddress(int address) __gc[]
{
	if(address > 0xffff || address < 0)
		return NULL;

	unsigned char b __gc[] = new unsigned char __gc[2];

	b[0] = (unsigned char)(address/256);
	b[1] = (unsigned char)(address%256);

	return b;
}


void bre20::SerialCom::close()
{
	if(port != NULL)
	{
		port->Close();
		port = NULL;

		connected = false;

		port = new SerialPorts::SerialPort(func);
	}
}
