#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;

#include "PortSetupDialog.h"
#include "CharWrap.h"

namespace bre20
{
	/// <summary> 
	/// Summary for SerialCom
	/// </summary>
	public __gc class SerialCom: public MarshalByRefObject
	{
    //my data members...
	protected:
		Queue * recv;
		bool connected, txdone;
		int timeout, bytestosend, badsends, portnum;
		SerialPorts::SerialPort * port;
		SerialPorts::WithEvents func;

		virtual unsigned char waitAndRecieve(int numback) __gc[];

		virtual void port_receive(unsigned char b __gc[])
		{

			for(int i = 0; i < b->Length; i++)
				recv->Enqueue(new CharWrap(b[i]));

		//	if(showboxes)
		//		MessageBox::Show(String::Concat(S"Read: ", b->Length.ToString()));
		}

		virtual void tx_Done()
		{
			txdone = true;
		}


		static SerialPorts::Parity getParity(int parity)
		{
			if(parity == 0)
				return SerialPorts::Parity::None;
			else if(parity == 1)
				return SerialPorts::Parity::Odd;
			else// if(parity == 2)
				return SerialPorts::Parity::Even;
		}

		static int getPortName(String * com)
		{
			if(com->Length == 5)
				com = com->Substring(3,2);
			else if(com->Length == 4)
				com = com->Substring(3,1);
			else
				return -1;

			return System::Convert::ToInt32(com);
		}

		virtual void onDisconnect(System::EventArgs* e)
		{
			if (Disconnect != NULL)
				Disconnect(this,e);
		}

		virtual void onReconnect(System::EventArgs* e)
		{
			if (Reconnect != NULL)
				Reconnect(this,e);
		}
	public:
		SerialCom();

		virtual void close();

		virtual unsigned char send(unsigned char cmd __gc[], int numback) __gc[];

		virtual unsigned char getAddress(int address) __gc[];

		virtual __event EventHandler* Disconnect;
		virtual __event EventHandler* Reconnect;



	};
}
