#include "StdAfx.h"
#include "Splash.h"

// A static method to create the thread and 
// launch the SplashScreen.
void bre20::Splash::ShowSplashScreen()
{
    // Make sure it is only launched once.
	if( m_spl != NULL )
		return;

	m_thread = new Thread( new ThreadStart(NULL,&Splash::ShowForm));
	m_thread->IsBackground = true;
	m_thread->ApartmentState = ApartmentState::STA;
	m_thread->Start();
}

void bre20::Splash::timer_Tick(Object * myObject, EventArgs * myEventArgs)
{
	String* str = "Loading";
	for(int i = 0; i< numDots; i++)
		str = String::Concat(str,".");
	if(numDots == 3)
		numDots = 1;
	else
		numDots++;
	loading->Text = str;
}

// A property returning the splash screen instance
bre20::Splash * bre20::Splash::GetSplashForm()
{
	return m_spl;
}

// A private entry point for the thread.
void bre20::Splash::ShowForm()
{
    m_spl = new Splash();
	splTimer = new System::Windows::Forms::Timer();
	splTimer->Interval = 200;
	splTimer->Tick += new System::EventHandler(m_spl, &Splash::timer_Tick);
	splTimer->Start();
	Application::Run(m_spl);
}

// A static method to close the SplashScreen
void bre20::Splash::CloseForm()
{
	splTimer->Stop();
    if( m_spl != NULL && !m_spl->IsDisposed)
		m_spl->Close();
	m_thread->Abort();
    m_thread = NULL;  // we do not need these any more.
    m_spl = NULL;
}
