#include "stdafx.h"
#include "EuroPw0.h"

RomRep::EuroPw0::EuroPw0(): VT0Ecu(){}

RomRep::EuroPw0::EuroPw0(int* rom, int flen): VT0Ecu(rom, flen, 0x3928, 0x3930, 0x3AEC, 4,0x3BE6, 0x3CE5,0x3DE4, 0x3EF2, "Euro PW0",15)
{
	checksumaddy = 0x36A0;
	checksumlen = 0x8000;
}
RomRep::EuroPw0::EuroPw0(int* rom, int flen,int revlim,int restrt,int vitek,int numvt,int igtbl1,int igtbl2,int fueltbl1,int fueltbl2,string tname,int xtbl): 
	VT0Ecu(rom, flen, revlim, restrt, vitek, numvt,igtbl1, igtbl2,fueltbl1, fueltbl2, tname,xtbl)
{
	checksumaddy = 0x36A0;
	checksumlen = 0x8000;
}
/*
(rom, flen, 0x3928, 0x3930, 0x3AEC, 4,0x3BE6, 0x3CE5,0x3DE4, 0x3EF2, "Euro PW0",15)
(int* rom, int flen,int revlim,int restrt,int vitek,int numvt,int igtbl1,int igtbl2,int fueltbl1,int fueltbl2,string tname,int xtbl)
euro pw0:
1F21 	 1 	 Checksum Bypass 	 C9=Perform checksum CB=Bypass 
3928 	 1 	 Warm/high cam revlimit 	 uses the OBD08 Bit Rev formula.
392A 	1 	Low cam revlimit 	uses the OBD08 Bit Rev formula.
3930 	1 	High cam restart 	uses the OBD08 Bit Rev formula.
3AEC 	1 	VTEC disengage 	uses the OBD0 VTEC formula.
3AED 	1 	VTEC engage 	uses the OBD0 VTEC formula.
3AEE 	1 	VTEC disengage 	I am guessing that 3AEC is the one the ECU uses based on my JDM PW0 findings.
3AEF 	1 	VTEC engage 	I am guessing that 3AED is the one the ECU uses.
3BE6 	255 	Ignition map 1 	uses the OBD0 Ignition formula.
3CE5 	255 	Ignition map VTEC 	the first row is not used so its really a 15x16 map at 3CF4. But the extra row works good as filler.
3DE4 	255 	Fuel map 1 	uses the OBD0 Fuel formula.
3EE3 	15 	Fuel multipliers 1 	fuel Column Multipliers for fuel map 1.
3EF2 	255 	Fuel map VTEC 	uses the OBD0 Fuel formula.
3FF1 	15 	Fuel multipliers 2 	fuel Column Multipliers for fuel map 2.
*/

bool RomRep::EuroPw0::validate(int* h)
{

	int head[10] = {0x73,0x16,0x9A,0x16,0x96,0x16,0x8F,0x00,0x1F,0x15};

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			return false;
		}

	return true;
}

void RomRep::EuroPw0::disableChecksum(bool disable)
{
	aDisableChecksum(0x1F21,disable);
}
void RomRep::EuroPw0::disableOxygenSensors(bool disable)
{
	aDisableOxygenSensors(0x2DFE,disable);
}
void RomRep::EuroPw0::disable2ndOxygenSensor(bool disable)
{
	aDisable2ndOxygenSensor(0x2dc6,disable);
}
int RomRep::EuroPw0::isChecksumDisabled()
{
	return aisChecksumDisabled(0x1F21);
}
int RomRep::EuroPw0::isOxygenSensorsDisabled()
{
	return aisOxygenSensorsDisabled(0x2DFE);
}
int RomRep::EuroPw0::is2ndOxygenSensorDisabled()
{
	return ais2ndOxygenSensorDisabled(0x2dc6);
}

//********new stuff


void RomRep::EuroPw0::setLaunchRpm(int val)
{
	asetLaunchRpm(0x324D, val);
}

void RomRep::EuroPw0::setLaunchSpeed(int val)
{
	asetLaunchSpeed(0x324D, val);
}
void RomRep::EuroPw0::enableLaunch(bool enable)
{
	int loc = 0xB66;
	if(enable)
	{
		setByte(loc, 0x32);
		setByte(loc+1, 0x4D);
		setByte(loc+2, 0x32);

		loc = 0x324D;
		setByte(loc, 0xC5);
		setByte(loc+1, 0xCB);
		setByte(loc+2, 0xC0);
		setByte(loc+3, 0x0A);
		setByte(loc+4, 0xC8);
		setByte(loc+5, 0x0B);
		setByte(loc+6, 0x67);
		setByte(loc+7, 0x02);
		setByte(loc+8, 0x02);
		setByte(loc+9, 0xC5);
		setByte(loc+10, 0xFE);
		setByte(loc+11, 0x2F);
		setByte(loc+12, 0xC8);
		setByte(loc+13, 0x03);
		setByte(loc+14, 0x86);
		setByte(loc+15, 0x01);
		setByte(loc+16, 0x00);
		setByte(loc+17, 0xC5);
		setByte(loc+18, 0x24);
		setByte(loc+19, 0x2C);
		setByte(loc+20, 0x01);
	}
	else
	{
		setByte(loc, 0xC5);
		setByte(loc+1, 0x24);
		setByte(loc+2, 0x2C);

		for(int i = 0x324D; i<0x3262; i++)
			setByte(i, 0xFF);
	}
/*
//launch
 C64:	C5	32
 C65:	24	FB
 C66:	2C	32
;
32FB:	FF	C5
32FC:	FF	CB
32FD:	FF	C0
32FE:	FF	0A
32FF:	FF	C8
3300:	FF	0B
3301:	FF	67
3302:	FF	02
3303:	FF	02
3304:	FF	C5
3305:	FF	FE
3306:	FF	2F
3307:	FF	C8
3308:	FF	03
3309:	FF	86
330A:	FF	01
330B:	FF	00
330C:	FF	C5
330D:	FF	24
330E:	FF	2C
330F:	FF	01
*/
}

void RomRep::EuroPw0::disableSpeedLimiter(bool disable) 
{
	int loc = 0xB44;
	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0xB4E;
		setByte(loc, 2);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xcf);
		setByte(loc+1, 3);

		loc = 0xB4E;
		setByte(loc, 0xf1);
		setByte(loc+1, 3);
	}
}

void RomRep::EuroPw0::disableVssCheck(bool disable) 
{
	int loc = 0xA3C;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xDB);
		setByte(loc+1, 0x29);
		setByte(loc+2, 0x06);
	}
}

void RomRep::EuroPw0::disableTempCheck(bool disable) 
{
	int loc = 0xA3A;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCD);
		setByte(loc+1, 0x09);
	}
}

void RomRep::EuroPw0::disablePsCheck(bool disable) 
{
	int loc = 0x7C7;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		
		loc = 0xA34;
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCA);
		setByte(loc+1, 0x13);
		
		loc = 0xA34;
		setByte(loc, 0xCA);
		setByte(loc+1, 0x0f);
	}
}

void RomRep::EuroPw0::disableCelCheck(bool disable)
{
	int loc = 0xA26;
	adisableCelCheck(loc, disable);

}

int RomRep::EuroPw0::isKnockSensorDisabled()
{
	return -1;
}
void RomRep::EuroPw0::disableKnockSensor(bool disable)
{
}

void RomRep::EuroPw0::disableCodes(bool disable)
{
	aDisableCodes(0x2ed6,disable);
}
int RomRep::EuroPw0::isCodesDisabled()
{
	return aisCodesDisabled(0x2ed6);
}

int RomRep::EuroPw0::isSpeedLimiterDisabled()
{
	return aisSpeedLimiterDisabled(0xB44);
}
int RomRep::EuroPw0::isVssCheckDisabled()
{
	return aisVssCheckDisabled(0xA3C);
}
int RomRep::EuroPw0::isTempCheckDisabled()
{
	return aisTempCheckDisabled(0xA3A);
}
int RomRep::EuroPw0::isCelCheckDisabled()
{
	return aisCelCheckDisabled(0xA26);
}
int RomRep::EuroPw0::isPsCheckDisabled()
{
	return aisPsCheckDisabled(0x7C7);
}
int RomRep::EuroPw0::isLaunchDisabled()
{
	return aisLaunchDisabled(0x324D);
}

int RomRep::EuroPw0::getLaunchRpm()
{
	return agetLaunchRpm(0x324D);
}
int RomRep::EuroPw0::getLaunchSpeed()
{
	return agetLaunchSpeed(0x324D);
}

//********************************************************
/*
EURO PW0:
|    CODE      |  loc  |    dis     |      en   |
mechanical map	0x20aa	00 00 00	C4 2C 3B
VSS
VTS
VTEC press
IAT		0x21c3	00 00 00	C4 2C 3F
ECT
IACV
ELD
*/
int RomRep::EuroPw0::isCodeBitDisable(int code)
{
    if(code == 5 || code == 10)
		return 1;
	else
		return 0;
}
int RomRep::EuroPw0::codeBitDisable(int code, bool disable)
{
	
	int vec[3];
	int loc;
	if(!disable)
	{
		switch(code)
		{
			case 5:
				loc = 0x20aa;
				vec[0] = 0xc4;
				vec[1] = 0x2c;
				vec[2] = 0x3b;
				break;
			case 10:
				loc = 0x21c3;
				vec[0] = 0xc4;
				vec[1] = 0x2c;
				vec[2] = 0x3f;
				break;
			default:
				return 0;
		}
	}
	else
	{
		vec[0] = vec[1] = vec[2] = 0;
		switch(code)
		{
			case 5:
				loc = 0x20aa;
				break;
			case 10:
				loc = 0x21c3;
				break;
			default:
				return 0;
		}

	}

	setArray(vec,loc,3);
	return 1;

}
int RomRep::EuroPw0::isCodeBitDisabled(int code)
{

	int id;
	int loc;

	switch(code)
	{
		case 5:
			loc = 0x20aa;
			id = 0xc4;
			break;
		case 10:
			loc = 0x21c3;
			id = 0xc4;
			break;
		default:
			return -1; //bit code doesnt exist
	}

	if(thefile[loc] == id)
		return 0;
	else
		return 1;
}