#include "stdafx.h"
#include "EuroPw0Boost.h"

RomRep::EuroPw0Boost::EuroPw0Boost(): EuroPw0(){}

RomRep::EuroPw0Boost::EuroPw0Boost(int* rom, int flen): EuroPw0(rom, flen, 0x3928, 0x3930, 0x3AEC, 4,0x6600, 0x6984,0x6D08, 0x70aa, "Euro PW0 turbo",21)
{

	colheaders[0][14] = "1.3 psi";
	colheaders[0][15] = "3.1 psi";
	colheaders[0][16] = "4.6 psi";
	colheaders[0][17] = "6.1 psi";
	colheaders[0][18] = "7.7 psi";
	colheaders[0][19] = "9.2 psi";
	colheaders[0][20] = "10.7";

    colheaders[1][14] = "1.3 psi";
	colheaders[1][15] = "3.1 psi";
	colheaders[1][16] = "4.6 psi";
	colheaders[1][17] = "6.1 psi";
	colheaders[1][18] = "7.7 psi";
	colheaders[1][19] = "9.2 psi";
	colheaders[1][20] = "10.7";
}

bool RomRep::EuroPw0Boost::validate(int* h)
{
	bool good = true;
	int head[10] = {0x73,0x16,0x9A,0x16,0x96,0x16,0x8F,0x00,0x1F,0x15};

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			good = false;
		}

	int boost[4] = {0x15,0x11,0x65,0x01};

	for(int i = 0; i<4; i++)
		if(boost[i] != h[0x7ffc + i])
			good = false;

	return good;
}