#pragma unmanaged

#if !defined BENS_FUELMAP_H
#define BENS_FUELMAP_H

#include "map.h"

//all maps that are fuel are derived from this...
namespace RomRep
{
	class FuelMap : public Map
	{

	public:
		
		FuelMap(int crap = 0);
		FuelMap(int x, int y, unsigned int loc, unsigned int multloc);
		FuelMap(int x, int y, unsigned int loc, unsigned int multloc, int* mltarray);
		FuelMap(int x, int y, unsigned int loc, unsigned int multloc, int* mltarray,int* fil);

		virtual ~FuelMap();

		virtual void setMultiplierLocation(unsigned int loc){multloc = loc;};
		virtual unsigned int getMultiplierLocation(unsigned int loc){return multloc;};

		virtual void insertColumn(int column); //column inserted AFTER 'column'

		//children MUST have these
		virtual void populate(int ** map, int * mltarray) = 0;
		virtual void getMultipliers(int x, double* mlts) = 0;
		virtual const int* getIntMultipliers() = 0;
		virtual double calculate(int x, int y, int intval) = 0;
		virtual int calculate(int x, int y, double mapval) = 0;

		virtual void setMultiplier(int column, int val);
		virtual int getMultiplierLocation(int column);

	protected:

		int* mult;
		unsigned int multloc;
	};
}
#endif