#include "HondaEcu.h"
#include "stdafx.h"


RomRep::HondaEcu::HondaEcu(string typ)
{
	//default: 1 fuel map, 1 ign map, no vtec, obd0, type unknown
	fuelmaps = new FuelMap*[1];
	fuelmaps[0] = NULL;
	ignmaps = new Map*[1];
	ignmaps[0] = NULL;

    type = typ;
	obd = 0;
	vtec = false;
	nummaps = 1;

	

//	setupHeaders();
    
}

RomRep::HondaEcu::HondaEcu(int* rom, int len, int obdd, bool vtech, int nummap, string typ)
{
	int i;
	fuelmaps = new FuelMap*[nummap];
	ignmaps = new Map*[nummap];

	flen = len;

	for(i = 0; i < nummap; i++)
	{	
		fuelmaps[i] = NULL;
		ignmaps[i] = NULL;
	}

	//shallow copy because the function giving it wont do
	//anything with it, and would have to delete it (the original)
	//sooooooooo we just steal the original
	thefile = rom;

    type = typ;
	obd = obdd;
	vtec = vtech;
	nummaps = nummap;

	colheaders = NULL;//colheaders[x][y] <-- x is which map, y is col#
	rowheaders = NULL;//rowheaders[x][y] <-- x is map#, y is row#

	target_afr_loc = new int[nummap];

//	setupHeaders(); //must do this in all dreived constructors
}

RomRep::HondaEcu::~HondaEcu()
{
	int i;
	for(i = 0; i<nummaps; i++)
	{
		delete fuelmaps[i];
		delete ignmaps[i];
	}

	delete[] fuelmaps;
	delete[] ignmaps;
	delete[] thefile;

	delete[] target_afr_loc;
}

int RomRep::HondaEcu::headlen = 10;


const char* RomRep::HondaEcu::getRowHeader(int map, int index)
{
	return rowheaders[map][index].c_str();
}
const char* RomRep::HondaEcu::getColHeader(int map, int index)
{
	return colheaders[map][index].c_str();
}

int** RomRep::HondaEcu::get2DArray(int* array, int loc, int x, int y)
{
	int i,j;
	int** map;

	map = new int*[x];
	for(i = 0; i<x; i++)
		map[i] = new int[y];

	int k = loc;

    for(i=0;i<y;i++)
        for(j=0;j<x;j++,k++)
            map[j][i] = array[k];

	return map;
}

int* RomRep::HondaEcu::getArray(int* array, int loc, int len)
{
	int i, j;
	int* map = new int[len];

	j = loc;

	for(i = 0; i<len; i++)
		map[i] = array[loc+i];

	return map;
}

void RomRep::HondaEcu::setArray(int* array, int loc, int len)
{
	for(int i = 0; i<len; i++)
	{
		setByte(loc+i,array[i]);
	}

}


void RomRep::HondaEcu::setByte(int loc, int val)
{
	if(val >=0 && val < 256)
	{
		//add undo shit here...
		//push a ByteHistory onto a stack (ByteChange array with a len)
		thefile[loc] = val;
	}
}
RomRep::ByteChange* RomRep::HondaEcu::setByteEx(int loc, int val)
{
	if(val >=0 && val < 256)
	{
		//add undo shit here...
		//push a ByteHistory onto a stack (ByteChange array with a len)
		thefile[loc] = val;

		return new ByteChange(loc,(char)val);
	}
	else
		return NULL;
}

RomRep::FuelMap* RomRep::HondaEcu::getFuelMap(int index)
{
	if(index>=0 && index<nummaps)
		return fuelmaps[index];
	else 
		return NULL;
}

RomRep::Map* RomRep::HondaEcu::getIgnitionMap(int index)
{
	if(index>=0 && index<nummaps)
		return ignmaps[index];
	else 
		return NULL;
}

double** RomRep::HondaEcu::getLambdaMap(int index)
{
	return NULL;
}

//both of these need to fix the column headers too...
void RomRep::HondaEcu::insertColumn(int column)
{
	for(int i = 0; i<nummaps; i++)
	{
		fuelmaps[i]->insertColumn(column);
		ignmaps[i]->insertColumn(column);
		
	}

	x++;
}
void RomRep::HondaEcu::insertRow(int row)
{
	for(int i = 0; i<nummaps; i++)
	{
		fuelmaps[i]->insertRow(row);
		ignmaps[i]->insertRow(row);
		
	}

	y++;
}

//sets the value in fuel map 'index' at cell (x,y)
void RomRep::HondaEcu::setFuelCell(int x, int y, double val, int index)
{
	if(index>=0 && index<nummaps)
	{
//		fuelmaps[index]->setVal(x,y,val);
		setByte((*fuelmaps[index]).getCellLocation(x,y), (*fuelmaps[index]).calculate(x,y,val));
		(*fuelmaps[index]).setVal(x,y,val);
	}
}
//sets the value in fuel map 'index' at cell (x,y)
RomRep::ByteChange* RomRep::HondaEcu::setFuelCellEx(int x, int y, double val, int index)
{
	if(index>=0 && index<nummaps)
	{
//		fuelmaps[index]->setVal(x,y,val);
		ByteChange* bc = setByteEx((*fuelmaps[index]).getCellLocation(x,y), (*fuelmaps[index]).calculate(x,y,val));
		
		(*fuelmaps[index]).setVal(x,y,val);

		return bc;
	}
	else
		return NULL;
}

void RomRep::HondaEcu::setIgnitionCell(int xx, int yy, double val, int index)
{
	if(index>=0 && index<nummaps)
	{
		setByte((*ignmaps[index]).getCellLocation(xx,yy), (*ignmaps[index]).calculate(xx,yy,val));
		(*ignmaps[index]).setVal(xx,yy,val);
	}
}
RomRep::ByteChange* RomRep::HondaEcu::setIgnitionCellEx(int xx, int yy, double val, int index)
{
	if(index>=0 && index<nummaps)
	{
		ByteChange* bc = setByteEx((*ignmaps[index]).getCellLocation(xx,yy), (*ignmaps[index]).calculate(xx,yy,val));
		
		(*ignmaps[index]).setVal(xx,yy,val);

		return bc;
	}
	else
		return NULL;
}

void RomRep::HondaEcu::setAfrCell(int xx, int yy, int val, int index)
{
	if(index>=0 && index<nummaps)
	{
		setByte(Map::getCellLocation(xx,yy,x,this->target_afr_loc[index]), val);
	}
}
RomRep::ByteChange* RomRep::HondaEcu::setAfrCellEx(int xx, int yy, int val, int index)
{
	if(index>=0 && index<nummaps)
	{
		ByteChange* bc = setByteEx(Map::getCellLocation(xx,yy,x,this->target_afr_loc[index]), val);

		return bc;
	}
	else
		return NULL;
}

void RomRep::HondaEcu::setMultiplier(int mapnum, int column, int val)
{

	if(column>=0 && column<=x)
	{
		setByteEx((*fuelmaps[mapnum]).getMultiplierLocation(column),val);
		(*fuelmaps[mapnum]).setMultiplier(column, val);
	}
}

RomRep::ByteChange* RomRep::HondaEcu::setMultiplierEx(int mapnum, int column, int val)
{

	if(column>=0 && column<=x)
	{
		ByteChange* bc = setByteEx((*fuelmaps[mapnum]).getMultiplierLocation(column),val);
		(*fuelmaps[mapnum]).setMultiplier(column, val);

		return bc;
	}
	else
		return NULL;
}

int RomRep::HondaEcu::Checksum()
{
	int i;
	int j;
 	long ad = 0;
 
 	for (i = 0;i< checksumlen; i++)//checksumlen
 	{
 		ad += thefile[i];
 	}
 	j = ad % 256;
 
 	return j;
}

int RomRep::HondaEcu::setChecksum()
{
	int cs;// = this->Checksum();
//	if (cs != 0)
//	{ 
 		thefile[checksumaddy]=0;
		cs = this->Checksum();
		thefile[checksumaddy] = (256 - cs);
 //	checksumlen
	
	return this->Checksum();
}