#pragma unmanaged

#if !defined BENS_HONDAECU_H
#define BENS_HONDAECU_H

#define MODEFUEL 0
#define MODEIGN 1

#include "map.h"
#include "FuelMap.h"
namespace RomRep
{
	class HondaEcu
	{
	protected:
		int* thefile; //muy importante!!
		int flen; //file length
		int x,y;

		FuelMap** fuelmaps;
		Map** ignmaps;
		
	//	int head[10]; //no. these are in the validate function of each ecu class

		int * target_afr_loc;

		string type;
		int obd, nummaps; //nummaps will be a 1 if there is 1 ignition and 1 fuel map 
		bool vtec;
		int checksumaddy;
		int checksumlen;
		//have some byte edit stuff here for undo

		//the column and row header strings
		//x = nummaps;
		//x == 0 is the nonvtec maps, x == 1 is the vtec maps
		string** colheaders;//colheaders[x][y] <-- x is which map, y is col#
		string** rowheaders;//rowheaders[x][y] <-- x is map#, y is row#

		void setArray(int* array, int loc, int len);

		virtual void setupHeaders() = 0;//called in this class' constructor
		virtual int Checksum();

	public:
		HondaEcu(string type = "Unknown");

		//Child classes will deal with setting up the maps in their constructor
		//because we dont know what type of maps must be set up.
		HondaEcu(int* rom, int length, int obd, bool vtec, int nummaps, string type);

		virtual ~HondaEcu();

		virtual void setByte(int loc, int val);
		virtual ByteChange* setByteEx(int loc, int val);
		virtual int getByte(int loc)
		{return thefile[loc];};

		virtual int setChecksum();
		
		virtual int getWidth(){	return x;};
		virtual int getHeight(){return y;};
		virtual int getNumMaps(){return nummaps;};

		virtual FuelMap* getFuelMap(int index);
		virtual Map* getIgnitionMap(int index);
		virtual double** getLambdaMap(int index);

		virtual void insertColumn(int column);
		virtual void insertRow(int row);

		virtual ByteChange* setFuelCellEx(int x, int y, double val, int index);
		virtual void setFuelCell(int x, int y, double val, int index);
	//	virtual void setFuelCell(int x, int y, int val);

		virtual ByteChange* setIgnitionCellEx(int x, int y, double val, int index);
		virtual void setIgnitionCell(int x, int y, double val, int index);
	//	virtual void setIgnitionCell(int x, int y, int val);

		virtual ByteChange* setAfrCellEx(int x, int y, double val, int index) = 0;
		virtual ByteChange* setAfrCellEx(int x, int y, int val, int index);
		virtual void setAfrCell(int x, int y, int val, int index);

		virtual ByteChange* setMultiplierEx(int mapnum, int column, int val);
		virtual void setMultiplier(int mapnum, int column, int val);

		//map == 0 for non vtec
		virtual const char* getRowHeader(int map, int index);
		virtual const char* getColHeader(int map, int index);

		virtual int getChecksumAddy(){return checksumaddy;}
		virtual int getChecksumLen(){return checksumlen;}

		//gets arrays from thefile. 
		//loc is the location of the first byte in the array
		int** get2DArray(int* array, int loc, int x, int y);
		int* getArray(int* array, int loc, int len);

		//returns value in the rpm scalar
		virtual int getRpmScalarValue(int row, bool fuel, bool vtec){return -1;}; 

		virtual const char* getType()
		{return type.c_str();}

		virtual int* getFile()
		{
			return getArray(thefile,0,flen);
		}

		virtual int getLength()
		{
			return flen;
		}

		static int headlen;


		//afr maps
		int getAfrMapLoc(int index)
		{ 
			if(index<nummaps)
				return target_afr_loc[index];
			else return -1;
		};
	};
}

#endif