#include "stdafx.h"
#include "JdmPr3.h"

RomRep::JdmPr3::JdmPr3(): VT0Ecu(){}

RomRep::JdmPr3::JdmPr3(int* rom, int flen): VT0Ecu(rom, flen, 0x31DE, 0x41DD, 0x3414, 8,0x3BE6, 0x3CE5,0x3DE4, 0x3EF2, "JDM PR3-58",15)
{
	checksumaddy = 0x4600;
	checksumlen = 0x8000;
}

RomRep::JdmPr3::JdmPr3(int* rom, int flen,int revlim,int restrt,int vitek,int numvt,int igtbl1,int igtbl2,int fueltbl1,int fueltbl2,string tname,int xtbl): 
	VT0Ecu(rom, flen, revlim, restrt, vitek, numvt,igtbl1, igtbl2,fueltbl1, fueltbl2, tname,xtbl)
{
	checksumaddy = 0x4600;
	checksumlen = 0x8000;
}
//	Jdm pr3...
//	revaddy = 0x31DE;
//	idleaddy = 0x32F6;
//	revrestartaddy = 41dd ;
//	low cam warm rev limit = 0x31E0;
//	vtecaddy = 0x3414; start of vtec vals

bool RomRep::JdmPr3::validate(int* h)
{

	int head[10] = {0x73,0x16,0x96,0x16,0x92,0x16,0x8F,0x00,0x03,0x16};

	bool good = true;

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			good = false;
		}

	if(good)
		return true;

	int noohead[10] = {0x09,0x16,0x2B,0x16,0x27,0x16,0x8F,0x00,0x99,0x15};
	
	good = true;
	for(int i = 0; i<HondaEcu::headlen; i++)
		if(noohead[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			good = false;
		}
	
	return good;
}

void RomRep::JdmPr3::disableChecksum(bool disable)
{
	aDisableChecksum(0x4019,disable);
}
void RomRep::JdmPr3::disableOxygenSensors(bool disable)
{
	aDisableOxygenSensors(0x2E0B,disable);
}
void RomRep::JdmPr3::disable2ndOxygenSensor(bool disable)
{
	aDisable2ndOxygenSensor(0x2dd3,disable);
}
int RomRep::JdmPr3::isChecksumDisabled()
{
	return aisChecksumDisabled(0x4019);
}
int RomRep::JdmPr3::isOxygenSensorsDisabled()
{
	return aisOxygenSensorsDisabled(0x2E0B);
}
int RomRep::JdmPr3::is2ndOxygenSensorDisabled()
{
	return ais2ndOxygenSensorDisabled(0x2dd3);
}

//*************new

void RomRep::JdmPr3::setLaunchRpm(int val)
{
	asetLaunchRpm(0x4266, val);
}

void RomRep::JdmPr3::setLaunchSpeed(int val)
{
	asetLaunchSpeed(0x4266, val);
}
void RomRep::JdmPr3::enableLaunch(bool enable)
{
	int loc = 0xD22;
	if(enable)
	{
		setByte(loc, 0x32);
		setByte(loc+1, 0x66);
		setByte(loc+2, 0x42);

		loc = 0x4266;
		setByte(loc, 0xC5);
		setByte(loc+1, 0xCB);
		setByte(loc+2, 0xC0);
		setByte(loc+3, 0x0A);
		setByte(loc+4, 0xC8);
		setByte(loc+5, 0x0B);
		setByte(loc+6, 0x67);
		setByte(loc+7, 0x02);
		setByte(loc+8, 0x02);
		setByte(loc+9, 0xC5);
		setByte(loc+10, 0xF2);
		setByte(loc+11, 0x2F);
		setByte(loc+12, 0xC8);
		setByte(loc+13, 0x03);
		setByte(loc+14, 0x86);
		setByte(loc+15, 0x01);
		setByte(loc+16, 0x00);
		setByte(loc+17, 0xC5);
		setByte(loc+18, 0x24);
		setByte(loc+19, 0x2C);
		setByte(loc+20, 0x01);
	}
	else
	{
		setByte(loc, 0xC5);
		setByte(loc+1, 0x24);
		setByte(loc+2, 0x2C);

		for(int i = 0x4266; i<0x427B; i++)
			setByte(i, 0xFF);
	}
}

void RomRep::JdmPr3::disableSpeedLimiter(bool disable) 
{
	int loc = 0x41C4;
	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0x41CE;
		setByte(loc, 2);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xcf);
		setByte(loc+1, 3);

		loc = 0x41CE;
		setByte(loc, 0xe0);
		setByte(loc+1, 3);
	}
}

void RomRep::JdmPr3::disableVssCheck(bool disable) 
{
	int loc = 0xB7F;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xDB);
		setByte(loc+1, 0x29);
		setByte(loc+2, 0x0E);
	}
}

void RomRep::JdmPr3::disableTempCheck(bool disable) 
{
	int loc = 0xB7D;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCD);
		setByte(loc+1, 0x11);
	}
}
//****************************************************
int RomRep::JdmPr3::isCodeBitDisable(int code)
{
    if(code == 5 || code == 17 || code == 21 || code == 22 || code == 10 || code == 6 || code == 14)
		return 1;
	else
		return 0;
}
int RomRep::JdmPr3::codeBitDisable(int code, bool disable)
{
	
	int vec[3];
	int loc;
	if(!disable)
	{
		switch(code)
		{
			/*
JDM PR3:
|    CODE      |  loc  |    dis     |      en   |
mechanical map	0x2082	00 00 00	C4 2C 3B
VSS				0x20b2	00 00 00	C4 2D 3A
VTS				0x20d6	00 00 00	C4 2D 3E
VTEC press		0x20ef	00 00 00	C4 2D 3F
IAT				0x2132	00 00 00	C4 2C 3F
ECT				0x21ff	00 00 00	C4 2C 39
IACV			0x2818	00 00 00	C4 2D 38
ELD				not available in the jdm pr3
*/
			case 5:
				loc = 0x2082;
				vec[0] = 0xc4;
				vec[1] = 0x2c;
				vec[2] = 0x3b;
				break;
			case 17:
				loc = 0x20b2;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x3a;
				break;
			case 21:
				loc = 0x20d6;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x3e;
				break;
			case 22:
				loc = 0x20ef;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x3f;
				break;
			case 10:
				loc = 0x2132;
				vec[0] = 0xc4;
				vec[1] = 0x2c;
				vec[2] = 0x3f;
				break;
			case 6:
				loc = 0x21ff;
				vec[0] = 0xc4;
				vec[1] = 0x2c;
				vec[2] = 0x39;
				break;
			case 14:
				loc = 0x2818;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x38;
				break;
			default:
				return 0;
		}
	}
	else
	{
		vec[0] = vec[1] = vec[2] = 0;
		switch(code)
		{
			case 5:
				loc = 0x2082;
				break;
			case 17:
				loc = 0x20b2;
				break;
			case 21:
				loc = 0x20d6;
				break;
			case 22:
				loc = 0x20ef;
				break;
			case 10:
				loc = 0x2132;
				break;
			case 6:
				loc = 0x21ff;
				break;
			case 14:
				loc = 0x2818;
				break;
			default:
				return 0;
		}

	}

	setArray(vec,loc,3);
	return 1;

}
int RomRep::JdmPr3::isCodeBitDisabled(int code)
{

	int id = 0xc4;
	int loc;

	switch(code)
	{
		case 5:
			loc = 0x2082;
			break;
		case 17:
			loc = 0x20b2;
			break;
		case 21:
			loc = 0x20d6;
			break;
		case 22:
			loc = 0x20ef;
			break;
		case 10:
			loc = 0x2132;
			break;
		case 6:
			loc = 0x21ff;
			break;
		case 14:
			loc = 0x2818;
			break;
		default:
			return -1; //bit code doesnt exist
	}

	if(thefile[loc] == id)
		return 0;
	else
		return 1;
}
//****************************************************************
void RomRep::JdmPr3::disablePsCheck(bool disable) 
{
	int loc = 0x808;

//	VTEC press		0x20ef	00 00 00	C4 2D 3F

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		
		loc = 0xB77;
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0x20ef;
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);

	}
	else
	{
		setByte(loc, 0xCA);
		setByte(loc+1, 0x13);
		
		loc = 0xB77;
		setByte(loc, 0xCA);
		setByte(loc+1, 0x17);
		
		loc = 0x20ef;
		setByte(loc, 0xc4);
		setByte(loc+1, 0x2d);
		setByte(loc+2, 0x3f);
	}
}

void RomRep::JdmPr3::disableCelCheck(bool disable)
{
	int loc = 0xB69;
	adisableCelCheck(loc, disable);

}

int RomRep::JdmPr3::isKnockSensorDisabled()
{
	return aisKnockSensorDisabled(0x82a);
}
void RomRep::JdmPr3::disableKnockSensor(bool disable)
{
	adisableKnockSensor(0x82a,0xa0e,0x409a,disable);
}
void RomRep::JdmPr3::disableCodes(bool disable)
{
	aDisableCodes(0x2ec0,disable);
}
int RomRep::JdmPr3::isCodesDisabled()
{
	return aisCodesDisabled(0x2ec0);
}

int RomRep::JdmPr3::isSpeedLimiterDisabled()
{
	return aisSpeedLimiterDisabled(0x41c4);
}
int RomRep::JdmPr3::isVssCheckDisabled()
{
	return aisVssCheckDisabled(0xb7f);
}
int RomRep::JdmPr3::isTempCheckDisabled()
{
	return aisTempCheckDisabled(0xb7d);
}
int RomRep::JdmPr3::isCelCheckDisabled()
{
	return aisCelCheckDisabled(0xb69);
}
int RomRep::JdmPr3::isPsCheckDisabled()
{
	return aisPsCheckDisabled(0x808);
}
int RomRep::JdmPr3::isLaunchDisabled()
{
	return aisLaunchDisabled(0x4266);
}

int RomRep::JdmPr3::getLaunchRpm()
{
	return agetLaunchRpm(0x4266);
}
int RomRep::JdmPr3::getLaunchSpeed()
{
	return agetLaunchSpeed(0x4266);
}