#include "JdmPr3ITB.h"
#include "stdafx.h"

RomRep::JdmPr3ITB::JdmPr3ITB(): JdmPr3(){}

RomRep::JdmPr3ITB::JdmPr3ITB(int* rom, int flen): JdmPr3(rom, flen)
{
	scalarloc = 0x4290;
	xoverloc = 0x427e;
	type = "PR3 ITB ROM";
	setupHeaders();
}

string RomRep::JdmPr3ITB::toStr(int per)
{

	string s = "%";
	

//	if(per>99)
//		return "100%";

	int fig = per%10;
	s.insert(s.begin(),fig+48);

	per/=10;
	fig = per%10;
	s.insert(s.begin(),fig+48);

	return s;
}

//this is called after the initial header setup
void RomRep::JdmPr3ITB::setupHeaders()
{
	int mapcolumns[14] = {0xb,0x20,0x28,0x30,0x38,0x40,0x48,0x50,0x58,0x60,0x68,0x70,0x80,0x90}; 

	int* scalars = getArray(thefile,scalarloc+4,30);
	int xover = thefile[xoverloc];

	for(int i = 0; i<14 && xover>=mapcolumns[i]; i++);
	int index = i-1; //the column where the ecu starts using the tps;

	colheaders[0][0] = colheaders[1][0] = "26 In";
	colheaders[0][1] = colheaders[1][1] = "24";
	colheaders[0][2] = colheaders[1][2] = "22";
	colheaders[0][3] = colheaders[1][3] = "21"; 
	colheaders[0][4] = colheaders[1][4] = "19";
	colheaders[0][5] = colheaders[1][5] = "18";
	colheaders[0][6] = colheaders[1][6] = "16";
	colheaders[0][7] = colheaders[1][7] = "14";
	colheaders[0][8] = colheaders[1][8] = "13";
	colheaders[0][9] = colheaders[1][9] = "11";
	colheaders[0][10] = colheaders[1][10] = "9";
	colheaders[0][11] = colheaders[1][11] = "8";
	colheaders[0][12] = colheaders[1][12] = "4";
	colheaders[0][13] = colheaders[1][13] = "1";
	colheaders[0][14] = colheaders[1][14] = "100%";
//10 - 30 5% jumps
//						   100%  13   95%  13   90%  12   85%  11   80%  10
//	DB           0ffh,0dfh,0e5h,0dfh,0dah,0d0h,0cfh,0c0h,0c3h,0b0h,0b8h,0a0h
//				  70%  9    60%  8    50%  7    40%  6    30%  5    25%  4
//	DB           0a1h,090h,08ah,080h,073h,070h,05ch,060h,045h,050h,039h,040h
//				  20%  3    15%  2    10%  1
//	DB			 02eh,030h,022h,020h,017h,010h,0h,0h,0h,0h

	for(int i = 13; i>=index; i--)
	{
		int per = ((scalars[(13-i)*2]+1)*100)/230;
		string str = JdmPr3ITB::toStr(per);

		colheaders[0][i] = str;
		colheaders[1][i] = str;
	}

	delete[] scalars;
	
}

bool RomRep::JdmPr3ITB::validate(int* h)
{

	int head[10] = {0x73,0x16,0x96,0x16,0x92,0x16,0x8F,0x00,0x03,0x16};

	bool good = true;

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			good = false;
		}

	int itbtest[6] = {0x60,0x90,0x42,0x10,0xCB,0x25};
	int loc = 0x4e6;
	for(int i = 0; i<6; i++)
		if(itbtest[i] != h[loc+i])
			good = false;

	return good;
}