#include "stdafx.h"
#include "JdmPw0.h"

RomRep::JdmPw0::JdmPw0(): VT0Ecu(){}

RomRep::JdmPw0::JdmPw0(int* rom, int flen): VT0Ecu(rom, flen, 0x391A, 0x3922, 0x3AD8, 4,0x3BE6, 0x3CE5,0x3DE4, 0x3EF2, "JDM PW0", 15)
{
	checksumaddy = 0x36A0;
	checksumlen = 0x8000;
//	VT0Ecu(rom, flen, 0x31DE, 0x31E0, 0x3414, 8, "OBD0 PR3") //jdm pr3
}
RomRep::JdmPw0::JdmPw0(int* rom, int flen,int revlim,int restrt,int vitek,int numvt,int igtbl1,int igtbl2,int fueltbl1,int fueltbl2,string tname,int xtbl): 
	VT0Ecu(rom, flen, revlim, restrt, vitek, numvt,igtbl1, igtbl2,fueltbl1, fueltbl2, tname,xtbl)
{
	checksumaddy = 0x36A0;
	checksumlen = 0x8000;
//	VT0Ecu(rom, flen, 0x31DE, 0x31E0, 0x3414, 8, "OBD0 PR3") //jdm pr3
}
//	Jdm pr3...
//	revaddy = 0x31DE;
//	idleaddy = 0x32F6;
//	revrestartaddy = 0x31E0;
//	vtecaddy = 0x3414; start of vtec vals

bool RomRep::JdmPw0::validate(int* h)
{
//	int head[10] = {0x3A,0x19,0x61,0x19,0x5D,0x19,0x8F,0,0xCA,0x18}; //pr3

	int head[10] = {0xD8,0x16,0xFF,0x16,0xFB,0x16,0x8F,0,0x84,0x15}; //pw0

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			return false;
		}

	return true;
}

//ostream& operator<<(ostream& out, JdmPw0& pw0)
//{
//	out << ((VT0Ecu)pw0);
//
//	return out;
//}

void RomRep::JdmPw0::disableChecksum(bool disable)
{
	aDisableChecksum(0x20B2,disable);
}
void RomRep::JdmPw0::disableOxygenSensors(bool disable)
{
	aDisableOxygenSensors(0x2F72,disable);
}
void RomRep::JdmPw0::disable2ndOxygenSensor(bool disable)
{
	aDisable2ndOxygenSensor(0x2f3a,disable);
}
int RomRep::JdmPw0::isChecksumDisabled()
{
	return aisChecksumDisabled(0x20B2);
}
int RomRep::JdmPw0::isOxygenSensorsDisabled()
{
	int d = aisOxygenSensorsDisabled(0x2F72);
	return d;
}
int RomRep::JdmPw0::is2ndOxygenSensorDisabled()
{
	return ais2ndOxygenSensorDisabled(0x2f3a);
}

void RomRep::JdmPw0::setLaunchRpm(int val)
{
	asetLaunchRpm(0x32FB, val);
}

void RomRep::JdmPw0::setLaunchSpeed(int val)
{
	asetLaunchSpeed(0x32FB, val);
}
void RomRep::JdmPw0::enableLaunch(bool enable)
{
	int loc = 0xC64;
	if(enable)
	{
		setByte(loc, 0x32);
		setByte(loc+1, 0xFB);
		setByte(loc+2, 0x32);

		loc = 0x32FB;
		setByte(loc, 0xC5);
		setByte(loc+1, 0xCB);
		setByte(loc+2, 0xC0);
		setByte(loc+3, 0x0A);
		setByte(loc+4, 0xC8);
		setByte(loc+5, 0x0B);
		setByte(loc+6, 0x67);
		setByte(loc+7, 0x31);
		setByte(loc+8, 0x02);
		setByte(loc+9, 0xC5);
		setByte(loc+10, 0xFE);
		setByte(loc+11, 0x2F);
		setByte(loc+12, 0xC8);
		setByte(loc+13, 0x03);
		setByte(loc+14, 0x86);
		setByte(loc+15, 0x01);
		setByte(loc+16, 0x00);
		setByte(loc+17, 0xC5);
		setByte(loc+18, 0x24);
		setByte(loc+19, 0x2C);
		setByte(loc+20, 0x01);
	}
	else
	{
		setByte(loc, 0xC5);
		setByte(loc+1, 0x24);
		setByte(loc+2, 0x2C);

		for(int i = 0x32FB; i<0x3310; i++)
			setByte(i, 0xFF);
	}
/*
//launch
 C64:	C5	32
 C65:	24	FB
 C66:	2C	32
;
32FB:	FF	C5
32FC:	FF	CB
32FD:	FF	C0
32FE:	FF	0A
32FF:	FF	C8
3300:	FF	0B
3301:	FF	67
3302:	FF	02
3303:	FF	02
3304:	FF	C5
3305:	FF	FE
3306:	FF	2F
3307:	FF	C8
3308:	FF	03
3309:	FF	86
330A:	FF	01
330B:	FF	00
330C:	FF	C5
330D:	FF	24
330E:	FF	2C
330F:	FF	01
*/
}

void RomRep::JdmPw0::disableSpeedLimiter(bool disable) 
{
	int loc = 0xc42;
	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0xc4c;
		setByte(loc, 2);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xcf);
		setByte(loc+1, 3);

		loc = 0xc4c;
		setByte(loc, 0xf1);
		setByte(loc+1, 3);
	}
}

void RomRep::JdmPw0::disableVssCheck(bool disable) 
{
	int loc = 0xB4C;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xDB);
		setByte(loc+1, 0x29);
		setByte(loc+2, 0x06);
	}
}

void RomRep::JdmPw0::disableTempCheck(bool disable) 
{
	int loc = 0xB4A;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCD);
		setByte(loc+1, 0x09);
	}
}

//JDM PW0:
/*
|    CODE      |  loc  |    dis     |      en   |
mechanical map	0x223b	00 00 00	C4 2C 3B
VSS				0x225b  00 00 00	C4 2D 3A
VTS				0x2288  00 00 00	C4 2D 3E
VTEC press		0x22a1  00 00 00	C4 2D 3F
IAT				0x22db  00 00 00	C4 2C 3F
ECT				0x22cb	00 00 00	C4 2C 39
IACV			0x2a13  00 00 00	C4 2D 38
ELD				0x1a69	00 00 00	C4 2D 3B
*/

//****************************************************
int RomRep::JdmPw0::isCodeBitDisable(int code)
{
    if(code == 5 || code == 17 || code == 21 || code == 22 || code == 10  || code == 14 || code == 20)
		return 1;
	else
		return 0;
}
int RomRep::JdmPw0::codeBitDisable(int code, bool disable)
{
	
	int vec[3];
	int loc;
	if(!disable)
	{
		switch(code)
		{

			case 5:
				loc = 0x223b;
				vec[0] = 0xc4;
				vec[1] = 0x2c;
				vec[2] = 0x3b;
				break;
			case 17:
				loc = 0x225b;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x3a;
				break;
			case 21:
				loc = 0x2288;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x3e;
				break;
			case 22:
				loc = 0x22a1;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x3f;
				break;
			case 10:
				loc = 0x22db;
				vec[0] = 0xc4;
				vec[1] = 0x2c;
				vec[2] = 0x3f;
				break;
//			case 6:
//				loc = 0x22cb;
//				vec[0] = 0xc4;
//				vec[1] = 0x2c;
//				vec[2] = 0x39;
//				break;
			case 14:
				loc = 0x2a13;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x38;
				break;
			case 20:
				loc = 0x1a69;
				vec[0] = 0xc4;
				vec[1] = 0x2d;
				vec[2] = 0x3b;
				break;
			default:
				return 0;
		}
	}
	else
	{
		vec[0] = vec[1] = vec[2] = 0;
		switch(code)
		{
			case 5:
				loc = 0x223b;
				break;
			case 17:
				loc = 0x225b;
				break;
			case 21:
				loc = 0x2288;
				break;
			case 22:
				loc = 0x22a1;
				break;
			case 10:
				loc = 0x22db;
				break;
//			case 6:
//				loc = 0x22cb;
//				break;
			case 14:
				loc = 0x2a13;
				break;
			case 20:
				loc = 0x1a69;
			default:
				return 0;
		}

	}

	setArray(vec,loc,3);
	return 1;

}
int RomRep::JdmPw0::isCodeBitDisabled(int code)
{

	int id = 0xc4;
	int loc;

	switch(code)
	{
		case 5:
			loc = 0x223b;
			break;
		case 17:
			loc = 0x225b;
			break;
		case 21:
			loc = 0x2288;
			break;
		case 22:
			loc = 0x22a1;
			break;
		case 10:
			loc = 0x22db;
			break;
//		case 6:
//			loc = 0x22cb;
//			break;
		case 14:
			loc = 0x2a13;
			break;
		case 20:
			loc = 0x1a69;
		default:
			return -1; //bit code doesnt exist
	}

	if(thefile[loc] == id)
		return 0;
	else
		return 1;
}
//****************************************************************

void RomRep::JdmPw0::disablePsCheck(bool disable) 
{
	int loc = 0x7D3;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		
		loc = 0xB44;
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0x22a1;
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xCA);
		setByte(loc+1, 0x13);
		
		loc = 0xB44;
		setByte(loc, 0xCA);
		setByte(loc+1, 0x0f);

		loc = 0x22a1;
		setByte(loc, 0xc4);
		setByte(loc+1, 0x2d);
		setByte(loc+2, 0x3f);
	}
}

void RomRep::JdmPw0::disableCelCheck(bool disable)
{
	int loc = 0xB36;
	adisableCelCheck(loc, disable);

}
int RomRep::JdmPw0::isKnockSensorDisabled()
{
	return aisKnockSensorDisabled(0x7f5);
}
void RomRep::JdmPw0::disableKnockSensor(bool disable)
{
	adisableKnockSensor(0x7f5,0xa21,0x10a6,disable);
}

void RomRep::JdmPw0::disableCodes(bool disable)
{
	aDisableCodes(0x304a,disable);
}
int RomRep::JdmPw0::isCodesDisabled()
{
	return aisCodesDisabled(0x304a);
}

int RomRep::JdmPw0::isSpeedLimiterDisabled()
{
	return aisSpeedLimiterDisabled(0xc42);
}
int RomRep::JdmPw0::isVssCheckDisabled()
{
	return aisVssCheckDisabled(0xb4c);
}
int RomRep::JdmPw0::isTempCheckDisabled()
{
	return aisTempCheckDisabled(0xb4a);
}
int RomRep::JdmPw0::isCelCheckDisabled()
{
	return aisCelCheckDisabled(0xb36);
}
int RomRep::JdmPw0::isPsCheckDisabled()
{
	return aisPsCheckDisabled(0x7D3);
}
int RomRep::JdmPw0::isLaunchDisabled()
{
	return aisLaunchDisabled(0x32fb);
}

int RomRep::JdmPw0::getLaunchRpm()
{
	return agetLaunchRpm(0x32FB);
}
int RomRep::JdmPw0::getLaunchSpeed()
{
	return agetLaunchSpeed(0x32FB);
}