#include "stdafx.h"
#include "JdmPw0Boost.h"

RomRep::JdmPw0Boost::JdmPw0Boost(): VT0Ecu(){}

RomRep::JdmPw0Boost::JdmPw0Boost(int* rom, int flen): VT0Ecu(rom, flen, 0x391A, 0x3922, 0x3AD8, 4,0x3BE6, 0x3D4B,0x3EB0, 0x402A, "JDM PW0 turbo",21)
{
	checksumaddy = 0x36A0;
	checksumlen = 0x8000;

	colheaders[0][14] = "1.3 psi";
	colheaders[0][15] = "3.1 psi";
	colheaders[0][16] = "4.6 psi";
	colheaders[0][17] = "6.1 psi";
	colheaders[0][18] = "7.7 psi";
	colheaders[0][19] = "9.2 psi";
	colheaders[0][20] = "10.7";

    colheaders[1][14] = "1.3 psi";
	colheaders[1][15] = "3.1 psi";
	colheaders[1][16] = "4.6 psi";
	colheaders[1][17] = "6.1 psi";
	colheaders[1][18] = "7.7 psi";
	colheaders[1][19] = "9.2 psi";
	colheaders[1][20] = "10.7";
}
//	Jdm pr3...
//	revaddy = 0x31DE;
//	idleaddy = 0x32F6;
//	revrestartaddy = 0x31E0;
//	vtecaddy = 0x3414; start of vtec vals

bool RomRep::JdmPw0Boost::validate(int* h)
{
//	int head[10] = {0x3A,0x19,0x61,0x19,0x5D,0x19,0x8F,0,0xCA,0x18}; //pr3

	int head[10] = {0xFC,0x16,0x23,0x17,0x1F,0x17,0x8F,0x00,0xA8,0x15}; //pw0

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			return false;
		}

	return true;
}

//ostream& operator<<(ostream& out, JdmPw0Boost& pw0)
//{
//	out << ((VT0Ecu)pw0);
//
//	return out;
//}

void RomRep::JdmPw0Boost::disableChecksum(bool disable)
{
	aDisableChecksum(0x20B2,disable);
}
void RomRep::JdmPw0Boost::disableOxygenSensors(bool disable)
{
	aDisableOxygenSensors(0x2F72,disable);
}
int RomRep::JdmPw0Boost::isChecksumDisabled()
{
	return aisChecksumDisabled(0x20B2);
}
int RomRep::JdmPw0Boost::isOxygenSensorsDisabled()
{
	int d = aisOxygenSensorsDisabled(0x2F72);
	return d;
}

void RomRep::JdmPw0Boost::setLaunchRpm(int val)
{
	asetLaunchRpm(0x32FB, val);
}

void RomRep::JdmPw0Boost::setLaunchSpeed(int val)
{
	asetLaunchSpeed(0x32FB, val);
}
void RomRep::JdmPw0Boost::enableLaunch(bool enable)
{
	int loc = 0xC64;
	if(enable)
	{
		setByte(loc, 0x32);
		setByte(loc+1, 0xFB);
		setByte(loc+2, 0x32);

		loc = 0x32FB;
		setByte(loc, 0xC5);
		setByte(loc+1, 0xCB);
		setByte(loc+2, 0xC0);
		setByte(loc+3, 0x0A);
		setByte(loc+4, 0xC8);
		setByte(loc+5, 0x0B);
		setByte(loc+6, 0x67);
		setByte(loc+7, 0x31);
		setByte(loc+8, 0x02);
		setByte(loc+9, 0xC5);
		setByte(loc+10, 0xFE);
		setByte(loc+11, 0x2F);
		setByte(loc+12, 0xC8);
		setByte(loc+13, 0x03);
		setByte(loc+14, 0x86);
		setByte(loc+15, 0x01);
		setByte(loc+16, 0x00);
		setByte(loc+17, 0xC5);
		setByte(loc+18, 0x24);
		setByte(loc+19, 0x2C);
		setByte(loc+20, 0x01);
	}
	else
	{
		setByte(loc, 0xC5);
		setByte(loc+1, 0x24);
		setByte(loc+2, 0x2C);

		for(int i = 0x32FB; i<0x3310; i++)
			setByte(i, 0xFF);
	}
/*
//launch
 C64:	C5	32
 C65:	24	FB
 C66:	2C	32
;
32FB:	FF	C5
32FC:	FF	CB
32FD:	FF	C0
32FE:	FF	0A
32FF:	FF	C8
3300:	FF	0B
3301:	FF	67
3302:	FF	02
3303:	FF	02
3304:	FF	C5
3305:	FF	FE
3306:	FF	2F
3307:	FF	C8
3308:	FF	03
3309:	FF	86
330A:	FF	01
330B:	FF	00
330C:	FF	C5
330D:	FF	24
330E:	FF	2C
330F:	FF	01
*/
}

void RomRep::JdmPw0Boost::disableSpeedLimiter(bool disable) 
{
	int loc = 0xc42;
	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0xc4c;
		setByte(loc, 2);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xcf);
		setByte(loc+1, 3);

		loc = 0xc4c;
		setByte(loc, 0xf1);
		setByte(loc+1, 3);
	}
}

void RomRep::JdmPw0Boost::disableVssCheck(bool disable) 
{
	int loc = 0xB4C;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xDB);
		setByte(loc+1, 0x29);
		setByte(loc+2, 0x06);
	}
}

void RomRep::JdmPw0Boost::disableTempCheck(bool disable) 
{
	int loc = 0xB4A;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCD);
		setByte(loc+1, 0x09);
	}
}

void RomRep::JdmPw0Boost::disablePsCheck(bool disable) 
{
}

int RomRep::JdmPw0Boost::isKnockSensorDisabled()
{
	return -1;
}
void RomRep::JdmPw0Boost::disableKnockSensor(bool disable)
{
}

void RomRep::JdmPw0Boost::disableCelCheck(bool disable)
{
	int loc = 0xB36;
	adisableCelCheck(loc, disable);

}

int RomRep::JdmPw0Boost::isSpeedLimiterDisabled()
{
	return aisSpeedLimiterDisabled(0xc42);
}
int RomRep::JdmPw0Boost::isVssCheckDisabled()
{
	return aisVssCheckDisabled(0xb4c);
}
int RomRep::JdmPw0Boost::isTempCheckDisabled()
{
	return aisTempCheckDisabled(0xb4a);
}
int RomRep::JdmPw0Boost::isCelCheckDisabled()
{
	return aisCelCheckDisabled(0xb36);
}
int RomRep::JdmPw0Boost::isPsCheckDisabled()
{
	return aisPsCheckDisabled(0x0); //not finished
}
int RomRep::JdmPw0Boost::isLaunchDisabled()
{
	return aisLaunchDisabled(0x32fb);
}

int RomRep::JdmPw0Boost::getLaunchRpm()
{
	return agetLaunchRpm(0x32FB);
}
int RomRep::JdmPw0Boost::getLaunchSpeed()
{
	return agetLaunchSpeed(0x32FB);
}