#include "stdafx.h"
#include "Obd0NonVtecEcu.h"

RomRep::Obd0Ecu::Obd0Ecu():HondaEcu("OBD0 Non-VTEC"), revlimit(), revrestart()
{
	revconst = 1920000;
	x = 15;
	y = 17;
	//setupHeaders();
}

//the file, location, location, location of first one, number of vtec values.
RomRep::Obd0Ecu::Obd0Ecu(int* rom, int flen, int revloc, int restartloc, int fuelmaploc, int fuelmltloc, int ignmaplocation, int fuelmaploc1, int fuelmltloc1, int ignmaploc1, int nummaps, string type):HondaEcu(rom, flen, 0, false, nummaps, type), revlimit(), revrestart()
{

	x = 15;
	y = 17;
	fmaploc = fuelmaploc;
	fmltloc = fuelmltloc;
	igmaploc = ignmaplocation;

	fmaploc1 = fuelmaploc1;
	fmltloc1 = fuelmltloc1;
	igmaploc1 = ignmaploc1;



	revconst = 1920000;

	revlimit = new RpmTwoByteValue(revloc, rom[revloc], revloc+2, rom[revloc+2]);
	revrestart = new RpmTwoByteValue(restartloc, rom[restartloc+2],restartloc, rom[restartloc+2]);

	setupMaps();
	setupHeaders();

}

RomRep::Obd0Ecu::~Obd0Ecu()
{
//	delete[] vtec;
	delete[] rowheaders[0];
	delete[] rowheaders[1];
	delete[] colheaders[0];
	delete[] colheaders[1];

	delete[] rowheaders;
	delete[] colheaders;

	delete revlimit;
	delete revrestart;
}

void RomRep::Obd0Ecu::setupMaps()
{
	int i;
	int** map;
	int* mlt;
	//nummaps = 1;



	//go get the maps from the rom and put the arrays into the map constructors...
	map = HondaEcu::get2DArray(thefile, fmaploc, x,y);
	mlt = HondaEcu::getArray(thefile, fmltloc, x);
	
	fuelmaps[0] = new Obd0FuelMap(x, y, fmaploc, map, fmltloc, mlt,thefile);

//--------------
//****************************MUST delete cause the map constructors dont do 
//****************************shallow copies.
	//delete map and mlt
	for(i = 0; i<x; i++)//i<x
		delete[] map[i];
	delete[] map;
	delete[] mlt;

//for boost pm6...
	if(nummaps>1)
	{
		//go get the maps from the rom and put the arrays into the map constructors...
		map = HondaEcu::get2DArray(thefile, fmaploc1, x,y);
		mlt = HondaEcu::getArray(thefile, fmltloc1, x);
		
		fuelmaps[1] = new Obd0FuelMap(x, y, fmaploc1, map, fmltloc1, mlt,thefile);

	//--------------
	//****************************MUST delete cause the map constructors dont do 
	//****************************shallow copies.
		//delete map and mlt
		for(i = 0; i<x; i++)//i<x
			delete[] map[i];
		delete[] map;
		delete[] mlt;
	}
///

	map = HondaEcu::get2DArray(thefile, igmaploc, x,y);

	ignmaps[0] = new Obd0IgnMap(x,y,igmaploc,map,thefile);
//--------------

	//delete map
	for(i = 0; i<x; i++)//i<x
		delete[] map[i];
	delete[] map;

	//for boost pm6
	if(nummaps>1)
	{
		map = HondaEcu::get2DArray(thefile, igmaploc1, x,y);

		ignmaps[1] = new Obd0IgnMap(x,y,igmaploc1,map,thefile);
	//--------------

		//delete map
		for(i = 0; i<x; i++)//i<x
			delete[] map[i];
		delete[] map;
	}
	///
}

void RomRep::Obd0Ecu::setupHeaders()
{
	colheaders = new string*[2];
	rowheaders = new string*[2];

	colheaders[0] = new string[x];
	colheaders[1] = new string[x];
	colheaders[0][0] = "26 In";
	colheaders[0][1] = "24";
	colheaders[0][2] = "22";
	colheaders[0][3] = "21"; 
	colheaders[0][4] = "19";
	colheaders[0][5] = "18";
	colheaders[0][6] = "16";
	colheaders[0][7] = "14";
	colheaders[0][8] = "13";
	colheaders[0][9] = "11";
	colheaders[0][10] = "9";
	colheaders[0][11] = "8";
	colheaders[0][12] = "4";
	colheaders[0][13] = "1";
	colheaders[0][14] = "1.3psi";

	colheaders[1][0] = "26 In";
	colheaders[1][1] = "24";
	colheaders[1][2] = "22";
	colheaders[1][3] = "21"; 
	colheaders[1][4] = "19";
	colheaders[1][5] = "18";
	colheaders[1][6] = "16";
	colheaders[1][7] = "14";
	colheaders[1][8] = "13";
	colheaders[1][9] = "11";
	colheaders[1][10] = "9";
	colheaders[1][11] = "8";
	colheaders[1][12] = "4";
	colheaders[1][13] = "1";
	colheaders[1][14] = "1.3psi";

	rowheaders[0] = new string[y];
	rowheaders[1] = new string[y];
	rowheaders[0][0] = rowheaders[1][0] = "500";
	rowheaders[0][1] = rowheaders[1][1] = "600";
	rowheaders[0][2] = rowheaders[1][2] = "700";
	rowheaders[0][3] = rowheaders[1][3] = "800";
	rowheaders[0][4] = rowheaders[1][4] = "900";
	rowheaders[0][5] = rowheaders[1][5] = "1100";
	rowheaders[0][6] = rowheaders[1][6] = "1300";
	rowheaders[0][7] = rowheaders[1][7] = "1600";
	rowheaders[0][8] = rowheaders[1][8] = "1900";
	rowheaders[0][9] = rowheaders[1][9] = "2200";
	rowheaders[0][10] = rowheaders[1][10] = "2600";
	rowheaders[0][11] = rowheaders[1][11] = "3100";
	rowheaders[0][12] = rowheaders[1][12] = "3700";
	rowheaders[0][13] = rowheaders[1][13] = "4400";
	rowheaders[0][14] = rowheaders[1][14] = "5300";
	rowheaders[0][15] = rowheaders[1][15] = "6300";
	rowheaders[0][16] = rowheaders[1][16] = "7400";	
}

//*********USE HondaEcu::setByte! it will set the byte in the rom
//setByte eventually will contain the undo stuff


void RomRep::Obd0Ecu::setRevlimit(int val)
{
	setRpmValue(revlimit, val);
//	revlimit.setByte(bite);
//	if(revlimit.getLocation() != 0)
//		RomRep::HondaEcu::setByte(revlimit.getLocation(), bite);

}

void RomRep::Obd0Ecu::setRevRestart(int val)
{
	setRpmValue(revrestart, val);
}

int RomRep::Obd0Ecu::getRevlimit()
{
	return getRpmValue(revlimit);
}

int RomRep::Obd0Ecu::getRevRestart()
{
	return getRpmValue(revrestart);
}
void RomRep::Obd0Ecu::setRpmValue(RomRep::RpmTwoByteValue* limit, int rpm)
{
	int bytes;
	if(rpm>0)
		bytes = revconst/rpm;
	else
		return;

	limit->setByte1(getHighByte(bytes));
	limit->setByte2(getLowByte(bytes));
	if(limit->getLocation1() != 0)
	{
		RomRep::HondaEcu::setByte(limit->getLocation1(), getHighByte(bytes));
		RomRep::HondaEcu::setByte(limit->getLocation2(), getLowByte(bytes));
	}
}

int RomRep::Obd0Ecu::getRpmValue(RomRep::RpmTwoByteValue* limit)
{
	int bytes = limit->getTwoByte();

	if(bytes >0)
		return revconst/bytes;
	else
		return -1;
}