#include "stdafx.h"

#include "Obd0VTECFuelMap.h"

RomRep::VT0FuelMap::VT0FuelMap(int crap):FuelMap(crap){}

RomRep::VT0FuelMap::VT0FuelMap(int x1, int y1):FuelMap(x1,y1,0,0){}

//must call populate(int ** map, int * multipliers) sometime after constructor call
RomRep::VT0FuelMap::VT0FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1):FuelMap(x1,y1,loc,multloc1){}

//must call populate(int **map) sometime after EVC call
RomRep::VT0FuelMap::VT0FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, int* mltarray):FuelMap(x1,y1,loc,multloc1,mltarray){}

RomRep::VT0FuelMap::VT0FuelMap(int x1, int y1,unsigned int loc, int** themap, unsigned int multloc1, int* mltarray,int* fil):FuelMap(x1,y1,loc,multloc1, mltarray,fil)
{
	populate(themap);
}

RomRep::VT0FuelMap::~VT0FuelMap(){}

//---------------------------------------------------

void RomRep::VT0FuelMap::populate(int **mapp)
{
	int i, j;

	for(i = 0; i<x; i++)
		for(j = 0; j<y; j++)
			map[i][j] = mapp[i][j];
}

void RomRep::VT0FuelMap::populate(int **mapp, int *mltarray)
{
	int i, j;

	for(i = 0; i<x; i++)
		mult[i] = mltarray[i];

	for(i = 0; i<x; i++)
		for(j = 0; j<y; j++)
			map[i][j] = i, j, mapp[i][j];
}

void RomRep::VT0FuelMap::setVal(int x1, int y1, int val)
{
//	double mapval;
//
//	mapval = calculate(x1, y1, val);
//
//	map[x1][y1] = mapval; //sets a double into the internal map
}

void RomRep::VT0FuelMap::getMultipliers(int x1, double* mlts)
{

	if(mult[x1] != 0)
	{
		mlts[0] = 208.0 / (pow(2.0,mult[x1]) - 1.0);
		mlts[1] = 224.0 / (pow(2.0,mult[x1]) - 1.0);
	}
	else
	{
		mlts[0] = 208.0;
		mlts[1] = 224.0;
	}

}

double RomRep::VT0FuelMap::calculate(int x1, int y1, int intval)
{
	double* mults = new double[2];
	double temp;

	getMultipliers(x1, mults);

	temp = (intval + mults[1]) / mults[0];

	delete[] mults;

	return temp;

}

int RomRep::VT0FuelMap::calculate(int x1, int y1, double mapval)
{
	double* mults = new double[2];
	int temp;

	getMultipliers(x1, mults);

	temp = (int)((mapval * mults[0]) - mults[1]);

	delete[] mults;

	return temp;
}


//----------------------------------non-member functions---
/*
ostream& operator<<(ostream& out, VT0FuelMap& fm)
{
	int i,j;

	for(j = 0; j<fm.getY(); j++)
	{
		for(i = 0; i<fm.getX(); i++)
			out<<fm.getVal(i,j)<< " ";

		out<<endl;
	}
	out<< endl;

	return out;
}
*/