#include "stdafx.h"
#include "Obd0VtecEcu.h"

RomRep::VT0Ecu::VT0Ecu():HondaEcu("OBD0 VTEC"), revlimit(), revrestart()
{
	revconst = 1848000;
	numvtec = 1;
	vtec = new RpmByteValue[numvtec];
	x = 15;
	y = 17;
	celvecloc = 0x7f00;

	target_afr_loc[0] = 0x7250;
	target_afr_loc[1] = 0x75dc;
	//setupHeaders();
}

//the file, location, location, location of first one, number of vtec values.
RomRep::VT0Ecu::VT0Ecu(int* rom, int flen, int revloc, int restartloc, int vtecloc, int vtecnum, int ignmapad1, int ignmapad2, int fuelmapad1, int fuelmapad2, string type,int width):HondaEcu(rom, flen, 0, true, 2, type), revlimit(), revrestart()
{
	int i;

	x = width;
	y = 17;

	target_afr_loc[0] = 0x7250;
	target_afr_loc[1] = 0x75dc;

	revconst = 1852000;
	numvtec = vtecnum;

	revlimit.setBoth(revloc, rom[revloc]);
	revrestart.setBoth(restartloc, rom[restartloc]);
	vtec = new RpmByteValue[vtecnum];

	for(i = 0; i<vtecnum; i++)
		vtec[i].setBoth(vtecloc+i, rom[vtecloc+i]);

	int ima[2];
	int fma[2];

	ima[0] = ignmapad1;
	ima[1] = ignmapad2;
	fma[0] = fuelmapad1;
	fma[1] = fuelmapad2;
	setupMaps(ima, fma);

	celvecloc = 0x7f00;

	revscalar_ig = 0x3ba6;
	revscalar_igv = 0x3bb6;
	revscalar_fu = 0x3bc6;
	revscalar_fuv = 0x3bd6;

	//need an idle array too
	idlescalar_loc = 0;	

	setupHeaders();

}

RomRep::VT0Ecu::~VT0Ecu()
{
	delete[] vtec;
	delete[] rowheaders[0];
	delete[] rowheaders[1];
	delete[] colheaders[0];
	delete[] colheaders[1];

	delete[] rowheaders;
	delete[] colheaders;
}

void RomRep::VT0Ecu::setupMaps(int* ignmapad, int* fuelmapad)
{
	int i;
	int** map;
	int* mlt;
	nummaps = 2;

	//go get the maps from the rom and put the arrays into the map constructors...
	map = HondaEcu::get2DArray(thefile, fuelmapad[0], x,y);//0x3DE4
	mlt = HondaEcu::getArray(thefile, fuelmapad[0]+(x*y), x);//0x3ee3
	
	fuelmaps[0] = new Obd0FuelMap(x, y, fuelmapad[0], map, fuelmapad[0]+(x*y), mlt,thefile);
//	tst = fuelmaps[0];
//	cout<<*tst<<endl;
//--------------
//****************************MUST delete cause the map constructors dont do 
//****************************shallow copies.
	//delete map and mlt
	for(i = 0; i<x; i++)//i<x
		delete[] map[i];
	delete[] map;
	delete[] mlt;

	map = HondaEcu::get2DArray(thefile, fuelmapad[1], x,y);//3ef2
	mlt = HondaEcu::getArray(thefile, fuelmapad[1]+(x*y), x);//3ff1

	fuelmaps[1] = new Obd0FuelMap(x, y, fuelmapad[1], map, fuelmapad[1]+(x*y), mlt,thefile);
//--------------

	//delete map and mlt
	for(i = 0; i<x; i++)//i<x
		delete[] map[i];
	delete[] map;
	delete[] mlt;

	map = HondaEcu::get2DArray(thefile, ignmapad[0], x,y);//3be6

	ignmaps[0] = new Obd0IgnMap(x,y,ignmapad[0],map,thefile);
//--------------

	//delete map
	for(i = 0; i<x; i++)//i<x
		delete[] map[i];
	delete[] map;

	map = HondaEcu::get2DArray(thefile, ignmapad[1], x,y);//3ce5

	ignmaps[1] = new Obd0IgnMap(x,y,ignmapad[1], map,thefile);
//--------------

	//delete map
	for(i = 0; i<x; i++)//i<x
		delete[] map[i];
	delete[] map;

}

void RomRep::VT0Ecu::setupHeaders()
{
	colheaders = new string*[2];
	rowheaders = new string*[4];

	colheaders[0] = new string[x];
	colheaders[0][0] = "26 In";
	colheaders[0][1] = "24";
	colheaders[0][2] = "22";
	colheaders[0][3] = "21"; 
	colheaders[0][4] = "19";
	colheaders[0][5] = "18";
	colheaders[0][6] = "16";
	colheaders[0][7] = "14";
	colheaders[0][8] = "13";
	colheaders[0][9] = "11";
	colheaders[0][10] = "9";
	colheaders[0][11] = "8";
	colheaders[0][12] = "4";
	colheaders[0][13] = "1";
	colheaders[0][14] = "1.3psi";

	colheaders[1] = new string[x];
	colheaders[1][0] = "26 In";
	colheaders[1][1] = "24";
	colheaders[1][2] = "22";
	colheaders[1][3] = "21"; 
	colheaders[1][4] = "19";
	colheaders[1][5] = "18";
	colheaders[1][6] = "16";
	colheaders[1][7] = "14";
	colheaders[1][8] = "13";
	colheaders[1][9] = "11";
	colheaders[1][10] = "9";
	colheaders[1][11] = "8";
	colheaders[1][12] = "4";
	colheaders[1][13] = "1";
	colheaders[1][14] = "1.3psi";

	rowheaders[0] = new string[y];
	rowheaders[2] = new string[y];

	/*
	rowheaders[0][0] = rowheaders[2][0] = "452";
	rowheaders[0][1] = rowheaders[2][1] = "565";
	rowheaders[0][2] = rowheaders[2][2] = "678";
	rowheaders[0][3] = rowheaders[2][3] = "791";
	rowheaders[0][4] = rowheaders[2][4] = "904";
	rowheaders[0][5] = rowheaders[2][5] = "1130";
	rowheaders[0][6] = rowheaders[2][6] = "1356";
	rowheaders[0][7] = rowheaders[2][7] = "1582";
	rowheaders[0][8] = rowheaders[2][8] = "1808";
	rowheaders[0][9] = rowheaders[2][9] = "2260";
	rowheaders[0][10] = rowheaders[2][10] = "2712";
	rowheaders[0][11] = rowheaders[2][11] = "3165";
	rowheaders[0][12] = rowheaders[2][12] = "3617";
	rowheaders[0][13] = rowheaders[2][13] = "4521";
	rowheaders[0][14] = rowheaders[2][14] = "5425";
	rowheaders[0][15] = rowheaders[2][15] = "6330";
	rowheaders[0][16] = rowheaders[2][16] = "7177";
*/
	rowheaders[1] = new string[y];
	rowheaders[3] = new string[y];
/*
	rowheaders[1][0] = rowheaders[3][0] = "0";
	rowheaders[1][1] = rowheaders[3][1] = "556";
	rowheaders[1][2] = rowheaders[3][2] = "1112";
	rowheaders[1][3] = rowheaders[3][3] = "1669";
	rowheaders[1][4] = rowheaders[3][4] = "2225";
	rowheaders[1][5] = rowheaders[3][5] = "2784";
	rowheaders[1][6] = rowheaders[3][6] = "3342";
	rowheaders[1][7] = rowheaders[3][7] = "3898";
	rowheaders[1][8] = rowheaders[3][8] = "4451";
	rowheaders[1][9] = rowheaders[3][9] = "5018";
	rowheaders[1][10] = rowheaders[3][10] = "5578";
	rowheaders[1][11] = rowheaders[3][11] = "6132";
	rowheaders[1][12] = rowheaders[3][12] = "6685";
	rowheaders[1][13] = rowheaders[3][13] = "7234";
	rowheaders[1][14] = rowheaders[3][14] = "7814";
	rowheaders[1][15] = rowheaders[3][15] = "8380";
	rowheaders[1][16] = rowheaders[3][16] = "8903";
*/

	int sum1,sum2,sum3,sum4;
	sum1 = sum2 = sum3 = sum4 = 256;

	rowheaders[0][16] = calcNonVtecRow(sum1);	
	rowheaders[2][16] = calcNonVtecRow(sum2);
	rowheaders[1][16] = calcVtecRow(sum3);
	rowheaders[3][16] = calcVtecRow(sum4);

		//row headers...
	for(int i = y-2; i>=0; i--)
	{

		int sptr = revscalar_ig + (i);
		sum1 -= thefile[sptr];
				
		rowheaders[0][i] = calcNonVtecRow(sum1);

		sptr = revscalar_fu + (i);
		sum2 -= thefile[sptr];
				
		rowheaders[2][i] = calcNonVtecRow(sum2);

		//vtec headers
		sptr = revscalar_igv + (i);
		sum3 -= thefile[sptr];
			
		rowheaders[1][i] = calcVtecRow(sum3);

		sptr = revscalar_fuv + (i);
		sum4 -= thefile[sptr];
			
		rowheaders[3][i] = calcVtecRow(sum4);
	}//end row header for loop
    //                   100   100   100   100   200    200    300    300    300    400    500    500    700    900   1000    1100
//	rowheaders[0] = {"500","600","700","800","900","1100","1300","1600","1900","2200","2600","3100","3700","4400","5300","6300","7400"};
	//				   1000  1000   1000    500    500    500    500    200    300    200    300    500    500    500    500    900 
//	rowheaders[1] = {"0","1000","2000","3000","3500","4000","4500","5000","5200","5500","5700","6000","6500","7000","7500","8000","8900"};
	
}


//***UTILITIES
string RomRep::VT0Ecu::calcNonVtecRow(int sum)
{
	int er0, er3;

	if(sum >= 0xcf)
	{
		er0 = 0x8000;
		er3 = 0x80;
	}
	else if(sum >= 0x8f)
	{
		er0 = 0x10000;
		er3 = 0x40;
	}
	else if(sum >= 0x4f)
	{
		er0 = 0x20000;
		er3 = 0;
	}
	else
	{
		er0 = 0x40000;
		er3 = -64;
	}
					
	return Engine::toStr(((sum - er3)*1852000)/er0);
}

string RomRep::VT0Ecu::calcVtecRow(int sum)
{
	int rpm = 0;
	if(sum>0)
	{
		rpm = 0xd000/sum;
				
		rpm = revconst/rpm;
	}

	return Engine::toStr(rpm);
}

int RomRep::VT0Ecu::getRpmScalarValue(int row, bool fuel, bool vtec)
{
	int loc;
	if(fuel && vtec)
		loc = revscalar_fuv;
	else if(fuel && !vtec)
		loc = revscalar_fu;
	else if(!fuel && vtec)
		loc = revscalar_igv;
	else// if(!fuel && !vtec)
		loc = revscalar_ig;
	

	return thefile[loc+row];
}

//*********USE HondaEcu::setByte! it will set the byte in the rom
//setByte eventually will contain the undo stuff

void RomRep::VT0Ecu::setVtecEngage(int i, int val)
{
	//i == addition past normal location
	//loc = absolute loc

	//first vtec location 
	int loc = vtec[0].getLocation() + i;

//	int i = loc - loc1;
	int bite = (int)((double)val/56.56)+128;
	
	if(i>=0 && i<numvtec && bite<256 && bite>=0)
	{	
		vtec[i].setByte(bite);

		RomRep::HondaEcu::setByte(loc, bite);
	}
	else
	{}
//		cout<<"VTEC location out of bounds"<<endl;
}

void RomRep::VT0Ecu::setVtecDisengage(int loc, int val)
{
	setVtecEngage(loc,val);
}

void RomRep::VT0Ecu::setRevlimit(int val)
{
	int bite; 

	//val is in rpm
	//min revlimit == 7219rpm

	bite = revconst/val;

	if(revlimit.getLocation() != 0 && bite<256 && bite>=0)
	{
		revlimit.setByte(bite);
		RomRep::HondaEcu::setByte(revlimit.getLocation(), bite);
	}

}

void RomRep::VT0Ecu::setRevRestart(int val)
{
	int bite;

	//val is in rpm
	//min restart == 7219rpm

	bite = revconst/val;

	if(revrestart.getLocation() != 0 && bite<256 && bite>=0)
	{
		revrestart.setByte(bite);
		RomRep::HondaEcu::setByte(revrestart.getLocation(), bite);
	}
}

int RomRep::VT0Ecu::getVtecEngage(int loc)
{
	//return an RPM value

	//first vtec location 
	int loc1 = vtec[0].getLocation();

	//get index
	//int i = loc - loc1; //if you want to use the actual rom location
	int i = loc;
	int bite = -1;
	
	//convert the bite into an rpm val
	if(i>=0 && i<numvtec)
		bite = (int)((double)(vtec[i].getByte()-128)*56.56);
//	else
//		cout<<"VTEC location out of bounds (getVTEC...); "<< "loc = " << i <<endl;
	
	return bite; //will be -1 if theres an error
}

int RomRep::VT0Ecu::getVtecDisengage(int loc)
{
	return getVtecEngage(loc);
}

int RomRep::VT0Ecu::getRevlimit()
{
	if(revlimit.getByte() != 0)
		return revconst/revlimit.getByte();
	else
		return 0;
}

int RomRep::VT0Ecu::getRevRestart()
{
	if(revrestart.getByte() != 0)
		return revconst/revrestart.getByte();
	else
		return 0;
}


///************parameters
int  RomRep::VT0Ecu::aisCodesDisabled(int loca)  
{
	if(this->thefile[loca] == 0xc0)
		return 0;
	else
		return 1;

}
void  RomRep::VT0Ecu::aDisableCodes(int loca, bool disable)  
{
	if(disable)
	{
		int nums[30]= {0x62,0x00,0x7F,0x92,0xAA,0xC6,0x00,0xC9,0x09,0xC6,0xFF,0xC9,0x05,0x4E,0xC9,0x0C,0xCB,0xF1,0x79,0xC0,0x30,0x01,0x11,0xC0,0x7B,0x02,0x11,0x01,0x01,0xff};
		setArray(nums,0x5000,30);

		setByte(loca,0x03);
		setByte(loca+1,0x00);
		setByte(loca+2,0x50);
		setByte(loca+3,0x00);
		setByte(loca+4,0x00);
		setByte(loca+5,0x00);
		setByte(loca+6,0x00);
		setByte(loca+7,0x00);

		int vec[4] = {0x17,0x01,0x02,0x00};
		setArray(vec,celvecloc,4);
	}
	else
	{
		int nums[33];
		for(int i = 0; i<33; i++)
			nums[i] = 0xff;

		setByte(loca,0xc0);
		setByte(loca+1,0x30);
		setByte(loca+2,0x01);
		setByte(loca+3,0x11);
		setByte(loca+3,0xc0);
		setByte(loca+3,0x7b);
		setByte(loca+3,0x02);
		setByte(loca+3,0x11);

	}
}

//adds a cel disable the the disable vector
int RomRep::VT0Ecu::addCelDisable(int code)
{
	if(this->isCodesDisabled())
	{
		int loc = celvecloc;
		int i;

		for(i = 0; thefile[loc+i] != 0 && thefile[loc+i] != 0xff && thefile[loc+i] != code; i++);

		if(thefile[loc+i] == code)
			return -1;
		setByte(loc+i,code);
		setByte(loc+i+1,0);
		return 1;
	}
	else
	{
		return -1;
	}
}

int RomRep::VT0Ecu::removeCelDisable(int code) //return negative for fail, 1 for success
{

	if(this->isCodesDisabled())
	{
		int loc = celvecloc;
		int i,j;

		for(i = 0; thefile[loc+i] != code && thefile[loc+i] != 0 && thefile[loc+i] != 0xff; i++);

		 //i has the code
		if(thefile[loc+i] == 0 || thefile[loc+i] == 255)
			return -2; //cant find code

//		setByte(loc+i+1,0);

		for(j = i+1; thefile[loc+j] != 0 && thefile[loc+j] != 0xff; j++)
			setByte(loc+j-1,thefile[loc+j]);

		setByte(loc+j-1,0);
		return 1;
	}
	else
		return -1;
	

}
//*********************
void  RomRep::VT0Ecu::aDisableChecksum(int loca, bool disable)  
{
	if(disable)
		setByte(loca,0xCB);
	else
		setByte(loca,0xC9);
}
void  RomRep::VT0Ecu::aDisableOxygenSensors(int loca, bool disable)  
{
	if(disable)
	{
		setByte(loca,0xCB);//disable the sensors
		setByte(loca+1,0x1D);
	}
	else
	{
		setByte(loca,0xCA);
		setByte(loca+1,0x0D);
	}
}

void  RomRep::VT0Ecu::aDisable2ndOxygenSensor(int loca, bool disable)  
{
	if(disable)
	{
		setByte(loca,0x65);//disable the sensor
	}
	else
	{
		setByte(loca,0x67);
	}
}
int RomRep::VT0Ecu::aisChecksumDisabled(int loca)
{
	int tmp = thefile[loca];
	return (tmp == 0xCB && true);// == 0xCB;
}
int RomRep::VT0Ecu::aisOxygenSensorsDisabled(int loca)
{
	int tmp1, tmp2;
	tmp1 = thefile[loca];
	tmp2 = thefile[loca+1];
	if(tmp1 == 0xCB && tmp2 == 0x1D)
		return 1;
	else
		return 0;
}

int RomRep::VT0Ecu::ais2ndOxygenSensorDisabled(int loca)
{
	if(thefile[loca] == 0x67)
		return 0;
	else
		return 1;
}

//******for launch stuff loc is the location of the 
//beginning of the launch code
void RomRep::VT0Ecu::asetLaunchRpm(int loc, int val)
{
	int hbyte, lbyte;
	if(thefile[loc] != 0xC5)
		return;
	int word = revconst/val;
	hbyte = word/256;
	lbyte = word%256;

	setByte(loc+8, hbyte);
	setByte(loc+7, lbyte);
}

void RomRep::VT0Ecu::asetLaunchSpeed(int loc, int val)
{
	int lbyte;
	if(thefile[loc] != 0xC5)
		return;
	
	lbyte = (int)((double)val*1.609)%256;

	setByte(loc+3, lbyte);
}
int RomRep::VT0Ecu::agetLaunchRpm(int loc)
{
	int lrpm = thefile[loc+7] + (thefile[loc+8]*256);
	lrpm = revconst/lrpm;

	return lrpm;
}
int RomRep::VT0Ecu::agetLaunchSpeed(int loc)
{
	int mph = (int)((double)thefile[loc+3]/1.609);

	return mph;
}
//void RomRep::VT0Ecu::aenableLaunch(int loc, bool enable)
//void RomRep::VT0Ecu::adisableSpeedLimiter(int loc, bool disable) 
//void RomRep::VT0Ecu::adisableVssCheck(int loc, bool disable) 


//void RomRep::VT0Ecu::adisableTempCheck(int loc, bool disable)


//void RomRep::VT0Ecu::adisablePsCheck(int loc, bool disable) 
int RomRep::VT0Ecu::aisKnockSensorDisabled(int loc)
{
	if(thefile[loc] == 0x00 && thefile[loc+1] == 0x00)
		return 1;
	else
		return 0;
}
void RomRep::VT0Ecu::adisableKnockSensor(int loc1,int loc2,int loc3, bool disable)
{
	if(disable)
	{
		setByte(loc1, 0x00);
		setByte(loc1+1, 0x00);

		setByte(loc2, 0xCB);

		setByte(loc3, 0);
		setByte(loc3+1, 0);
		setByte(loc3+2, 0);
	}
	else
	{
		setByte(loc1, 0xCD);
		setByte(loc1+1, 0x03);

		setByte(loc2, 0xCA);

		setByte(loc3, 0xC4);
		setByte(loc3+1, 0x2D);
		setByte(loc3+2, 0x3C);
	}
}
void RomRep::VT0Ecu::adisableCelCheck(int loc, bool disable)
{
	if(disable)
	{
		setByte(loc, 0xCB);
	}
	else
	{
		setByte(loc, 0xC9);
	}
}

int RomRep::VT0Ecu::aisSpeedLimiterDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisVssCheckDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisTempCheckDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisCelCheckDisabled(int loc)
{
	if(thefile[loc] == 0xCB)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisPsCheckDisabled(int loc)
{
	if(thefile[loc] == 0)
		return 1;
	else
		return 0;
}
int RomRep::VT0Ecu::aisLaunchDisabled(int loc)
{
	if(thefile[loc] != 0xC5)
		return 1;
	else
		return 0;
}


/*****************************************/

double** RomRep::VT0Ecu::getLambdaMap(int index)
{
	if(index >= nummaps)
		return NULL;

	int ** afrmap = get2DArray(thefile,getAfrMapLoc(index),getWidth(),getHeight());
	double** finalmap = new double*[x];

	for(int i = 0; i<x; i++)
		finalmap[i] = new double[y];

	for(int i = 0; i<x; i++)
		for(int j = 0; j<y; j++)
			finalmap[i][j] = ((double)afrmap[i][j]/25.0)+10.0;

	return finalmap;

}

RomRep::ByteChange* RomRep::VT0Ecu::setAfrCellEx(int xx, int yy, double val, int index)
{
	int byte = (int)((val-10.0)*25.0);
	return HondaEcu::setAfrCellEx(xx,yy,byte,index);
}