#include "stdafx.h"
#include "Pm6Ng.h"


RomRep::Pm6Ng::Pm6Ng(): Obd0Ecu(){}
RomRep::Pm6Ng::~Pm6Ng()
{
	delete idle;
	delete launchlimit;
}

RomRep::Pm6Ng::Pm6Ng(int* rom, int flen): Obd0Ecu(rom, flen, 0x0DE6, 0x0, 0x3EFE, 0x3FFD,0x3DFF,0,0,0,1, "Ghd Pm6")
{
	checksumaddy = 0x4418;
	checksumlen = 0x5000;
	int launchaddy = 0x40EB;
	int idleaddy = 0x399F;

	idle = new RpmTwoByteValue(idleaddy, rom[idleaddy], idleaddy+2, rom[idleaddy]);
	launchlimit = new RpmTwoByteValue(launchaddy, rom[launchaddy],launchaddy+2,rom[launchaddy+2]);
//(int* rom, int flen, int revloc, int restartloc, int fmaploc, int fmltloc, int imaploc, string type);
}
/*
			fuelmap1addy = 0x3EFE;
			fuelmltaddy = 0x3FFD;

			ignmap1addy = 0x3DFF;

			revaddy = 0x0DE6;
			idleaddy = 0x399F;
		
			launchaddy = 0x40EB; 
			checksumaddy = 0x4418;
			checksumlen = 0x5000;

			m_staticecu.Format("ECU: GhD PM6");
*/
int RomRep::Pm6Ng::getLaunchLimit()//returns RPM
{
	return getRpmValue(launchlimit);
}
int RomRep::Pm6Ng::getIdle()//returns RPM
{
	return getRpmValue(idle);
}
void RomRep::Pm6Ng::setLaunchLimit(int rpm)
{
	setRpmValue(launchlimit, rpm);
}
void RomRep::Pm6Ng::setIdle(int rpm)
{
	setRpmValue(idle,rpm);
}
bool RomRep::Pm6Ng::validate(int* h)
{
	int head[10] = {0x02,0x16,0x03,0xC0,0xE0,0xC0,0x83,0xC0,0x82,0x61}; //pm6

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
			return false;

	return true;
}
