#include "stdafx.h"
#include "JdmPr3Boost.h"

RomRep::JdmPr3Boost::JdmPr3Boost(): VT0Ecu(){}

RomRep::JdmPr3Boost::JdmPr3Boost(int* rom, int flen): VT0Ecu(rom, flen, 0x31DE, 0x41dd, 0x3414, 8,0x6600, 0x6984,0x6D08, 0x70aa, "JDM PR3 turbo",21)
{
	checksumaddy = 0x4600;
	checksumlen = 0x8000;

	colheaders[0][14] = "1.3 psi";
	colheaders[0][15] = "3.1 psi";
	colheaders[0][16] = "4.6 psi";
	colheaders[0][17] = "6.1 psi";
	colheaders[0][18] = "7.7 psi";
	colheaders[0][19] = "9.2 psi";
	colheaders[0][20] = "10.7";

    colheaders[1][14] = "1.3 psi";
	colheaders[1][15] = "3.1 psi";
	colheaders[1][16] = "4.6 psi";
	colheaders[1][17] = "6.1 psi";
	colheaders[1][18] = "7.7 psi";
	colheaders[1][19] = "9.2 psi";
	colheaders[1][20] = "10.7";
//	VT0Ecu(rom, flen, 0x31DE, 0x31E0, 0x3414, 8, "OBD0 PR3") //jdm pr3
}
//	Jdm pr3...
//	revaddy = 0x31DE;
//	idleaddy = 0x32F6;
//	revrestartaddy = 0x31E0;
//	vtecaddy = 0x3414; start of vtec vals

bool RomRep::JdmPr3Boost::validate(int* h)
{

	int head[10] = {0x73,0x16,0x96,0x16,0x92,0x16,0x8F,0x00,0x03,0x16};

	bool good = true;

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			good = false;
		}

	if(good)
		return true;

	int noohead[10] = {0x09,0x16,0x2B,0x16,0x27,0x16,0x8F,0x00,0x99,0x15};
	
	good = true;
	for(int i = 0; i<HondaEcu::headlen; i++)
		if(noohead[i] != h[i])
		{
			cout<<head[i]<<" shit "<< h[i];
			good = false;
		}
	
	return good;
}

void RomRep::JdmPr3Boost::disableChecksum(bool disable)
{
	aDisableChecksum(0x4019,disable);
}
void RomRep::JdmPr3Boost::disableOxygenSensors(bool disable)
{
	aDisableOxygenSensors(0x2E0B,disable);
}
int RomRep::JdmPr3Boost::isChecksumDisabled()
{
	return aisChecksumDisabled(0x4019);
}
int RomRep::JdmPr3Boost::isOxygenSensorsDisabled()
{
	return aisOxygenSensorsDisabled(0x2E0B);
}

//*************new

void RomRep::JdmPr3Boost::setLaunchRpm(int val)
{
	asetLaunchRpm(0x4266, val);
}

void RomRep::JdmPr3Boost::setLaunchSpeed(int val)
{
	asetLaunchSpeed(0x4266, val);
}
void RomRep::JdmPr3Boost::enableLaunch(bool enable)
{
	int loc = 0xD22;
	if(enable)
	{
		setByte(loc, 0x32);
		setByte(loc+1, 0x66);
		setByte(loc+2, 0x42);

		loc = 0x4266;
		setByte(loc, 0xC5);
		setByte(loc+1, 0xCB);
		setByte(loc+2, 0xC0);
		setByte(loc+3, 0x0A);
		setByte(loc+4, 0xC8);
		setByte(loc+5, 0x0B);
		setByte(loc+6, 0x67);
		setByte(loc+7, 0x02);
		setByte(loc+8, 0x02);
		setByte(loc+9, 0xC5);
		setByte(loc+10, 0xF2);
		setByte(loc+11, 0x2F);
		setByte(loc+12, 0xC8);
		setByte(loc+13, 0x03);
		setByte(loc+14, 0x86);
		setByte(loc+15, 0x01);
		setByte(loc+16, 0x00);
		setByte(loc+17, 0xC5);
		setByte(loc+18, 0x24);
		setByte(loc+19, 0x2C);
		setByte(loc+20, 0x01);
	}
	else
	{
		setByte(loc, 0xC5);
		setByte(loc+1, 0x24);
		setByte(loc+2, 0x2C);

		for(int i = 0x4266; i<0x427B; i++)
			setByte(i, 0xFF);
	}
}

void RomRep::JdmPr3Boost::disableSpeedLimiter(bool disable) 
{
	int loc = 0x41C4;
	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);

		loc = 0x41CE;
		setByte(loc, 2);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xcf);
		setByte(loc+1, 3);

		loc = 0x41CE;
		setByte(loc, 0xe0);
		setByte(loc+1, 3);
	}
}

void RomRep::JdmPr3Boost::disableVssCheck(bool disable) 
{
	int loc = 0xB7F;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		setByte(loc+2, 0);
	}
	else
	{
		setByte(loc, 0xDB);
		setByte(loc+1, 0x29);
		setByte(loc+2, 0x0E);
	}
}

void RomRep::JdmPr3Boost::disableTempCheck(bool disable) 
{
	int loc = 0xB7D;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCD);
		setByte(loc+1, 0x11);
	}
}

void RomRep::JdmPr3Boost::disablePsCheck(bool disable) 
{
	int loc = 0x808;

	if(disable)
	{
		setByte(loc, 0);
		setByte(loc+1, 0);
		
		loc = 0xB77;
		setByte(loc, 0);
		setByte(loc+1, 0);
	}
	else
	{
		setByte(loc, 0xCA);
		setByte(loc+1, 0x13);
		
		loc = 0xB77;
		setByte(loc, 0xCA);
		setByte(loc+1, 0x17);
	}
}

void RomRep::JdmPr3Boost::disableCelCheck(bool disable)
{
	int loc = 0xB69;
	adisableCelCheck(loc, disable);

}

int RomRep::JdmPr3Boost::isKnockSensorDisabled()
{
	return -1;
}
void RomRep::JdmPr3Boost::disableKnockSensor(bool disable)
{
//	adisableKnockSensor(0xA0E,disable);
}

int RomRep::JdmPr3Boost::isSpeedLimiterDisabled()
{
	return aisSpeedLimiterDisabled(0x41c4);
}
int RomRep::JdmPr3Boost::isVssCheckDisabled()
{
	return aisVssCheckDisabled(0xb7f);
}
int RomRep::JdmPr3Boost::isTempCheckDisabled()
{
	return aisTempCheckDisabled(0xb7d);
}
int RomRep::JdmPr3Boost::isCelCheckDisabled()
{
	return aisCelCheckDisabled(0xb69);
}
int RomRep::JdmPr3Boost::isPsCheckDisabled()
{
	return aisPsCheckDisabled(0x808);
}
int RomRep::JdmPr3Boost::isLaunchDisabled()
{
	return aisLaunchDisabled(0x4266);
}

int RomRep::JdmPr3Boost::getLaunchRpm()
{
	return agetLaunchRpm(0x4266);
}
int RomRep::JdmPr3Boost::getLaunchSpeed()
{
	return agetLaunchSpeed(0x4266);
}