#include "stdafx.h"
#include "map.h"

RomRep::Map::Map()
{
	thefile = NULL;
	map = new int*[1];
	map[0] = new int[1];

	vac = new string[1];
	rpm = new string[1];

	x = 1;
	y = 1;
	location = 0;
}
RomRep::Map::Map(int x1, int y1, unsigned int loc)
{
	thefile = NULL;
	location = loc;

	map = new int*[x1];

	for(int i = 0; i< x1; i++)
		map[i] = new int[y1];

	vac = new string[x1];
	rpm = new string[y1];

	x = x1;
	y = y1;
}
RomRep::Map::Map(int x1, int y1, unsigned int loc,int* fil)
{
	thefile = fil; //shallow copy for a reason...
	location = loc;

	map = new int*[x1];

	for(int i = 0; i< x1; i++)
		map[i] = new int[y1];

	vac = new string[x1];
	rpm = new string[y1];

	x = x1;
	y = y1;
}
RomRep::Map::~Map()//destruction!... Muahahahahahahahahaaaahahaha!!11!!
{
	delete[] vac;
	delete[] rpm;

	for(int i = 0; i<x; i++)
		delete[] map[i];

	delete[] map;
}

//---------------------------end constructors---------------------

double** RomRep::Map::getMap()
{
	//try not to use this...
	//too much powah.
	int i, j;
	double ** mapp = new double*[x];
	for(i = 0; i<x; i++)
		mapp[i] = new double[y];

	for(i = 0; i<x; i++)
		for(j = 0; j<y; j++)
			mapp[i][j] = calculate(i,j,map[i][j]);
	return mapp;
}

double RomRep::Map::getVal(int x1, int y1)
{
	if(x1<x && x1>(-1) && y1<y && y1>(-1)) //if its inside the map's bounds
		return calculate(x1,y1,map[x1][y1]);
	else
	{
		return -1; //error, y0
		cout<<"Map out of bounds"<<endl;
	}
}

void RomRep::Map::setVal(int x1, int y1, double val)
{
	int noo = calculate(x1,y1,val);
	if(x1<x && x1>(-1) && y1<y && y1>(-1) && noo>=0 && noo<256) //if its inside the map's bounds
		map[x1][y1] = noo;
	else
		cout<<"Map out of bounds"<<endl; 
}

void RomRep::Map::insertColumn(int column) //column inserted AFTER 'column'
{
	if(column > x-1 || column < 0)
		return;

	int** tmpmap = map;

	//create larger map
	map = new int*[x+1];
	for(int i = 0; i < (x+1); i++)
		map[i] = new int[y];

	x++; //new size

	//populate up to the new column, which gets 1s right now
	for(int row = 0; row<y; row++)
		for(int col = 0; col<=column; col++)
		{
			int val = tmpmap[col][row];

			map[col][row] = val;
			thefile[this->getCellLocation(col,row)] = val;
		}

	for(int row = 0; row<y; row++)
	{
		//interpolation goes here...
		int val = 1;
//		if(column+2 < x)
//		{
//			double left = this->calculate(column,row,map[column][row]); //left val
//			double right = this->calculate(column+1,row,map[column+2][row]); //right val
//
//			val = this->calculate(column,row,(left+right)/2.0);
//		
//		}
//		else
//		{
			val = map[column][row];
//		}

		map[column+1][row] = val;
		thefile[this->getCellLocation(column+1,row)] = val;
	}

	//fill after the new column
	for(int row = 0; row<y; row++)
		for(int col = column+1; col<(x-1); col++)
		{
			map[col+1][row] = tmpmap[col][row];
			thefile[this->getCellLocation(col+1,row)] = tmpmap[col][row];

		}

	//delete old map
	for(int i = 0; i<(x-1); i++)
		delete[] tmpmap[i];
	delete[] tmpmap;
}

void RomRep::Map::insertRow(int row) //column inserted AFTER 'row'
{
	if(row > y-1 || row < 0)
		return;

	int** tmpmap = map;

	//create larger map
	map = new int*[x];
	for(int i = 0; i < x; i++)
		map[i] = new int[y+1];

	y++; //new size

	//populate up to the new row, which gets 1s right now
	for(int r = 0; r<=row; r++)
		for(int col = 0; col<x; col++)
		{
			int val = tmpmap[col][r];

			map[col][r] = val;
			thefile[this->getCellLocation(col,r)] = val;
		}

	for(int col = 0; col<x; col++)
	{
		//interpolation goes here...
		int val = 1;
		if(row+2 < y)
		{
			val = (map[col][row] + map[col][row+2])/2; //avg
		
		}
		else
		{
			val = map[col][row];
		}

		map[col][row+1] = val;
		thefile[this->getCellLocation(col,row+1)] = val;
	}

	//fill after the new row
	for(int r = row+1; r<(y-1); r++)
		for(int col = 0; col<x; col++)
		{
			map[col][r+1] = tmpmap[col][r];
			thefile[this->getCellLocation(col,r+1)] = tmpmap[col][r];

		}

	//delete old map
	for(int i = 0; i<x; i++)
		delete[] tmpmap[i];
	delete[] tmpmap;
}

void RomRep::Map::setVal(int x1, int y1, int val)
{
//	double mapval;
//
//	mapval = calculate(x1, y1, val);
//
//	map[x1][y1] = mapval; //sets a double into the internal map
}


void RomRep::Map::populate(int **mapp)
{
	int i, j;

	for(i = 0; i<x; i++)
		for(j = 0; j<y; j++)
			map[i][j] = mapp[i][j];
}

//gets the location of the cell (x1,y1) in the rom file
unsigned int RomRep::Map::getCellLocation(int x1, int y1)
{
	return (unsigned int)((x * y1) + x1 + location); 
}

//gets the location of the cell (x1,y1) in the rom file
unsigned int RomRep::Map::getCellLocation(int x1, int y1, int cols, int loc)
{
	return (unsigned int)((cols * y1) + x1 + loc); 
}

//////////------------end member functions
/*
ostream& operator<<(ostream& out, Map& m)
{
	out.setf(ios::fixed);
	int i,j;

	for(j = 0; j<m.getY(); j++)
	{
		for(i = 0; i<m.getX(); i++)
			out<<setprecision(1)<<m.getVal(i,j)<< " ";

		out<<endl;
	}
	out<< endl;

	return out;
}
*/