#pragma unmanaged

#if !defined BENS_MAP_H
#define BENS_MAP_H

#include<iostream>
#include<string>
#include<iomanip>
using namespace std;

//idea behind this: Have a base class that all other maps can be derived from.
//Data will be stored in its double form (real world val) and will be returned as such 
//in this class.

//Concrete derived Maps will get passed an integer representation of the map (from
//the raw file) then will convert the map and store it in this class' 2D array.
namespace RomRep
{
	class Map
	{

		protected:

		int* thefile;

		int **map;
		string *vac;
		string *rpm;

		int x,y; //max dimensions
		unsigned int location;//location of 1st byte

		public:

		Map();
		Map(int x, int y, unsigned int locale); //width, height
		Map(int x, int y, unsigned int locale, int* fil);

		virtual ~Map(); //virtual calls destruct when child destructs

		double ** getMap();

		//can be overridden
		virtual double getVal(int x, int y); 
		virtual void setVal(int x, int y, int val);
		virtual void setVal(int x, int y, double val);

		virtual void insertColumn(int column); //column inserted AFTER 'column'
		virtual void insertRow(int row); //column inserted AFTER 'row'

		virtual double calculate(int x, int y, int intval) = 0;
		virtual int calculate(int x, int y, double mapval) = 0;

		virtual void populate(int **map);

		virtual int getX(){return x;}
		virtual int getY(){return y;}

		virtual unsigned int getMapLocation(){return location;};
		virtual void setMapLocation(unsigned int loc){location = loc;};
		virtual unsigned int getCellLocation(int x, int y);
		static unsigned int getCellLocation(int x, int y, int cols, int loc);

		virtual void setMultiplier(int column, int val) = 0;
		virtual int getMultiplierLocation(int column) = 0;

	};
}
//ostream& operator<<(ostream& out, Map& m);

#endif