

using System;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

using bre20;
//css_reference ..\..\bre.exe;
//css_import OutputFunctionDlg.cs;

namespace BensScripts
{
	public class OutputFunctions
	{
		private child romWind;
		private static int start = 0x50A0;
		private static int rpmAdd = 0x7FF2;
		private static int optAdd = 0x7FF4;
		
		private static int F_SHIFT = 1;
		private static int F_KNOCK = 2;

		private OutputFunctionDlg dlg;

		public static object AppliesTo(){return "pr3:pw0";}
		public static object ScriptTitle(){return "CEL Functions by Ben Ogle";}

		//args[1] = child window of type bre20.child
		public object ScriptMain(params object[] args)
		{
			romWind = (child)args[1];

			MenuItem item = romWind.AddMenuItem("Scripts", "CEL Functions...", "BensScripts.OutputFunctions.mnu_click");
			return null;
		}

		private int get2ByteVal(int addr)
		{
			int val = (int)romWind.getRom().getByte(addr);
			val = val+ 256*((int)romWind.getRom().getByte(addr+1));
			return val;
		}

		private void set2ByteVal(int addr, int val)
		{
			romWind.getRom().setByte(addr,val%256);
			romWind.getRom().setByte(addr+1,val/256);
		}

		private bool isEnabled()
		{
			return (int)romWind.getRom().getByte(start) == 0xE5;
		}

		private void setFunctionEnabled(bool en)
		{
			if((en && isEnabled()) || (!en && !isEnabled()))
				return;

			string type = romWind.getRomType();
			string chpath = null;
			if(Common.isMatch("jdm pr3",type,false))
				chpath = "\\JPr3OutputFn.txt";
			else if(Common.isMatch("jdm pw0",type,false))
				chpath = "\\JPw0OutputFn.txt";
			else if(Common.isMatch("euro pw0",type,false))
				chpath = "\\EPw0OutputFn.txt";

			if(chpath != null)
			{
				Assembly asm = Assembly.GetAssembly(this.GetType());
				romWind.parseByteChanges(Path.GetDirectoryName(asm.Location) + chpath, en);
			}
		}

		public object mnu_click(params object[] objs)
		{
			int val = (int)romWind.getRom().getByte(optAdd);
			int rpm = 1852000/get2ByteVal(rpmAdd);

			dlg = new OutputFunctionDlg();

			dlg.FunctionEnabled = isEnabled();
			dlg.Rpm = rpm;
			dlg.Function = val;

			if(dlg.ShowDialog() == DialogResult.OK)
			{
				setFunctionEnabled(dlg.FunctionEnabled);
				romWind.getRom().setByte(optAdd,dlg.Function);
				if(dlg.Function == F_SHIFT)
					set2ByteVal(rpmAdd,1852000/dlg.Rpm);
			}

			dlg.Dispose();
			dlg = null;
			return null;
		}
	}//end class
}//end namespace