using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace BensScripts
{
	/// <summary>
	/// Summary description for RomNotesDlg.
	/// </summary>
	public class RomNotesDlg : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.TextBox notes;
		private System.Windows.Forms.Label lblMaxLen;
		private System.Windows.Forms.Label charsLeft;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public RomNotesDlg()
		{
			InitializeComponent();
			MaxChars = 128;
		}
		public string RomNotes
		{
			set{
				if(value.Length > MaxChars)
					notes.Text = value.Substring(0,128);
				else
					notes.Text = value;
				charsLeft.Text = (MaxChars - notes.Text.Length) + " characters left";
			}
			get{return notes.Text;}
		}
		public int MaxChars
		{
			set{
				notes.MaxLength = value;
				lblMaxLen.Text = "Max Length: " + value + " chars";
			}
			get{return notes.MaxLength;}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOk = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.notes = new System.Windows.Forms.TextBox();
			this.lblMaxLen = new System.Windows.Forms.Label();
			this.charsLeft = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnOk
			// 
			this.btnOk.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOk.Location = new System.Drawing.Point(240, 88);
			this.btnOk.Name = "btnOk";
			this.btnOk.Size = new System.Drawing.Size(72, 32);
			this.btnOk.TabIndex = 1;
			this.btnOk.Text = "OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(160, 88);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(72, 32);
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// notes
			// 
			this.notes.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.notes.Location = new System.Drawing.Point(8, 8);
			this.notes.Multiline = true;
			this.notes.Name = "notes";
			this.notes.Size = new System.Drawing.Size(304, 72);
			this.notes.TabIndex = 0;
			this.notes.Text = "";
			this.notes.TextChanged += new System.EventHandler(this.notes_TextChanged);
			// 
			// lblMaxLen
			// 
			this.lblMaxLen.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblMaxLen.Location = new System.Drawing.Point(8, 88);
			this.lblMaxLen.Name = "lblMaxLen";
			this.lblMaxLen.Size = new System.Drawing.Size(160, 16);
			this.lblMaxLen.TabIndex = 3;
			this.lblMaxLen.Text = "Max Length: 128 chars";
			// 
			// charsLeft
			// 
			this.charsLeft.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.charsLeft.Location = new System.Drawing.Point(8, 104);
			this.charsLeft.Name = "charsLeft";
			this.charsLeft.Size = new System.Drawing.Size(144, 16);
			this.charsLeft.TabIndex = 4;
			this.charsLeft.Text = "128 characters left";
			// 
			// RomNotesDlg
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(320, 125);
			this.ControlBox = false;
			this.Controls.Add(this.notes);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOk);
			this.Controls.Add(this.lblMaxLen);
			this.Controls.Add(this.charsLeft);
			this.Name = "RomNotesDlg";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ROM Notes";
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOk_Click(object sender, System.EventArgs e){
			this.DialogResult = DialogResult.OK;
			this.Close();
		}

		private void notes_TextChanged(object sender, System.EventArgs e)
		{
			charsLeft.Text = (MaxChars - notes.Text.Length) + " characters left";
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
